/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with EDIF_ or edif_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with edif or EDIF, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define EDIFBISON 30802

/* Bison version string.  */
#define EDIFBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define EDIFSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define EDIFPURE 0

/* Push parsers.  */
#define EDIFPUSH 0

/* Pull parsers.  */
#define EDIFPULL 1




/* First part of user prologue.  */
#line 1 "./parser_y.y"


/*----------------------------------------------------------------------*/
/*                      @(#) Edif Parser For MBK.                       */
/*----------------------------------------------------------------------*/
/*                      version 1.00:   by Fred Petrot.                 */
/*                      version 4.02:   by Mokhtar Hirech (Jan. 92)     */
/*                      version 4.03:   by Olivier BEAURIN (Aou. 93)    */
/*                      version 4.04:   by Olivier BEAURIN (Sep. 93)    */
/*                      version 4.06:   by Olivier BEAURIN (Nov. 93)    */
/*----------------------------------------------------------------------*/

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mut.h>
#include <mlo.h>
#include <rcn.h>

/*---------------------------------------------------------\
                     Les defines
\---------------------------------------------------------*/
#define MAXSTRLEN       100

/*---------------------------------------------------------\
                     Globals variables
\---------------------------------------------------------*/
static lofig_list     *EDIF_LOFIG                = (lofig_list *) NULL;
static lofig_list     *EDIF_PTFIG                = (lofig_list *) NULL;
static losig_list     *EDIF_PTSIG                = (losig_list *) NULL;
static chain_list     *EDIF_PORTLIST_SIG         = (chain_list *) NULL;
static chain_list     *EDIF_PORTLIST_SIG_TMP     = (chain_list *) NULL;
static loins_list     *EDIF_PTINS                = (loins_list *) NULL;
static chain_list     *EDIF_V_PORTINSTANCE       = (chain_list *) NULL;

static char           *EDIF_RIPPER_IN            = (char *)NULL;
static char           *EDIF_RIPPER_OUT           = (char *)NULL;

static char            EDIF_BLACKBOX             = 'N';  
static int             EDIF_BUS_WIDTH            = 0;
static char            EDIF_DIRECTION            = UNKNOWN;
static int             EDIF_INDEX                = 0;
static char            EDIF_SIGTYPE              = 'Z'; /* Z=not alr. defined, I=interne, E=externe */
static int             EDIF_NOLOAD_LOCON         = 0;
static int             EDIF_NOLOAD_FIG           = 0;

static int             EDIF_BASE_CELL;
static char           *EDIF_FIGNAME;
static char           *EDIF_INS_MODELNAME;
static char            EDIF_ARRAYPORTNAME[MAXSTRLEN];
static char            EDIF_PORTLIST_NUM;
static char            EDIF_PORTLIST;
static char           *EDIF_RIPPER_CELL = (char *) NULL;

/*---------------------------------------------------------\
                     Functions
\---------------------------------------------------------*/
static  void        REnamealloc         ( );
static  void        del_patch           ( );
static  void        sig_merge           ( );

static  char        bus_nameref         ( );
static  char        CheckCadenceBusError( );
static  char       *CheckCadenceNetError( );
static  lofig_list *get_figure_pt       ( );
static  char        is_portinstance     ( );
static  int         ediferror             ( );
extern  void        edifrestart           ( );
extern  char       *edif_busname        ( );

extern  int         ediflineno;
extern  int         ediflex               ( );


#line 146 "y.tab.c"

# ifndef EDIF_CAST
#  ifdef __cplusplus
#   define EDIF_CAST(Type, Val) static_cast<Type> (Val)
#   define EDIF_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define EDIF_CAST(Type, Val) ((Type) (Val))
#   define EDIF_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef EDIF_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define EDIF_NULLPTR nullptr
#   else
#    define EDIF_NULLPTR 0
#   endif
#  else
#   define EDIF_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef EDIF_EDIF_Y_TAB_H_INCLUDED
# define EDIF_EDIF_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef EDIFDEBUG
# define EDIFDEBUG 0
#endif
#if EDIFDEBUG
extern int edifdebug;
#endif

/* Token kinds.  */
#ifndef EDIFTOKENTYPE
# define EDIFTOKENTYPE
  enum ediftokentype
  {
    EDIFEMPTY = -2,
    EDIFEOF = 0,                     /* "end of file"  */
    EDIFerror = 256,                 /* error  */
    EDIFUNDEF = 257,                 /* "invalid token"  */
    T_EDIF = 258,                  /* T_EDIF  */
    T_EDIFVERSION = 259,           /* T_EDIFVERSION  */
    T_EDIFLEVEL = 260,             /* T_EDIFLEVEL  */
    T_TECHNOLOGY = 261,            /* T_TECHNOLOGY  */
    T_CELLTYPE = 262,              /* T_CELLTYPE  */
    T_CELLTYPE_GENERIC = 263,      /* T_CELLTYPE_GENERIC  */
    T_CELLTYPE_TIE = 264,          /* T_CELLTYPE_TIE  */
    T_CELLTYPE_RIPPER = 265,       /* T_CELLTYPE_RIPPER  */
    T_PROPERTY = 266,              /* T_PROPERTY  */
    T_VIEWTYPE = 267,              /* T_VIEWTYPE  */
    T_INTERFACE = 268,             /* T_INTERFACE  */
    T_CONTENTS = 269,              /* T_CONTENTS  */
    T_JOINED = 270,                /* T_JOINED  */
    T_INSTANCE = 271,              /* T_INSTANCE  */
    T_VIEWREF = 272,               /* T_VIEWREF  */
    T_PORT = 273,                  /* T_PORT  */
    T_DIRECTION = 274,             /* T_DIRECTION  */
    T_INOUT = 275,                 /* T_INOUT  */
    T_PORTREF = 276,               /* T_PORTREF  */
    T_NETLIST = 277,               /* T_NETLIST  */
    T_KEYWORDMAP = 278,            /* T_KEYWORDMAP  */
    T_KEYWORDLEVEL = 279,          /* T_KEYWORDLEVEL  */
    T_EXTERNAL = 280,              /* T_EXTERNAL  */
    T_LIBRARYREF = 281,            /* T_LIBRARYREF  */
    T_OUTPUT = 282,                /* T_OUTPUT  */
    T_INSTANCEREF = 283,           /* T_INSTANCEREF  */
    T_MEMBER = 284,                /* T_MEMBER  */
    T_RENAME = 285,                /* T_RENAME  */
    T_NAME = 286,                  /* T_NAME  */
    T_STRING = 287,                /* T_STRING  */
    T_PORTINSTANCE = 288,          /* T_PORTINSTANCE  */
    T_LIBRARY = 289,               /* T_LIBRARY  */
    T_CELL = 290,                  /* T_CELL  */
    T_VIEW = 291,                  /* T_VIEW  */
    T_NET = 292,                   /* T_NET  */
    T_CELLREF = 293,               /* T_CELLREF  */
    T_INPUT = 294,                 /* T_INPUT  */
    T_STATUS = 295,                /* T_STATUS  */
    T_IDENT = 296,                 /* T_IDENT  */
    T_ARRAY = 297,                 /* T_ARRAY  */
    T_RENAME_STRING = 298,         /* T_RENAME_STRING  */
    T_PORTLIST = 299,              /* T_PORTLIST  */
    T_INTEGER = 300                /* T_INTEGER  */
  };
  typedef enum ediftokentype ediftoken_kind_t;
#endif
/* Token kinds.  */
#define EDIFEMPTY -2
#define EDIFEOF 0
#define EDIFerror 256
#define EDIFUNDEF 257
#define T_EDIF 258
#define T_EDIFVERSION 259
#define T_EDIFLEVEL 260
#define T_TECHNOLOGY 261
#define T_CELLTYPE 262
#define T_CELLTYPE_GENERIC 263
#define T_CELLTYPE_TIE 264
#define T_CELLTYPE_RIPPER 265
#define T_PROPERTY 266
#define T_VIEWTYPE 267
#define T_INTERFACE 268
#define T_CONTENTS 269
#define T_JOINED 270
#define T_INSTANCE 271
#define T_VIEWREF 272
#define T_PORT 273
#define T_DIRECTION 274
#define T_INOUT 275
#define T_PORTREF 276
#define T_NETLIST 277
#define T_KEYWORDMAP 278
#define T_KEYWORDLEVEL 279
#define T_EXTERNAL 280
#define T_LIBRARYREF 281
#define T_OUTPUT 282
#define T_INSTANCEREF 283
#define T_MEMBER 284
#define T_RENAME 285
#define T_NAME 286
#define T_STRING 287
#define T_PORTINSTANCE 288
#define T_LIBRARY 289
#define T_CELL 290
#define T_VIEW 291
#define T_NET 292
#define T_CELLREF 293
#define T_INPUT 294
#define T_STATUS 295
#define T_IDENT 296
#define T_ARRAY 297
#define T_RENAME_STRING 298
#define T_PORTLIST 299
#define T_INTEGER 300

/* Value type.  */
#if ! defined EDIFSTYPE && ! defined EDIFSTYPE_IS_DECLARED
union EDIFSTYPE
{
#line 79 "./parser_y.y"

		long    lval;
		char    sval[100];
	

#line 295 "y.tab.c"

};
typedef union EDIFSTYPE EDIFSTYPE;
# define EDIFSTYPE_IS_TRIVIAL 1
# define EDIFSTYPE_IS_DECLARED 1
#endif


extern EDIFSTYPE ediflval;


int edifparse (void);


#endif /* !EDIF_EDIF_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum edifsymbol_kind_t
{
  EDIFSYMBOL_EDIFEMPTY = -2,
  EDIFSYMBOL_EDIFEOF = 0,                      /* "end of file"  */
  EDIFSYMBOL_EDIFerror = 1,                    /* error  */
  EDIFSYMBOL_EDIFUNDEF = 2,                    /* "invalid token"  */
  EDIFSYMBOL_T_EDIF = 3,                     /* T_EDIF  */
  EDIFSYMBOL_T_EDIFVERSION = 4,              /* T_EDIFVERSION  */
  EDIFSYMBOL_T_EDIFLEVEL = 5,                /* T_EDIFLEVEL  */
  EDIFSYMBOL_T_TECHNOLOGY = 6,               /* T_TECHNOLOGY  */
  EDIFSYMBOL_T_CELLTYPE = 7,                 /* T_CELLTYPE  */
  EDIFSYMBOL_T_CELLTYPE_GENERIC = 8,         /* T_CELLTYPE_GENERIC  */
  EDIFSYMBOL_T_CELLTYPE_TIE = 9,             /* T_CELLTYPE_TIE  */
  EDIFSYMBOL_T_CELLTYPE_RIPPER = 10,         /* T_CELLTYPE_RIPPER  */
  EDIFSYMBOL_T_PROPERTY = 11,                /* T_PROPERTY  */
  EDIFSYMBOL_T_VIEWTYPE = 12,                /* T_VIEWTYPE  */
  EDIFSYMBOL_T_INTERFACE = 13,               /* T_INTERFACE  */
  EDIFSYMBOL_T_CONTENTS = 14,                /* T_CONTENTS  */
  EDIFSYMBOL_T_JOINED = 15,                  /* T_JOINED  */
  EDIFSYMBOL_T_INSTANCE = 16,                /* T_INSTANCE  */
  EDIFSYMBOL_T_VIEWREF = 17,                 /* T_VIEWREF  */
  EDIFSYMBOL_T_PORT = 18,                    /* T_PORT  */
  EDIFSYMBOL_T_DIRECTION = 19,               /* T_DIRECTION  */
  EDIFSYMBOL_T_INOUT = 20,                   /* T_INOUT  */
  EDIFSYMBOL_T_PORTREF = 21,                 /* T_PORTREF  */
  EDIFSYMBOL_T_NETLIST = 22,                 /* T_NETLIST  */
  EDIFSYMBOL_T_KEYWORDMAP = 23,              /* T_KEYWORDMAP  */
  EDIFSYMBOL_T_KEYWORDLEVEL = 24,            /* T_KEYWORDLEVEL  */
  EDIFSYMBOL_T_EXTERNAL = 25,                /* T_EXTERNAL  */
  EDIFSYMBOL_T_LIBRARYREF = 26,              /* T_LIBRARYREF  */
  EDIFSYMBOL_T_OUTPUT = 27,                  /* T_OUTPUT  */
  EDIFSYMBOL_T_INSTANCEREF = 28,             /* T_INSTANCEREF  */
  EDIFSYMBOL_T_MEMBER = 29,                  /* T_MEMBER  */
  EDIFSYMBOL_T_RENAME = 30,                  /* T_RENAME  */
  EDIFSYMBOL_T_NAME = 31,                    /* T_NAME  */
  EDIFSYMBOL_T_STRING = 32,                  /* T_STRING  */
  EDIFSYMBOL_T_PORTINSTANCE = 33,            /* T_PORTINSTANCE  */
  EDIFSYMBOL_T_LIBRARY = 34,                 /* T_LIBRARY  */
  EDIFSYMBOL_T_CELL = 35,                    /* T_CELL  */
  EDIFSYMBOL_T_VIEW = 36,                    /* T_VIEW  */
  EDIFSYMBOL_T_NET = 37,                     /* T_NET  */
  EDIFSYMBOL_T_CELLREF = 38,                 /* T_CELLREF  */
  EDIFSYMBOL_T_INPUT = 39,                   /* T_INPUT  */
  EDIFSYMBOL_T_STATUS = 40,                  /* T_STATUS  */
  EDIFSYMBOL_T_IDENT = 41,                   /* T_IDENT  */
  EDIFSYMBOL_T_ARRAY = 42,                   /* T_ARRAY  */
  EDIFSYMBOL_T_RENAME_STRING = 43,           /* T_RENAME_STRING  */
  EDIFSYMBOL_T_PORTLIST = 44,                /* T_PORTLIST  */
  EDIFSYMBOL_T_INTEGER = 45,                 /* T_INTEGER  */
  EDIFSYMBOL_46_ = 46,                       /* ')'  */
  EDIFSYMBOL_EDIFACCEPT = 47,                  /* $accept  */
  EDIFSYMBOL_r_edif = 48,                    /* r_edif  */
  EDIFSYMBOL_r_edifversion = 49,             /* r_edifversion  */
  EDIFSYMBOL_r_ediflevel = 50,               /* r_ediflevel  */
  EDIFSYMBOL_l_externals = 51,               /* l_externals  */
  EDIFSYMBOL_r_external = 52,                /* r_external  */
  EDIFSYMBOL_l_finexternal = 53,             /* l_finexternal  */
  EDIFSYMBOL_r_finexternal = 54,             /* r_finexternal  */
  EDIFSYMBOL_r_extcell = 55,                 /* r_extcell  */
  EDIFSYMBOL_56_1 = 56,                      /* $@1  */
  EDIFSYMBOL_l_finextcell = 57,              /* l_finextcell  */
  EDIFSYMBOL_r_finextcell = 58,              /* r_finextcell  */
  EDIFSYMBOL_r_extview = 59,                 /* r_extview  */
  EDIFSYMBOL_r_extinterface = 60,            /* r_extinterface  */
  EDIFSYMBOL_l_finextinterf = 61,            /* l_finextinterf  */
  EDIFSYMBOL_r_finextinterf = 62,            /* r_finextinterf  */
  EDIFSYMBOL_l_finedif = 63,                 /* l_finedif  */
  EDIFSYMBOL_r_library = 64,                 /* r_library  */
  EDIFSYMBOL_l_finlibrary = 65,              /* l_finlibrary  */
  EDIFSYMBOL_r_finlibrary = 66,              /* r_finlibrary  */
  EDIFSYMBOL_r_cell = 67,                    /* r_cell  */
  EDIFSYMBOL_68_2 = 68,                      /* $@2  */
  EDIFSYMBOL_r_celltype = 69,                /* r_celltype  */
  EDIFSYMBOL_l_fincell = 70,                 /* l_fincell  */
  EDIFSYMBOL_r_fincell = 71,                 /* r_fincell  */
  EDIFSYMBOL_r_property = 72,                /* r_property  */
  EDIFSYMBOL_r_opt_property = 73,            /* r_opt_property  */
  EDIFSYMBOL_r_view = 74,                    /* r_view  */
  EDIFSYMBOL_l_finview = 75,                 /* l_finview  */
  EDIFSYMBOL_r_finview = 76,                 /* r_finview  */
  EDIFSYMBOL_r_contents = 77,                /* r_contents  */
  EDIFSYMBOL_l_fincontents = 78,             /* l_fincontents  */
  EDIFSYMBOL_r_fincontents = 79,             /* r_fincontents  */
  EDIFSYMBOL_r_instance = 80,                /* r_instance  */
  EDIFSYMBOL_81_3 = 81,                      /* $@3  */
  EDIFSYMBOL_r_viewref = 82,                 /* r_viewref  */
  EDIFSYMBOL_l_portinstance = 83,            /* l_portinstance  */
  EDIFSYMBOL_r_portinstance = 84,            /* r_portinstance  */
  EDIFSYMBOL_r_cellref = 85,                 /* r_cellref  */
  EDIFSYMBOL_r_libraryref = 86,              /* r_libraryref  */
  EDIFSYMBOL_r_net = 87,                     /* r_net  */
  EDIFSYMBOL_88_4 = 88,                      /* $@4  */
  EDIFSYMBOL_89_5 = 89,                      /* $@5  */
  EDIFSYMBOL_l_finnet = 90,                  /* l_finnet  */
  EDIFSYMBOL_r_finnet = 91,                  /* r_finnet  */
  EDIFSYMBOL_r_array_joined = 92,            /* r_array_joined  */
  EDIFSYMBOL_l_array_joined = 93,            /* l_array_joined  */
  EDIFSYMBOL_r_portlist = 94,                /* r_portlist  */
  EDIFSYMBOL_95_6 = 95,                      /* $@6  */
  EDIFSYMBOL_l_list_portref = 96,            /* l_list_portref  */
  EDIFSYMBOL_r_array_portref = 97,           /* r_array_portref  */
  EDIFSYMBOL_r_joined = 98,                  /* r_joined  */
  EDIFSYMBOL_l_finjoined = 99,               /* l_finjoined  */
  EDIFSYMBOL_r_finjoined = 100,              /* r_finjoined  */
  EDIFSYMBOL_r_portref = 101,                /* r_portref  */
  EDIFSYMBOL_r_interface = 102,              /* r_interface  */
  EDIFSYMBOL_l_fininterface = 103,           /* l_fininterface  */
  EDIFSYMBOL_r_fininterface = 104,           /* r_fininterface  */
  EDIFSYMBOL_r_port = 105,                   /* r_port  */
  EDIFSYMBOL_l_finport = 106,                /* l_finport  */
  EDIFSYMBOL_r_finport = 107,                /* r_finport  */
  EDIFSYMBOL_r_direction = 108,              /* r_direction  */
  EDIFSYMBOL_l_anything = 109,               /* l_anything  */
  EDIFSYMBOL_r_anything = 110,               /* r_anything  */
  EDIFSYMBOL_r_namedef = 111,                /* r_namedef  */
  EDIFSYMBOL_r_name = 112,                   /* r_name  */
  EDIFSYMBOL_r_port_joined = 113,            /* r_port_joined  */
  EDIFSYMBOL_l_finport_joined = 114,         /* l_finport_joined  */
  EDIFSYMBOL_r_finport_joined = 115,         /* r_finport_joined  */
  EDIFSYMBOL_r_shorted_portref = 116         /* r_shorted_portref  */
};
typedef enum edifsymbol_kind_t edifsymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define EDIF_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ ediftype_int8;
#elif defined EDIF_STDINT_H
typedef int_least8_t ediftype_int8;
#else
typedef signed char ediftype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ ediftype_int16;
#elif defined EDIF_STDINT_H
typedef int_least16_t ediftype_int16;
#else
typedef short ediftype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ ediftype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined EDIF_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t ediftype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char ediftype_uint8;
#else
typedef short ediftype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ ediftype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined EDIF_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t ediftype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short ediftype_uint16;
#else
typedef int ediftype_uint16;
#endif

#ifndef EDIFPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define EDIFPTRDIFF_T __PTRDIFF_TYPE__
#  define EDIFPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define EDIFPTRDIFF_T ptrdiff_t
#  define EDIFPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define EDIFPTRDIFF_T long
#  define EDIFPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef EDIFSIZE_T
# ifdef __SIZE_TYPE__
#  define EDIFSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define EDIFSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define EDIFSIZE_T size_t
# else
#  define EDIFSIZE_T unsigned
# endif
#endif

#define EDIFSIZE_MAXIMUM                                  \
  EDIF_CAST (EDIFPTRDIFF_T,                                 \
           (EDIFPTRDIFF_MAXIMUM < EDIF_CAST (EDIFSIZE_T, -1)  \
            ? EDIFPTRDIFF_MAXIMUM                         \
            : EDIF_CAST (EDIFSIZE_T, -1)))

#define EDIFSIZEOF(X) EDIF_CAST (EDIFPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef ediftype_uint8 edif_state_t;

/* State numbers in computations.  */
typedef int edif_state_fast_t;

#ifndef EDIF_
# if defined EDIFENABLE_NLS && EDIFENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define EDIF_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef EDIF_
#  define EDIF_(Msgid) Msgid
# endif
#endif


#ifndef EDIF_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define EDIF_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define EDIF_ATTRIBUTE_PURE
# endif
#endif

#ifndef EDIF_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define EDIF_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define EDIF_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define EDIF_USE(E) ((void) (E))
#else
# define EDIF_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about ediflval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define EDIF_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define EDIF_INITIAL_VALUE(Value) Value
#endif
#ifndef EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define EDIF_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef EDIF_INITIAL_VALUE
# define EDIF_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define EDIF_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define EDIF_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef EDIF_IGNORE_USELESS_CAST_BEGIN
# define EDIF_IGNORE_USELESS_CAST_BEGIN
# define EDIF_IGNORE_USELESS_CAST_END
#endif


#define EDIF_ASSERT(E) ((void) (0 && (E)))

#if !defined edifoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef EDIFSTACK_USE_ALLOCA
#  if EDIFSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define EDIFSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define EDIFSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define EDIFSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef EDIFSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define EDIFSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef EDIFSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define EDIFSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define EDIFSTACK_ALLOC EDIFMALLOC
#  define EDIFSTACK_FREE EDIFFREE
#  ifndef EDIFSTACK_ALLOC_MAXIMUM
#   define EDIFSTACK_ALLOC_MAXIMUM EDIFSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined EDIFMALLOC || defined malloc) \
             && (defined EDIFFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef EDIFMALLOC
#   define EDIFMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (EDIFSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef EDIFFREE
#   define EDIFFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined edifoverflow */

#if (! defined edifoverflow \
     && (! defined __cplusplus \
         || (defined EDIFSTYPE_IS_TRIVIAL && EDIFSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union edifalloc
{
  edif_state_t edifss_alloc;
  EDIFSTYPE edifvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define EDIFSTACK_GAP_MAXIMUM (EDIFSIZEOF (union edifalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define EDIFSTACK_BYTES(N) \
     ((N) * (EDIFSIZEOF (edif_state_t) + EDIFSIZEOF (EDIFSTYPE)) \
      + EDIFSTACK_GAP_MAXIMUM)

# define EDIFCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables EDIFSIZE and EDIFSTACKSIZE give the old and new number of
   elements in the stack, and EDIFPTR gives the new location of the
   stack.  Advance EDIFPTR to a properly aligned location for the next
   stack.  */
# define EDIFSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        EDIFPTRDIFF_T edifnewbytes;                                         \
        EDIFCOPY (&edifptr->Stack_alloc, Stack, edifsize);                    \
        Stack = &edifptr->Stack_alloc;                                    \
        edifnewbytes = edifstacksize * EDIFSIZEOF (*Stack) + EDIFSTACK_GAP_MAXIMUM; \
        edifptr += edifnewbytes / EDIFSIZEOF (*edifptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined EDIFCOPY_NEEDED && EDIFCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef EDIFCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define EDIFCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, EDIF_CAST (EDIFSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define EDIFCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          EDIFPTRDIFF_T edifi;                      \
          for (edifi = 0; edifi < (Count); edifi++)   \
            (Dst)[edifi] = (Src)[edifi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !EDIFCOPY_NEEDED */

/* EDIFFINAL -- State number of the termination state.  */
#define EDIFFINAL  7
/* EDIFLAST -- Last index in EDIFTABLE.  */
#define EDIFLAST   217

/* EDIFNTOKENS -- Number of terminals.  */
#define EDIFNTOKENS  47
/* EDIFNNTS -- Number of nonterminals.  */
#define EDIFNNTS  70
/* EDIFNRULES -- Number of rules.  */
#define EDIFNRULES  115
/* EDIFNSTATES -- Number of states.  */
#define EDIFNSTATES  225

/* EDIFMAXUTOK -- Last valid token kind.  */
#define EDIFMAXUTOK   300


/* EDIFTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by ediflex, with out-of-bounds checking.  */
#define EDIFTRANSLATE(EDIFX)                                \
  (0 <= (EDIFX) && (EDIFX) <= EDIFMAXUTOK                     \
   ? EDIF_CAST (edifsymbol_kind_t, ediftranslate[EDIFX])        \
   : EDIFSYMBOL_EDIFUNDEF)

/* EDIFTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by ediflex.  */
static const ediftype_int8 ediftranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if EDIFDEBUG
/* EDIFRLINE[EDIFN] -- Source line where rule number EDIFN was defined.  */
static const ediftype_int16 edifrline[] =
{
       0,   127,   127,   131,   142,   155,   157,   161,   164,   166,
     170,   175,   174,   213,   215,   219,   220,   224,   232,   235,
     237,   241,   242,   248,   250,   254,   257,   259,   263,   268,
     267,   410,   411,   412,   418,   420,   424,   425,   429,   433,
     435,   441,   448,   450,   454,   455,   459,   465,   467,   471,
     472,   477,   476,   504,   505,   508,   510,   514,   521,   525,
     532,   537,   536,   553,   552,   610,   612,   616,   620,   623,
     625,   629,   630,   635,   634,   654,   656,   660,   696,   769,
     772,   774,   778,   782,   811,   858,   894,   952,   955,   957,
     961,   962,   963,   967,   974,  1009,  1011,  1015,  1016,  1020,
    1024,  1028,  1036,  1037,  1042,  1043,  1047,  1051,  1058,  1062,
    1069,  1076,  1079,  1081,  1085,  1089
};
#endif

/** Accessing symbol of state STATE.  */
#define EDIF_ACCESSING_SYMBOL(State) EDIF_CAST (edifsymbol_kind_t, edifstos[State])

#if EDIFDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   EDIFSYMBOL.  No bounds checking.  */
static const char *edifsymbol_name (edifsymbol_kind_t edifsymbol) EDIF_ATTRIBUTE_UNUSED;

/* EDIFTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at EDIFNTOKENS, nonterminals.  */
static const char *const ediftname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_EDIF",
  "T_EDIFVERSION", "T_EDIFLEVEL", "T_TECHNOLOGY", "T_CELLTYPE",
  "T_CELLTYPE_GENERIC", "T_CELLTYPE_TIE", "T_CELLTYPE_RIPPER",
  "T_PROPERTY", "T_VIEWTYPE", "T_INTERFACE", "T_CONTENTS", "T_JOINED",
  "T_INSTANCE", "T_VIEWREF", "T_PORT", "T_DIRECTION", "T_INOUT",
  "T_PORTREF", "T_NETLIST", "T_KEYWORDMAP", "T_KEYWORDLEVEL", "T_EXTERNAL",
  "T_LIBRARYREF", "T_OUTPUT", "T_INSTANCEREF", "T_MEMBER", "T_RENAME",
  "T_NAME", "T_STRING", "T_PORTINSTANCE", "T_LIBRARY", "T_CELL", "T_VIEW",
  "T_NET", "T_CELLREF", "T_INPUT", "T_STATUS", "T_IDENT", "T_ARRAY",
  "T_RENAME_STRING", "T_PORTLIST", "T_INTEGER", "')'", "$accept", "r_edif",
  "r_edifversion", "r_ediflevel", "l_externals", "r_external",
  "l_finexternal", "r_finexternal", "r_extcell", "$@1", "l_finextcell",
  "r_finextcell", "r_extview", "r_extinterface", "l_finextinterf",
  "r_finextinterf", "l_finedif", "r_library", "l_finlibrary",
  "r_finlibrary", "r_cell", "$@2", "r_celltype", "l_fincell", "r_fincell",
  "r_property", "r_opt_property", "r_view", "l_finview", "r_finview",
  "r_contents", "l_fincontents", "r_fincontents", "r_instance", "$@3",
  "r_viewref", "l_portinstance", "r_portinstance", "r_cellref",
  "r_libraryref", "r_net", "$@4", "$@5", "l_finnet", "r_finnet",
  "r_array_joined", "l_array_joined", "r_portlist", "$@6",
  "l_list_portref", "r_array_portref", "r_joined", "l_finjoined",
  "r_finjoined", "r_portref", "r_interface", "l_fininterface",
  "r_fininterface", "r_port", "l_finport", "r_finport", "r_direction",
  "l_anything", "r_anything", "r_namedef", "r_name", "r_port_joined",
  "l_finport_joined", "r_finport_joined", "r_shorted_portref", EDIF_NULLPTR
};

static const char *
edifsymbol_name (edifsymbol_kind_t edifsymbol)
{
  return ediftname[edifsymbol];
}
#endif

#define EDIFPACT_NINF (-62)

#define edifpact_value_is_default(Yyn) \
  ((Yyn) == EDIFPACT_NINF)

#define EDIFTABLE_NINF (-1)

#define ediftable_value_is_error(Yyn) \
  0

/* EDIFPACT[STATE-NUM] -- Index in EDIFTABLE of the portion describing
   STATE-NUM.  */
static const ediftype_int16 edifpact[] =
{
      16,    81,    22,    88,   -62,   -62,    64,   -62,    24,    40,
      58,    57,    79,    23,    78,    84,    59,    76,   -62,   -62,
     -62,   -62,    80,    89,   111,    91,   -62,    81,   -62,    21,
     -62,    79,    81,   -62,   -62,   -62,    79,    29,   -62,    81,
     -62,   -62,   -62,    63,   -62,    81,   -62,   -62,   -62,   131,
     -62,   124,   -62,   131,    94,    95,    96,    -7,   -62,   -62,
     -62,   -62,   -62,    81,   -62,   -62,   -62,   -62,    -6,    41,
     132,    81,   -62,   -62,   -62,   -62,   -62,    44,   -62,   -62,
     123,   135,   -62,   102,   127,   137,   105,   -62,   106,   140,
      -3,   -62,   -62,   -62,    73,   -62,   -62,   -62,   -62,    -9,
      -4,    81,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   109,     1,     3,    -5,   110,    39,
     -62,   -62,   -62,   -62,    81,   -62,   -62,   -62,    81,    75,
     -62,   -62,   -62,   -62,   -62,   112,   113,   114,   115,   138,
      81,   -62,     2,   -62,   -62,   -62,   -62,    81,   151,   118,
     149,   -62,    61,   -62,   -62,   119,   -62,   -62,    81,   -62,
     120,   -62,   -62,     4,     5,    27,   -62,   134,    13,    47,
     -62,   -62,   -62,   -62,   -62,   -62,    81,   -62,   125,    81,
     -62,    50,   -62,    81,   -62,   -62,   -62,   -62,    81,    26,
     126,   -62,   -62,   -62,    12,    33,   -62,     6,   128,    81,
     -62,   -62,    67,   -62,   -62,    81,   -62,    14,   -62,   130,
     133,   -62,   139,   -62,   -62,    35,   142,   143,    81,   -62,
     -62,   -62,   144,   145,   -62
};

/* EDIFDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when EDIFTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const ediftype_int8 edifdefact[] =
{
       0,     0,     0,     0,   106,   107,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,   110,
     108,   109,     0,     0,    23,     0,     4,     0,     6,     0,
       3,     0,     0,     2,    24,     8,     0,     0,    26,     0,
       7,     9,    10,     0,    11,     0,    25,    27,    28,     0,
      29,     0,    13,     0,     0,     0,     0,     0,    34,    31,
      32,    33,   102,     0,    12,    14,    15,    16,     0,     0,
       0,     0,    30,    35,    37,    36,    38,     0,   103,   105,
       0,     0,   104,     0,     0,     0,     0,    19,     0,     0,
       0,    17,    88,    42,     0,    18,    20,    22,    21,     0,
       0,     0,    95,   112,    87,    92,    89,    90,    91,    47,
      41,    45,    43,    44,     0,     0,     0,     0,     0,     0,
      93,    98,    96,    97,     0,   111,   113,   114,     0,     0,
      46,    48,    49,    50,    95,     0,     0,     0,     0,     0,
       0,    61,     0,    99,   101,   100,   115,     0,    39,     0,
       0,    94,     0,    40,    51,     0,    80,    65,     0,    53,
       0,    55,    63,     0,     0,     0,    54,   102,     0,     0,
      79,    81,    82,    62,    67,    66,     0,    58,     0,     0,
      56,     0,    69,     0,    73,    65,    72,    71,     0,     0,
       0,    59,   102,    52,     0,     0,    75,     0,     0,     0,
      83,    60,     0,    68,    70,     0,    77,     0,    64,     0,
       0,    57,     0,    74,    76,     0,     0,     0,     0,    85,
      84,    78,     0,     0,    86
};

/* EDIFPGOTO[NTERM-NUM].  */
static const ediftype_int8 edifpgoto[] =
{
     -62,   -62,   -62,   -13,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   116,   -62,   -62,   -54,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -15,   -62,   -20,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -30,   -62,   -62,   -62,    82,    46,
     -62,   -62,   -61,   -62,    -1,   -62,   -62,   -62,   -62,   -62
};

/* EDIFDEFGOTO[NTERM-NUM].  */
static const ediftype_uint8 edifdefgoto[] =
{
       0,     2,    12,    18,    24,    28,    37,    41,    42,    49,
      57,    65,    66,    88,    90,    96,    29,    34,    43,    47,
      48,    53,    52,    68,    73,   121,   154,    75,   100,   112,
     113,   117,   131,   132,   161,   148,   167,   180,   160,   178,
     133,   150,   168,   164,   175,   185,   194,   186,   196,   207,
     187,   157,   163,   171,   172,    93,    99,   106,    98,   115,
     122,   123,    77,    78,    79,    10,   108,   116,   126,   127
};

/* EDIFTABLE[EDIFPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If EDIFTABLE_NINF, syntax error.  */
static const ediftype_uint8 ediftable[] =
{
       6,    69,    62,    67,    62,    62,   103,    62,    62,    94,
     109,   128,    62,    62,    74,    94,    62,    62,    35,     1,
     119,   119,     7,    38,   124,   169,    31,   182,   182,    63,
      71,    36,   129,   183,   183,   169,    97,   104,    44,    64,
      72,   130,   110,    95,    50,   105,   111,   120,   151,   125,
     170,   173,   208,   176,   199,    32,   184,   184,   203,   135,
     213,   205,    70,   218,    39,    13,   136,    33,    11,    19,
      81,     3,   200,   177,     3,    40,   188,     3,   137,   206,
       3,   219,     4,    14,    17,     4,     5,    76,     4,     5,
      82,     4,     5,   102,   153,     5,   193,     3,    45,   158,
     114,    15,    16,     3,    22,     3,   181,   159,     4,    46,
     174,     3,     5,   211,     4,   101,     4,   140,     5,     8,
       5,    23,     4,   138,    20,    25,     5,   139,   141,     9,
      21,   202,    54,    55,    56,    26,    27,    30,    51,   149,
      59,    60,    61,   174,    80,    83,   152,    84,    85,    86,
      87,    89,    91,    92,   118,   147,   134,   165,   143,   144,
     145,   146,    62,   155,   156,   162,   166,   179,   189,    58,
     197,   191,   201,   209,   204,   190,   215,   214,   192,   216,
     142,   107,   195,     0,     0,   217,     0,   198,   220,   221,
     223,   224,     0,     0,     0,     0,     0,     0,   210,     0,
       0,     0,     0,     0,   212,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222
};

static const ediftype_int16 edifcheck[] =
{
       1,    62,    11,    57,    11,    11,    15,    11,    11,    18,
      14,    16,    11,    11,    68,    18,    11,    11,    31,     3,
      19,    19,     0,    36,    21,    21,    27,    15,    15,    36,
      36,    32,    37,    21,    21,    21,    90,    46,    39,    46,
      46,    46,    46,    46,    45,    99,   100,    46,    46,    46,
      46,    46,    46,    26,    28,    34,    44,    44,    46,    20,
      46,    28,    63,    28,    35,    41,    27,    46,     4,    46,
      71,    30,    46,    46,    30,    46,    29,    30,    39,    46,
      30,    46,    41,    43,     5,    41,    45,    46,    41,    45,
      46,    41,    45,    94,   148,    45,    46,    30,    35,    38,
     101,    43,    45,    30,    45,    30,   167,    46,    41,    46,
     164,    30,    45,    46,    41,    42,    41,    42,    45,    31,
      45,    45,    41,   124,    46,    45,    45,   128,   129,    41,
      46,   192,     8,     9,    10,    46,    25,    46,     7,   140,
      46,    46,    46,   197,    12,    22,   147,    12,    46,    22,
      13,    46,    46,    13,    45,    17,    46,   158,    46,    46,
      46,    46,    11,    45,    15,    46,    46,    33,   169,    53,
     185,    46,    46,    45,   194,   176,    46,   207,   179,    46,
     134,    99,   183,    -1,    -1,    46,    -1,   188,    46,    46,
      46,    46,    -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218
};

/* EDIFSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const ediftype_int8 edifstos[] =
{
       0,     3,    48,    30,    41,    45,   111,     0,    31,    41,
     112,     4,    49,    41,    43,    43,    45,     5,    50,    46,
      46,    46,    45,    45,    51,    45,    46,    25,    52,    63,
      46,   111,    34,    46,    64,    50,   111,    53,    50,    35,
      46,    54,    55,    65,   111,    35,    46,    66,    67,    56,
     111,     7,    69,    68,     8,     9,    10,    57,    69,    46,
      46,    46,    11,    36,    46,    58,    59,    72,    70,   109,
     111,    36,    46,    71,    72,    74,    46,   109,   110,   111,
      12,   111,    46,    22,    12,    46,    22,    13,    60,    46,
      61,    46,    13,   102,    18,    46,    62,    72,   105,   103,
      75,    42,   111,    15,    46,    72,   104,   105,   113,    14,
      46,    72,    76,    77,   111,   106,   114,    78,    45,    19,
      46,    72,   107,   108,    21,    46,   115,   116,    16,    37,
      46,    79,    80,    87,    46,    20,    27,    39,   111,   111,
      42,   111,   106,    46,    46,    46,    46,    17,    82,   111,
      88,    46,   111,    72,    73,    45,    15,    98,    38,    46,
      85,    81,    46,    99,    90,   111,    46,    83,    89,    21,
      46,   100,   101,    46,    72,    91,    26,    46,    86,    33,
      84,   109,    15,    21,    44,    92,    94,    97,    29,   111,
     111,    46,   111,    46,    93,   111,    95,    90,   111,    28,
      46,    46,   109,    46,    92,    28,    46,    96,    46,    45,
     111,    46,   111,    46,   101,    46,    46,    46,    28,    46,
      46,    46,   111,    46,    46
};

/* EDIFR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const ediftype_int8 edifr1[] =
{
       0,    47,    48,    49,    50,    51,    51,    52,    53,    53,
      54,    56,    55,    57,    57,    58,    58,    59,    60,    61,
      61,    62,    62,    63,    63,    64,    65,    65,    66,    68,
      67,    69,    69,    69,    70,    70,    71,    71,    72,    73,
      73,    74,    75,    75,    76,    76,    77,    78,    78,    79,
      79,    81,    80,    82,    82,    83,    83,    84,    85,    85,
      86,    88,    87,    89,    87,    90,    90,    91,    92,    93,
      93,    92,    92,    95,    94,    96,    96,    97,    97,    98,
      99,    99,   100,   101,   101,   101,   101,   102,   103,   103,
     104,   104,   104,   105,   105,   106,   106,   107,   107,   108,
     108,   108,   109,   109,   110,   110,   111,   111,   111,   111,
     112,   113,   114,   114,   115,   116
};

/* EDIFR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const ediftype_int8 edifr2[] =
{
       0,     2,     7,     5,     3,     0,     2,     5,     0,     2,
       1,     0,     6,     0,     2,     1,     1,     7,     3,     0,
       2,     1,     1,     0,     2,     5,     0,     2,     1,     0,
       6,     3,     3,     3,     0,     2,     1,     1,     3,     0,
       1,     8,     0,     2,     1,     1,     3,     0,     2,     1,
       1,     0,     8,     3,     4,     0,     2,     4,     3,     4,
       3,     0,     6,     0,     9,     0,     2,     1,     3,     0,
       2,     1,     1,     0,     4,     0,     2,     3,     6,     3,
       0,     2,     1,     3,     6,     6,     9,     3,     0,     2,
       1,     1,     1,     4,     7,     0,     2,     1,     1,     3,
       3,     3,     0,     2,     2,     1,     1,     1,     4,     4,
       3,     3,     0,     2,     1,     3
};


enum { EDIFENOMEM = -2 };

#define ediferrok         (ediferrstatus = 0)
#define edifclearin       (edifchar = EDIFEMPTY)

#define EDIFACCEPT        goto edifacceptlab
#define EDIFABORT         goto edifabortlab
#define EDIFERROR         goto ediferrorlab
#define EDIFNOMEM         goto edifexhaustedlab


#define EDIFRECOVERING()  (!!ediferrstatus)

#define EDIFBACKUP(Token, Value)                                    \
  do                                                              \
    if (edifchar == EDIFEMPTY)                                        \
      {                                                           \
        edifchar = (Token);                                         \
        ediflval = (Value);                                         \
        EDIFPOPSTACK (ediflen);                                       \
        edifstate = *edifssp;                                         \
        goto edifbackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        ediferror (EDIF_("syntax error: cannot back up")); \
        EDIFERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use EDIFerror or EDIFUNDEF. */
#define EDIFERRCODE EDIFUNDEF


/* Enable debugging if requested.  */
#if EDIFDEBUG

# ifndef EDIFFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define EDIFFPRINTF fprintf
# endif

# define EDIFDPRINTF(Args)                        \
do {                                            \
  if (edifdebug)                                  \
    EDIFFPRINTF Args;                             \
} while (0)




# define EDIF_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (edifdebug)                                                            \
    {                                                                     \
      EDIFFPRINTF (stderr, "%s ", Title);                                   \
      edif_symbol_print (stderr,                                            \
                  Kind, Value); \
      EDIFFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on EDIFO.  |
`-----------------------------------*/

static void
edif_symbol_value_print (FILE *edifo,
                       edifsymbol_kind_t edifkind, EDIFSTYPE const * const edifvaluep)
{
  FILE *edifoutput = edifo;
  EDIF_USE (edifoutput);
  if (!edifvaluep)
    return;
  EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  EDIF_USE (edifkind);
  EDIF_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on EDIFO.  |
`---------------------------*/

static void
edif_symbol_print (FILE *edifo,
                 edifsymbol_kind_t edifkind, EDIFSTYPE const * const edifvaluep)
{
  EDIFFPRINTF (edifo, "%s %s (",
             edifkind < EDIFNTOKENS ? "token" : "nterm", edifsymbol_name (edifkind));

  edif_symbol_value_print (edifo, edifkind, edifvaluep);
  EDIFFPRINTF (edifo, ")");
}

/*------------------------------------------------------------------.
| edif_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
edif_stack_print (edif_state_t *edifbottom, edif_state_t *ediftop)
{
  EDIFFPRINTF (stderr, "Stack now");
  for (; edifbottom <= ediftop; edifbottom++)
    {
      int edifbot = *edifbottom;
      EDIFFPRINTF (stderr, " %d", edifbot);
    }
  EDIFFPRINTF (stderr, "\n");
}

# define EDIF_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (edifdebug)                                                  \
    edif_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the EDIFRULE is going to be reduced.  |
`------------------------------------------------*/

static void
edif_reduce_print (edif_state_t *edifssp, EDIFSTYPE *edifvsp,
                 int edifrule)
{
  int ediflno = edifrline[edifrule];
  int edifnrhs = edifr2[edifrule];
  int edifi;
  EDIFFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             edifrule - 1, ediflno);
  /* The symbols being reduced.  */
  for (edifi = 0; edifi < edifnrhs; edifi++)
    {
      EDIFFPRINTF (stderr, "   $%d = ", edifi + 1);
      edif_symbol_print (stderr,
                       EDIF_ACCESSING_SYMBOL (+edifssp[edifi + 1 - edifnrhs]),
                       &edifvsp[(edifi + 1) - (edifnrhs)]);
      EDIFFPRINTF (stderr, "\n");
    }
}

# define EDIF_REDUCE_PRINT(Rule)          \
do {                                    \
  if (edifdebug)                          \
    edif_reduce_print (edifssp, edifvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int edifdebug;
#else /* !EDIFDEBUG */
# define EDIFDPRINTF(Args) ((void) 0)
# define EDIF_SYMBOL_PRINT(Title, Kind, Value, Location)
# define EDIF_STACK_PRINT(Bottom, Top)
# define EDIF_REDUCE_PRINT(Rule)
#endif /* !EDIFDEBUG */


/* EDIFINITDEPTH -- initial size of the parser's stacks.  */
#ifndef EDIFINITDEPTH
# define EDIFINITDEPTH 200
#endif

/* EDIFMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   EDIFSTACK_ALLOC_MAXIMUM < EDIFSTACK_BYTES (EDIFMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef EDIFMAXDEPTH
# define EDIFMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
edifdestruct (const char *edifmsg,
            edifsymbol_kind_t edifkind, EDIFSTYPE *edifvaluep)
{
  EDIF_USE (edifvaluep);
  if (!edifmsg)
    edifmsg = "Deleting";
  EDIF_SYMBOL_PRINT (edifmsg, edifkind, edifvaluep, ediflocationp);

  EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  EDIF_USE (edifkind);
  EDIF_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int edifchar;

/* The semantic value of the lookahead symbol.  */
EDIFSTYPE ediflval;
/* Number of syntax errors so far.  */
int edifnerrs;




/*----------.
| edifparse.  |
`----------*/

int
edifparse (void)
{
    edif_state_fast_t edifstate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int ediferrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow edifoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    EDIFPTRDIFF_T edifstacksize = EDIFINITDEPTH;

    /* The state stack: array, bottom, top.  */
    edif_state_t edifssa[EDIFINITDEPTH];
    edif_state_t *edifss = edifssa;
    edif_state_t *edifssp = edifss;

    /* The semantic value stack: array, bottom, top.  */
    EDIFSTYPE edifvsa[EDIFINITDEPTH];
    EDIFSTYPE *edifvs = edifvsa;
    EDIFSTYPE *edifvsp = edifvs;

  int edifn;
  /* The return value of edifparse.  */
  int edifresult;
  /* Lookahead symbol kind.  */
  edifsymbol_kind_t ediftoken = EDIFSYMBOL_EDIFEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  EDIFSTYPE edifval;



#define EDIFPOPSTACK(N)   (edifvsp -= (N), edifssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int ediflen = 0;

  EDIFDPRINTF ((stderr, "Starting parse\n"));

  edifchar = EDIFEMPTY; /* Cause a token to be read.  */

  goto edifsetstate;


/*------------------------------------------------------------.
| edifnewstate -- push a new state, which is found in edifstate.  |
`------------------------------------------------------------*/
edifnewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  edifssp++;


/*--------------------------------------------------------------------.
| edifsetstate -- set current state (the top of the stack) to edifstate.  |
`--------------------------------------------------------------------*/
edifsetstate:
  EDIFDPRINTF ((stderr, "Entering state %d\n", edifstate));
  EDIF_ASSERT (0 <= edifstate && edifstate < EDIFNSTATES);
  EDIF_IGNORE_USELESS_CAST_BEGIN
  *edifssp = EDIF_CAST (edif_state_t, edifstate);
  EDIF_IGNORE_USELESS_CAST_END
  EDIF_STACK_PRINT (edifss, edifssp);

  if (edifss + edifstacksize - 1 <= edifssp)
#if !defined edifoverflow && !defined EDIFSTACK_RELOCATE
    EDIFNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      EDIFPTRDIFF_T edifsize = edifssp - edifss + 1;

# if defined edifoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        edif_state_t *edifss1 = edifss;
        EDIFSTYPE *edifvs1 = edifvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if edifoverflow is a macro.  */
        edifoverflow (EDIF_("memory exhausted"),
                    &edifss1, edifsize * EDIFSIZEOF (*edifssp),
                    &edifvs1, edifsize * EDIFSIZEOF (*edifvsp),
                    &edifstacksize);
        edifss = edifss1;
        edifvs = edifvs1;
      }
# else /* defined EDIFSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (EDIFMAXDEPTH <= edifstacksize)
        EDIFNOMEM;
      edifstacksize *= 2;
      if (EDIFMAXDEPTH < edifstacksize)
        edifstacksize = EDIFMAXDEPTH;

      {
        edif_state_t *edifss1 = edifss;
        union edifalloc *edifptr =
          EDIF_CAST (union edifalloc *,
                   EDIFSTACK_ALLOC (EDIF_CAST (EDIFSIZE_T, EDIFSTACK_BYTES (edifstacksize))));
        if (! edifptr)
          EDIFNOMEM;
        EDIFSTACK_RELOCATE (edifss_alloc, edifss);
        EDIFSTACK_RELOCATE (edifvs_alloc, edifvs);
#  undef EDIFSTACK_RELOCATE
        if (edifss1 != edifssa)
          EDIFSTACK_FREE (edifss1);
      }
# endif

      edifssp = edifss + edifsize - 1;
      edifvsp = edifvs + edifsize - 1;

      EDIF_IGNORE_USELESS_CAST_BEGIN
      EDIFDPRINTF ((stderr, "Stack size increased to %ld\n",
                  EDIF_CAST (long, edifstacksize)));
      EDIF_IGNORE_USELESS_CAST_END

      if (edifss + edifstacksize - 1 <= edifssp)
        EDIFABORT;
    }
#endif /* !defined edifoverflow && !defined EDIFSTACK_RELOCATE */


  if (edifstate == EDIFFINAL)
    EDIFACCEPT;

  goto edifbackup;


/*-----------.
| edifbackup.  |
`-----------*/
edifbackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  edifn = edifpact[edifstate];
  if (edifpact_value_is_default (edifn))
    goto edifdefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* EDIFCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (edifchar == EDIFEMPTY)
    {
      EDIFDPRINTF ((stderr, "Reading a token\n"));
      edifchar = ediflex ();
    }

  if (edifchar <= EDIFEOF)
    {
      edifchar = EDIFEOF;
      ediftoken = EDIFSYMBOL_EDIFEOF;
      EDIFDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (edifchar == EDIFerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      edifchar = EDIFUNDEF;
      ediftoken = EDIFSYMBOL_EDIFerror;
      goto ediferrlab1;
    }
  else
    {
      ediftoken = EDIFTRANSLATE (edifchar);
      EDIF_SYMBOL_PRINT ("Next token is", ediftoken, &ediflval, &ediflloc);
    }

  /* If the proper action on seeing token EDIFTOKEN is to reduce or to
     detect an error, take that action.  */
  edifn += ediftoken;
  if (edifn < 0 || EDIFLAST < edifn || edifcheck[edifn] != ediftoken)
    goto edifdefault;
  edifn = ediftable[edifn];
  if (edifn <= 0)
    {
      if (ediftable_value_is_error (edifn))
        goto ediferrlab;
      edifn = -edifn;
      goto edifreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (ediferrstatus)
    ediferrstatus--;

  /* Shift the lookahead token.  */
  EDIF_SYMBOL_PRINT ("Shifting", ediftoken, &ediflval, &ediflloc);
  edifstate = edifn;
  EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++edifvsp = ediflval;
  EDIF_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  edifchar = EDIFEMPTY;
  goto edifnewstate;


/*-----------------------------------------------------------.
| edifdefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
edifdefault:
  edifn = edifdefact[edifstate];
  if (edifn == 0)
    goto ediferrlab;
  goto edifreduce;


/*-----------------------------.
| edifreduce -- do a reduction.  |
`-----------------------------*/
edifreduce:
  /* edifn is the number of a rule to reduce with.  */
  ediflen = edifr2[edifn];

  /* If EDIFLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets EDIFVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to EDIFVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that EDIFVAL may be used uninitialized.  */
  edifval = edifvsp[1-ediflen];


  EDIF_REDUCE_PRINT (edifn);
  switch (edifn)
    {
  case 3: /* r_edifversion: T_EDIFVERSION T_INTEGER T_INTEGER T_INTEGER ')'  */
#line 132 "./parser_y.y"
                { 
			if (((edifvsp[-3].lval) != 2) || ((edifvsp[-2].lval) != 0) || ((edifvsp[-1].lval) != 0))
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : unable to read this version of edif.\n");
				exit (1);
			}
		}
#line 1563 "y.tab.c"
    break;

  case 4: /* r_ediflevel: T_EDIFLEVEL T_INTEGER ')'  */
#line 143 "./parser_y.y"
                { 
			if ((edifvsp[-1].lval) != 0)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : EdifLevel incorrect ( must be 0 ).\n");
				exit (1);
			}
		}
#line 1575 "y.tab.c"
    break;

  case 11: /* $@1: %empty  */
#line 175 "./parser_y.y"
                {
			lofig_list *ptf;
			char       *cell_name;
                        
        
			cell_name = namealloc((edifvsp[0].sval));
                        
			if( !( ptf = get_figure_pt( cell_name ) ) )  
			{
				EDIF_PTFIG = addlofig( cell_name );
				EDIF_NOLOAD_FIG = 0; 
				EDIF_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == EDIF_FIGNAME )
					EDIF_PTFIG = EDIF_LOFIG;
				else
					EDIF_PTFIG = ptf;

				EDIF_BASE_CELL = incatalog( cell_name );

				if( (ptf->LOCON && EDIF_BASE_CELL) || ptf->LOSIG )
					EDIF_NOLOAD_FIG = 1; 
				else
					EDIF_NOLOAD_FIG = 0; 

				EDIF_NOLOAD_LOCON = ( ptf->LOCON ) ? 1 : 0;

			}
			EDIF_INDEX = 0;
		}
#line 1612 "y.tab.c"
    break;

  case 12: /* r_extcell: T_CELL r_namedef $@1 r_celltype l_finextcell ')'  */
#line 208 "./parser_y.y"
                {
			EDIF_PTFIG->MODE = 'A';
		}
#line 1620 "y.tab.c"
    break;

  case 17: /* r_extview: T_VIEW r_namedef T_VIEWTYPE T_NETLIST ')' r_extinterface ')'  */
#line 225 "./parser_y.y"
                {
			if( EDIF_BASE_CELL && EDIF_PTFIG == EDIF_LOFIG )
				EDIF_BLACKBOX = 'Y';
		}
#line 1629 "y.tab.c"
    break;

  case 29: /* $@2: %empty  */
#line 268 "./parser_y.y"
                { 
			lofig_list      *ptf;
			char            *cell_name;
                        
			cell_name = namealloc((edifvsp[0].sval));

			EDIF_BASE_CELL = 0;

			if (!(ptf = get_figure_pt(cell_name)))
			{
				EDIF_PTFIG = addlofig ((edifvsp[0].sval));
				EDIF_NOLOAD_FIG = 0;
				EDIF_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == EDIF_FIGNAME )
					EDIF_PTFIG = EDIF_LOFIG;
				else
					EDIF_PTFIG = ptf;

				EDIF_BASE_CELL = incatalog( cell_name );

				if( (ptf->LOCON && EDIF_BASE_CELL) || ptf->LOSIG )
					EDIF_NOLOAD_FIG = 1; 
				else
					EDIF_NOLOAD_FIG = 0; 

				EDIF_NOLOAD_LOCON = (ptf->LOCON) ? 1 : 0;
			}
			EDIF_INDEX = 0;
		}
#line 1666 "y.tab.c"
    break;

  case 30: /* r_cell: T_CELL r_namedef $@2 r_celltype l_fincell ')'  */
#line 301 "./parser_y.y"
                {
			loins_list *inst_pt;

			if (EDIF_NOLOAD_FIG == 0)
			{
				char        new_sig_name[MAXSTRLEN];
				locon_list *EDIF_INS_PTCON  = (locon_list *) NULL;
				locon_list *EDIF_PTCON      = (locon_list *) NULL;
                losig_list *sigvss        = NULL;
                losig_list *sigvdd        = NULL;
                locon_list *ptlocon;

                for( ptlocon = EDIF_PTFIG->LOCON; ptlocon; ptlocon = ptlocon->NEXT )
                {
                    if( isvss( ptlocon->NAME ) || isvdd( ptlocon->NAME ) )
                    {
                        break;
                    }
                }

                if( !ptlocon )
                {
                    sigvss = addlosig (EDIF_PTFIG,
                                       ++EDIF_INDEX,
                                       addchain( NULL, namealloc( VSS ) ),
                                       EXTERNAL );
                    sigvdd = addlosig (EDIF_PTFIG,
                                       ++EDIF_INDEX,
                                       addchain( NULL, namealloc( VDD ) ),
                                       EXTERNAL );
                    addlocon( EDIF_PTFIG, namealloc( VDD ), sigvdd, IN );
                    addlocon( EDIF_PTFIG, namealloc( VSS ), sigvss, IN );
                }
				/* scan all instances */
				for( EDIF_PTINS = EDIF_PTFIG->LOINS; EDIF_PTINS; EDIF_PTINS=EDIF_PTINS->NEXT ) 
				{
					if( EDIF_PTINS->FIGNAME != EDIF_RIPPER_CELL )
					{
						for (EDIF_INS_PTCON  = EDIF_PTINS->LOCON; 
						     EDIF_INS_PTCON != (locon_list *) NULL;
						     EDIF_INS_PTCON  = EDIF_INS_PTCON->NEXT)
						{
                            if( isvss( EDIF_INS_PTCON->NAME ) )
                            {
                                EDIF_INS_PTCON->SIG = sigvss;
                            }
                            if( isvdd( EDIF_INS_PTCON->NAME ) )
                            {
                                EDIF_INS_PTCON->SIG = sigvdd;
                            }
							if (EDIF_INS_PTCON->SIG == NULL)
							{
								sprintf(new_sig_name,"unused_%d",++EDIF_INDEX);
								if ( EDIF_PTINS->USER == (struct ptype *) NULL ||
								    !is_portinstance( EDIF_PTINS, EDIF_INS_PTCON->NAME ) )
								{
									fprintf (stderr, "*** mbk warning *** edifloadlofig :\n");
									fprintf (stderr, "Connector '%s' ",EDIF_INS_PTCON->NAME);
									fprintf (stderr, "of instance '%s' ",EDIF_PTINS->INSNAME);
									fprintf (stderr, "has no signal in figure ");
									fprintf (stderr, "'%s'.\n",EDIF_PTFIG->NAME);
									fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 
								}
	
								EDIF_INS_PTCON->SIG = addlosig (EDIF_PTFIG, EDIF_INDEX,
								                              addchain( NULL, namealloc( new_sig_name ) ),
									                              INTERNAL );
							}
						}
					}


					/* scan all figure's connectors */
					for  (EDIF_PTCON  = EDIF_PTFIG->LOCON; 
					      EDIF_PTCON != (locon_list *) NULL;
					      EDIF_PTCON  = EDIF_PTCON->NEXT)
					{
						if (EDIF_PTCON->SIG == NULL) 
						{
							sprintf(new_sig_name,"unused_%d",++EDIF_INDEX);

							fprintf (stderr, "*** mbk warning *** ");
							fprintf (stderr, "edifloadlofig : \n");
							fprintf (stderr, "connector '%s' ",EDIF_PTCON->NAME);
							fprintf (stderr, "of figure '%s' ",EDIF_PTFIG->NAME);
							fprintf (stderr, "has no signal\n");
							fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 

							EDIF_PTCON->SIG = addlosig (EDIF_PTFIG, EDIF_INDEX,
							                          addchain( NULL, namealloc( new_sig_name ) ),
							                          EXTERNAL );

						}
					}
				}
			}
			/* free all instance->USER that are filled with chain_list data */
			for( inst_pt = EDIF_PTFIG->LOINS; inst_pt; inst_pt=inst_pt->NEXT )
			{
				if( inst_pt->USER != (struct ptype *)NULL )
				{
					freechain( (chain_list *)inst_pt->USER );
					inst_pt->USER = (struct ptype *)NULL;
				}
			}
		}
#line 1777 "y.tab.c"
    break;

  case 33: /* r_celltype: T_CELLTYPE T_CELLTYPE_RIPPER ')'  */
#line 413 "./parser_y.y"
                {
			EDIF_RIPPER_CELL = EDIF_PTFIG->NAME;
		}
#line 1785 "y.tab.c"
    break;

  case 39: /* r_opt_property: %empty  */
#line 433 "./parser_y.y"
          {
          }
#line 1792 "y.tab.c"
    break;

  case 40: /* r_opt_property: r_property  */
#line 436 "./parser_y.y"
          {
          }
#line 1799 "y.tab.c"
    break;

  case 41: /* r_view: T_VIEW r_namedef T_VIEWTYPE T_NETLIST ')' r_interface l_finview ')'  */
#line 442 "./parser_y.y"
                {
			if( EDIF_BASE_CELL && EDIF_PTFIG == EDIF_LOFIG )
				EDIF_BLACKBOX = 'Y';
		}
#line 1808 "y.tab.c"
    break;

  case 46: /* r_contents: T_CONTENTS l_fincontents ')'  */
#line 460 "./parser_y.y"
                { 
			EDIF_PTFIG->MODE = 'A';
		}
#line 1816 "y.tab.c"
    break;

  case 51: /* $@3: %empty  */
#line 477 "./parser_y.y"
                {
			if( EDIF_NOLOAD_FIG == 0 )
			{
				lofig_list *EDIF_INS_PTMODEL  = (lofig_list *) NULL;
				chain_list *EDIF_INS_SIGCHAIN = (chain_list *) NULL;
				locon_list *EDIF_INS_PTCON    = (locon_list *) NULL;

				EDIF_INS_PTMODEL = getlofig( EDIF_INS_MODELNAME, 'P' );
				EDIF_INS_SIGCHAIN = NULL;

				for( EDIF_INS_PTCON = EDIF_INS_PTMODEL->LOCON;
				     EDIF_INS_PTCON != NULL; 
				     EDIF_INS_PTCON = EDIF_INS_PTCON->NEXT) 
					EDIF_INS_SIGCHAIN = addchain( EDIF_INS_SIGCHAIN, NULL );

				EDIF_PTINS = addloins( EDIF_PTFIG, (edifvsp[-2].sval), EDIF_INS_PTMODEL, EDIF_INS_SIGCHAIN );

				EDIF_V_PORTINSTANCE = addchain(EDIF_V_PORTINSTANCE, NULL);
			}
		}
#line 1841 "y.tab.c"
    break;

  case 52: /* r_instance: T_INSTANCE r_namedef r_viewref r_opt_property $@3 l_portinstance l_anything ')'  */
#line 498 "./parser_y.y"
                {
			EDIF_PTINS->USER = (struct ptype *)EDIF_V_PORTINSTANCE->DATA; 
		}
#line 1849 "y.tab.c"
    break;

  case 57: /* r_portinstance: T_PORTINSTANCE r_namedef l_anything ')'  */
#line 515 "./parser_y.y"
                {
			EDIF_V_PORTINSTANCE->DATA = addchain( EDIF_V_PORTINSTANCE->DATA, (void *)namealloc( (edifvsp[-2].sval) ) );
		}
#line 1857 "y.tab.c"
    break;

  case 58: /* r_cellref: T_CELLREF r_namedef ')'  */
#line 522 "./parser_y.y"
                { 
			EDIF_INS_MODELNAME = namealloc( (edifvsp[-1].sval) ); 
		}
#line 1865 "y.tab.c"
    break;

  case 59: /* r_cellref: T_CELLREF r_namedef r_libraryref ')'  */
#line 526 "./parser_y.y"
                { 
			EDIF_INS_MODELNAME = namealloc( (edifvsp[-2].sval) ); 
		}
#line 1873 "y.tab.c"
    break;

  case 61: /* $@4: %empty  */
#line 537 "./parser_y.y"
                {
			if (EDIF_NOLOAD_FIG == 0)
			{
				EDIF_PTSIG = addlosig (EDIF_PTFIG, ++EDIF_INDEX, addchain (NULL, CheckCadenceNetError( (edifvsp[0].sval) ) ), 'Z');
				EDIF_SIGTYPE = INTERNAL;
			}
			EDIF_BUS_WIDTH = 1;
		}
#line 1886 "y.tab.c"
    break;

  case 62: /* r_net: T_NET r_namedef $@4 r_joined l_finnet ')'  */
#line 546 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_FIG == 0)
			{
				EDIF_PTSIG->TYPE = EDIF_SIGTYPE; 
			}
		}
#line 1897 "y.tab.c"
    break;

  case 63: /* $@5: %empty  */
#line 553 "./parser_y.y"
                {
			if (EDIF_NOLOAD_FIG == 0)
			{
				int         i;
				int         begin;
				int         end;
				char        net_name[MAXSTRLEN];
				losig_list *EDIF_SIG_TMP = (losig_list *) NULL;

				if( (edifvsp[-1].lval) <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n");
					exit( 1 ); 
				}

				for (i=0; i < (edifvsp[-1].lval); i++)
				{
					if( (CheckCadenceBusError ((edifvsp[-2].sval), &begin, &end)) && (i <= abs( end - begin) ) )
						sprintf(&net_name[0], "%s %d", EDIF_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i); 
					else
						sprintf(&net_name[0], "%s %d", (edifvsp[-2].sval), i); 

					EDIF_PTSIG = addlosig (EDIF_PTFIG, ++EDIF_INDEX, addchain (NULL, namealloc (net_name)), 'Z');
					EDIF_SIGTYPE = INTERNAL;
					EDIF_BUS_WIDTH = (edifvsp[-1].lval);
				}

				EDIF_SIG_TMP = EDIF_PTSIG;
				for (i=0; i<EDIF_BUS_WIDTH; i++)
				{
        			EDIF_PORTLIST_SIG = addchain(EDIF_PORTLIST_SIG, (void *)EDIF_PTSIG);
        			EDIF_PTSIG = EDIF_PTSIG->NEXT;
				}
				EDIF_PTSIG = EDIF_SIG_TMP;
				EDIF_PORTLIST_SIG_TMP = EDIF_PORTLIST_SIG;
			}
		}
#line 1939 "y.tab.c"
    break;

  case 64: /* r_net: T_NET T_ARRAY r_namedef T_INTEGER ')' $@5 r_array_joined l_finnet ')'  */
#line 591 "./parser_y.y"
                {
			if (EDIF_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list *ptsig;

				freechain( (chain_list *)EDIF_PORTLIST_SIG );
				EDIF_PORTLIST_SIG = (chain_list *)NULL;

				ptsig = EDIF_PTSIG;
				for (i = EDIF_BUS_WIDTH - 1; i >= 0; i--)
				{
					ptsig->TYPE = EDIF_SIGTYPE;
					ptsig = ptsig->NEXT;
				}
			}
		}
#line 1961 "y.tab.c"
    break;

  case 73: /* $@6: %empty  */
#line 635 "./parser_y.y"
                {
			EDIF_PORTLIST = 1;
			EDIF_PORTLIST_NUM = 0;
			EDIF_PORTLIST_SIG = EDIF_PORTLIST_SIG_TMP;
		}
#line 1971 "y.tab.c"
    break;

  case 74: /* r_portlist: T_PORTLIST $@6 l_list_portref ')'  */
#line 641 "./parser_y.y"
                {
			EDIF_PORTLIST = 0;

			if (EDIF_PORTLIST_NUM < EDIF_BUS_WIDTH)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : ");
				fprintf (stderr, "PortList width < signal bus '%s' width ( line %d ).\n", 
				                  edif_busname( getsigname(EDIF_PTSIG)), ediflineno );
				exit (1);
			}
		}
#line 1987 "y.tab.c"
    break;

  case 77: /* r_array_portref: T_PORTREF r_namedef ')'  */
#line 661 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list  *ptsig;
				char         port_name[MAXSTRLEN];
				int          begin, end;
				locon_list  *EDIF_PTCON = (locon_list *) NULL;

				ptsig = EDIF_PTSIG;
				if (bus_nameref(EDIF_PTFIG->LOCON, (edifvsp[-1].sval), EDIF_BUS_WIDTH))
				{
					for (i = EDIF_BUS_WIDTH - 1; i >= 0; i--)
					{
						if ( (CheckCadenceBusError ((edifvsp[-1].sval), &begin, &end)) && (i <= abs( end - begin) ) )
							sprintf(&port_name[0], "%s %d", EDIF_ARRAYPORTNAME, (begin <= end) ? begin + i : begin - i); 
						else
							sprintf(&port_name[0], "%s %d", (edifvsp[-1].sval), i); 

						EDIF_PTCON = getlocon (EDIF_PTFIG, &port_name[0]);
						EDIF_PTCON->SIG = ptsig;
						ptsig = ptsig->NEXT;
					}
					EDIF_SIGTYPE = EXTERNAL;
				}
				else
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig :\n"); 
					fprintf (stderr, "Connector '%s' in figure '%s' do not refer to an ARRAY construct",
					                 (edifvsp[-1].sval), EDIF_PTFIG->NAME); 
					fprintf (stderr, "\n    or it is a bus with incompatible width than Signal Bus\n");
					exit (1);
				}
			}
		}
#line 2027 "y.tab.c"
    break;

  case 78: /* r_array_portref: T_PORTREF r_namedef T_INSTANCEREF r_namedef ')' ')'  */
#line 697 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_FIG == 0)
			{
				int         i;
				char        port_name[MAXSTRLEN];
				char       *port_name_alloc;
				losig_list *ptsig; 
				int         begin, end;
				locon_list *EDIF_PTCON = (locon_list *) NULL;

				ptsig = EDIF_PTSIG;
				EDIF_PTINS = getloins (EDIF_PTFIG, (edifvsp[-2].sval));

				if( bus_nameref(EDIF_PTINS->LOCON, (edifvsp[-4].sval), EDIF_BUS_WIDTH))
				{
					if(  ( CheckCadenceBusError ((edifvsp[-4].sval), &begin, &end))
					   &&( (EDIF_BUS_WIDTH - 1) == abs(end - begin) ) )
						sprintf(&port_name[0], "%s %d", EDIF_ARRAYPORTNAME, ( begin <= end ) ? end : begin ); 
					else
						sprintf(&port_name[0], "%s %d", (edifvsp[-4].sval), EDIF_BUS_WIDTH - 1); 

					port_name_alloc = namealloc( port_name );

					for (EDIF_PTCON = EDIF_PTINS->LOCON; EDIF_PTCON; EDIF_PTCON = EDIF_PTCON->NEXT)
						if( port_name_alloc == EDIF_PTCON->NAME)
							break;

					if (EDIF_PTCON == (locon_list *) NULL)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig :");
						fprintf (stderr, " bus connector %s not found", (edifvsp[-4].sval));
						fprintf (stderr, " in instance %s", (edifvsp[-2].sval));
						fprintf (stderr, " of figure %s\n", EDIF_PTINS->FIGNAME);
						exit( 1 );
					}
					else
					{
						for (i = EDIF_BUS_WIDTH - 1; (i >= 0) && EDIF_PTCON; i--)
						{
							EDIF_PTCON->SIG = ptsig;
							ptsig         = ptsig->NEXT;
							EDIF_PTCON      = EDIF_PTCON->NEXT;
						}
					}
				}
				else
				{
					port_name_alloc = namealloc( CheckCadenceNetError( (edifvsp[-4].sval) ) );

					for (EDIF_PTCON = EDIF_PTINS->LOCON; EDIF_PTCON; EDIF_PTCON = EDIF_PTCON->NEXT)
						if( EDIF_PTCON->NAME == port_name_alloc )
							break;
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");  
					if (EDIF_PTCON)
					{
						fprintf (stderr, "Connector '%s' in instance '%s' of figure '%s' do not refer", 
						                  port_name_alloc, (edifvsp[-2].sval), EDIF_PTFIG->NAME); 
						fprintf (stderr, "\n    to an ARRAY construct or it is a bus with" );
						fprintf (stderr, "incompatible width than Signal Bus/n");
						exit( 1 );
					}
					else
					{
						fprintf (stderr, "Connector '%s' not found on instance '%s'\n", port_name_alloc, (edifvsp[-2].sval));   
						exit( 1 );
					} 
				}
			}
		}
#line 2101 "y.tab.c"
    break;

  case 83: /* r_portref: T_PORTREF r_namedef ')'  */
#line 783 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_FIG == 0)
			{
				locon_list *EDIF_PTCON = (locon_list *) NULL;

				EDIF_PTCON = getlocon( EDIF_PTFIG, CheckCadenceNetError( (edifvsp[-1].sval) ) );

				if (!EDIF_PORTLIST)
					EDIF_PTCON->SIG = EDIF_PTSIG;
				else
					EDIF_PTCON->SIG = (losig_list *)EDIF_PORTLIST_SIG->DATA;

				EDIF_SIGTYPE = EXTERNAL;
				if (EDIF_PORTLIST) 
				{
					if (++EDIF_PORTLIST_NUM < EDIF_BUS_WIDTH) 
						EDIF_PORTLIST_SIG = EDIF_PORTLIST_SIG->NEXT;
					else
						if (EDIF_PORTLIST_NUM > EDIF_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							         edif_busname(getsigname(EDIF_PTCON->SIG)), ediflineno );
							exit( 1 );
						}
				}
			}
		}
#line 2134 "y.tab.c"
    break;

  case 84: /* r_portref: T_PORTREF r_namedef T_INSTANCEREF r_namedef ')' ')'  */
#line 812 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_FIG == 0)
			{
				char       *port_name_ref;
				locon_list *EDIF_PTCON = (locon_list *) NULL;

				port_name_ref = namealloc( CheckCadenceNetError( (edifvsp[-4].sval) ) );

				EDIF_PTINS = getloins (EDIF_PTFIG, (edifvsp[-2].sval));
				for (EDIF_PTCON = EDIF_PTINS->LOCON; EDIF_PTCON; EDIF_PTCON = EDIF_PTCON->NEXT)
				{
					if ( port_name_ref == EDIF_PTCON->NAME)
					{
						if( !EDIF_PORTLIST )
							EDIF_PTCON->SIG = EDIF_PTSIG;
						else 
							EDIF_PTCON->SIG = (losig_list *)EDIF_PORTLIST_SIG->DATA;
						break;
					}
				}

			if (EDIF_PTCON == NULL)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig :");
				fprintf (stderr, " connector %s not found", (edifvsp[-4].sval));
				fprintf (stderr, " in instance %s", (edifvsp[-2].sval));
				fprintf (stderr, " of figure %s\n", EDIF_PTINS->FIGNAME);
				exit( 1 );
			}

			if (EDIF_PORTLIST)
            {
				if (++EDIF_PORTLIST_NUM < EDIF_BUS_WIDTH) 
				EDIF_PORTLIST_SIG = EDIF_PORTLIST_SIG->NEXT;
				else
					if (EDIF_PORTLIST_NUM > EDIF_BUS_WIDTH)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig : ");
						fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
						                  edif_busname(getsigname(EDIF_PTCON->SIG)),
						                  ediflineno );
						exit (1);
					}
            }
			}
		}
#line 2185 "y.tab.c"
    break;

  case 85: /* r_portref: T_PORTREF T_MEMBER r_namedef T_INTEGER ')' ')'  */
#line 859 "./parser_y.y"
                {
			if (EDIF_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *EDIF_PTCON = (locon_list *) NULL;

				if ( (CheckCadenceBusError ((edifvsp[-3].sval), &begin, &end))
				  && ((edifvsp[-2].lval) <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %ld", EDIF_ARRAYPORTNAME, ( begin <= end ) ? begin + (edifvsp[-2].lval) : begin - (edifvsp[-2].lval) ); 
				else
					sprintf(&port_name[0], "%s %ld", (edifvsp[-3].sval), (edifvsp[-2].lval)); 

				EDIF_PTCON = getlocon (EDIF_PTFIG, port_name);
				if (!EDIF_PORTLIST)
					EDIF_PTCON->SIG = EDIF_PTSIG;
				else
					EDIF_PTCON->SIG = (losig_list *)EDIF_PORTLIST_SIG->DATA;

				EDIF_SIGTYPE = EXTERNAL;
				if (EDIF_PORTLIST) {
					if (++EDIF_PORTLIST_NUM < EDIF_BUS_WIDTH) 
						EDIF_PORTLIST_SIG = EDIF_PORTLIST_SIG->NEXT;
					else
						if (EDIF_PORTLIST_NUM > EDIF_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                  edif_busname(getsigname(EDIF_PTCON->SIG)),
							                  ediflineno );
							exit (1);
						}
                }
			}
		}
#line 2225 "y.tab.c"
    break;

  case 86: /* r_portref: T_PORTREF T_MEMBER r_namedef T_INTEGER ')' T_INSTANCEREF r_namedef ')' ')'  */
#line 895 "./parser_y.y"
                {

			if (EDIF_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *EDIF_PTCON    = (locon_list *) NULL;
				char       *EDIF_PORTNAME = (char *) NULL;

				EDIF_PTINS = getloins (EDIF_PTFIG, (edifvsp[-2].sval));

				if ( (CheckCadenceBusError ((edifvsp[-6].sval), &begin, &end) )
				  && ((edifvsp[-5].lval) <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %ld", EDIF_ARRAYPORTNAME, ( begin <= end ) ? begin + (edifvsp[-5].lval) : begin - (edifvsp[-5].lval) ); 
				else
					sprintf(&port_name[0], "%s %ld", (edifvsp[-6].sval), (edifvsp[-5].lval)); 

				EDIF_PORTNAME = namealloc (&port_name[0]);
				for (EDIF_PTCON = EDIF_PTINS->LOCON; EDIF_PTCON; EDIF_PTCON = EDIF_PTCON->NEXT)
				{
					if (EDIF_PORTNAME == EDIF_PTCON->NAME)
					{
						if (!EDIF_PORTLIST)
							EDIF_PTCON->SIG = EDIF_PTSIG;
						else 
							EDIF_PTCON->SIG = (losig_list *)EDIF_PORTLIST_SIG->DATA;
						break;
					}
				}

				if (EDIF_PTCON == NULL)
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");
					fprintf (stderr, "connector %s not found ", port_name);
					fprintf (stderr, " in instance %s", (edifvsp[-2].sval));
					fprintf (stderr, " of figure %s\n", EDIF_PTINS->FIGNAME);
					exit (1);
				}

				if (EDIF_PORTLIST) {
					if (++EDIF_PORTLIST_NUM < EDIF_BUS_WIDTH) 
						EDIF_PORTLIST_SIG = EDIF_PORTLIST_SIG->NEXT;
					else
						if (EDIF_PORTLIST_NUM > EDIF_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                 edif_busname(getsigname(EDIF_PTCON->SIG)),
							                 ediflineno );
							exit (1);
						}
                }
			}
		}
#line 2284 "y.tab.c"
    break;

  case 93: /* r_port: T_PORT r_namedef l_finport ')'  */
#line 968 "./parser_y.y"
                { 
			if (EDIF_NOLOAD_LOCON == 0)
			{
				addlocon( EDIF_PTFIG, CheckCadenceNetError( (edifvsp[-2].sval) ), NULL ,EDIF_DIRECTION );
			}
		}
#line 2295 "y.tab.c"
    break;

  case 94: /* r_port: T_PORT T_ARRAY r_namedef T_INTEGER ')' l_finport ')'  */
#line 975 "./parser_y.y"
                {
			if (EDIF_NOLOAD_LOCON == 0)
			{
				char port_name    [MAXSTRLEN];
				int i;
				int begin;
				int end;

				if( (edifvsp[-3].lval) <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n"); 
					exit( 1 ); 
				}

				if ( (CheckCadenceBusError ((edifvsp[-4].sval), &begin, &end)) && ( (abs (end - begin) + 1) == (edifvsp[-3].lval)) )
				{
					for (i=0; i < (edifvsp[-3].lval); i++)
					{
						sprintf(&port_name[0], "%s %d", EDIF_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i ); 
						addlocon (EDIF_PTFIG, &port_name[0], NULL ,EDIF_DIRECTION);
					}
				}
				else
				{
					for (i=0; i < (edifvsp[-3].lval); i++)
					{
						sprintf(&port_name[0], "%s %d", (edifvsp[-4].sval), i); 
						addlocon (EDIF_PTFIG, &port_name[0], NULL ,EDIF_DIRECTION);
					}
				}
			}
		}
#line 2332 "y.tab.c"
    break;

  case 99: /* r_direction: T_DIRECTION T_INOUT ')'  */
#line 1021 "./parser_y.y"
                { 
			EDIF_DIRECTION = UNKNOWN; 
		}
#line 2340 "y.tab.c"
    break;

  case 100: /* r_direction: T_DIRECTION T_INPUT ')'  */
#line 1025 "./parser_y.y"
                { 
			EDIF_DIRECTION = IN; 
		}
#line 2348 "y.tab.c"
    break;

  case 101: /* r_direction: T_DIRECTION T_OUTPUT ')'  */
#line 1029 "./parser_y.y"
                { 
			EDIF_DIRECTION = OUT; 
		}
#line 2356 "y.tab.c"
    break;

  case 102: /* l_anything: %empty  */
#line 1036 "./parser_y.y"
        { }
#line 2362 "y.tab.c"
    break;

  case 103: /* l_anything: l_anything r_anything  */
#line 1038 "./parser_y.y"
        { }
#line 2368 "y.tab.c"
    break;

  case 106: /* r_namedef: T_IDENT  */
#line 1048 "./parser_y.y"
                { 
			strcpy((edifval.sval), (edifvsp[0].sval)); 
		}
#line 2376 "y.tab.c"
    break;

  case 107: /* r_namedef: T_INTEGER  */
#line 1052 "./parser_y.y"
                { 
			char EDIF_TMP [MAXSTRLEN];

			sprintf(EDIF_TMP, "%ld", (edifvsp[0].lval)); 
			strcpy((edifval.sval), EDIF_TMP); 
		}
#line 2387 "y.tab.c"
    break;

  case 108: /* r_namedef: T_RENAME T_IDENT T_RENAME_STRING ')'  */
#line 1059 "./parser_y.y"
                {
			strcpy((edifval.sval), (edifvsp[-2].sval)); 
		}
#line 2395 "y.tab.c"
    break;

  case 109: /* r_namedef: T_RENAME r_name T_RENAME_STRING ')'  */
#line 1063 "./parser_y.y"
                {
			strcpy((edifval.sval), (edifvsp[-2].sval));
		}
#line 2403 "y.tab.c"
    break;

  case 110: /* r_name: T_NAME T_IDENT ')'  */
#line 1070 "./parser_y.y"
                {
			strcpy((edifval.sval), (edifvsp[-1].sval)); 
		}
#line 2411 "y.tab.c"
    break;


#line 2415 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter edifchar, and that requires
     that ediftoken be updated with the new translation.  We take the
     approach of translating immediately before every use of ediftoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     EDIFABORT, EDIFACCEPT, or EDIFERROR immediately after altering edifchar or
     if it invokes EDIFBACKUP.  In the case of EDIFABORT or EDIFACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of EDIFERROR or EDIFBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  EDIF_SYMBOL_PRINT ("-> $$ =", EDIF_CAST (edifsymbol_kind_t, edifr1[edifn]), &edifval, &edifloc);

  EDIFPOPSTACK (ediflen);
  ediflen = 0;

  *++edifvsp = edifval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int ediflhs = edifr1[edifn] - EDIFNTOKENS;
    const int edifi = edifpgoto[ediflhs] + *edifssp;
    edifstate = (0 <= edifi && edifi <= EDIFLAST && edifcheck[edifi] == *edifssp
               ? ediftable[edifi]
               : edifdefgoto[ediflhs]);
  }

  goto edifnewstate;


/*--------------------------------------.
| ediferrlab -- here on detecting error.  |
`--------------------------------------*/
ediferrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  ediftoken = edifchar == EDIFEMPTY ? EDIFSYMBOL_EDIFEMPTY : EDIFTRANSLATE (edifchar);
  /* If not already recovering from an error, report this error.  */
  if (!ediferrstatus)
    {
      ++edifnerrs;
      ediferror (EDIF_("syntax error"));
    }

  if (ediferrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (edifchar <= EDIFEOF)
        {
          /* Return failure if at end of input.  */
          if (edifchar == EDIFEOF)
            EDIFABORT;
        }
      else
        {
          edifdestruct ("Error: discarding",
                      ediftoken, &ediflval);
          edifchar = EDIFEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto ediferrlab1;


/*---------------------------------------------------.
| ediferrorlab -- error raised explicitly by EDIFERROR.  |
`---------------------------------------------------*/
ediferrorlab:
  /* Pacify compilers when the user code never invokes EDIFERROR and the
     label ediferrorlab therefore never appears in user code.  */
  if (0)
    EDIFERROR;
  ++edifnerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this EDIFERROR.  */
  EDIFPOPSTACK (ediflen);
  ediflen = 0;
  EDIF_STACK_PRINT (edifss, edifssp);
  edifstate = *edifssp;
  goto ediferrlab1;


/*-------------------------------------------------------------.
| ediferrlab1 -- common code for both syntax error and EDIFERROR.  |
`-------------------------------------------------------------*/
ediferrlab1:
  ediferrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      edifn = edifpact[edifstate];
      if (!edifpact_value_is_default (edifn))
        {
          edifn += EDIFSYMBOL_EDIFerror;
          if (0 <= edifn && edifn <= EDIFLAST && edifcheck[edifn] == EDIFSYMBOL_EDIFerror)
            {
              edifn = ediftable[edifn];
              if (0 < edifn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (edifssp == edifss)
        EDIFABORT;


      edifdestruct ("Error: popping",
                  EDIF_ACCESSING_SYMBOL (edifstate), edifvsp);
      EDIFPOPSTACK (1);
      edifstate = *edifssp;
      EDIF_STACK_PRINT (edifss, edifssp);
    }

  EDIF_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++edifvsp = ediflval;
  EDIF_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  EDIF_SYMBOL_PRINT ("Shifting", EDIF_ACCESSING_SYMBOL (edifn), edifvsp, ediflsp);

  edifstate = edifn;
  goto edifnewstate;


/*-------------------------------------.
| edifacceptlab -- EDIFACCEPT comes here.  |
`-------------------------------------*/
edifacceptlab:
  edifresult = 0;
  goto edifreturnlab;


/*-----------------------------------.
| edifabortlab -- EDIFABORT comes here.  |
`-----------------------------------*/
edifabortlab:
  edifresult = 1;
  goto edifreturnlab;


/*-----------------------------------------------------------.
| edifexhaustedlab -- EDIFNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
edifexhaustedlab:
  ediferror (EDIF_("memory exhausted"));
  edifresult = 2;
  goto edifreturnlab;


/*----------------------------------------------------------.
| edifreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
edifreturnlab:
  if (edifchar != EDIFEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      ediftoken = EDIFTRANSLATE (edifchar);
      edifdestruct ("Cleanup: discarding lookahead",
                  ediftoken, &ediflval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this EDIFABORT or EDIFACCEPT.  */
  EDIFPOPSTACK (ediflen);
  EDIF_STACK_PRINT (edifss, edifssp);
  while (edifssp != edifss)
    {
      edifdestruct ("Cleanup: popping",
                  EDIF_ACCESSING_SYMBOL (+*edifssp), edifvsp);
      EDIFPOPSTACK (1);
    }
#ifndef edifoverflow
  if (edifss != edifssa)
    EDIFSTACK_FREE (edifss);
#endif

  return edifresult;
}

#line 1092 "./parser_y.y"


extern  char            ediftext[];
extern  FILE            *edifin;


/*----------------------------------------------------------------------*/
/*      bus_nameref: checks that name ref is bus name ref and with      */
/*      the same width. It returns 1 if ok.                             */
/*      Do not forget that locon list is in reverse order.              */
/*----------------------------------------------------------------------*/

/*---------------------------------------------------------\
                     bus_nameref
\---------------------------------------------------------*/
static char bus_nameref( ptlocon, bnameref, bus_width )
locon_list *ptlocon;
char       *bnameref;
int         bus_width;
{
	char        port_name[MAXSTRLEN];
	char       *pname;
	locon_list *loconp;
	int         begin, end;

	bus_width --;
	if ( (!CheckCadenceBusError( bnameref, &begin, &end ) ) || (bus_width != abs( end - begin ) ) )
	{
		strcpy( EDIF_ARRAYPORTNAME, bnameref );
		end = bus_width;
	}

	sprintf(&port_name[0], "%s %d", EDIF_ARRAYPORTNAME, end ); 

	pname = namealloc( &port_name[0] );

	for (loconp = ptlocon; loconp != (locon_list *) NULL; loconp = loconp->NEXT)
		if (loconp->NAME == pname)
			break;

	if (loconp == (locon_list *) NULL)
		return 0;

	for( loconp = loconp->NEXT; loconp != (locon_list *) NULL; loconp = loconp->NEXT )
	{
		sprintf( &port_name[0], "%s %d", EDIF_ARRAYPORTNAME, ( begin <= end ) ? --end : ++end );
		if ( ( loconp->NAME == namealloc( port_name ) ) && bus_width >= 0)
			bus_width--;
		else
			break;
	}

	return( bus_width == 0 );

} /* end of bus_nameref */

/*---------------------------------------------------------\
                     edifloadlofig
\---------------------------------------------------------*/
void edifloadlofig( ptfig, figname, mode )
lofig_list *ptfig;
char       *figname;
char        mode;
{
	char        filename[120];
	lofig_list *pt;
	losig_list *ptsig;
	loins_list *ptins;

	static char Vierge = 1; /* first time */

	ediflineno = 0;

    EDIF_RIPPER_IN  = (char *)NULL;
    EDIF_RIPPER_OUT = (char *)NULL;

    EDIF_LOFIG                = (lofig_list *) NULL;
    EDIF_PTFIG                = (lofig_list *) NULL;
    EDIF_PTSIG                = (losig_list *) NULL;
    EDIF_PORTLIST_SIG         = (chain_list *) NULL;
    EDIF_PORTLIST_SIG_TMP     = (chain_list *) NULL;
    EDIF_PTINS                = (loins_list *) NULL;
    EDIF_V_PORTINSTANCE       = (chain_list *) NULL;
    EDIF_BLACKBOX             = 'N';  
    EDIF_BUS_WIDTH            = 0;
    EDIF_DIRECTION            = UNKNOWN;
    EDIF_INDEX                = 0;
    EDIF_SIGTYPE              = 'Z';
    EDIF_NOLOAD_LOCON         = 0;
    EDIF_NOLOAD_FIG           = 0;
    EDIF_RIPPER_CELL = (char *) NULL;

	sprintf( filename, "%s/%s.%s", WORK_LIB, figname, IN_LO );
	if( ( edifin = mbkfopen( figname, IN_LO, READ_TEXT ) ) == NULL )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : can't open file %s\n", filename );
		exit( 1 );
	}

	if( Vierge == 0 )
		edifrestart( edifin );
	Vierge = 0;

	EDIF_LOFIG = ptfig;
	EDIF_FIGNAME = figname;
	EDIF_V_PORTINSTANCE = (chain_list *) NULL;

	if( edifparse() != 0 )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : abnormal parsing for %s\n", filename );
		exit( 1 );
	}

	if( fclose( edifin ) != 0 )
	{
		fprintf(stderr, "*** mbk error *** edifloadlofig : can't close file %s\n", filename);
		exit(1);
	}

	if (EDIF_BLACKBOX == 'Y')
	{
		ptfig->MODE = 'A';
		for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT)
		{
			if (pt == ptfig)
				break;
			for (ptins = ptfig->LOINS; ptins != NULL; ptins = ptins->NEXT)
			{
				if( pt->NAME ==  ptins->FIGNAME )
					break;
			}
			if (ptins == NULL)
				dellofig( pt->NAME );
		}

		for( pt = HEAD_LOFIG; pt != (lofig_list *) NULL; pt = pt->NEXT )
		{
			if( pt != ptfig )
			{
				for( ptsig = pt->LOSIG; ptsig != (losig_list *) NULL; ptsig = ptsig->NEXT )
					free( ptsig );
				pt->LOSIG = (losig_list *) NULL;

				for( ptins = pt->LOINS; ptins != (loins_list *) NULL; ptins = ptins->NEXT )
					delloins( pt , ptins->INSNAME );
				pt->MODE = 'P';
			}
		}
	}

	for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT) 
		if( pt != ptfig ) 
			pt->MODE = (pt->LOSIG == NULL) ? 'P' : 'A';
        else
			pt->MODE = 'A';

	REnamealloc( );

	del_patch( ptfig, 1 );


} /* end of edifloadlofig */

/*---------------------------------------------------------\
                     ediferror
\---------------------------------------------------------*/
int ediferror( String )
char *String;
{
        fprintf( stderr,
                 "*** mbk error *** edifloadlofig : %s at ligne %d on '%s'\n",
                 String, ediflineno + 1, ediftext );
        exit( 1 );
} /* end of ediferror */

/*---------------------------------------------------------\
                     edifwrap
\---------------------------------------------------------*/
int edifwrap()
{
    return 1;
} /* end of edifwrap */

/*---------------------------------------------------------\
                     get_figure_pt
\---------------------------------------------------------*/
static lofig_list *get_figure_pt( Name )
char *Name;
{
	lofig_list *pt;

	for( pt = HEAD_LOFIG; pt; pt = pt->NEXT )
		if( pt->NAME == Name )
			return pt;

	return (lofig_list *)NULL;

} /* end of get_figure_pt */

/*---------------------------------------------------------\
                     is_portinstance
\---------------------------------------------------------*/
static char is_portinstance(inst_pt, Name)
loins_list *inst_pt;
char       *Name;
{
	chain_list      *chain_pt;

	chain_pt = (chain_list *)EDIF_PTINS->USER;

	while( chain_pt )
	{
		if( Name == (char *)chain_pt->DATA )
			return 1;
		chain_pt = chain_pt->NEXT;
	}

	return 0;
} /* end of is_portinstance */

/*---------------------------------------------------------\
                     CheckCadenceNetError
\---------------------------------------------------------*/
static char *CheckCadenceNetError( Name )
char *Name;
{
	char  net_name[MAXSTRLEN];
	char *first;
	char *second;

	strcpy (net_name, Name);

	first = net_name;

	while( first )
	{
		if ( ( first = strchr( first, '_' ) ) != NULL )
		{
            if( strncmp( first, "_60_", 4 ) != 0 )
            {
                first++;
                continue;
            }
			second = first + 4;
			while( isdigit( *second ) ) second ++;

			if( strcmp( second, "_62" ) != 0 )
			{
				*first = ' ';
                first ++;
                second = first + 3;
                while( isdigit( *second ) )
                {
                    *first = *second;
                    second ++;
                    first ++;
                }
				first[ 0 ] = '\0';
				return namealloc( net_name );
			}
			first ++;
		}
		else
		{
			return namealloc( Name );
		}
	}

	return namealloc( Name );

} /* fin de CheckCadenceNetError */

/*---------------------------------------------------------\
                     CheckCadenceBusError
\---------------------------------------------------------*/
static char CheckCadenceBusError(PortName, Min, Max)
char *PortName;
int  *Min;
int  *Max;
{
	char *array;
	char *first;
	char *middle;
	char  save;

	strcpy (EDIF_ARRAYPORTNAME, PortName);

	first = EDIF_ARRAYPORTNAME;

	while (first)
	{
		if ( (first = strchr (first, '_') ) != NULL )
		{
            if( strncmp( first, "_60_", 4 ) != 0 )
            {
                first++;
                continue;
            }
			first[0] = '\0';
			array = first + 4;
			while ( isdigit (*array) ) array ++;

			if ( ( *array != 0 ) && ( strncasecmp (array, "TO", 2) == 0 ) )
			{
				middle = array;
				save = middle [0];
				middle [0] = '\0';
				array += 2;
				while ( isdigit (*array) ) array ++;

				if ( strcmp( first, "_62" ) != 0 )
				{
					array [0] = '\0';
					sscanf (first  + 4, "%d", Min);
					sscanf (middle + 2, "%d", Max);
					return 1;
				}
				middle [0] = save;
			}
			first[0] = '_';
			first ++;
		}
	}
	*Min = 0;
	*Max = 0;
	return 0;

} /* end of CheckCadenceBusError */

/*---------------------------------------------------------\
                     sig_merge
\---------------------------------------------------------*/
static void sig_merge(pt_lofig, sig1, sig2)
lofig_list *pt_lofig;
long        sig1;
long        sig2;
{
	losig_list *ls1, *ls2;
	locon_list *c;
	loins_list *i;
	lotrs_list *t;

    for (ls1 = pt_lofig->LOSIG; ls1; ls1 = ls1->NEXT) {
        if (ls1->INDEX == sig1)
            break;
    }

    for (ls2 = pt_lofig->LOSIG; ls2; ls2 = ls2->NEXT) {
        if (ls2->INDEX == sig2)
            break;
    }

    if (ls1 == NULL || ls2 == NULL) /* one of them not exists ! */
	{
        return;
    }

    if (ls1 == ls2) /* already joined!, just return */
        return;

    for (c = pt_lofig->LOCON; c; c = c->NEXT)
        if (c->SIG == ls2)
            c->SIG = ls1;

    for (i = pt_lofig->LOINS; i; i = i->NEXT)
        for (c = i->LOCON; c; c = c->NEXT)
            if (c->SIG == ls2)
                c->SIG = ls1;

    for (t = pt_lofig->LOTRS; t; t = t->NEXT) {
        if (t->GRID->SIG == ls2)
            t->GRID->SIG = ls1;
        if (t->DRAIN->SIG == ls2)
            t->DRAIN->SIG = ls1;
        if (t->SOURCE->SIG == ls2)
            t->SOURCE->SIG = ls1;
    }

     if(!ls1->PRCN)
       addlorcnet( ls1 );
    (void)addcapa(ls1, getcapa(ls2));
    (void)dellosig(pt_lofig, ls2->INDEX);
}

/*---------------------------------------------------------\
                     find_ripper_con_name
\---------------------------------------------------------*/
void find_ripper_con_name( lofig )
lofig_list *lofig;
{
    locon_list *c1;
    char save;
    char *pt;

    for( c1 = lofig->LOCON; c1; c1 = c1->NEXT )
    {
        if( isvss( c1->NAME ) || isvdd( c1->NAME ) )
        {
            continue;
        }
        if( !EDIF_RIPPER_IN )
        {
            if( ( pt = strrchr( c1->NAME, ' ' ) ) == NULL )
            {
                fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (2)!!\n" );
                exit(1);
            }
            save = *pt;
            *pt = '\0';
            EDIF_RIPPER_IN = namealloc ( c1->NAME );
            *pt = save;
        }
        else if( strncmp( EDIF_RIPPER_IN, c1->NAME, strlen( EDIF_RIPPER_IN ) ) != 0 )
        {
            if( EDIF_RIPPER_OUT )
            {
                if( strncmp( EDIF_RIPPER_OUT, c1->NAME, strlen( EDIF_RIPPER_OUT ) ) != 0 )
                {
                    fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (3)!!\n" );
                    exit(1);
                }
            }
            else
            {
                if( ( pt = strrchr( c1->NAME, ' ' ) ) == NULL )
                {
                    fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (4)!!\n" );
                    exit(1);
                }
                save = *pt;
                *pt = '\0';
                EDIF_RIPPER_OUT = namealloc ( c1->NAME );
                *pt = save;
            }
        }
    }

} /* end of find_ripper_con_name */
/*---------------------------------------------------------\
                     del_patch
\---------------------------------------------------------*/
static void del_patch(pt_lofig, master)
lofig_list *pt_lofig;
char        master;
{
	loins_list *i;
	loins_list *k;
	locon_list *c1, *c2;
	chain_list *ptchain;
	char *b;
	long j;
	long i1, i2;
	char buf[MAXSTRLEN];

	if( EDIF_RIPPER_CELL == (char *) NULL)
		return;

    if( master == 1 )
    {
        find_ripper_con_name( getlofig( EDIF_RIPPER_CELL, 'P' ) );
    }

    for (ptchain = pt_lofig->MODELCHAIN; ptchain != NULL; ptchain = ptchain->NEXT)
    {
		if ( EDIF_RIPPER_CELL != ptchain->DATA )
        	del_patch( getlofig( ptchain->DATA, 'P'), 0 );
    }

    for (i = pt_lofig->LOINS; i; )
	{
        if (EDIF_RIPPER_CELL == i->FIGNAME)
		{
			j = 0;
            do
			{
				sprintf (buf, "%s %ld", EDIF_RIPPER_IN, j);
   				b = namealloc (buf);

        		for (c1 = i->LOCON; c1; c1 = c1->NEXT)
                {
					if ( (c1->NAME == b) && ( c1->SIG ) )
					{
						i1 = c1->SIG->INDEX;

						sprintf (buf, "%s %ld", EDIF_RIPPER_OUT, j);
   						b = namealloc (buf);

        				for (c2 = i->LOCON; c2; c2 = c2->NEXT)
						{
							if ( (c2->NAME == b) && ( c2->SIG ) )
							{
								i2 = c2->SIG->INDEX;
								sig_merge(pt_lofig, i1, i2);
  								break;
							}
						}

                     break;
					}
				}

                j++;
			} while ( c1 );

			k = i->NEXT;
			delloins (pt_lofig, i->INSNAME);
			i = k;
		}
		else
		{
			i = i->NEXT;
		}
	}

	if( master == 1 )
		dellofig( EDIF_RIPPER_CELL );
}

/*---------------------------------------------------------\
                     REnamealloc
\---------------------------------------------------------*/
static void REnamealloc( )
{
	lofig_list *t;
	char       *te;

	for (t = EDIF_LOFIG; t; t = t->NEXT)
	{
		te = namealloc (t->NAME);
		if( te != t->NAME )
		{
			fprintf( stderr, "*** mbk warning *** edifloadlofig : instance name not namealloced !!!\n" );
			t->NAME = te;
		}
	}
}
