/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "./mips_y.y"

#include <stdio.h>
#include <string.h>
#include "mut.h"
#include "log.h"
#include "beh.h"
#include "mips_type.h"
#include "mips_defs.h"
#include "mips_yacc.h"

extern  void  yyrestart ( );
extern  int   yyparse   ( );
extern  int   yylex     ( );
extern  void  yyerror   ( );


int  main (argc, argv)

int   argc   ;
char *argv [];

  {
  extern FILE  *yyin          ;
  extern FILE  *MPS_WRTFIL    ;
  extern FILE  *MPS_TXTFIL    ;
  extern FILE  *MPS_DATFIL    ;
  extern FILE  *MPS_SYMFIL    ;
  FILE         *fp_read       ;
  char          arg_flg [ 32] ;
  unsigned int  txt_siz       = 256;
  unsigned int  dat_siz       =  64;
  int           exit_val      =   1;
  int           asm_fil       =   0;
  int           txt_fil       =   0;
  int           dat_fil       =   0;
  int           i             ;
  char         *symbol_fil    = NULL;
  char          arg_err       =   0;
  static int    call_nbr      =   0;

	/* ###------------------------------------------------------### */
	/*   initializations						*/
	/* ###------------------------------------------------------### */

  mbkenv ();

  alliancebanner_with_authors( "asm", "v0.3",
                  "MIPS Assembler", "1992",
                  ALLIANCE_VERSION,
                  "Pirouz Bazargan Sabet" );

  for (i=1 ; i<argc ; i++)
    arg_flg [i] = 0;

  if (MPS_HSHTAB == NULL)
    MPS_HSHTAB = beh_initab ();

	/* ###------------------------------------------------------### */
	/*   analyze the command line:					*/
	/*     - for each argument set a flag to 1 if recognized	*/
	/*     - find the last recognized option to identify the source	*/
	/*       and result files					*/
	/* ###------------------------------------------------------### */

  arg_flg [0] = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      {
      if (!strcmp (argv[i], "-textsize") && argc > i + 1)
        {
        sscanf (argv[i+1], "%u", &txt_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-datasize") && argc > i + 1)
        {
        sscanf (argv[i+1], "%u", &dat_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-dump"))
        {
        MPS_DUMP      = 'y'       ;
        arg_flg [i]   = 1         ;
        }

      if (!strcmp (argv[i], "-symbol") && argc > i + 1)
        {
        MPS_SYMBOL    = 'y'       ;
        symbol_fil    = argv [i+1];
        arg_flg [i]   = 1         ;
        arg_flg [i+1] = 1         ;
        }

      }
    }

  for (i=(argc-1) ; i>0 ; i--)
    {
    if (arg_flg [i] == 1)
      break;
    }

  asm_fil       = i + 1;
  arg_flg [i+1] = 1    ;
  txt_fil       = i + 2;
  arg_flg [i+2] = 1    ;

  if ((i+3) < argc)
    {
    dat_fil       = i + 3;
    arg_flg [i+3] = 1    ;
    }


	/* ###------------------------------------------------------### */
	/*   cases of errors on the command line:			*/
	/*     - a unrecognized argument				*/
	/*     - not enough arguments					*/
	/*     - too many arguments					*/
	/* ###------------------------------------------------------### */

  if ((argc > 11) || (argc < 3))
    arg_err = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      arg_err = 1;
    }

  if (arg_err == 1)
    {
    mips_error (101, NULL);
    exit (1);
    }

	/* ###------------------------------------------------------### */
	/*   open source file (assembly) and result files (vhdl)	*/
	/* ###------------------------------------------------------### */

  if ((fp_read = fopen (argv [asm_fil], "r")) == NULL)
    {
    mips_error (100, argv [asm_fil]);
    exit (1);
    }

  if (MPS_DUMP != 'y')
    {
    if ((MPS_TXTFIL = mbkfopen (argv[txt_fil], "vbe", WRITE_TEXT)) == NULL)
      {
      mips_error (100, argv [txt_fil]);
      exit (1);
      }

    if (dat_fil != 0)
      {
      if ((MPS_DATFIL = mbkfopen (argv[dat_fil], "vbe", WRITE_TEXT)) == NULL)
        {
        mips_error (100, argv [dat_fil]);
        exit (1);
        }
      }
    }
  else
    {
    if ((MPS_TXTFIL = fopen (argv[txt_fil], "w")) == NULL)
      {
      mips_error (100, argv [txt_fil]);
      exit (1);
      }
    if (dat_fil != 0)
      {
      if ((MPS_DATFIL = fopen (argv[txt_fil], "w")) == NULL)
        {
        mips_error (100, argv [dat_fil]);
        exit (1);
        }
      }
    }

  if (MPS_SYMBOL == 'y')
    {
    if ((MPS_SYMFIL = fopen (symbol_fil, "w")) == NULL)
      {
      mips_error (100, symbol_fil);
      exit (1);
      }
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the text address.	*/
	/* The address is a word (4 bytes) address			*/
	/* ###------------------------------------------------------### */

  txt_siz = (txt_siz >> 2) - 1;
  while (txt_siz != 0)
    {
    txt_siz = txt_siz >> 1;
    MPS_TXTSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the data address	*/
	/* ###------------------------------------------------------### */

  dat_siz -= 1;
  while (dat_siz != 0)
    {
    dat_siz = dat_siz >> 1;
    MPS_DATSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   call the assembly file parser (two passes):		*/
	/*	- set the address space (by default) to text		*/
	/*      - in the first pass identify labels			*/
	/*      - if no error has been found print the result files'	*/
	/*        header						*/
	/*      - translate insstructions in the second pass		*/
	/*      - print the result files' foot				*/
	/* ###------------------------------------------------------### */

  MPS_ADRSPC = 'T'       ;
  MPS_ADDRES = MPS_TXTADR;
  MPS_WRTFIL = MPS_TXTFIL;
  MPS_ADRSIZ = MPS_TXTSIZ;
  MPS_WRDSIZ = 4         ;

  MPS_PASNBR = 1  ;

  if (call_nbr != 0)
    yyrestart (yyin);

  yyin = fp_read;
  yyparse ();

  call_nbr++;

  if (MPS_ERRFLG == 0)
    {
    fclose (fp_read);
    fp_read = fopen (argv [asm_fil], "r");
    yyin    = fp_read;

    MPS_ADRSPC = 'T';
    MPS_ADDRES = MPS_TXTADR;
    MPS_WRTFIL = MPS_TXTFIL;
    MPS_ADRSIZ = MPS_TXTSIZ;
    MPS_WRDSIZ = 4;

    MPS_PASNBR = 2  ;
    MPS_LINNUM = 1  ;

    if (MPS_DUMP != 'y')
      {
      mips_head (MPS_TXTFIL, argv [txt_fil], MPS_TXTSIZ, 4);
      if (MPS_DATFIL != NULL)
        mips_head (MPS_DATFIL, argv [dat_fil], MPS_DATSIZ, 1);
      }

    yyrestart (yyin);
    yyparse ();

    if (MPS_DUMP != 'y')
      {
      mips_foot (MPS_TXTFIL, 4);
      if (MPS_DATFIL != NULL)
        mips_foot (MPS_DATFIL, 1);
      }

    exit_val = 0;

    }

	/* ###------------------------------------------------------### */
	/*   close source and result files				*/
	/* ###------------------------------------------------------### */

  fclose (fp_read);
  fclose (MPS_TXTFIL);

  if (MPS_DATFIL != NULL)
    fclose (MPS_DATFIL);

  if (MPS_SYMBOL == 'y')
    fclose (MPS_SYMFIL);

  exit (exit_val);
  }


#line 368 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    _ALIGN = 258,                  /* _ALIGN  */
    _ASCII = 259,                  /* _ASCII  */
    _ASCIIZ = 260,                 /* _ASCIIZ  */
    _BYTE = 261,                   /* _BYTE  */
    _BYTEZ = 262,                  /* _BYTEZ  */
    _DATA = 263,                   /* _DATA  */
    _END = 264,                    /* _END  */
    _EQU = 265,                    /* _EQU  */
    _GLOBAL = 266,                 /* _GLOBAL  */
    _ORG = 267,                    /* _ORG  */
    _SPACE = 268,                  /* _SPACE  */
    _SKIP = 269,                   /* _SKIP  */
    _START = 270,                  /* _START  */
    _TEXT = 271,                   /* _TEXT  */
    _WORD = 272,                   /* _WORD  */
    Ampersand = 273,               /* Ampersand  */
    Bar = 274,                     /* Bar  */
    CarriageReturn = 275,          /* CarriageReturn  */
    Circomflex = 276,              /* Circomflex  */
    Codop_rd = 277,                /* Codop_rd  */
    Codop_rd_rs_rt = 278,          /* Codop_rd_rs_rt  */
    Codop_rd_rt_sham = 279,        /* Codop_rd_rt_sham  */
    Codop_rd_rt_rs = 280,          /* Codop_rd_rt_rs  */
    Codop_rd_rs_imd = 281,         /* Codop_rd_rs_imd  */
    Codop_rs_rt_labl = 282,        /* Codop_rs_rt_labl  */
    Codop_od_rs = 283,             /* Codop_od_rs  */
    Codop_rs = 284,                /* Codop_rs  */
    Codop_rd_mem = 285,            /* Codop_rd_mem  */
    Codop_rt_mem = 286,            /* Codop_rt_mem  */
    Codop_rt_cp0rd = 287,          /* Codop_rt_cp0rd  */
    Codop_rs_labl = 288,           /* Codop_rs_labl  */
    Codop_rd_imd = 289,            /* Codop_rd_imd  */
    Codop_labl = 290,              /* Codop_labl  */
    Codop_imd = 291,               /* Codop_imd  */
    Codop_n = 292,                 /* Codop_n  */
    Colon = 293,                   /* Colon  */
    Comma = 294,                   /* Comma  */
    CP0Register = 295,             /* CP0Register  */
    DoubleGreat = 296,             /* DoubleGreat  */
    DoubleLess = 297,              /* DoubleLess  */
    Identifier = 298,              /* Identifier  */
    IntegerRegister = 299,         /* IntegerRegister  */
    LeftParen = 300,               /* LeftParen  */
    Litteral = 301,                /* Litteral  */
    Macro_n = 302,                 /* Macro_n  */
    Macro_rd_longi = 303,          /* Macro_rd_longi  */
    Minus = 304,                   /* Minus  */
    Plus = 305,                    /* Plus  */
    Register = 306,                /* Register  */
    RightParen = 307,              /* RightParen  */
    Sharp = 308,                   /* Sharp  */
    Slash = 309,                   /* Slash  */
    Star = 310,                    /* Star  */
    String = 311,                  /* String  */
    Tilda = 312                    /* Tilda  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define _ALIGN 258
#define _ASCII 259
#define _ASCIIZ 260
#define _BYTE 261
#define _BYTEZ 262
#define _DATA 263
#define _END 264
#define _EQU 265
#define _GLOBAL 266
#define _ORG 267
#define _SPACE 268
#define _SKIP 269
#define _START 270
#define _TEXT 271
#define _WORD 272
#define Ampersand 273
#define Bar 274
#define CarriageReturn 275
#define Circomflex 276
#define Codop_rd 277
#define Codop_rd_rs_rt 278
#define Codop_rd_rt_sham 279
#define Codop_rd_rt_rs 280
#define Codop_rd_rs_imd 281
#define Codop_rs_rt_labl 282
#define Codop_od_rs 283
#define Codop_rs 284
#define Codop_rd_mem 285
#define Codop_rt_mem 286
#define Codop_rt_cp0rd 287
#define Codop_rs_labl 288
#define Codop_rd_imd 289
#define Codop_labl 290
#define Codop_imd 291
#define Codop_n 292
#define Colon 293
#define Comma 294
#define CP0Register 295
#define DoubleGreat 296
#define DoubleLess 297
#define Identifier 298
#define IntegerRegister 299
#define LeftParen 300
#define Litteral 301
#define Macro_n 302
#define Macro_rd_longi 303
#define Minus 304
#define Plus 305
#define Register 306
#define RightParen 307
#define Sharp 308
#define Slash 309
#define Star 310
#define String 311
#define Tilda 312

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 330 "./mips_y.y"

  unsigned long  valu;
  struct immd    immd;
  char          *text;
  

#line 542 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL__ALIGN = 3,                     /* _ALIGN  */
  YYSYMBOL__ASCII = 4,                     /* _ASCII  */
  YYSYMBOL__ASCIIZ = 5,                    /* _ASCIIZ  */
  YYSYMBOL__BYTE = 6,                      /* _BYTE  */
  YYSYMBOL__BYTEZ = 7,                     /* _BYTEZ  */
  YYSYMBOL__DATA = 8,                      /* _DATA  */
  YYSYMBOL__END = 9,                       /* _END  */
  YYSYMBOL__EQU = 10,                      /* _EQU  */
  YYSYMBOL__GLOBAL = 11,                   /* _GLOBAL  */
  YYSYMBOL__ORG = 12,                      /* _ORG  */
  YYSYMBOL__SPACE = 13,                    /* _SPACE  */
  YYSYMBOL__SKIP = 14,                     /* _SKIP  */
  YYSYMBOL__START = 15,                    /* _START  */
  YYSYMBOL__TEXT = 16,                     /* _TEXT  */
  YYSYMBOL__WORD = 17,                     /* _WORD  */
  YYSYMBOL_Ampersand = 18,                 /* Ampersand  */
  YYSYMBOL_Bar = 19,                       /* Bar  */
  YYSYMBOL_CarriageReturn = 20,            /* CarriageReturn  */
  YYSYMBOL_Circomflex = 21,                /* Circomflex  */
  YYSYMBOL_Codop_rd = 22,                  /* Codop_rd  */
  YYSYMBOL_Codop_rd_rs_rt = 23,            /* Codop_rd_rs_rt  */
  YYSYMBOL_Codop_rd_rt_sham = 24,          /* Codop_rd_rt_sham  */
  YYSYMBOL_Codop_rd_rt_rs = 25,            /* Codop_rd_rt_rs  */
  YYSYMBOL_Codop_rd_rs_imd = 26,           /* Codop_rd_rs_imd  */
  YYSYMBOL_Codop_rs_rt_labl = 27,          /* Codop_rs_rt_labl  */
  YYSYMBOL_Codop_od_rs = 28,               /* Codop_od_rs  */
  YYSYMBOL_Codop_rs = 29,                  /* Codop_rs  */
  YYSYMBOL_Codop_rd_mem = 30,              /* Codop_rd_mem  */
  YYSYMBOL_Codop_rt_mem = 31,              /* Codop_rt_mem  */
  YYSYMBOL_Codop_rt_cp0rd = 32,            /* Codop_rt_cp0rd  */
  YYSYMBOL_Codop_rs_labl = 33,             /* Codop_rs_labl  */
  YYSYMBOL_Codop_rd_imd = 34,              /* Codop_rd_imd  */
  YYSYMBOL_Codop_labl = 35,                /* Codop_labl  */
  YYSYMBOL_Codop_imd = 36,                 /* Codop_imd  */
  YYSYMBOL_Codop_n = 37,                   /* Codop_n  */
  YYSYMBOL_Colon = 38,                     /* Colon  */
  YYSYMBOL_Comma = 39,                     /* Comma  */
  YYSYMBOL_CP0Register = 40,               /* CP0Register  */
  YYSYMBOL_DoubleGreat = 41,               /* DoubleGreat  */
  YYSYMBOL_DoubleLess = 42,                /* DoubleLess  */
  YYSYMBOL_Identifier = 43,                /* Identifier  */
  YYSYMBOL_IntegerRegister = 44,           /* IntegerRegister  */
  YYSYMBOL_LeftParen = 45,                 /* LeftParen  */
  YYSYMBOL_Litteral = 46,                  /* Litteral  */
  YYSYMBOL_Macro_n = 47,                   /* Macro_n  */
  YYSYMBOL_Macro_rd_longi = 48,            /* Macro_rd_longi  */
  YYSYMBOL_Minus = 49,                     /* Minus  */
  YYSYMBOL_Plus = 50,                      /* Plus  */
  YYSYMBOL_Register = 51,                  /* Register  */
  YYSYMBOL_RightParen = 52,                /* RightParen  */
  YYSYMBOL_Sharp = 53,                     /* Sharp  */
  YYSYMBOL_Slash = 54,                     /* Slash  */
  YYSYMBOL_Star = 55,                      /* Star  */
  YYSYMBOL_String = 56,                    /* String  */
  YYSYMBOL_Tilda = 57,                     /* Tilda  */
  YYSYMBOL_YYACCEPT = 58,                  /* $accept  */
  YYSYMBOL_mips_assembly_prog = 59,        /* mips_assembly_prog  */
  YYSYMBOL_assembly_instructions = 60,     /* assembly_instructions  */
  YYSYMBOL_61_an_assembly_instruction_ = 61, /* ..an_assembly_instruction..  */
  YYSYMBOL_an_assembly_instruction = 62,   /* an_assembly_instruction  */
  YYSYMBOL_63_a_label_ = 63,               /* .a_label.  */
  YYSYMBOL_64_unlabeled_assembly_instruction_ = 64, /* .unlabeled_assembly_instruction.  */
  YYSYMBOL_mem_alloc_directive = 65,       /* mem_alloc_directive  */
  YYSYMBOL_word_alloc = 66,                /* word_alloc  */
  YYSYMBOL_byte_alloc = 67,                /* byte_alloc  */
  YYSYMBOL_bytez_alloc = 68,               /* bytez_alloc  */
  YYSYMBOL_ascii_alloc = 69,               /* ascii_alloc  */
  YYSYMBOL_asciiz_alloc = 70,              /* asciiz_alloc  */
  YYSYMBOL_unlabeled_pseudo_instruction = 71, /* unlabeled_pseudo_instruction  */
  YYSYMBOL_data_pseudo_inst = 72,          /* data_pseudo_inst  */
  YYSYMBOL_text_pseudo_inst = 73,          /* text_pseudo_inst  */
  YYSYMBOL_global_pseudo_inst = 74,        /* global_pseudo_inst  */
  YYSYMBOL_align_pseudo_inst = 75,         /* align_pseudo_inst  */
  YYSYMBOL_76_end_pseudo_inst_ = 76,       /* .end_pseudo_inst.  */
  YYSYMBOL_end_pseudo_inst = 77,           /* end_pseudo_inst  */
  YYSYMBOL_start_pseudo_inst = 78,         /* start_pseudo_inst  */
  YYSYMBOL_space_pseudo_inst = 79,         /* space_pseudo_inst  */
  YYSYMBOL_skip_pseudo_inst = 80,          /* skip_pseudo_inst  */
  YYSYMBOL_org_pseudo_inst = 81,           /* org_pseudo_inst  */
  YYSYMBOL_equ_pseudo_inst = 82,           /* equ_pseudo_inst  */
  YYSYMBOL_effective_instruction = 83,     /* effective_instruction  */
  YYSYMBOL_mips_instruction = 84,          /* mips_instruction  */
  YYSYMBOL_format_rd_rs_rt = 85,           /* format_rd_rs_rt  */
  YYSYMBOL_format_rd_rt_rs = 86,           /* format_rd_rt_rs  */
  YYSYMBOL_format_rt_cp0rd = 87,           /* format_rt_cp0rd  */
  YYSYMBOL_format_rd = 88,                 /* format_rd  */
  YYSYMBOL_format_od_rs = 89,              /* format_od_rs  */
  YYSYMBOL_format_rs = 90,                 /* format_rs  */
  YYSYMBOL_format_rd_rs_imd = 91,          /* format_rd_rs_imd  */
  YYSYMBOL_format_rd_rt_sham = 92,         /* format_rd_rt_sham  */
  YYSYMBOL_format_rd_mem = 93,             /* format_rd_mem  */
  YYSYMBOL_format_rt_mem = 94,             /* format_rt_mem  */
  YYSYMBOL_format_rs_rt_labl = 95,         /* format_rs_rt_labl  */
  YYSYMBOL_format_rs_labl = 96,            /* format_rs_labl  */
  YYSYMBOL_format_rd_imd = 97,             /* format_rd_imd  */
  YYSYMBOL_format_imd = 98,                /* format_imd  */
  YYSYMBOL_format_labl = 99,               /* format_labl  */
  YYSYMBOL_format_n = 100,                 /* format_n  */
  YYSYMBOL_101_sharp_ = 101,               /* .sharp.  */
  YYSYMBOL_macro_instruction = 102,        /* macro_instruction  */
  YYSYMBOL_macro_ri = 103,                 /* macro_ri  */
  YYSYMBOL_macro_n = 104,                  /* macro_n  */
  YYSYMBOL_offset = 105,                   /* offset  */
  YYSYMBOL_106_immediate_ = 106,           /* .immediate.  */
  YYSYMBOL_immediate = 107,                /* immediate  */
  YYSYMBOL_108_expr_addop__expr_ = 108,    /* expr..addop__expr..  */
  YYSYMBOL_109_expr__mulop__expr_mulop__expr_ = 109, /* expr__mulop__expr..mulop__expr..  */
  YYSYMBOL_110_expr__logop__expr_logop__expr_ = 110, /* expr__logop__expr..logop__expr..  */
  YYSYMBOL_expr__shfop__expr = 111,        /* expr__shfop__expr  */
  YYSYMBOL_shift_operator = 112,           /* shift_operator  */
  YYSYMBOL_mul_div_operator = 113,         /* mul_div_operator  */
  YYSYMBOL_expression = 114,               /* expression  */
  YYSYMBOL_logical_operator = 115,         /* logical_operator  */
  YYSYMBOL_adding_operator = 116,          /* adding_operator  */
  YYSYMBOL_term = 117,                     /* term  */
  YYSYMBOL_destination_register = 118,     /* destination_register  */
  YYSYMBOL_source_register = 119,          /* source_register  */
  YYSYMBOL_integer_register = 120,         /* integer_register  */
  YYSYMBOL_cp0_reg = 121,                  /* cp0_reg  */
  YYSYMBOL_label = 122,                    /* label  */
  YYSYMBOL_123_CR_ = 123,                  /* ..CR..  */
  YYSYMBOL_CarriageReturn_ERR = 124        /* CarriageReturn_ERR  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   251

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  58
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  67
/* YYNRULES -- Number of rules.  */
#define YYNRULES  130
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  222

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   312


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   447,   447,   452,   456,   457,   462,   465,   467,   472,
     473,   498,   499,   509,   522,   524,   526,   528,   530,   532,
     537,   545,   559,   574,   592,   605,   624,   625,   626,   627,
     628,   629,   630,   634,   666,   698,   703,   730,   731,   735,
     740,   745,   753,   761,   776,   806,   808,   813,   815,   817,
     819,   821,   823,   825,   827,   829,   831,   833,   835,   837,
     839,   841,   843,   848,   869,   890,   909,   926,   940,   959,
     976,  1001,  1026,  1051,  1076,  1108,  1138,  1160,  1181,  1209,
    1225,  1226,  1230,  1232,  1237,  1275,  1296,  1302,  1306,  1311,
    1313,  1315,  1317,  1322,  1324,  1346,  1365,  1384,  1407,  1433,
    1455,  1457,  1462,  1464,  1469,  1475,  1483,  1491,  1496,  1498,
    1500,  1505,  1507,  1512,  1517,  1523,  1529,  1537,  1546,  1558,
    1560,  1565,  1567,  1572,  1574,  1579,  1581,  1586,  1591,  1592,
    1597
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "_ALIGN", "_ASCII",
  "_ASCIIZ", "_BYTE", "_BYTEZ", "_DATA", "_END", "_EQU", "_GLOBAL", "_ORG",
  "_SPACE", "_SKIP", "_START", "_TEXT", "_WORD", "Ampersand", "Bar",
  "CarriageReturn", "Circomflex", "Codop_rd", "Codop_rd_rs_rt",
  "Codop_rd_rt_sham", "Codop_rd_rt_rs", "Codop_rd_rs_imd",
  "Codop_rs_rt_labl", "Codop_od_rs", "Codop_rs", "Codop_rd_mem",
  "Codop_rt_mem", "Codop_rt_cp0rd", "Codop_rs_labl", "Codop_rd_imd",
  "Codop_labl", "Codop_imd", "Codop_n", "Colon", "Comma", "CP0Register",
  "DoubleGreat", "DoubleLess", "Identifier", "IntegerRegister",
  "LeftParen", "Litteral", "Macro_n", "Macro_rd_longi", "Minus", "Plus",
  "Register", "RightParen", "Sharp", "Slash", "Star", "String", "Tilda",
  "$accept", "mips_assembly_prog", "assembly_instructions",
  "..an_assembly_instruction..", "an_assembly_instruction", ".a_label.",
  ".unlabeled_assembly_instruction.", "mem_alloc_directive", "word_alloc",
  "byte_alloc", "bytez_alloc", "ascii_alloc", "asciiz_alloc",
  "unlabeled_pseudo_instruction", "data_pseudo_inst", "text_pseudo_inst",
  "global_pseudo_inst", "align_pseudo_inst", ".end_pseudo_inst.",
  "end_pseudo_inst", "start_pseudo_inst", "space_pseudo_inst",
  "skip_pseudo_inst", "org_pseudo_inst", "equ_pseudo_inst",
  "effective_instruction", "mips_instruction", "format_rd_rs_rt",
  "format_rd_rt_rs", "format_rt_cp0rd", "format_rd", "format_od_rs",
  "format_rs", "format_rd_rs_imd", "format_rd_rt_sham", "format_rd_mem",
  "format_rt_mem", "format_rs_rt_labl", "format_rs_labl", "format_rd_imd",
  "format_imd", "format_labl", "format_n", ".sharp.", "macro_instruction",
  "macro_ri", "macro_n", "offset", ".immediate.", "immediate",
  "expr..addop__expr..", "expr__mulop__expr..mulop__expr..",
  "expr__logop__expr..logop__expr..", "expr__shfop__expr",
  "shift_operator", "mul_div_operator", "expression", "logical_operator",
  "adding_operator", "term", "destination_register", "source_register",
  "integer_register", "cp0_reg", "label", "..CR..", "CarriageReturn_ERR", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-145)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-123)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -145,     9,     5,   203,  -145,  -145,  -145,  -145,    16,    11,
     -38,   -18,   -38,   -18,   -38,    19,  -145,    42,    16,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,    12,    16,  -145,  -145,
    -145,  -145,   -38,  -145,    49,    54,  -145,  -145,     4,     7,
      24,  -145,    -3,  -145,  -145,  -145,  -145,  -145,  -145,   -38,
      32,    37,   -38,   -38,    56,    57,   -38,   -34,   -34,   -34,
     -34,   -34,   -21,   -17,   -21,   -34,   -21,   -16,   -21,   -34,
     -38,    51,  -145,  -145,   -34,    16,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,    53,  -145,
     -38,  -145,  -145,   -38,  -145,  -145,  -145,   -38,   -38,  -145,
    -145,  -145,   -38,  -145,  -145,  -145,  -145,   -38,   -38,   -38,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,    67,    68,    69,    70,  -145,  -145,    71,    91,    98,
      80,  -145,  -145,    81,    82,  -145,  -145,    83,    84,    85,
    -145,  -145,   -38,    86,  -145,  -145,    74,    75,  -145,  -145,
    -145,  -145,  -145,  -145,   -21,   -21,   -21,   -21,   -21,   -21,
     -38,   -38,   -27,   -38,   -38,  -145,   -38,  -145,  -145,    89,
      90,    92,    93,    94,  -145,    95,  -145,    96,  -145,  -145,
    -145,  -145,  -145,  -145,   -21,    51,   -21,    51,   -38,   -21,
     -21,  -145,   -38,  -145,   -38,  -145,    78,    87,  -145,  -145,
    -145,  -145
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,    37,     0,     1,   128,     2,    38,     0,     0,
      87,     0,     0,     0,    87,   127,     5,    11,     0,    27,
      32,    29,    26,    31,    30,    28,     0,    39,   130,     8,
      36,   116,     0,   113,     0,     0,    33,    88,    89,    90,
      91,    92,    93,   107,   127,    35,    43,    40,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    79,    85,     0,     0,    12,    14,    15,    16,
      17,    18,    20,    19,    13,    45,    60,    61,    62,    57,
      58,    59,    55,    56,    53,    54,    52,    51,    50,    49,
      48,    47,    46,    82,    83,     7,    10,   129,     0,   117,
       0,   114,   118,     0,   115,   112,   111,     0,     0,   109,
     108,   110,     0,   101,   100,   103,   102,     0,     0,     0,
      44,    24,    25,    22,    23,    41,    42,    21,   119,   120,
      66,     0,     0,     0,     0,   121,   122,     0,   119,   120,
       0,    67,    69,     0,     0,   123,   124,     0,     0,     0,
      78,    81,     0,     0,     6,   104,     0,     0,    94,    96,
      98,    99,    95,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    77,     0,   106,   105,     0,
       0,     0,     0,     0,    68,     0,    86,     0,   125,   126,
      65,    75,    76,    84,     0,    80,     0,    80,     0,     0,
       0,    63,     0,    64,     0,    74,     0,     0,    71,    70,
      72,    73
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -144,  -145,  -145,  -145,   -47,   121,   -12,
    -145,  -145,  -145,  -145,  -145,  -145,   -96,   101,  -145,  -145,
      22,   -62,  -145,  -145,    73,  -145,   -15
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     2,     3,    16,    17,    75,    76,    77,    78,
      79,    80,    81,    18,    19,    20,    21,    22,     6,     7,
      23,    82,    83,    24,    25,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   162,   102,   103,   104,   195,    36,    37,
      38,    39,    40,    41,   127,   128,    42,   122,   117,    43,
     140,   147,   157,   200,    26,    27,    29
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      46,   151,   152,   105,   154,    31,   158,    32,    33,     4,
     138,    34,   107,   198,     5,   119,   120,   139,   121,    35,
     108,   168,   169,   145,   199,    44,   170,   148,   155,    49,
     146,   171,   172,   173,   149,   156,    28,   130,   123,   124,
     133,   134,   119,   120,   137,   121,    50,    51,    52,    53,
     106,   125,   126,   115,   116,    54,    55,    30,   160,    56,
     164,   212,   118,   214,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     141,   142,   143,   144,    45,   150,    47,   153,   131,    73,
      74,   159,   109,   132,   110,   111,   163,   112,   166,   113,
     114,   167,   135,   136,   161,   165,   174,   175,   176,   177,
     178,  -121,   189,   190,   191,   192,   193,   194,  -122,   179,
     180,   181,   182,   183,   184,   186,   187,   188,   204,   205,
     220,   206,   207,   208,   197,    48,     0,     0,     0,   221,
     209,   210,   211,   129,   213,     0,     0,   216,   217,     0,
     185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   196,   196,
       0,   201,   202,     0,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   215,     0,     0,     0,
     218,     0,   219,    -3,     8,     0,     9,    -9,    -9,    -9,
      -9,    10,    -3,     0,    11,    12,    -9,    -9,    13,    14,
      -9,     0,     0,    -9,     0,    -9,    -9,    -9,    -9,    -9,
      -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,
      -9,     0,     0,     0,     0,     0,    15,     0,     0,     0,
      -9,    -9
};

static const yytype_int16 yycheck[] =
{
      12,    63,    64,    18,    66,    43,    68,    45,    46,     0,
      44,    49,    27,    40,     9,    18,    19,    51,    21,    57,
      32,   117,   118,    44,    51,    43,   122,    44,    44,    10,
      51,   127,   128,   129,    51,    51,    20,    49,    41,    42,
      52,    53,    18,    19,    56,    21,     4,     5,     6,     7,
      38,    54,    55,    49,    50,    13,    14,    46,    70,    17,
      75,   205,    55,   207,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      58,    59,    60,    61,    11,    63,    13,    65,    56,    47,
      48,    69,    43,    56,    45,    46,    74,    43,   110,    45,
      46,   113,    46,    46,    53,    52,    39,    39,    39,    39,
      39,    20,   174,   175,   176,   177,   178,   179,    20,    39,
      39,    39,    39,    39,    39,    39,    52,    52,    39,    39,
      52,    39,    39,    39,   181,    14,    -1,    -1,    -1,    52,
      45,    45,   204,    42,   206,    -1,    -1,   209,   210,    -1,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,   181,
      -1,   183,   184,    -1,   186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,
     212,    -1,   214,     0,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,
      47,    48
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    59,    60,    61,     0,     9,    76,    77,     1,     3,
       8,    11,    12,    15,    16,    43,    62,    63,    71,    72,
      73,    74,    75,    78,    81,    82,   122,   123,    20,   124,
      46,    43,    45,    46,    49,    57,   106,   107,   108,   109,
     110,   111,   114,   117,    43,   122,   107,   122,   106,    10,
       4,     5,     6,     7,    13,    14,    17,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    47,    48,    64,    65,    66,    67,    68,
      69,    70,    79,    80,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   102,   103,   104,   124,    38,   124,   107,    43,
      45,    46,    43,    45,    46,    49,    50,   116,    55,    18,
      19,    21,   115,    41,    42,    54,    55,   112,   113,   115,
     107,    56,    56,   107,   107,    46,    46,   107,    44,    51,
     118,   118,   118,   118,   118,    44,    51,   119,    44,    51,
     118,   119,   119,   118,   119,    44,    51,   120,   119,   118,
     107,    53,   101,   118,   124,    52,   107,   107,   114,   114,
     114,   114,   114,   114,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,   107,    39,    52,    52,   119,
     119,   119,   119,   119,   119,   105,   107,   105,    40,    51,
     121,   107,   107,   107,    39,    39,    39,    39,    39,    45,
      45,   119,   101,   119,   101,   107,   119,   119,   107,   107,
      52,    52
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    58,    59,    60,    61,    61,    62,    62,    62,    63,
      63,    64,    64,    64,    65,    65,    65,    65,    65,    65,
      65,    66,    67,    68,    69,    70,    71,    71,    71,    71,
      71,    71,    71,    72,    73,    74,    75,    76,    76,    77,
      78,    79,    80,    81,    82,    83,    83,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    85,    86,    87,    88,    89,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   101,   102,   102,   103,   104,   105,   106,   106,   107,
     107,   107,   107,   108,   108,   109,   109,   110,   110,   111,
     112,   112,   113,   113,   114,   114,   114,   114,   115,   115,
     115,   116,   116,   117,   117,   117,   117,   117,   117,   118,
     118,   119,   119,   120,   120,   121,   121,   122,   123,   123,
     124
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     0,     2,     3,     2,     2,     0,
       2,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     0,     1,     2,
       2,     2,     2,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     6,     4,     2,     2,     4,     2,
       7,     7,     7,     7,     6,     4,     4,     3,     2,     1,
       0,     1,     1,     1,     4,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 10: /* .a_label.: label Colon  */
#line 475 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the label is unique.	*/
		/* Save its address in the dictionary and flag it as a	*/
		/* label.						*/
		/* ###----------------------------------------------### */

		if (MPS_PASNBR == 1)
		  {
		  if (beh_chktab (MPS_HSHTAB, (yyvsp[-1].text), NULL, 0) == 0)
		    {
		    beh_addtab (MPS_HSHTAB, (yyvsp[-1].text), NULL, 0, 'l'       );
		    beh_addtab (MPS_HSHTAB, (yyvsp[-1].text), NULL, 7, MPS_ADDRES);
		    if (MPS_SYMBOL == 'y')
		      mips_symbol ((yyvsp[-1].text));
		    }
		  else
		    mips_error (3, NULL);
		  }
		}
#line 1851 "y.tab.c"
    break;

  case 12: /* .unlabeled_assembly_instruction.: mem_alloc_directive  */
#line 500 "./mips_y.y"
                {
		if ((MPS_PASNBR == 2) && ((yyvsp[0].immd).flag == 0))
		  mips_error (4, NULL);

		if (MPS_PASNBR == 2)
		  mips_print ((yyvsp[0].immd).valu);

		MPS_ADDRES += (yyvsp[0].immd).valu;
		}
#line 1865 "y.tab.c"
    break;

  case 13: /* .unlabeled_assembly_instruction.: effective_instruction  */
#line 510 "./mips_y.y"
                {
		if ((MPS_PASNBR == 2) && ((yyvsp[0].immd).flag == 0))
		  mips_error (4, NULL);

		if (MPS_PASNBR == 2)
		  mips_print ((yyvsp[0].immd).valu);

		MPS_ADDRES += (yyvsp[0].immd).valu;
		}
#line 1879 "y.tab.c"
    break;

  case 14: /* mem_alloc_directive: word_alloc  */
#line 523 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 1885 "y.tab.c"
    break;

  case 15: /* mem_alloc_directive: byte_alloc  */
#line 525 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 1891 "y.tab.c"
    break;

  case 16: /* mem_alloc_directive: bytez_alloc  */
#line 527 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 1897 "y.tab.c"
    break;

  case 17: /* mem_alloc_directive: ascii_alloc  */
#line 529 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 1903 "y.tab.c"
    break;

  case 18: /* mem_alloc_directive: asciiz_alloc  */
#line 531 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 1909 "y.tab.c"
    break;

  case 19: /* mem_alloc_directive: skip_pseudo_inst  */
#line 533 "./mips_y.y"
                {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
#line 1918 "y.tab.c"
    break;

  case 20: /* mem_alloc_directive: space_pseudo_inst  */
#line 538 "./mips_y.y"
                {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
#line 1927 "y.tab.c"
    break;

  case 21: /* word_alloc: _WORD immediate  */
#line 547 "./mips_y.y"
                {
		MPS_BYTTAB [3] = (yyvsp[0].immd).valu >> 24;
		MPS_BYTTAB [2] = (yyvsp[0].immd).valu >> 16;
		MPS_BYTTAB [1] = (yyvsp[0].immd).valu >>  8;
		MPS_BYTTAB [0] = (yyvsp[0].immd).valu      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 1941 "y.tab.c"
    break;

  case 22: /* byte_alloc: _BYTE immediate  */
#line 561 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   initialize a byte address with a value		*/
		/* ###----------------------------------------------### */

		MPS_BYTTAB [0] = (yyvsp[0].immd).valu;

		(yyval.immd).valu = 1      ;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 1956 "y.tab.c"
    break;

  case 23: /* bytez_alloc: _BYTEZ immediate  */
#line 576 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   initialize a byte table with zeros			*/
		/* ###----------------------------------------------### */

		unsigned int i;

		for (i=0; i<(yyvsp[0].immd).valu ; i++)
		  MPS_BYTTAB [i] = 0x00;

		(yyval.immd).valu = (yyvsp[0].immd).valu;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 1974 "y.tab.c"
    break;

  case 24: /* ascii_alloc: _ASCII String  */
#line 594 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* ###----------------------------------------------### */

		(yyval.immd).valu = mips_strtobin ((yyvsp[0].text), MPS_BYTTAB);
		(yyval.immd).flag = 'n';
		}
#line 1987 "y.tab.c"
    break;

  case 25: /* asciiz_alloc: _ASCIIZ String  */
#line 607 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* followed by a null character				*/
		/* ###----------------------------------------------### */

		unsigned int size;

		size = mips_strtobin ((yyvsp[0].text), MPS_BYTTAB);
		MPS_BYTTAB [size] = '\0';

		(yyval.immd).valu = size + 1;
		(yyval.immd).flag = 'n';
		}
#line 2006 "y.tab.c"
    break;

  case 33: /* data_pseudo_inst: _DATA .immediate.  */
#line 636 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   if the current region is the 'text region', switch	*/
		/* to the 'data region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (MPS_ADRSPC == 'T')
		  {
		  MPS_TXTADR = MPS_ADDRES;

		  MPS_ADDRES = MPS_DATADR;
		  MPS_WRTFIL = MPS_DATFIL;
		  MPS_ADRSIZ = MPS_DATSIZ;
		  MPS_WRDSIZ =  1 ;
		  MPS_ADRSPC = 'D';
		  }

		if ((yyvsp[0].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[0].immd).valu;
		else
		  {
		  if ((yyvsp[0].immd).flag != 'n')
		    mips_error (4, NULL);
		  }
		}
#line 2038 "y.tab.c"
    break;

  case 34: /* text_pseudo_inst: _TEXT .immediate.  */
#line 668 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   if the current region is the 'data region', switch	*/
		/* to the 'text region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (MPS_ADRSPC == 'D')
		  {
		  MPS_DATADR = MPS_ADDRES;

		  MPS_ADDRES = MPS_TXTADR;
		  MPS_WRTFIL = MPS_TXTFIL;
		  MPS_ADRSIZ = MPS_TXTSIZ;
		  MPS_WRDSIZ = 4;
		  MPS_ADRSPC = 'T';
		  }

		if ((yyvsp[0].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[0].immd).valu;
		else
		  {
		  if ((yyvsp[0].immd).flag != 'n')
		    mips_error (4, NULL);
		  }
		}
#line 2070 "y.tab.c"
    break;

  case 36: /* align_pseudo_inst: _ALIGN Litteral  */
#line 705 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   align the current address				*/
		/* ###----------------------------------------------### */

		switch ((yyvsp[0].valu))
		  {
		  case 1:
		    break;
		  case 2:
		    MPS_ADDRES = (MPS_ADDRES + 1) & 0xfffffffe;
		    break;
		  case 4:
		    MPS_ADDRES = (MPS_ADDRES + 3) & 0xfffffffc;
		    break;
		  case 8:
		    MPS_ADDRES = (MPS_ADDRES + 7) & 0xfffffff8;
		    break;
		  default:
		    mips_error (4, NULL);
		  }
		}
#line 2097 "y.tab.c"
    break;

  case 41: /* space_pseudo_inst: _SPACE Litteral  */
#line 747 "./mips_y.y"
                {
		MPS_ADDRES += (yyvsp[0].valu);
		}
#line 2105 "y.tab.c"
    break;

  case 42: /* skip_pseudo_inst: _SKIP Litteral  */
#line 755 "./mips_y.y"
                {
		MPS_ADDRES += (yyvsp[0].valu);
		}
#line 2113 "y.tab.c"
    break;

  case 43: /* org_pseudo_inst: _ORG immediate  */
#line 763 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   define the first address (must be an immediate)	*/
		/* ###----------------------------------------------### */

		if ((yyvsp[0].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[0].immd).valu;
		else
		  mips_error (4, NULL);
		}
#line 2128 "y.tab.c"
    break;

  case 44: /* equ_pseudo_inst: Identifier _EQU immediate  */
#line 779 "./mips_y.y"
                {
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the identifier has	*/
		/* not been defined ealier.				*/
		/*   Save its value in the dictionary and flag it as	*/
		/* an immediate.					*/
		/* ###----------------------------------------------### */

		if (MPS_PASNBR == 1)
		  {
		  if ((yyvsp[0].immd).flag == 'i')
		    {
		    if (beh_chktab (MPS_HSHTAB, (yyvsp[-2].text), NULL, 0) == 0)
		      {
		      beh_addtab (MPS_HSHTAB, (yyvsp[-2].text), NULL, 0, 'i'    );
		      beh_addtab (MPS_HSHTAB, (yyvsp[-2].text), NULL, 7, (yyvsp[0].immd).valu);
		      }
		    else
		      mips_error (3, NULL);
		    }
		  else
		    mips_error (4, NULL);
		  }
		}
#line 2157 "y.tab.c"
    break;

  case 45: /* effective_instruction: mips_instruction  */
#line 807 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2163 "y.tab.c"
    break;

  case 46: /* effective_instruction: macro_instruction  */
#line 809 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2169 "y.tab.c"
    break;

  case 47: /* mips_instruction: format_n  */
#line 814 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2175 "y.tab.c"
    break;

  case 48: /* mips_instruction: format_labl  */
#line 816 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2181 "y.tab.c"
    break;

  case 49: /* mips_instruction: format_imd  */
#line 818 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2187 "y.tab.c"
    break;

  case 50: /* mips_instruction: format_rd_imd  */
#line 820 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2193 "y.tab.c"
    break;

  case 51: /* mips_instruction: format_rs_labl  */
#line 822 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2199 "y.tab.c"
    break;

  case 52: /* mips_instruction: format_rs_rt_labl  */
#line 824 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2205 "y.tab.c"
    break;

  case 53: /* mips_instruction: format_rd_mem  */
#line 826 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2211 "y.tab.c"
    break;

  case 54: /* mips_instruction: format_rt_mem  */
#line 828 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2217 "y.tab.c"
    break;

  case 55: /* mips_instruction: format_rd_rs_imd  */
#line 830 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2223 "y.tab.c"
    break;

  case 56: /* mips_instruction: format_rd_rt_sham  */
#line 832 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2229 "y.tab.c"
    break;

  case 57: /* mips_instruction: format_rd  */
#line 834 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2235 "y.tab.c"
    break;

  case 58: /* mips_instruction: format_od_rs  */
#line 836 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2241 "y.tab.c"
    break;

  case 59: /* mips_instruction: format_rs  */
#line 838 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2247 "y.tab.c"
    break;

  case 60: /* mips_instruction: format_rd_rs_rt  */
#line 840 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2253 "y.tab.c"
    break;

  case 61: /* mips_instruction: format_rd_rt_rs  */
#line 842 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2259 "y.tab.c"
    break;

  case 62: /* mips_instruction: format_rt_cp0rd  */
#line 844 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2265 "y.tab.c"
    break;

  case 63: /* format_rd_rs_rt: Codop_rd_rs_rt destination_register Comma source_register Comma source_register  */
#line 854 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-5].valu) | ((yyvsp[-2].valu) << 21) | ((yyvsp[0].valu) << 16) | ((yyvsp[-4].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2282 "y.tab.c"
    break;

  case 64: /* format_rd_rt_rs: Codop_rd_rt_rs destination_register Comma source_register Comma source_register  */
#line 875 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-5].valu) | ((yyvsp[0].valu) << 21) | ((yyvsp[-2].valu) << 16) | ((yyvsp[-4].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4  ;
		(yyval.immd).flag = 'n';
		}
#line 2299 "y.tab.c"
    break;

  case 65: /* format_rt_cp0rd: Codop_rt_cp0rd integer_register Comma cp0_reg  */
#line 894 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-3].valu) | ((yyvsp[-2].valu) << 16) | ((yyvsp[0].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4  ;
		(yyval.immd).flag = 'n';
		}
#line 2316 "y.tab.c"
    break;

  case 66: /* format_rd: Codop_rd destination_register  */
#line 911 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-1].valu) | ((yyvsp[0].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2333 "y.tab.c"
    break;

  case 67: /* format_od_rs: Codop_od_rs source_register  */
#line 928 "./mips_y.y"
                {
		unsigned long inst = 0x0000f800;

		inst           |= (yyvsp[-1].valu) | ((yyvsp[0].valu) << 21);
		MPS_BYTTAB [3]  = inst >> 24;
		MPS_BYTTAB [2]  = inst >> 16;
		MPS_BYTTAB [1]  = inst >>  8;
		MPS_BYTTAB [0]  = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2350 "y.tab.c"
    break;

  case 68: /* format_od_rs: Codop_od_rs destination_register Comma source_register  */
#line 944 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-3].valu) | ((yyvsp[0].valu) << 21) | ((yyvsp[-2].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2367 "y.tab.c"
    break;

  case 69: /* format_rs: Codop_rs source_register  */
#line 961 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[-1].valu) | ((yyvsp[0].valu) << 21);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2384 "y.tab.c"
    break;

  case 70: /* format_rd_rs_imd: Codop_rd_rs_imd destination_register Comma source_register Comma .sharp. immediate  */
#line 983 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[0].immd).valu;
		inst = (yyvsp[-6].valu) | ((yyvsp[-3].valu) << 21) | ((yyvsp[-5].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2404 "y.tab.c"
    break;

  case 71: /* format_rd_rt_sham: Codop_rd_rt_sham destination_register Comma source_register Comma .sharp. immediate  */
#line 1008 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000001f & (yyvsp[0].immd).valu;
		inst = (yyvsp[-6].valu) | ((yyvsp[-3].valu) << 16) | ((yyvsp[-5].valu) << 11) | (imd << 6);

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2424 "y.tab.c"
    break;

  case 72: /* format_rd_mem: Codop_rd_mem destination_register Comma offset LeftParen source_register RightParen  */
#line 1033 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[-3].immd).valu;
		inst = (yyvsp[-6].valu) | ((yyvsp[-1].valu) << 21) | ((yyvsp[-5].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[-3].immd).flag;
		}
#line 2444 "y.tab.c"
    break;

  case 73: /* format_rt_mem: Codop_rt_mem source_register Comma offset LeftParen source_register RightParen  */
#line 1058 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[-3].immd).valu;
		inst = (yyvsp[-6].valu) | ((yyvsp[-1].valu) << 21) | ((yyvsp[-5].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[-3].immd).flag;
		}
#line 2464 "y.tab.c"
    break;

  case 74: /* format_rs_rt_labl: Codop_rs_rt_labl source_register Comma source_register Comma immediate  */
#line 1082 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if ((yyvsp[0].immd).flag == 'l')
		  imd = (yyvsp[0].immd).valu - MPS_ADDRES - 4;
		else
		  {
		  if (MPS_PASNBR == 2)
		    mips_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = (yyvsp[-5].valu) | ((yyvsp[-4].valu) << 21) | ((yyvsp[-2].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4      ;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2492 "y.tab.c"
    break;

  case 75: /* format_rs_labl: Codop_rs_labl source_register Comma immediate  */
#line 1112 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if ((yyvsp[0].immd).flag == 'l')
		  imd = (yyvsp[0].immd).valu - MPS_ADDRES - 4;
		else
		  {
		  if (MPS_PASNBR == 2)
		    mips_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = (yyvsp[-3].valu) | ((yyvsp[-2].valu) << 21) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2520 "y.tab.c"
    break;

  case 76: /* format_rd_imd: Codop_rd_imd destination_register Comma immediate  */
#line 1142 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[0].immd).valu;
		inst = (yyvsp[-3].valu) | ((yyvsp[-2].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2540 "y.tab.c"
    break;

  case 77: /* format_imd: Codop_imd .sharp. immediate  */
#line 1163 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[0].immd).valu;
		inst = (yyvsp[-2].valu) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2560 "y.tab.c"
    break;

  case 78: /* format_labl: Codop_labl immediate  */
#line 1183 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd = (yyvsp[0].immd).valu;
/*--------
		if ($2.flag == 'l')
		  imd = $2.valu - MPS_ADDRES - 4;
		else
		  imd = $2.valu;
----------*/

		imd  = 0x03ffffff & (imd >> 2);
		inst = (yyvsp[-1].valu) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[0].immd).flag;
		}
#line 2588 "y.tab.c"
    break;

  case 79: /* format_n: Codop_n  */
#line 1210 "./mips_y.y"
                {
		unsigned long inst = 0;

		inst           = (yyvsp[0].valu);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
#line 2605 "y.tab.c"
    break;

  case 82: /* macro_instruction: macro_ri  */
#line 1231 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2611 "y.tab.c"
    break;

  case 83: /* macro_instruction: macro_n  */
#line 1233 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2617 "y.tab.c"
    break;

  case 84: /* macro_ri: Macro_rd_longi destination_register Comma immediate  */
#line 1241 "./mips_y.y"
                {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		switch ((yyvsp[-3].valu))
		  {
		  case _LOADI :
		    imd  = 0x0000ffff & ((yyvsp[0].immd).valu >> 16);
		    inst = _LUI | ((yyvsp[-2].valu) << 16) | imd;

		    MPS_BYTTAB [3] = inst >> 24;
		    MPS_BYTTAB [2] = inst >> 16;
		    MPS_BYTTAB [1] = inst >>  8;
		    MPS_BYTTAB [0] = inst      ;

		    imd  = 0x0000ffff & (yyvsp[0].immd).valu;
		    inst = _ORI | ((yyvsp[-2].valu) << 21) | ((yyvsp[-2].valu) << 16) | imd;

		    MPS_BYTTAB [7] = inst >> 24;
		    MPS_BYTTAB [6] = inst >> 16;
		    MPS_BYTTAB [5] = inst >>  8;
		    MPS_BYTTAB [4] = inst      ;

		    (yyval.immd).valu = 8;
		    (yyval.immd).flag = (yyvsp[0].immd).flag;
		    break;

		  default:
		    mips_error (5, NULL);
		  }
		}
#line 2653 "y.tab.c"
    break;

  case 85: /* macro_n: Macro_n  */
#line 1276 "./mips_y.y"
                {
		switch ((yyvsp[0].valu))
		  {
		  case _NOP :
		    MPS_BYTTAB [3] = 0x00;
		    MPS_BYTTAB [2] = 0x00;
		    MPS_BYTTAB [1] = 0x00;
		    MPS_BYTTAB [0] = 0x21;

		    (yyval.immd).valu = 4;
		    (yyval.immd).flag = 'n';
		    break;

		  default:
		    mips_error (5, NULL);
		  }
		}
#line 2675 "y.tab.c"
    break;

  case 86: /* offset: immediate  */
#line 1297 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2681 "y.tab.c"
    break;

  case 87: /* .immediate.: %empty  */
#line 1302 "./mips_y.y"
                {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
#line 2690 "y.tab.c"
    break;

  case 88: /* .immediate.: immediate  */
#line 1307 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2696 "y.tab.c"
    break;

  case 89: /* immediate: expr..addop__expr..  */
#line 1312 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2702 "y.tab.c"
    break;

  case 90: /* immediate: expr__mulop__expr..mulop__expr..  */
#line 1314 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2708 "y.tab.c"
    break;

  case 91: /* immediate: expr__logop__expr..logop__expr..  */
#line 1316 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2714 "y.tab.c"
    break;

  case 92: /* immediate: expr__shfop__expr  */
#line 1318 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2720 "y.tab.c"
    break;

  case 93: /* expr..addop__expr..: expression  */
#line 1323 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2726 "y.tab.c"
    break;

  case 94: /* expr..addop__expr..: expr..addop__expr.. adding_operator expression  */
#line 1327 "./mips_y.y"
                {
		if ((yyvsp[-1].valu) == MPS_PLSDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu + (yyvsp[0].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[-2].immd).valu - (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2747 "y.tab.c"
    break;

  case 95: /* expr__mulop__expr..mulop__expr..: expression mul_div_operator expression  */
#line 1349 "./mips_y.y"
                {
		if ((yyvsp[-1].valu) == MPS_MULDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu * (yyvsp[0].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[-2].immd).valu / (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2768 "y.tab.c"
    break;

  case 96: /* expr__mulop__expr..mulop__expr..: expr__mulop__expr..mulop__expr.. Star expression  */
#line 1368 "./mips_y.y"
                {
		(yyval.immd).valu = (yyvsp[-2].immd).valu * (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2786 "y.tab.c"
    break;

  case 97: /* expr__logop__expr..logop__expr..: expression logical_operator expression  */
#line 1387 "./mips_y.y"
                {
		if ((yyvsp[-1].valu) == MPS_ORDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu | (yyvsp[0].immd).valu;

		if ((yyvsp[-1].valu) == MPS_ANDDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu & (yyvsp[0].immd).valu;

		if ((yyvsp[-1].valu) == MPS_XORDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu ^ (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2811 "y.tab.c"
    break;

  case 98: /* expr__logop__expr..logop__expr..: expr__logop__expr..logop__expr.. logical_operator expression  */
#line 1410 "./mips_y.y"
                {
		if ((yyvsp[-1].valu) == MPS_ORDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu | (yyvsp[0].immd).valu;

		if ((yyvsp[-1].valu) == MPS_ANDDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu & (yyvsp[0].immd).valu;

		if ((yyvsp[-1].valu) == MPS_XORDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu ^ (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2836 "y.tab.c"
    break;

  case 99: /* expr__shfop__expr: expression shift_operator expression  */
#line 1436 "./mips_y.y"
                {
		if ((yyvsp[-1].valu) == MPS_SHLDFN)
		  (yyval.immd).valu = (yyvsp[-2].immd).valu << (yyvsp[0].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[-2].immd).valu >> (yyvsp[0].immd).valu;

		if (((yyvsp[-2].immd).flag == 0) || ((yyvsp[0].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[-2].immd).flag == 'l') || ((yyvsp[0].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
#line 2857 "y.tab.c"
    break;

  case 100: /* shift_operator: DoubleLess  */
#line 1456 "./mips_y.y"
                { (yyval.valu) = MPS_SHLDFN; }
#line 2863 "y.tab.c"
    break;

  case 101: /* shift_operator: DoubleGreat  */
#line 1458 "./mips_y.y"
                { (yyval.valu) = MPS_SHRDFN; }
#line 2869 "y.tab.c"
    break;

  case 102: /* mul_div_operator: Star  */
#line 1463 "./mips_y.y"
                { (yyval.valu) = MPS_MULDFN; }
#line 2875 "y.tab.c"
    break;

  case 103: /* mul_div_operator: Slash  */
#line 1465 "./mips_y.y"
                { (yyval.valu) = MPS_DIVDFN; }
#line 2881 "y.tab.c"
    break;

  case 104: /* expression: LeftParen immediate RightParen  */
#line 1472 "./mips_y.y"
                {
		(yyval.immd) = (yyvsp[-1].immd);
		}
#line 2889 "y.tab.c"
    break;

  case 105: /* expression: Tilda LeftParen immediate RightParen  */
#line 1479 "./mips_y.y"
                {
		(yyval.immd).valu = ~ ((yyvsp[-1].immd).valu);
		(yyval.immd).flag = (yyvsp[-1].immd).flag;
		}
#line 2898 "y.tab.c"
    break;

  case 106: /* expression: Minus LeftParen immediate RightParen  */
#line 1487 "./mips_y.y"
                {
		(yyval.immd).valu = - (yyvsp[-1].immd).valu;
		(yyval.immd).flag = (yyvsp[-1].immd).flag;
		}
#line 2907 "y.tab.c"
    break;

  case 107: /* expression: term  */
#line 1492 "./mips_y.y"
                { (yyval.immd) = (yyvsp[0].immd); }
#line 2913 "y.tab.c"
    break;

  case 108: /* logical_operator: Bar  */
#line 1497 "./mips_y.y"
                { (yyval.valu) = MPS_ORDFN;  }
#line 2919 "y.tab.c"
    break;

  case 109: /* logical_operator: Ampersand  */
#line 1499 "./mips_y.y"
                { (yyval.valu) = MPS_ANDDFN; }
#line 2925 "y.tab.c"
    break;

  case 110: /* logical_operator: Circomflex  */
#line 1501 "./mips_y.y"
                { (yyval.valu) = MPS_XORDFN; }
#line 2931 "y.tab.c"
    break;

  case 111: /* adding_operator: Plus  */
#line 1506 "./mips_y.y"
                { (yyval.valu) = MPS_PLSDFN; }
#line 2937 "y.tab.c"
    break;

  case 112: /* adding_operator: Minus  */
#line 1508 "./mips_y.y"
                { (yyval.valu) = MPS_MNSDFN; }
#line 2943 "y.tab.c"
    break;

  case 113: /* term: Litteral  */
#line 1513 "./mips_y.y"
                {
		(yyval.immd).valu = (yyvsp[0].valu);
		(yyval.immd).flag = 'i';
		}
#line 2952 "y.tab.c"
    break;

  case 114: /* term: Minus Litteral  */
#line 1519 "./mips_y.y"
                {
		(yyval.immd).valu = - (yyvsp[0].valu);
		(yyval.immd).flag = 'i';
		}
#line 2961 "y.tab.c"
    break;

  case 115: /* term: Tilda Litteral  */
#line 1525 "./mips_y.y"
                {
		(yyval.immd).valu = ~ (yyvsp[0].valu);
		(yyval.immd).flag = 'i';
		}
#line 2970 "y.tab.c"
    break;

  case 116: /* term: Identifier  */
#line 1530 "./mips_y.y"
                {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 7);
		(yyval.immd).valu = imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 0);
		}
#line 2982 "y.tab.c"
    break;

  case 117: /* term: Minus Identifier  */
#line 1539 "./mips_y.y"
                {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 7);
		(yyval.immd).valu = -imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 0);
		}
#line 2994 "y.tab.c"
    break;

  case 118: /* term: Tilda Identifier  */
#line 1548 "./mips_y.y"
                {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 7);
		(yyval.immd).valu = ~imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[0].text), NULL, 0);
		}
#line 3006 "y.tab.c"
    break;

  case 119: /* destination_register: IntegerRegister  */
#line 1559 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3012 "y.tab.c"
    break;

  case 120: /* destination_register: Register  */
#line 1561 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3018 "y.tab.c"
    break;

  case 121: /* source_register: IntegerRegister  */
#line 1566 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3024 "y.tab.c"
    break;

  case 122: /* source_register: Register  */
#line 1568 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3030 "y.tab.c"
    break;

  case 123: /* integer_register: IntegerRegister  */
#line 1573 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3036 "y.tab.c"
    break;

  case 124: /* integer_register: Register  */
#line 1575 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3042 "y.tab.c"
    break;

  case 125: /* cp0_reg: CP0Register  */
#line 1580 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3048 "y.tab.c"
    break;

  case 126: /* cp0_reg: Register  */
#line 1582 "./mips_y.y"
                { (yyval.valu) = (yyvsp[0].valu); }
#line 3054 "y.tab.c"
    break;

  case 127: /* label: Identifier  */
#line 1587 "./mips_y.y"
                { (yyval.text) = (yyvsp[0].text); }
#line 3060 "y.tab.c"
    break;

  case 130: /* CarriageReturn_ERR: CarriageReturn  */
#line 1598 "./mips_y.y"
                { yyerrok; }
#line 3066 "y.tab.c"
    break;


#line 3070 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1600 "./mips_y.y"


/* ###--------------------------------------------------------------### */
/* function	: mips_error						*/
/* description	: print an error message				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_error (code, str)

int   code;
char *str;

  {
  MPS_ERRFLG = 1;
  if (code <100)
    fprintf (stderr,"Error %d near line %d : ",code, MPS_LINNUM);

  switch (code)
    {
    case 2:
      fprintf (stderr, "missing label\n");
      break;
    case 3:
      fprintf (stderr, "redefinition of label\n");
      break;
    case 4:
      fprintf (stderr, "undifined string\n");
      break;
    case 5:
      fprintf (stderr, "parse error\n");
      break;
    case 6:
      fprintf (stderr, "no output file has been specified\n");
      break;
    case 100:
      fprintf (stderr, "cannot open file `%s`\n",str);
      break;
    case 101:
      fprintf (stderr, "usage: mips_asm [<options>] <assembly_file> <vhdl_file> <vhdl_file>\n");
      break;
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: yyerror						*/
/* description	: print yacc error messages				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

void yyerror (str)

char *str;

  {
  MPS_ERRFLG = 1;
  fprintf (stderr, "line %d : %s\n",MPS_LINNUM, str);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_foot						*/
/* description	: print the head lines of the behavioural description	*/
/*		  of a ROM. The 'address size' defines the number of	*/
/*		  bits of the address, the 'word size' defines the size	*/
/*		  of the rom line in bytes and the 'name' specifies the	*/
/*		  name of the Entity.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_head (fp, name, adr_siz, wrd_siz)

FILE         *fp;
char         *name;
unsigned int  adr_siz;
unsigned int  wrd_siz;

  {
  adr_siz --;
  wrd_siz = (wrd_siz * 8) - 1;

  fprintf (fp, "entity %s is\n  port (\n", name);
  fprintf (fp, "    address : in  bit_vector (%u downto 0);\n", adr_siz);
  fprintf (fp, "    e_n     : in  bit;\n");
  fprintf (fp, "    data    : out mux_vector (%u downto 0) bus;\n", wrd_siz);
  fprintf (fp, "    vdd     : in bit;\n");
  fprintf (fp, "    vss     : in bit);\nend %s;\n\n",name);
  fprintf (fp, "architecture VBE of %s is\n\n", name);
  fprintf (fp, "  signal rom_out : bit_vector (%u downto 0);\n\n", wrd_siz);
  fprintf (fp, "begin\n\n");
  fprintf (fp, "  write_out : block (e_n = '0')\n  begin\n");
  fprintf (fp, "    data <= guarded rom_out;\n  end block;\n\n");
  fprintf (fp, "  with address (%u downto 0) select\n  rom_out <=\n", adr_siz);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_foot						*/
/* description	: print the foot lines of the behavioural description	*/
/*		  of a ROM. The 'word size' defines the size of the	*/
/*		  rom line in bytes.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_foot (fp, wrd_siz)

FILE         *fp     ;
unsigned int  wrd_siz;

  {
  unsigned int i;

  fprintf (fp, "          X\"");

  for (i=0 ; i<wrd_siz ; i++)
    fprintf (fp, "00");

  fprintf (fp, "\" when others;\n\nend;\n");
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_print						*/
/* description	: print one or several lines of the rom content. the	*/
/*		  global variable 'word size' defines the size of the	*/
/*		  rom line in bytes.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_print (byte_nbr)

int byte_nbr;

  {
  unsigned int  i    ;
  unsigned int  j    ;
  unsigned long adr  ;
  unsigned long mask ;
  char          binadr [36];

  if (MPS_WRTFIL == NULL)
    {
    mips_error (6, NULL);
    exit (1);
    }
  else
    {
    if (byte_nbr != 0)
      {
      if (MPS_DUMP == 'y')
        {
        adr = MPS_ADDRES;
        for (i=0 ; i<byte_nbr ; i++)
          fprintf (MPS_WRTFIL, "%.8lx : %.2x\n", adr+i, MPS_BYTTAB [i]);
        }
      else
        {
        if (MPS_WRDSIZ == 4)
          adr = MPS_ADDRES >> 2;
        else
          adr = MPS_ADDRES;

        for (i=0 ; i<byte_nbr ; i += MPS_WRDSIZ)
          {
          fprintf (MPS_WRTFIL, "          X\"");

          for (j=0 ; j<MPS_WRDSIZ ; j++)
            fprintf (MPS_WRTFIL, "%.2x", MPS_BYTTAB [i+MPS_WRDSIZ-j-1]);

          mask = 0x00000001 << (MPS_ADRSIZ - 1);
          for (j=0 ; j<MPS_ADRSIZ ; j++)
            {
            if ((adr & mask) != 0)
              binadr [j] = '1';
            else
              binadr [j] = '0';
            mask = mask >> 1;
            }
          binadr [j] = '\0';

          fprintf (MPS_WRTFIL, "\" when B\"%s\",\n", binadr);
          adr++;
          }
        }
      }
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_symbol						*/
/* description	: print out the location (in text or data region) of a	*/
/*		  symbol						*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_symbol (str)

char *str;
  {
  char *seg;

  if (MPS_ADRSPC == 'T')
    seg = "text";
  else
    seg = "data";

  fprintf (MPS_SYMFIL, "%s\t: location %lx in %s segment\n", str,
           MPS_ADDRES, seg);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_strtobin						*/
/* description	: make a binary  ? from a string			*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static int mips_strtobin (str, tab)

char *str;
char *tab;

  {
  int  i  = 1;
  int  j  = 0;

  while (str [i] != '\0')
    {
    tab [j] = str [i];
    i++;
    if (str[i-1] == '\\')
      {
      if ((str [i] <= '7') && (str [i] >= '0'))
        {
        tab [j] = str [i] - '0';
        i++;
        if ((str [i] <= '7') && (str [i] >= '0'))
          {
          tab [j] = (tab [j] * 8) + (str [i] - '0');
          i++;
          if ((str [i] <= '7') && (str [i] >= '0'))
            tab [j] = (tab [j] * 8) + (str [i] - '0');
          }
        }
      else
        {
        if (str [i] == '"')
          {
          tab [j] = str [i];
          i++;
          }
        }
      }

    j++;
    }

  return (j-1);
  }
