/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with PAT_DECL_Y__ or pat_decl_y__.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with pat_decl_y_ or PAT_DECL_Y_, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define PAT_DECL_Y_BISON 30802

/* Bison version string.  */
#define PAT_DECL_Y_BISON_VERSION "3.8.2"

/* Skeleton name.  */
#define PAT_DECL_Y_SKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define PAT_DECL_Y_PURE 0

/* Push parsers.  */
#define PAT_DECL_Y_PUSH 0

/* Pull parsers.  */
#define PAT_DECL_Y_PULL 1




/* First part of user prologue.  */
#line 32 "./pat_decl_y.y"


#include <stdio.h>
#include <string.h>
#include "mut.h"
#include "pat.h"
#include "ppt.h"
#include "pat_defs.h"
#include "pat_type.h"
#include "pat_decl.h"

extern  void  pat_decl_y_restart ( );
extern  int   pat_decl_y_parse   ( );
extern  int   pat_decl_y_lex     ( );

/* ###--------------------------------------------------------------### */
/* function	: pat_decl_y_error						*/
/* description	: print an error message (errors detected by yacc)	*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

void pat_decl_y_error (str)

char *str;
  {
  ERR_FLG += pat_error (99, str, ' ', PAT_LINNUM);
  }

/* ###--------------------------------------------------------------### */
/* function	: addiol						*/
/* description	: add a list of PAIOL structure at the top of the list	*/
/* called func.	: pat_addpaiol						*/
/* ###--------------------------------------------------------------### */

static struct paiol *addiol (lastiol, gname, format, mode, blank, flag)

struct paiol *lastiol;
struct array  gname  ;
char          format ;
char          mode   ;
short         blank  ;
char          flag   ;

  {
  struct paiol *ptiol         = lastiol;
  char          extname [100] ;
  short         i             ;
  short         inc           = 1;

  if (gname.left == -1)
    {
    ptiol       = pat_addpaiol (ptiol, gname.ident, format, mode, blank);
    ptiol->FLAG = flag;
    }
  else
    {
    if (gname.left >= gname.right)
      inc = -1;

    for (i=gname.left ; i!=(gname.right+inc) ; i+=inc)
      {
      sprintf (extname, "%s %d", gname.ident, i);
      ptiol       = pat_addpaiol (ptiol, extname, format, mode, blank);
      ptiol->FLAG = flag;
      }
    }

  return (ptiol);
  }

/* ###--------------------------------------------------------------### */
/* function	: pshtab						*/
/* description	: push a name on the TAB stack to build a virtual array	*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void pshtab (gname)

struct array gname;

  {
  if (TAB_IDX > 256)
    ERR_FLG += pat_error (6, NULL, ' ', PAT_LINNUM);
  else
    {
    TAB [TAB_IDX] = gname;
    TAB_IDX++;
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: pshnam						*/
/* description	: push a name on the NAMTAB stack to build a		*/
/*		  hierarchical name					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void pshnam (str)

char *str;

  {
  if (NAM_IDX > 30)
    ERR_FLG += pat_error (14, NULL, ' ', PAT_LINNUM);
  else
    {
    NAMTAB [NAM_IDX] = str;
    NAM_IDX++;
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: initab						*/
/* description	: create a new dictionary				*/
/* called func.	: mbkalloc						*/
/* ###--------------------------------------------------------------### */

static struct entry **initab ()

  {
  struct entry **head;
  int            i;

  head = (struct entry **) mbkalloc (sizeof(struct entry *) * PAT_HSZDFN);

  for (i=0 ; i<PAT_HSZDFN ; i++)
    head[i] = NULL;

  return (head);
  }

/* ###--------------------------------------------------------------### */
/* function	: addent						*/
/* description	: add a new entry in a dictionary			*/
/* called func.	: mbkaloc						*/
/* ###--------------------------------------------------------------### */

static struct entry *addent (head, key)

struct entry *head;
char         *key;

  {
  struct entry *entry;
  int           i;

  if (ENTRY_HEAD == NULL)
    {
    ENTRY_HEAD = (struct entry *) mbkalloc (sizeof(struct entry) * PAT_ALODFN);

    entry = ENTRY_HEAD;
    for (i=1 ; i<PAT_ALODFN ; i++)
      {
      entry->next = entry + 1;
      entry++;
      }
    entry->next = NULL;
    }

  entry       = ENTRY_HEAD;
  ENTRY_HEAD  = ENTRY_HEAD->next;

  entry->next     = head;

  entry->fd0_val  = 0;
  entry->fd1_val  = 0;
  entry->pt0_val  = 0;
  entry->pt1_val  = 0;

  entry->key      = key;

  return (entry);
  }

/* ###--------------------------------------------------------------### */
/* function	: addtab						*/
/* description	: add a new information into a dictionary. If the key	*/
/*		  doesn't exist create a new entry			*/
/* called func.	: addent						*/
/* ###--------------------------------------------------------------### */

static void addtab (head, key_str, field, valu)

struct entry **head   ;
char          *key_str;
int            field  ;
int            valu   ;

  {
  int           found    = 0;
  int           index    ;
  struct entry *entry_pnt;

  index     = ((unsigned long) key_str) % PAT_HSZDFN;
  entry_pnt = head [index];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 0)
    {
    head [index] = addent (head [index], key_str);
    entry_pnt    = head [index];
    }

  switch (field)
    {
    case 0 :
      entry_pnt->fd0_val = valu; break;
    case 1 :
      entry_pnt->fd1_val = valu; break;
    case 6 :
      entry_pnt->pt0_val = valu; break;
    case 7 :
      entry_pnt->pt1_val = valu; break;
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: chktab						*/
/* description	: extract an information from a dictionary. Return	*/
/*		  0 if the information has not been found.		*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static int chktab (head, key_str, field)

struct entry **head   ;
char          *key_str;
int            field  ;

  {
  int           found = 0;
  int           valu  = 0;
  struct entry *entry_pnt;

  entry_pnt = head [((unsigned long)key_str) % PAT_HSZDFN];

  while (entry_pnt != NULL)
    {
    if (entry_pnt->key == key_str)
      {
      found = 1;
      break;
      }
    entry_pnt = entry_pnt->next;
    }

  if (found == 1)
    {
    switch (field)
      {
      case 0 :
        valu = entry_pnt->fd0_val; break;
      case 1 :
        valu = entry_pnt->fd1_val; break;
      case 6 :
        valu = entry_pnt->pt0_val; break;
      case 7 :
        valu = entry_pnt->pt1_val; break;
      }
    }

  return (valu);
  }

/* ###--------------------------------------------------------------### */
/* function	: fretab						*/
/* description	: remove entirely a dictionary				*/
/* called func.	: mbkfree						*/
/* ###--------------------------------------------------------------### */

static void fretab (pt_hash)

struct entry **pt_hash;
  {
  struct entry *pt_entry;
  int           i       ;

  if (pt_hash != NULL)
    {
    for (i=0 ; i<PAT_HSZDFN ; i++)
      {
      if ((pt_entry = pt_hash[i]) != NULL)
        {
        while (pt_entry->next != NULL)
          pt_entry = pt_entry->next;

        pt_entry->next = ENTRY_HEAD ;
        ENTRY_HEAD     = pt_hash [i];
        }
      }
    mbkfree (pt_hash);
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: pat_declpat						*/
/* description	: parse a file in pat format and return a PASEQ		*/
/* called func.	: pat_decl_y_parse			 			*/
/* ###--------------------------------------------------------------### */

struct paseq *pat_declpat (fp, ptseq)

FILE          *fp    ;
struct paseq  *ptseq ;

  {
  extern FILE *pat_decl_y_in     ;
  static int   call_nbr = 0;

  PAT_SEQPNT = ptseq;
  pat_decl_y_in        = fp;

  PAT_INSPNT = NULL;
  PAT_COMPNT = NULL;
  PAT_GRPPNT = NULL;
  PAT_IOLPNT = NULL;
  PAT_LINNUM = 1;
  STT_NBR    = 0;
  DCL_NBR    = 0;
  ERR_FLG    = 0;
  TAB_IDX    = 0;
  NAM_IDX    = 0;

  HSHTAB             = initab ();

  PAT_SEQPNT         = pat_addpaseq (PAT_SEQPNT);
  PAT_SEQPNT->FLAGS |= PAT_SEQ__ZERODELAY;

  if (call_nbr != 0)
    pat_decl_y_restart (pat_decl_y_in);

  pat_decl_y_parse ();
  call_nbr++;
  
  PAT_SEQPNT->PAINS   = (struct pains *) reverse ((struct chain *)PAT_INSPNT);
  PAT_SEQPNT->DECCOM  = (struct pacom *) reverse ((struct chain *)PAT_COMPNT);
  PAT_SEQPNT->PAGRP   = (struct pagrp *) reverse ((struct chain *)PAT_GRPPNT);
  PAT_IOLPNT          = (struct paiol *) reverse ((struct chain *)PAT_IOLPNT);
  PAT_SEQPNT->PAIOL   = pat_crtpaiol (PAT_IOLPNT);
  PAT_SEQPNT->FLAGS  |= PAT_SEQ__IOLARRAY;
  PAT_SEQPNT->LINENO  = PAT_LINNUM ;
  PAT_SEQPNT->IOLNBR  = DCL_NBR;

  if (ERR_FLG == 0)
    PAT_SEQPNT->ERRFLG = 0;
  else
    PAT_SEQPNT->ERRFLG = 1;

  pat_frepaiol (PAT_IOLPNT);
  fretab (HSHTAB);

  return (PAT_SEQPNT);
  }


#line 436 "y.tab.c"

# ifndef PAT_DECL_Y__CAST
#  ifdef __cplusplus
#   define PAT_DECL_Y__CAST(Type, Val) static_cast<Type> (Val)
#   define PAT_DECL_Y__REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define PAT_DECL_Y__CAST(Type, Val) ((Type) (Val))
#   define PAT_DECL_Y__REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef PAT_DECL_Y__NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define PAT_DECL_Y__NULLPTR nullptr
#   else
#    define PAT_DECL_Y__NULLPTR 0
#   endif
#  else
#   define PAT_DECL_Y__NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef PAT_DECL_Y__PAT_DECL_Y__Y_TAB_H_INCLUDED
# define PAT_DECL_Y__PAT_DECL_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef PAT_DECL_Y_DEBUG
# define PAT_DECL_Y_DEBUG 0
#endif
#if PAT_DECL_Y_DEBUG
extern int pat_decl_y_debug;
#endif

/* Token kinds.  */
#ifndef PAT_DECL_Y_TOKENTYPE
# define PAT_DECL_Y_TOKENTYPE
  enum pat_decl_y_tokentype
  {
    PAT_DECL_Y_EMPTY = -2,
    PAT_DECL_Y_EOF = 0,                     /* "end of file"  */
    PAT_DECL_Y_error = 256,                 /* error  */
    PAT_DECL_Y_UNDEF = 257,                 /* "invalid token"  */
    _GTSym = 258,                  /* _GTSym  */
    _IN = 259,                     /* _IN  */
    _INOUT = 260,                  /* _INOUT  */
    _LESym = 261,                  /* _LESym  */
    _LTSym = 262,                  /* _LTSym  */
    _OUT = 263,                    /* _OUT  */
    AbstractLit = 264,             /* AbstractLit  */
    BitStringLit = 265,            /* BitStringLit  */
    BEGIN_ = 266,                  /* BEGIN_  */
    Colon = 267,                   /* Colon  */
    Comma = 268,                   /* Comma  */
    Comment = 269,                 /* Comment  */
    DOWNTO = 270,                  /* DOWNTO  */
    Dot = 271,                     /* Dot  */
    END_ = 272,                    /* END_  */
    FS = 273,                      /* FS  */
    Format = 274,                  /* Format  */
    INSPECT = 275,                 /* INSPECT  */
    Identifier = 276,              /* Identifier  */
    LeftParen = 277,               /* LeftParen  */
    Literal = 278,                 /* Literal  */
    NS = 279,                      /* NS  */
    MS = 280,                      /* MS  */
    PS = 281,                      /* PS  */
    Plus = 282,                    /* Plus  */
    REGISTER = 283,                /* REGISTER  */
    RightParen = 284,              /* RightParen  */
    SAVE = 285,                    /* SAVE  */
    SIGNAL = 286,                  /* SIGNAL  */
    Semicolons = 287,              /* Semicolons  */
    SPY = 288,                     /* SPY  */
    TO = 289,                      /* TO  */
    TRACE = 290,                   /* TRACE  */
    US = 291,                      /* US  */
    UnknownChar = 292              /* UnknownChar  */
  };
  typedef enum pat_decl_y_tokentype pat_decl_y_token_kind_t;
#endif
/* Token kinds.  */
#define PAT_DECL_Y_EMPTY -2
#define PAT_DECL_Y_EOF 0
#define PAT_DECL_Y_error 256
#define PAT_DECL_Y_UNDEF 257
#define _GTSym 258
#define _IN 259
#define _INOUT 260
#define _LESym 261
#define _LTSym 262
#define _OUT 263
#define AbstractLit 264
#define BitStringLit 265
#define BEGIN_ 266
#define Colon 267
#define Comma 268
#define Comment 269
#define DOWNTO 270
#define Dot 271
#define END_ 272
#define FS 273
#define Format 274
#define INSPECT 275
#define Identifier 276
#define LeftParen 277
#define Literal 278
#define NS 279
#define MS 280
#define PS 281
#define Plus 282
#define REGISTER 283
#define RightParen 284
#define SAVE 285
#define SIGNAL 286
#define Semicolons 287
#define SPY 288
#define TO 289
#define TRACE 290
#define US 291
#define UnknownChar 292

/* Value type.  */
#if ! defined PAT_DECL_Y_STYPE && ! defined PAT_DECL_Y_STYPE_IS_DECLARED
union PAT_DECL_Y_STYPE
{
#line 398 "./pat_decl_y.y"

  int           valu;
  float         fval;
  char          immd;
  char         *text;
  struct array  arra;
  struct label  labe;
  

#line 573 "y.tab.c"

};
typedef union PAT_DECL_Y_STYPE PAT_DECL_Y_STYPE;
# define PAT_DECL_Y_STYPE_IS_TRIVIAL 1
# define PAT_DECL_Y_STYPE_IS_DECLARED 1
#endif


extern PAT_DECL_Y_STYPE pat_decl_y_lval;


int pat_decl_y_parse (void);


#endif /* !PAT_DECL_Y__PAT_DECL_Y__Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum pat_decl_y_symbol_kind_t
{
  PAT_DECL_Y_SYMBOL_PAT_DECL_Y_EMPTY = -2,
  PAT_DECL_Y_SYMBOL_PAT_DECL_Y_EOF = 0,                      /* "end of file"  */
  PAT_DECL_Y_SYMBOL_PAT_DECL_Y_error = 1,                    /* error  */
  PAT_DECL_Y_SYMBOL_PAT_DECL_Y_UNDEF = 2,                    /* "invalid token"  */
  PAT_DECL_Y_SYMBOL__GTSym = 3,                     /* _GTSym  */
  PAT_DECL_Y_SYMBOL__IN = 4,                        /* _IN  */
  PAT_DECL_Y_SYMBOL__INOUT = 5,                     /* _INOUT  */
  PAT_DECL_Y_SYMBOL__LESym = 6,                     /* _LESym  */
  PAT_DECL_Y_SYMBOL__LTSym = 7,                     /* _LTSym  */
  PAT_DECL_Y_SYMBOL__OUT = 8,                       /* _OUT  */
  PAT_DECL_Y_SYMBOL_AbstractLit = 9,                /* AbstractLit  */
  PAT_DECL_Y_SYMBOL_BitStringLit = 10,              /* BitStringLit  */
  PAT_DECL_Y_SYMBOL_BEGIN_ = 11,                    /* BEGIN_  */
  PAT_DECL_Y_SYMBOL_Colon = 12,                     /* Colon  */
  PAT_DECL_Y_SYMBOL_Comma = 13,                     /* Comma  */
  PAT_DECL_Y_SYMBOL_Comment = 14,                   /* Comment  */
  PAT_DECL_Y_SYMBOL_DOWNTO = 15,                    /* DOWNTO  */
  PAT_DECL_Y_SYMBOL_Dot = 16,                       /* Dot  */
  PAT_DECL_Y_SYMBOL_END_ = 17,                      /* END_  */
  PAT_DECL_Y_SYMBOL_FS = 18,                        /* FS  */
  PAT_DECL_Y_SYMBOL_Format = 19,                    /* Format  */
  PAT_DECL_Y_SYMBOL_INSPECT = 20,                   /* INSPECT  */
  PAT_DECL_Y_SYMBOL_Identifier = 21,                /* Identifier  */
  PAT_DECL_Y_SYMBOL_LeftParen = 22,                 /* LeftParen  */
  PAT_DECL_Y_SYMBOL_Literal = 23,                   /* Literal  */
  PAT_DECL_Y_SYMBOL_NS = 24,                        /* NS  */
  PAT_DECL_Y_SYMBOL_MS = 25,                        /* MS  */
  PAT_DECL_Y_SYMBOL_PS = 26,                        /* PS  */
  PAT_DECL_Y_SYMBOL_Plus = 27,                      /* Plus  */
  PAT_DECL_Y_SYMBOL_REGISTER = 28,                  /* REGISTER  */
  PAT_DECL_Y_SYMBOL_RightParen = 29,                /* RightParen  */
  PAT_DECL_Y_SYMBOL_SAVE = 30,                      /* SAVE  */
  PAT_DECL_Y_SYMBOL_SIGNAL = 31,                    /* SIGNAL  */
  PAT_DECL_Y_SYMBOL_Semicolons = 32,                /* Semicolons  */
  PAT_DECL_Y_SYMBOL_SPY = 33,                       /* SPY  */
  PAT_DECL_Y_SYMBOL_TO = 34,                        /* TO  */
  PAT_DECL_Y_SYMBOL_TRACE = 35,                     /* TRACE  */
  PAT_DECL_Y_SYMBOL_US = 36,                        /* US  */
  PAT_DECL_Y_SYMBOL_UnknownChar = 37,               /* UnknownChar  */
  PAT_DECL_Y_SYMBOL_PAT_DECL_Y_ACCEPT = 38,                  /* $accept  */
  PAT_DECL_Y_SYMBOL_pat_format_file = 39,           /* pat_format_file  */
  PAT_DECL_Y_SYMBOL_declarative_block = 40,         /* declarative_block  */
  PAT_DECL_Y_SYMBOL_41_declaration_item_ = 41,      /* ..declaration_item..  */
  PAT_DECL_Y_SYMBOL_declaration_item = 42,          /* declaration_item  */
  PAT_DECL_Y_SYMBOL_instance_inspection = 43,       /* instance_inspection  */
  PAT_DECL_Y_SYMBOL_instance_name = 44,             /* instance_name  */
  PAT_DECL_Y_SYMBOL_file_name = 45,                 /* file_name  */
  PAT_DECL_Y_SYMBOL_other_statement = 46,           /* other_statement  */
  PAT_DECL_Y_SYMBOL_input_output_declaration = 47,  /* input_output_declaration  */
  PAT_DECL_Y_SYMBOL_signal_declaration = 48,        /* signal_declaration  */
  PAT_DECL_Y_SYMBOL_group_declaration = 49,         /* group_declaration  */
  PAT_DECL_Y_SYMBOL_50_Format_ = 50,                /* .Format.  */
  PAT_DECL_Y_SYMBOL_51_name_ = 51,                  /* ...name..  */
  PAT_DECL_Y_SYMBOL_name = 52,                      /* name  */
  PAT_DECL_Y_SYMBOL_simple_name = 53,               /* simple_name  */
  PAT_DECL_Y_SYMBOL_indexed_name = 54,              /* indexed_name  */
  PAT_DECL_Y_SYMBOL_slice_name = 55,                /* slice_name  */
  PAT_DECL_Y_SYMBOL_56_Identifier_Identifier_ = 56, /* Identifier...Identifier..  */
  PAT_DECL_Y_SYMBOL_57_Identifier_ = 57,            /* ...Identifier..  */
  PAT_DECL_Y_SYMBOL_direction = 58,                 /* direction  */
  PAT_DECL_Y_SYMBOL_mode = 59,                      /* mode  */
  PAT_DECL_Y_SYMBOL_Semicolons_ERR = 60,            /* Semicolons_ERR  */
  PAT_DECL_Y_SYMBOL_61_SPY_ = 61,                   /* .SPY.  */
  PAT_DECL_Y_SYMBOL_62_TRACE_ = 62                  /* .TRACE.  */
};
typedef enum pat_decl_y_symbol_kind_t pat_decl_y_symbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define PAT_DECL_Y__STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ pat_decl_y_type_int8;
#elif defined PAT_DECL_Y__STDINT_H
typedef int_least8_t pat_decl_y_type_int8;
#else
typedef signed char pat_decl_y_type_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ pat_decl_y_type_int16;
#elif defined PAT_DECL_Y__STDINT_H
typedef int_least16_t pat_decl_y_type_int16;
#else
typedef short pat_decl_y_type_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ pat_decl_y_type_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined PAT_DECL_Y__STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t pat_decl_y_type_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char pat_decl_y_type_uint8;
#else
typedef short pat_decl_y_type_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ pat_decl_y_type_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined PAT_DECL_Y__STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t pat_decl_y_type_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short pat_decl_y_type_uint16;
#else
typedef int pat_decl_y_type_uint16;
#endif

#ifndef PAT_DECL_Y_PTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define PAT_DECL_Y_PTRDIFF_T __PTRDIFF_TYPE__
#  define PAT_DECL_Y_PTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define PAT_DECL_Y_PTRDIFF_T ptrdiff_t
#  define PAT_DECL_Y_PTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define PAT_DECL_Y_PTRDIFF_T long
#  define PAT_DECL_Y_PTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef PAT_DECL_Y_SIZE_T
# ifdef __SIZE_TYPE__
#  define PAT_DECL_Y_SIZE_T __SIZE_TYPE__
# elif defined size_t
#  define PAT_DECL_Y_SIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define PAT_DECL_Y_SIZE_T size_t
# else
#  define PAT_DECL_Y_SIZE_T unsigned
# endif
#endif

#define PAT_DECL_Y_SIZE_MAXIMUM                                  \
  PAT_DECL_Y__CAST (PAT_DECL_Y_PTRDIFF_T,                                 \
           (PAT_DECL_Y_PTRDIFF_MAXIMUM < PAT_DECL_Y__CAST (PAT_DECL_Y_SIZE_T, -1)  \
            ? PAT_DECL_Y_PTRDIFF_MAXIMUM                         \
            : PAT_DECL_Y__CAST (PAT_DECL_Y_SIZE_T, -1)))

#define PAT_DECL_Y_SIZEOF(X) PAT_DECL_Y__CAST (PAT_DECL_Y_PTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef pat_decl_y_type_int8 pat_decl_y__state_t;

/* State numbers in computations.  */
typedef int pat_decl_y__state_fast_t;

#ifndef PAT_DECL_Y__
# if defined PAT_DECL_Y_ENABLE_NLS && PAT_DECL_Y_ENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define PAT_DECL_Y__(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef PAT_DECL_Y__
#  define PAT_DECL_Y__(Msgid) Msgid
# endif
#endif


#ifndef PAT_DECL_Y__ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define PAT_DECL_Y__ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define PAT_DECL_Y__ATTRIBUTE_PURE
# endif
#endif

#ifndef PAT_DECL_Y__ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define PAT_DECL_Y__ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define PAT_DECL_Y__ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define PAT_DECL_Y__USE(E) ((void) (E))
#else
# define PAT_DECL_Y__USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about pat_decl_y_lval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define PAT_DECL_Y__INITIAL_VALUE(Value) Value
#endif
#ifndef PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef PAT_DECL_Y__INITIAL_VALUE
# define PAT_DECL_Y__INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define PAT_DECL_Y__IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define PAT_DECL_Y__IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef PAT_DECL_Y__IGNORE_USELESS_CAST_BEGIN
# define PAT_DECL_Y__IGNORE_USELESS_CAST_BEGIN
# define PAT_DECL_Y__IGNORE_USELESS_CAST_END
#endif


#define PAT_DECL_Y__ASSERT(E) ((void) (0 && (E)))

#if !defined pat_decl_y_overflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef PAT_DECL_Y_STACK_USE_ALLOCA
#  if PAT_DECL_Y_STACK_USE_ALLOCA
#   ifdef __GNUC__
#    define PAT_DECL_Y_STACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define PAT_DECL_Y_STACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define PAT_DECL_Y_STACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef PAT_DECL_Y_STACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define PAT_DECL_Y_STACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef PAT_DECL_Y_STACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define PAT_DECL_Y_STACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define PAT_DECL_Y_STACK_ALLOC PAT_DECL_Y_MALLOC
#  define PAT_DECL_Y_STACK_FREE PAT_DECL_Y_FREE
#  ifndef PAT_DECL_Y_STACK_ALLOC_MAXIMUM
#   define PAT_DECL_Y_STACK_ALLOC_MAXIMUM PAT_DECL_Y_SIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined PAT_DECL_Y_MALLOC || defined malloc) \
             && (defined PAT_DECL_Y_FREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef PAT_DECL_Y_MALLOC
#   define PAT_DECL_Y_MALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (PAT_DECL_Y_SIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef PAT_DECL_Y_FREE
#   define PAT_DECL_Y_FREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined pat_decl_y_overflow */

#if (! defined pat_decl_y_overflow \
     && (! defined __cplusplus \
         || (defined PAT_DECL_Y_STYPE_IS_TRIVIAL && PAT_DECL_Y_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union pat_decl_y_alloc
{
  pat_decl_y__state_t pat_decl_y_ss_alloc;
  PAT_DECL_Y_STYPE pat_decl_y_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define PAT_DECL_Y_STACK_GAP_MAXIMUM (PAT_DECL_Y_SIZEOF (union pat_decl_y_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define PAT_DECL_Y_STACK_BYTES(N) \
     ((N) * (PAT_DECL_Y_SIZEOF (pat_decl_y__state_t) + PAT_DECL_Y_SIZEOF (PAT_DECL_Y_STYPE)) \
      + PAT_DECL_Y_STACK_GAP_MAXIMUM)

# define PAT_DECL_Y_COPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables PAT_DECL_Y_SIZE and PAT_DECL_Y_STACKSIZE give the old and new number of
   elements in the stack, and PAT_DECL_Y_PTR gives the new location of the
   stack.  Advance PAT_DECL_Y_PTR to a properly aligned location for the next
   stack.  */
# define PAT_DECL_Y_STACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        PAT_DECL_Y_PTRDIFF_T pat_decl_y_newbytes;                                         \
        PAT_DECL_Y_COPY (&pat_decl_y_ptr->Stack_alloc, Stack, pat_decl_y_size);                    \
        Stack = &pat_decl_y_ptr->Stack_alloc;                                    \
        pat_decl_y_newbytes = pat_decl_y_stacksize * PAT_DECL_Y_SIZEOF (*Stack) + PAT_DECL_Y_STACK_GAP_MAXIMUM; \
        pat_decl_y_ptr += pat_decl_y_newbytes / PAT_DECL_Y_SIZEOF (*pat_decl_y_ptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined PAT_DECL_Y_COPY_NEEDED && PAT_DECL_Y_COPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef PAT_DECL_Y_COPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define PAT_DECL_Y_COPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, PAT_DECL_Y__CAST (PAT_DECL_Y_SIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define PAT_DECL_Y_COPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          PAT_DECL_Y_PTRDIFF_T pat_decl_y_i;                      \
          for (pat_decl_y_i = 0; pat_decl_y_i < (Count); pat_decl_y_i++)   \
            (Dst)[pat_decl_y_i] = (Src)[pat_decl_y_i];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !PAT_DECL_Y_COPY_NEEDED */

/* PAT_DECL_Y_FINAL -- State number of the termination state.  */
#define PAT_DECL_Y_FINAL  24
/* PAT_DECL_Y_LAST -- Last index in PAT_DECL_Y_TABLE.  */
#define PAT_DECL_Y_LAST   51

/* PAT_DECL_Y_NTOKENS -- Number of terminals.  */
#define PAT_DECL_Y_NTOKENS  38
/* PAT_DECL_Y_NNTS -- Number of nonterminals.  */
#define PAT_DECL_Y_NNTS  25
/* PAT_DECL_Y_NRULES -- Number of rules.  */
#define PAT_DECL_Y_NRULES  42
/* PAT_DECL_Y_NSTATES -- Number of states.  */
#define PAT_DECL_Y_NSTATES  64

/* PAT_DECL_Y_MAXUTOK -- Last valid token kind.  */
#define PAT_DECL_Y_MAXUTOK   292


/* PAT_DECL_Y_TRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by pat_decl_y_lex, with out-of-bounds checking.  */
#define PAT_DECL_Y_TRANSLATE(PAT_DECL_Y_X)                                \
  (0 <= (PAT_DECL_Y_X) && (PAT_DECL_Y_X) <= PAT_DECL_Y_MAXUTOK                     \
   ? PAT_DECL_Y__CAST (pat_decl_y_symbol_kind_t, pat_decl_y_translate[PAT_DECL_Y_X])        \
   : PAT_DECL_Y_SYMBOL_PAT_DECL_Y_UNDEF)

/* PAT_DECL_Y_TRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by pat_decl_y_lex.  */
static const pat_decl_y_type_int8 pat_decl_y_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37
};

#if PAT_DECL_Y_DEBUG
/* PAT_DECL_Y_RLINE[PAT_DECL_Y_N] -- Source line where rule number PAT_DECL_Y_N was defined.  */
static const pat_decl_y_type_int16 pat_decl_y_rline[] =
{
       0,   461,   461,   469,   473,   474,   479,   480,   481,   482,
     487,   495,   500,   505,   513,   514,   518,   562,   610,   611,
     616,   618,   625,   627,   629,   634,   643,   655,   669,   687,
     688,   695,   696,   700,   702,   704,   706,   708,   713,   724,
     725,   731,   732
};
#endif

/** Accessing symbol of state STATE.  */
#define PAT_DECL_Y__ACCESSING_SYMBOL(State) PAT_DECL_Y__CAST (pat_decl_y_symbol_kind_t, pat_decl_y_stos[State])

#if PAT_DECL_Y_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   PAT_DECL_Y_SYMBOL.  No bounds checking.  */
static const char *pat_decl_y_symbol_name (pat_decl_y_symbol_kind_t pat_decl_y_symbol) PAT_DECL_Y__ATTRIBUTE_UNUSED;

/* PAT_DECL_Y_TNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at PAT_DECL_Y_NTOKENS, nonterminals.  */
static const char *const pat_decl_y_tname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "_GTSym", "_IN",
  "_INOUT", "_LESym", "_LTSym", "_OUT", "AbstractLit", "BitStringLit",
  "BEGIN_", "Colon", "Comma", "Comment", "DOWNTO", "Dot", "END_", "FS",
  "Format", "INSPECT", "Identifier", "LeftParen", "Literal", "NS", "MS",
  "PS", "Plus", "REGISTER", "RightParen", "SAVE", "SIGNAL", "Semicolons",
  "SPY", "TO", "TRACE", "US", "UnknownChar", "$accept", "pat_format_file",
  "declarative_block", "..declaration_item..", "declaration_item",
  "instance_inspection", "instance_name", "file_name", "other_statement",
  "input_output_declaration", "signal_declaration", "group_declaration",
  ".Format.", "...name..", "name", "simple_name", "indexed_name",
  "slice_name", "Identifier...Identifier..", "...Identifier..",
  "direction", "mode", "Semicolons_ERR", ".SPY.", ".TRACE.", PAT_DECL_Y__NULLPTR
};

static const char *
pat_decl_y_symbol_name (pat_decl_y_symbol_kind_t pat_decl_y_symbol)
{
  return pat_decl_y_tname[pat_decl_y_symbol];
}
#endif

#define PAT_DECL_Y_PACT_NINF (-26)

#define pat_decl_y_pact_value_is_default(Yyn) \
  ((Yyn) == PAT_DECL_Y_PACT_NINF)

#define PAT_DECL_Y_TABLE_NINF (-4)

#define pat_decl_y_table_value_is_error(Yyn) \
  0

/* PAT_DECL_Y_PACT[STATE-NUM] -- Index in PAT_DECL_Y_TABLE of the portion describing
   STATE-NUM.  */
static const pat_decl_y_type_int8 pat_decl_y_pact[] =
{
       1,   -21,   -26,   -26,   -26,   -26,    -7,   -26,   -26,    18,
      13,    -1,   -26,   -26,   -26,   -26,   -26,   -26,    -7,   -26,
     -26,   -26,    -7,   -26,   -26,   -26,   -26,     6,   -26,   -26,
     -26,    11,    19,   -21,   -26,   -26,     8,     7,    21,   -26,
     -26,     4,    -3,   -12,   -26,    22,   -26,   -26,   -21,   -26,
     -26,   -26,    31,    -7,     6,    34,   -26,    17,   -26,     8,
     -26,     4,   -21,   -26
};

/* PAT_DECL_Y_DEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when PAT_DECL_Y_TABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const pat_decl_y_type_int8 pat_decl_y_defact[] =
{
       0,     0,    33,    35,    34,    13,     0,    37,    36,     0,
       0,     0,     4,     7,     8,     6,    14,    15,     0,    38,
       9,    29,     0,    11,     1,     2,     5,    18,    22,    23,
      24,    25,    28,     0,    12,    19,    39,     0,     0,    10,
      40,    41,     0,     0,    20,    25,    30,    42,     0,    32,
      26,    31,     0,     0,    18,     0,    16,     0,    21,    39,
      27,    41,     0,    17
};

/* PAT_DECL_Y_PGOTO[NTERM-NUM].  */
static const pat_decl_y_type_int8 pat_decl_y_pgoto[] =
{
     -26,   -26,   -26,   -26,    36,   -26,   -26,   -26,   -26,   -26,
     -26,   -26,    -9,   -26,   -17,   -26,   -26,   -26,    16,   -26,
     -26,   -26,   -25,   -11,   -10
};

/* PAT_DECL_Y_DEFGOTO[NTERM-NUM].  */
static const pat_decl_y_type_int8 pat_decl_y_defgoto[] =
{
       0,     9,    10,    11,    12,    13,    22,    33,    14,    15,
      16,    17,    36,    43,    27,    28,    29,    30,    45,    32,
      52,    18,    20,    41,    48
};

/* PAT_DECL_Y_TABLE[PAT_DECL_Y_PACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If PAT_DECL_Y_TABLE_NINF, syntax error.  */
static const pat_decl_y_type_int8 pat_decl_y_table[] =
{
       1,    53,     1,     2,     3,     2,     3,     4,    39,     4,
      -3,    19,    49,     5,    21,     5,    42,    54,    24,     6,
      44,     6,    23,    56,    25,    35,    50,     7,    21,     7,
       8,    51,     8,    37,    31,    38,    58,    63,    34,    47,
      57,    40,    46,    42,    55,    59,    60,    26,    61,     0,
       0,    62
};

static const pat_decl_y_type_int8 pat_decl_y_check[] =
{
       1,    13,     1,     4,     5,     4,     5,     8,    33,     8,
      11,    32,    15,    14,    21,    14,     9,    29,     0,    20,
      37,    20,     6,    48,    11,    19,    29,    28,    21,    28,
      31,    34,    31,    22,    18,    16,    53,    62,    22,    35,
       9,    33,    21,     9,    22,    54,    29,    11,    59,    -1,
      -1,    61
};

/* PAT_DECL_Y_STOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const pat_decl_y_type_int8 pat_decl_y_stos[] =
{
       0,     1,     4,     5,     8,    14,    20,    28,    31,    39,
      40,    41,    42,    43,    46,    47,    48,    49,    59,    32,
      60,    21,    44,    56,     0,    11,    42,    52,    53,    54,
      55,    56,    57,    45,    56,    19,    50,    22,    16,    60,
      33,    61,     9,    51,    52,    56,    21,    35,    62,    15,
      29,    34,    58,    13,    29,    22,    60,     9,    52,    50,
      29,    61,    62,    60
};

/* PAT_DECL_Y_R1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const pat_decl_y_type_int8 pat_decl_y_r1[] =
{
       0,    38,    39,    40,    41,    41,    42,    42,    42,    42,
      43,    44,    45,    46,    47,    47,    48,    49,    50,    50,
      51,    51,    52,    52,    52,    53,    54,    55,    56,    57,
      57,    58,    58,    59,    59,    59,    59,    59,    60,    61,
      61,    62,    62
};

/* PAT_DECL_Y_R2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const pat_decl_y_type_int8 pat_decl_y_r2[] =
{
       0,     2,     2,     1,     1,     2,     1,     1,     1,     2,
       4,     1,     1,     1,     1,     1,     6,     9,     0,     1,
       1,     3,     1,     1,     1,     1,     4,     6,     2,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     0,     1
};


enum { PAT_DECL_Y_ENOMEM = -2 };

#define pat_decl_y_errok         (pat_decl_y_errstatus = 0)
#define pat_decl_y_clearin       (pat_decl_y_char = PAT_DECL_Y_EMPTY)

#define PAT_DECL_Y_ACCEPT        goto pat_decl_y_acceptlab
#define PAT_DECL_Y_ABORT         goto pat_decl_y_abortlab
#define PAT_DECL_Y_ERROR         goto pat_decl_y_errorlab
#define PAT_DECL_Y_NOMEM         goto pat_decl_y_exhaustedlab


#define PAT_DECL_Y_RECOVERING()  (!!pat_decl_y_errstatus)

#define PAT_DECL_Y_BACKUP(Token, Value)                                    \
  do                                                              \
    if (pat_decl_y_char == PAT_DECL_Y_EMPTY)                                        \
      {                                                           \
        pat_decl_y_char = (Token);                                         \
        pat_decl_y_lval = (Value);                                         \
        PAT_DECL_Y_POPSTACK (pat_decl_y_len);                                       \
        pat_decl_y_state = *pat_decl_y_ssp;                                         \
        goto pat_decl_y_backup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        pat_decl_y_error (PAT_DECL_Y__("syntax error: cannot back up")); \
        PAT_DECL_Y_ERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use PAT_DECL_Y_error or PAT_DECL_Y_UNDEF. */
#define PAT_DECL_Y_ERRCODE PAT_DECL_Y_UNDEF


/* Enable debugging if requested.  */
#if PAT_DECL_Y_DEBUG

# ifndef PAT_DECL_Y_FPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define PAT_DECL_Y_FPRINTF fprintf
# endif

# define PAT_DECL_Y_DPRINTF(Args)                        \
do {                                            \
  if (pat_decl_y_debug)                                  \
    PAT_DECL_Y_FPRINTF Args;                             \
} while (0)




# define PAT_DECL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (pat_decl_y_debug)                                                            \
    {                                                                     \
      PAT_DECL_Y_FPRINTF (stderr, "%s ", Title);                                   \
      pat_decl_y__symbol_print (stderr,                                            \
                  Kind, Value); \
      PAT_DECL_Y_FPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on PAT_DECL_Y_O.  |
`-----------------------------------*/

static void
pat_decl_y__symbol_value_print (FILE *pat_decl_y_o,
                       pat_decl_y_symbol_kind_t pat_decl_y_kind, PAT_DECL_Y_STYPE const * const pat_decl_y_valuep)
{
  FILE *pat_decl_y_output = pat_decl_y_o;
  PAT_DECL_Y__USE (pat_decl_y_output);
  if (!pat_decl_y_valuep)
    return;
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  PAT_DECL_Y__USE (pat_decl_y_kind);
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on PAT_DECL_Y_O.  |
`---------------------------*/

static void
pat_decl_y__symbol_print (FILE *pat_decl_y_o,
                 pat_decl_y_symbol_kind_t pat_decl_y_kind, PAT_DECL_Y_STYPE const * const pat_decl_y_valuep)
{
  PAT_DECL_Y_FPRINTF (pat_decl_y_o, "%s %s (",
             pat_decl_y_kind < PAT_DECL_Y_NTOKENS ? "token" : "nterm", pat_decl_y_symbol_name (pat_decl_y_kind));

  pat_decl_y__symbol_value_print (pat_decl_y_o, pat_decl_y_kind, pat_decl_y_valuep);
  PAT_DECL_Y_FPRINTF (pat_decl_y_o, ")");
}

/*------------------------------------------------------------------.
| pat_decl_y__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
pat_decl_y__stack_print (pat_decl_y__state_t *pat_decl_y_bottom, pat_decl_y__state_t *pat_decl_y_top)
{
  PAT_DECL_Y_FPRINTF (stderr, "Stack now");
  for (; pat_decl_y_bottom <= pat_decl_y_top; pat_decl_y_bottom++)
    {
      int pat_decl_y_bot = *pat_decl_y_bottom;
      PAT_DECL_Y_FPRINTF (stderr, " %d", pat_decl_y_bot);
    }
  PAT_DECL_Y_FPRINTF (stderr, "\n");
}

# define PAT_DECL_Y__STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (pat_decl_y_debug)                                                  \
    pat_decl_y__stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the PAT_DECL_Y_RULE is going to be reduced.  |
`------------------------------------------------*/

static void
pat_decl_y__reduce_print (pat_decl_y__state_t *pat_decl_y_ssp, PAT_DECL_Y_STYPE *pat_decl_y_vsp,
                 int pat_decl_y_rule)
{
  int pat_decl_y_lno = pat_decl_y_rline[pat_decl_y_rule];
  int pat_decl_y_nrhs = pat_decl_y_r2[pat_decl_y_rule];
  int pat_decl_y_i;
  PAT_DECL_Y_FPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             pat_decl_y_rule - 1, pat_decl_y_lno);
  /* The symbols being reduced.  */
  for (pat_decl_y_i = 0; pat_decl_y_i < pat_decl_y_nrhs; pat_decl_y_i++)
    {
      PAT_DECL_Y_FPRINTF (stderr, "   $%d = ", pat_decl_y_i + 1);
      pat_decl_y__symbol_print (stderr,
                       PAT_DECL_Y__ACCESSING_SYMBOL (+pat_decl_y_ssp[pat_decl_y_i + 1 - pat_decl_y_nrhs]),
                       &pat_decl_y_vsp[(pat_decl_y_i + 1) - (pat_decl_y_nrhs)]);
      PAT_DECL_Y_FPRINTF (stderr, "\n");
    }
}

# define PAT_DECL_Y__REDUCE_PRINT(Rule)          \
do {                                    \
  if (pat_decl_y_debug)                          \
    pat_decl_y__reduce_print (pat_decl_y_ssp, pat_decl_y_vsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int pat_decl_y_debug;
#else /* !PAT_DECL_Y_DEBUG */
# define PAT_DECL_Y_DPRINTF(Args) ((void) 0)
# define PAT_DECL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)
# define PAT_DECL_Y__STACK_PRINT(Bottom, Top)
# define PAT_DECL_Y__REDUCE_PRINT(Rule)
#endif /* !PAT_DECL_Y_DEBUG */


/* PAT_DECL_Y_INITDEPTH -- initial size of the parser's stacks.  */
#ifndef PAT_DECL_Y_INITDEPTH
# define PAT_DECL_Y_INITDEPTH 200
#endif

/* PAT_DECL_Y_MAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   PAT_DECL_Y_STACK_ALLOC_MAXIMUM < PAT_DECL_Y_STACK_BYTES (PAT_DECL_Y_MAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef PAT_DECL_Y_MAXDEPTH
# define PAT_DECL_Y_MAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
pat_decl_y_destruct (const char *pat_decl_y_msg,
            pat_decl_y_symbol_kind_t pat_decl_y_kind, PAT_DECL_Y_STYPE *pat_decl_y_valuep)
{
  PAT_DECL_Y__USE (pat_decl_y_valuep);
  if (!pat_decl_y_msg)
    pat_decl_y_msg = "Deleting";
  PAT_DECL_Y__SYMBOL_PRINT (pat_decl_y_msg, pat_decl_y_kind, pat_decl_y_valuep, pat_decl_y_locationp);

  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  PAT_DECL_Y__USE (pat_decl_y_kind);
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
extern int pat_decl_y_char;

/* The semantic value of the lookahead symbol.  */

/* Number of syntax errors so far.  */
extern int pat_decl_y_nerrs;




/*----------.
| pat_decl_y_parse.  |
`----------*/

int
pat_decl_y_parse (void)
{
    pat_decl_y__state_fast_t pat_decl_y_state = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int pat_decl_y_errstatus = 0;

    /* Refer to the stacks through separate pointers, to allow pat_decl_y_overflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    PAT_DECL_Y_PTRDIFF_T pat_decl_y_stacksize = PAT_DECL_Y_INITDEPTH;

    /* The state stack: array, bottom, top.  */
    pat_decl_y__state_t pat_decl_y_ssa[PAT_DECL_Y_INITDEPTH];
    pat_decl_y__state_t *pat_decl_y_ss = pat_decl_y_ssa;
    pat_decl_y__state_t *pat_decl_y_ssp = pat_decl_y_ss;

    /* The semantic value stack: array, bottom, top.  */
    PAT_DECL_Y_STYPE pat_decl_y_vsa[PAT_DECL_Y_INITDEPTH];
    PAT_DECL_Y_STYPE *pat_decl_y_vs = pat_decl_y_vsa;
    PAT_DECL_Y_STYPE *pat_decl_y_vsp = pat_decl_y_vs;

  int pat_decl_y_n;
  /* The return value of pat_decl_y_parse.  */
  int pat_decl_y_result;
  /* Lookahead symbol kind.  */
  pat_decl_y_symbol_kind_t pat_decl_y_token = PAT_DECL_Y_SYMBOL_PAT_DECL_Y_EMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  PAT_DECL_Y_STYPE pat_decl_y_val;



#define PAT_DECL_Y_POPSTACK(N)   (pat_decl_y_vsp -= (N), pat_decl_y_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int pat_decl_y_len = 0;

  PAT_DECL_Y_DPRINTF ((stderr, "Starting parse\n"));

  pat_decl_y_char = PAT_DECL_Y_EMPTY; /* Cause a token to be read.  */

  goto pat_decl_y_setstate;


/*------------------------------------------------------------.
| pat_decl_y_newstate -- push a new state, which is found in pat_decl_y_state.  |
`------------------------------------------------------------*/
pat_decl_y_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  pat_decl_y_ssp++;


/*--------------------------------------------------------------------.
| pat_decl_y_setstate -- set current state (the top of the stack) to pat_decl_y_state.  |
`--------------------------------------------------------------------*/
pat_decl_y_setstate:
  PAT_DECL_Y_DPRINTF ((stderr, "Entering state %d\n", pat_decl_y_state));
  PAT_DECL_Y__ASSERT (0 <= pat_decl_y_state && pat_decl_y_state < PAT_DECL_Y_NSTATES);
  PAT_DECL_Y__IGNORE_USELESS_CAST_BEGIN
  *pat_decl_y_ssp = PAT_DECL_Y__CAST (pat_decl_y__state_t, pat_decl_y_state);
  PAT_DECL_Y__IGNORE_USELESS_CAST_END
  PAT_DECL_Y__STACK_PRINT (pat_decl_y_ss, pat_decl_y_ssp);

  if (pat_decl_y_ss + pat_decl_y_stacksize - 1 <= pat_decl_y_ssp)
#if !defined pat_decl_y_overflow && !defined PAT_DECL_Y_STACK_RELOCATE
    PAT_DECL_Y_NOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      PAT_DECL_Y_PTRDIFF_T pat_decl_y_size = pat_decl_y_ssp - pat_decl_y_ss + 1;

# if defined pat_decl_y_overflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        pat_decl_y__state_t *pat_decl_y_ss1 = pat_decl_y_ss;
        PAT_DECL_Y_STYPE *pat_decl_y_vs1 = pat_decl_y_vs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if pat_decl_y_overflow is a macro.  */
        pat_decl_y_overflow (PAT_DECL_Y__("memory exhausted"),
                    &pat_decl_y_ss1, pat_decl_y_size * PAT_DECL_Y_SIZEOF (*pat_decl_y_ssp),
                    &pat_decl_y_vs1, pat_decl_y_size * PAT_DECL_Y_SIZEOF (*pat_decl_y_vsp),
                    &pat_decl_y_stacksize);
        pat_decl_y_ss = pat_decl_y_ss1;
        pat_decl_y_vs = pat_decl_y_vs1;
      }
# else /* defined PAT_DECL_Y_STACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (PAT_DECL_Y_MAXDEPTH <= pat_decl_y_stacksize)
        PAT_DECL_Y_NOMEM;
      pat_decl_y_stacksize *= 2;
      if (PAT_DECL_Y_MAXDEPTH < pat_decl_y_stacksize)
        pat_decl_y_stacksize = PAT_DECL_Y_MAXDEPTH;

      {
        pat_decl_y__state_t *pat_decl_y_ss1 = pat_decl_y_ss;
        union pat_decl_y_alloc *pat_decl_y_ptr =
          PAT_DECL_Y__CAST (union pat_decl_y_alloc *,
                   PAT_DECL_Y_STACK_ALLOC (PAT_DECL_Y__CAST (PAT_DECL_Y_SIZE_T, PAT_DECL_Y_STACK_BYTES (pat_decl_y_stacksize))));
        if (! pat_decl_y_ptr)
          PAT_DECL_Y_NOMEM;
        PAT_DECL_Y_STACK_RELOCATE (pat_decl_y_ss_alloc, pat_decl_y_ss);
        PAT_DECL_Y_STACK_RELOCATE (pat_decl_y_vs_alloc, pat_decl_y_vs);
#  undef PAT_DECL_Y_STACK_RELOCATE
        if (pat_decl_y_ss1 != pat_decl_y_ssa)
          PAT_DECL_Y_STACK_FREE (pat_decl_y_ss1);
      }
# endif

      pat_decl_y_ssp = pat_decl_y_ss + pat_decl_y_size - 1;
      pat_decl_y_vsp = pat_decl_y_vs + pat_decl_y_size - 1;

      PAT_DECL_Y__IGNORE_USELESS_CAST_BEGIN
      PAT_DECL_Y_DPRINTF ((stderr, "Stack size increased to %ld\n",
                  PAT_DECL_Y__CAST (long, pat_decl_y_stacksize)));
      PAT_DECL_Y__IGNORE_USELESS_CAST_END

      if (pat_decl_y_ss + pat_decl_y_stacksize - 1 <= pat_decl_y_ssp)
        PAT_DECL_Y_ABORT;
    }
#endif /* !defined pat_decl_y_overflow && !defined PAT_DECL_Y_STACK_RELOCATE */


  if (pat_decl_y_state == PAT_DECL_Y_FINAL)
    PAT_DECL_Y_ACCEPT;

  goto pat_decl_y_backup;


/*-----------.
| pat_decl_y_backup.  |
`-----------*/
pat_decl_y_backup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  pat_decl_y_n = pat_decl_y_pact[pat_decl_y_state];
  if (pat_decl_y_pact_value_is_default (pat_decl_y_n))
    goto pat_decl_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* PAT_DECL_Y_CHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (pat_decl_y_char == PAT_DECL_Y_EMPTY)
    {
      PAT_DECL_Y_DPRINTF ((stderr, "Reading a token\n"));
      pat_decl_y_char = pat_decl_y_lex ();
    }

  if (pat_decl_y_char <= PAT_DECL_Y_EOF)
    {
      pat_decl_y_char = PAT_DECL_Y_EOF;
      pat_decl_y_token = PAT_DECL_Y_SYMBOL_PAT_DECL_Y_EOF;
      PAT_DECL_Y_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (pat_decl_y_char == PAT_DECL_Y_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      pat_decl_y_char = PAT_DECL_Y_UNDEF;
      pat_decl_y_token = PAT_DECL_Y_SYMBOL_PAT_DECL_Y_error;
      goto pat_decl_y_errlab1;
    }
  else
    {
      pat_decl_y_token = PAT_DECL_Y_TRANSLATE (pat_decl_y_char);
      PAT_DECL_Y__SYMBOL_PRINT ("Next token is", pat_decl_y_token, &pat_decl_y_lval, &pat_decl_y_lloc);
    }

  /* If the proper action on seeing token PAT_DECL_Y_TOKEN is to reduce or to
     detect an error, take that action.  */
  pat_decl_y_n += pat_decl_y_token;
  if (pat_decl_y_n < 0 || PAT_DECL_Y_LAST < pat_decl_y_n || pat_decl_y_check[pat_decl_y_n] != pat_decl_y_token)
    goto pat_decl_y_default;
  pat_decl_y_n = pat_decl_y_table[pat_decl_y_n];
  if (pat_decl_y_n <= 0)
    {
      if (pat_decl_y_table_value_is_error (pat_decl_y_n))
        goto pat_decl_y_errlab;
      pat_decl_y_n = -pat_decl_y_n;
      goto pat_decl_y_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (pat_decl_y_errstatus)
    pat_decl_y_errstatus--;

  /* Shift the lookahead token.  */
  PAT_DECL_Y__SYMBOL_PRINT ("Shifting", pat_decl_y_token, &pat_decl_y_lval, &pat_decl_y_lloc);
  pat_decl_y_state = pat_decl_y_n;
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++pat_decl_y_vsp = pat_decl_y_lval;
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  pat_decl_y_char = PAT_DECL_Y_EMPTY;
  goto pat_decl_y_newstate;


/*-----------------------------------------------------------.
| pat_decl_y_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
pat_decl_y_default:
  pat_decl_y_n = pat_decl_y_defact[pat_decl_y_state];
  if (pat_decl_y_n == 0)
    goto pat_decl_y_errlab;
  goto pat_decl_y_reduce;


/*-----------------------------.
| pat_decl_y_reduce -- do a reduction.  |
`-----------------------------*/
pat_decl_y_reduce:
  /* pat_decl_y_n is the number of a rule to reduce with.  */
  pat_decl_y_len = pat_decl_y_r2[pat_decl_y_n];

  /* If PAT_DECL_Y_LEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets PAT_DECL_Y_VAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to PAT_DECL_Y_VAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that PAT_DECL_Y_VAL may be used uninitialized.  */
  pat_decl_y_val = pat_decl_y_vsp[1-pat_decl_y_len];


  PAT_DECL_Y__REDUCE_PRINT (pat_decl_y_n);
  switch (pat_decl_y_n)
    {
  case 2: /* pat_format_file: declarative_block BEGIN_  */
#line 463 "./pat_decl_y.y"
                {
		PAT_DECL_Y_ACCEPT;
		}
#line 1660 "y.tab.c"
    break;

  case 10: /* instance_inspection: INSPECT instance_name file_name Semicolons_ERR  */
#line 491 "./pat_decl_y.y"
                { PAT_INSPNT = pat_addpains (PAT_INSPNT, (pat_decl_y_vsp[-2].text), (pat_decl_y_vsp[-1].text)); }
#line 1666 "y.tab.c"
    break;

  case 11: /* instance_name: Identifier...Identifier..  */
#line 496 "./pat_decl_y.y"
                { (pat_decl_y_val.text) = (pat_decl_y_vsp[0].text); }
#line 1672 "y.tab.c"
    break;

  case 12: /* file_name: Identifier...Identifier..  */
#line 501 "./pat_decl_y.y"
                { (pat_decl_y_val.text) = (pat_decl_y_vsp[0].text); }
#line 1678 "y.tab.c"
    break;

  case 13: /* other_statement: Comment  */
#line 506 "./pat_decl_y.y"
                {
		PAT_COMPNT = pat_addpacom (PAT_COMPNT, (pat_decl_y_vsp[0].text), STT_NBR);
		STT_NBR    = 0;
		}
#line 1687 "y.tab.c"
    break;

  case 16: /* signal_declaration: mode name .Format. .SPY. .TRACE. Semicolons_ERR  */
#line 524 "./pat_decl_y.y"
                {
		int           length;
		int           lclmod;
		unsigned char flag  ;

		if ((lclmod = chktab (HSHTAB, (pat_decl_y_vsp[-4].arra).ident, PAT_MODDFN)) != 0)
		  {
		  if (lclmod == 'I')
		    ERR_FLG += pat_error (13, (pat_decl_y_vsp[-4].arra).ident, ' ', PAT_LINNUM);
		  if (lclmod != (pat_decl_y_vsp[-5].immd))
		    ERR_FLG += pat_error (7, (pat_decl_y_vsp[-4].arra).ident, ' ', PAT_LINNUM);
		  }
		else
		  addtab (HSHTAB, (pat_decl_y_vsp[-4].arra).ident, PAT_MODDFN, (pat_decl_y_vsp[-5].immd));

		if ((pat_decl_y_vsp[-4].arra).left < (pat_decl_y_vsp[-4].arra).right)
		  length = (pat_decl_y_vsp[-4].arra).right - (pat_decl_y_vsp[-4].arra).left + 1;
		else
		  length = (pat_decl_y_vsp[-4].arra).left - (pat_decl_y_vsp[-4].arra).right + 1;

		STT_NBR ++;
		flag       = (pat_decl_y_vsp[-2].valu) | (pat_decl_y_vsp[-1].valu);
		PAT_IOLPNT = addiol (PAT_IOLPNT, (pat_decl_y_vsp[-4].arra), (pat_decl_y_vsp[-3].immd), (pat_decl_y_vsp[-5].immd), (pat_decl_y_vsp[0].valu), flag);

		if (length != 1)
		  PAT_GRPPNT = pat_addpagrp (PAT_GRPPNT, (pat_decl_y_vsp[-4].arra).ident, length,
		                             DCL_NBR   , 0);
		else
		  {
		  if ((pat_decl_y_vsp[-3].immd) != 'B')
		    ERR_FLG += pat_error (1, NULL, ' ', PAT_LINNUM);
		  }

		DCL_NBR += length;
		}
#line 1727 "y.tab.c"
    break;

  case 17: /* group_declaration: mode Identifier...Identifier.. LeftParen ...name.. RightParen .Format. .SPY. .TRACE. Semicolons_ERR  */
#line 571 "./pat_decl_y.y"
                {
		int           i      ;
		int           lclmod ;
		int           length = 0;
		unsigned char flag   ;

		if (chktab (HSHTAB, (pat_decl_y_vsp[-7].text), PAT_MODDFN) != 0)
		  ERR_FLG += pat_error (8, (pat_decl_y_vsp[-7].text), ' ', PAT_LINNUM);
		else
		  addtab (HSHTAB, (pat_decl_y_vsp[-7].text), PAT_MODDFN, (pat_decl_y_vsp[-8].immd));

		STT_NBR++;

		for (i=0 ; i<TAB_IDX ; i++)
                  {
		  if ((lclmod = chktab(HSHTAB,TAB[i].ident,PAT_MODDFN)) != 0)
		    {
		    if (lclmod != (pat_decl_y_vsp[-8].immd))
		      ERR_FLG += pat_error (7, TAB[i].ident, ' ', PAT_LINNUM);
		    }
		  else
		    addtab (HSHTAB, TAB[i].ident, PAT_MODDFN, (pat_decl_y_vsp[-8].immd));

		  flag       = (pat_decl_y_vsp[-2].valu) | (pat_decl_y_vsp[-1].valu);
		  PAT_IOLPNT = addiol (PAT_IOLPNT, TAB[i], (pat_decl_y_vsp[-3].immd), (pat_decl_y_vsp[-8].immd), (pat_decl_y_vsp[0].valu), flag);
		  if (TAB[i].left < TAB[i].right)
		    length += TAB[i].right - TAB[i].left + 1;
		  else
		    length += TAB[i].left - TAB[i].right + 1;
                  }

		PAT_GRPPNT = pat_addpagrp (PAT_GRPPNT, (pat_decl_y_vsp[-7].text), length, DCL_NBR, 1);
		TAB_IDX    = 0;
		DCL_NBR   += length;
		}
#line 1767 "y.tab.c"
    break;

  case 18: /* .Format.: %empty  */
#line 610 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'B'; }
#line 1773 "y.tab.c"
    break;

  case 19: /* .Format.: Format  */
#line 612 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = (pat_decl_y_vsp[0].immd); }
#line 1779 "y.tab.c"
    break;

  case 20: /* ...name..: name  */
#line 617 "./pat_decl_y.y"
                { pshtab ((pat_decl_y_vsp[0].arra)); }
#line 1785 "y.tab.c"
    break;

  case 21: /* ...name..: ...name.. Comma name  */
#line 621 "./pat_decl_y.y"
                { pshtab ((pat_decl_y_vsp[0].arra)); }
#line 1791 "y.tab.c"
    break;

  case 22: /* name: simple_name  */
#line 626 "./pat_decl_y.y"
                { (pat_decl_y_val.arra) = (pat_decl_y_vsp[0].arra); }
#line 1797 "y.tab.c"
    break;

  case 23: /* name: indexed_name  */
#line 628 "./pat_decl_y.y"
                { (pat_decl_y_val.arra) = (pat_decl_y_vsp[0].arra); }
#line 1803 "y.tab.c"
    break;

  case 24: /* name: slice_name  */
#line 630 "./pat_decl_y.y"
                { (pat_decl_y_val.arra) = (pat_decl_y_vsp[0].arra); }
#line 1809 "y.tab.c"
    break;

  case 25: /* simple_name: Identifier...Identifier..  */
#line 635 "./pat_decl_y.y"
                {
		(pat_decl_y_val.arra).ident = (pat_decl_y_vsp[0].text);
		(pat_decl_y_val.arra).left  = -1;
		(pat_decl_y_val.arra).right = -1;
		}
#line 1819 "y.tab.c"
    break;

  case 26: /* indexed_name: Identifier...Identifier.. LeftParen AbstractLit RightParen  */
#line 647 "./pat_decl_y.y"
                {
		(pat_decl_y_val.arra).ident = (pat_decl_y_vsp[-3].text);
		(pat_decl_y_val.arra).left  = (pat_decl_y_vsp[-1].valu);
		(pat_decl_y_val.arra).right = (pat_decl_y_vsp[-1].valu);
		}
#line 1829 "y.tab.c"
    break;

  case 27: /* slice_name: Identifier...Identifier.. LeftParen AbstractLit direction AbstractLit RightParen  */
#line 661 "./pat_decl_y.y"
                {
		(pat_decl_y_val.arra).ident = (pat_decl_y_vsp[-5].text);
		(pat_decl_y_val.arra).left  = (pat_decl_y_vsp[-3].valu);
		(pat_decl_y_val.arra).right = (pat_decl_y_vsp[-1].valu);
		}
#line 1839 "y.tab.c"
    break;

  case 28: /* Identifier...Identifier..: Identifier ...Identifier..  */
#line 671 "./pat_decl_y.y"
                {
		char name [256];
		int  i         ;

		strcpy (name, (pat_decl_y_vsp[-1].text));
		for (i=0; i<NAM_IDX ; i++)
		 {
		 strcat (name, ".");
		 strcat (name, NAMTAB [i]);
		 }
		NAM_IDX = 0;
		(pat_decl_y_val.text) = namealloc (name);
		}
#line 1857 "y.tab.c"
    break;

  case 30: /* ...Identifier..: ...Identifier.. Dot Identifier  */
#line 691 "./pat_decl_y.y"
                { pshnam ((pat_decl_y_vsp[0].text)); }
#line 1863 "y.tab.c"
    break;

  case 33: /* mode: _IN  */
#line 701 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'I'; }
#line 1869 "y.tab.c"
    break;

  case 34: /* mode: _OUT  */
#line 703 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'O'; }
#line 1875 "y.tab.c"
    break;

  case 35: /* mode: _INOUT  */
#line 705 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'T'; }
#line 1881 "y.tab.c"
    break;

  case 36: /* mode: SIGNAL  */
#line 707 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'S'; }
#line 1887 "y.tab.c"
    break;

  case 37: /* mode: REGISTER  */
#line 709 "./pat_decl_y.y"
                { (pat_decl_y_val.immd) = 'R'; }
#line 1893 "y.tab.c"
    break;

  case 38: /* Semicolons_ERR: Semicolons  */
#line 714 "./pat_decl_y.y"
                {
		if (ERR_FLG > 30)
		  PAT_DECL_Y_ABORT;
		else
		   pat_decl_y_errok;
		}
#line 1904 "y.tab.c"
    break;

  case 39: /* .SPY.: %empty  */
#line 724 "./pat_decl_y.y"
                { (pat_decl_y_val.valu) = 0 ;           }
#line 1910 "y.tab.c"
    break;

  case 40: /* .SPY.: SPY  */
#line 726 "./pat_decl_y.y"
                { (pat_decl_y_val.valu) = PAT_IOL__SPY; }
#line 1916 "y.tab.c"
    break;

  case 41: /* .TRACE.: %empty  */
#line 731 "./pat_decl_y.y"
                { (pat_decl_y_val.valu) = 0 ;             }
#line 1922 "y.tab.c"
    break;

  case 42: /* .TRACE.: TRACE  */
#line 733 "./pat_decl_y.y"
                { (pat_decl_y_val.valu) = PAT_IOL__TRACE; }
#line 1928 "y.tab.c"
    break;


#line 1932 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter pat_decl_y_char, and that requires
     that pat_decl_y_token be updated with the new translation.  We take the
     approach of translating immediately before every use of pat_decl_y_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     PAT_DECL_Y_ABORT, PAT_DECL_Y_ACCEPT, or PAT_DECL_Y_ERROR immediately after altering pat_decl_y_char or
     if it invokes PAT_DECL_Y_BACKUP.  In the case of PAT_DECL_Y_ABORT or PAT_DECL_Y_ACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of PAT_DECL_Y_ERROR or PAT_DECL_Y_BACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  PAT_DECL_Y__SYMBOL_PRINT ("-> $$ =", PAT_DECL_Y__CAST (pat_decl_y_symbol_kind_t, pat_decl_y_r1[pat_decl_y_n]), &pat_decl_y_val, &pat_decl_y_loc);

  PAT_DECL_Y_POPSTACK (pat_decl_y_len);
  pat_decl_y_len = 0;

  *++pat_decl_y_vsp = pat_decl_y_val;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int pat_decl_y_lhs = pat_decl_y_r1[pat_decl_y_n] - PAT_DECL_Y_NTOKENS;
    const int pat_decl_y_i = pat_decl_y_pgoto[pat_decl_y_lhs] + *pat_decl_y_ssp;
    pat_decl_y_state = (0 <= pat_decl_y_i && pat_decl_y_i <= PAT_DECL_Y_LAST && pat_decl_y_check[pat_decl_y_i] == *pat_decl_y_ssp
               ? pat_decl_y_table[pat_decl_y_i]
               : pat_decl_y_defgoto[pat_decl_y_lhs]);
  }

  goto pat_decl_y_newstate;


/*--------------------------------------.
| pat_decl_y_errlab -- here on detecting error.  |
`--------------------------------------*/
pat_decl_y_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  pat_decl_y_token = pat_decl_y_char == PAT_DECL_Y_EMPTY ? PAT_DECL_Y_SYMBOL_PAT_DECL_Y_EMPTY : PAT_DECL_Y_TRANSLATE (pat_decl_y_char);
  /* If not already recovering from an error, report this error.  */
  if (!pat_decl_y_errstatus)
    {
      ++pat_decl_y_nerrs;
      pat_decl_y_error (PAT_DECL_Y__("syntax error"));
    }

  if (pat_decl_y_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (pat_decl_y_char <= PAT_DECL_Y_EOF)
        {
          /* Return failure if at end of input.  */
          if (pat_decl_y_char == PAT_DECL_Y_EOF)
            PAT_DECL_Y_ABORT;
        }
      else
        {
          pat_decl_y_destruct ("Error: discarding",
                      pat_decl_y_token, &pat_decl_y_lval);
          pat_decl_y_char = PAT_DECL_Y_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto pat_decl_y_errlab1;


/*---------------------------------------------------.
| pat_decl_y_errorlab -- error raised explicitly by PAT_DECL_Y_ERROR.  |
`---------------------------------------------------*/
pat_decl_y_errorlab:
  /* Pacify compilers when the user code never invokes PAT_DECL_Y_ERROR and the
     label pat_decl_y_errorlab therefore never appears in user code.  */
  if (0)
    PAT_DECL_Y_ERROR;
  ++pat_decl_y_nerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this PAT_DECL_Y_ERROR.  */
  PAT_DECL_Y_POPSTACK (pat_decl_y_len);
  pat_decl_y_len = 0;
  PAT_DECL_Y__STACK_PRINT (pat_decl_y_ss, pat_decl_y_ssp);
  pat_decl_y_state = *pat_decl_y_ssp;
  goto pat_decl_y_errlab1;


/*-------------------------------------------------------------.
| pat_decl_y_errlab1 -- common code for both syntax error and PAT_DECL_Y_ERROR.  |
`-------------------------------------------------------------*/
pat_decl_y_errlab1:
  pat_decl_y_errstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      pat_decl_y_n = pat_decl_y_pact[pat_decl_y_state];
      if (!pat_decl_y_pact_value_is_default (pat_decl_y_n))
        {
          pat_decl_y_n += PAT_DECL_Y_SYMBOL_PAT_DECL_Y_error;
          if (0 <= pat_decl_y_n && pat_decl_y_n <= PAT_DECL_Y_LAST && pat_decl_y_check[pat_decl_y_n] == PAT_DECL_Y_SYMBOL_PAT_DECL_Y_error)
            {
              pat_decl_y_n = pat_decl_y_table[pat_decl_y_n];
              if (0 < pat_decl_y_n)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (pat_decl_y_ssp == pat_decl_y_ss)
        PAT_DECL_Y_ABORT;


      pat_decl_y_destruct ("Error: popping",
                  PAT_DECL_Y__ACCESSING_SYMBOL (pat_decl_y_state), pat_decl_y_vsp);
      PAT_DECL_Y_POPSTACK (1);
      pat_decl_y_state = *pat_decl_y_ssp;
      PAT_DECL_Y__STACK_PRINT (pat_decl_y_ss, pat_decl_y_ssp);
    }

  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++pat_decl_y_vsp = pat_decl_y_lval;
  PAT_DECL_Y__IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  PAT_DECL_Y__SYMBOL_PRINT ("Shifting", PAT_DECL_Y__ACCESSING_SYMBOL (pat_decl_y_n), pat_decl_y_vsp, pat_decl_y_lsp);

  pat_decl_y_state = pat_decl_y_n;
  goto pat_decl_y_newstate;


/*-------------------------------------.
| pat_decl_y_acceptlab -- PAT_DECL_Y_ACCEPT comes here.  |
`-------------------------------------*/
pat_decl_y_acceptlab:
  pat_decl_y_result = 0;
  goto pat_decl_y_returnlab;


/*-----------------------------------.
| pat_decl_y_abortlab -- PAT_DECL_Y_ABORT comes here.  |
`-----------------------------------*/
pat_decl_y_abortlab:
  pat_decl_y_result = 1;
  goto pat_decl_y_returnlab;


/*-----------------------------------------------------------.
| pat_decl_y_exhaustedlab -- PAT_DECL_Y_NOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
pat_decl_y_exhaustedlab:
  pat_decl_y_error (PAT_DECL_Y__("memory exhausted"));
  pat_decl_y_result = 2;
  goto pat_decl_y_returnlab;


/*----------------------------------------------------------.
| pat_decl_y_returnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
pat_decl_y_returnlab:
  if (pat_decl_y_char != PAT_DECL_Y_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      pat_decl_y_token = PAT_DECL_Y_TRANSLATE (pat_decl_y_char);
      pat_decl_y_destruct ("Cleanup: discarding lookahead",
                  pat_decl_y_token, &pat_decl_y_lval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this PAT_DECL_Y_ABORT or PAT_DECL_Y_ACCEPT.  */
  PAT_DECL_Y_POPSTACK (pat_decl_y_len);
  PAT_DECL_Y__STACK_PRINT (pat_decl_y_ss, pat_decl_y_ssp);
  while (pat_decl_y_ssp != pat_decl_y_ss)
    {
      pat_decl_y_destruct ("Cleanup: popping",
                  PAT_DECL_Y__ACCESSING_SYMBOL (+*pat_decl_y_ssp), pat_decl_y_vsp);
      PAT_DECL_Y_POPSTACK (1);
    }
#ifndef pat_decl_y_overflow
  if (pat_decl_y_ss != pat_decl_y_ssa)
    PAT_DECL_Y_STACK_FREE (pat_decl_y_ss);
#endif

  return pat_decl_y_result;
}

#line 735 "./pat_decl_y.y"

