/*------------------------------------------------------------\
|                                                             |
| This file is part of the Alliance CAD System Copyright      |
| (C) Laboratoire LIP6 - Dpartement ASIM Universite P&M Curie|
|                                                             |
| Home page      : http://www-asim.lip6.fr/alliance/          |
| E-mail support : mailto:alliance-support@asim.lip6.fr       |
|                                                             |
| This progam is  free software; you can redistribute it      |
| and/or modify it under the  terms of the GNU General Public |
| License as  published by the Free Software Foundation;      |
| either version 2 of the License, or (at your option) any    |
| later version.                                              |
|                                                             |
| Alliance VLSI  CAD System  is distributed  in the hope that |
| it  will be useful, but WITHOUT  ANY WARRANTY;              |
| without even the  implied warranty of MERCHANTABILITY or    |
| FITNESS FOR A PARTICULAR PURPOSE. See the GNU General       |
| Public License for more details.                            |
|                                                             |
| You should have received a copy  of the GNU General Public  |
| License along with the GNU C Library; see the file COPYING. |
| If not, write to the Free Software Foundation, Inc.,        |
| 675 Mass Ave, Cambridge, MA 02139, USA.                     |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
| Tool    :                    XGRA                           |
|                                                             |
| File    :                  Panel.c                          |
|                                                             |
| Authors :              Jacomme Ludovic                      |
|                                                             |
| Date    :                   04.12.96                        |
|                                                             |
\------------------------------------------------------------*/

/*------------------------------------------------------------\
|                                                             |
|                         Include Files                       |
|                                                             |
\------------------------------------------------------------*/

# include <stdio.h>
# include <X11/Intrinsic.h>
# include <Xm/Xm.h>
# include <Xm/Frame.h>
# include <Xm/Form.h>
# include <Xm/List.h>
# include <Xm/Text.h>
# include <Xm/TextF.h>
# include <Xm/PushB.h>
# include <Xm/DialogS.h>
# include <Xm/Label.h>
# include <Xm/LabelG.h>
 
# include "mut.h"
# include "aut.h"
# include "XSB.h"
# include "XTB.h"
# include "XMX.h"
# include "XMH.h"

# include "XMH_panel.h" 
# include "XTB_dialog.h"

/*------------------------------------------------------------\
|                                                             |
|                           Constants                         |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                            Types                            |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                          Variables                          |
|                                                             |
\------------------------------------------------------------*/

   XgraPanelItem XgraHelpPresentPanel =

         {
           "Xgra present",
           1,
           0,
           XGRA_HELP_PRESENT_X,
           XGRA_HELP_PRESENT_Y,
           700,
           360,
           0,
           0,
           (Widget)NULL,
           (Widget)NULL,
           (Widget)NULL,
           (Widget)NULL,
           (XgraPanelButtonItem *)NULL
         };

   int XgraHelpPresentDefaultValues[ 5 ] =

         {
           XGRA_HELP_PRESENT_X,
           XGRA_HELP_PRESENT_Y,
           700, 360, 0
         };


  static char XgraHelpPresentPixmap[] = 
  {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x40, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x15,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x22, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x68, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x94, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x85,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4a, 0xa5, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x59, 0x52, 0x02, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x80, 0x46, 0x95, 0x02, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xaa, 0xa4,
    0x04, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x40, 0x25, 0x29, 0x01, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xfe, 0x00, 0x40, 0x29, 0x45, 0x0d, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xd7, 0x00,
    0x28, 0xc5, 0x28, 0x10, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xef, 0x7b, 0x00, 0x40, 0x92, 0x52,
    0x05, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x42, 0xef, 0xdd, 0x7f, 0x00, 0x94, 0x54, 0x15, 0x52, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0xe0, 0xf5,
    0xf7, 0x3d, 0x00, 0x50, 0x49, 0xc5, 0x44, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xf7, 0xbf, 0x0e, 0x00,
    0x05, 0x51, 0x10, 0x90, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x7f, 0x0f, 0x00, 0x68, 0x75, 0x4d,
    0x55, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xb8, 0xdb, 0xff, 0x05, 0x80, 0x4a, 0x6c, 0x42, 0x26, 0x01, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x7c, 0xf7,
    0x1d, 0x00, 0x00, 0x24, 0xfb, 0x28, 0x8d, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xee, 0xff, 0x06, 0x00, 0x40,
    0x91, 0xf4, 0x51, 0x12, 0x02, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x6b, 0xdf, 0x05, 0x00, 0x00, 0x48, 0xfd, 0x8a,
    0xa4, 0x04, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x80, 0xb5, 0xb5, 0x0f, 0x00, 0x90, 0x12, 0xaf, 0x53, 0x04, 0x08, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x80, 0xbf, 0xea,
    0x1d, 0x00, 0x00, 0xa0, 0xfe, 0x25, 0x59, 0x01, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0xc4, 0xeb, 0x78, 0x1f, 0x00, 0xa0,
    0x2a, 0x7f, 0x0b, 0x81, 0x10, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe0, 0xbd, 0xa6, 0x1d, 0x00, 0x08, 0x40, 0xdc, 0xa7,
    0x14, 0x08, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
    0xf0, 0x6f, 0x71, 0x0d, 0x00, 0x80, 0x54, 0xb8, 0x0e, 0x41, 0x01, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0xa8, 0x9b, 0xca,
    0x05, 0x00, 0x41, 0x20, 0xd0, 0x1d, 0x12, 0x40, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x42, 0xec, 0xaf, 0x5a, 0x07, 0x00, 0x08,
    0x10, 0xb0, 0xa2, 0x00, 0x10, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x20, 0xbc, 0xa7, 0x84, 0x01, 0x00, 0x00, 0x02, 0x60, 0x3d,
    0x14, 0x09, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00,
    0xd6, 0x2b, 0xb5, 0x00, 0x00, 0x00, 0x04, 0x20, 0x25, 0x01, 0x60, 0x01,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x40, 0x11, 0xff, 0x55, 0x44,
    0x01, 0x00, 0x24, 0x00, 0x40, 0x49, 0x20, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x08, 0x84, 0xee, 0x4c, 0xa9, 0x00, 0x20, 0x01,
    0x03, 0x40, 0x92, 0x08, 0x03, 0x02, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0xa4, 0x40, 0x57, 0x50, 0x53, 0x00, 0x00, 0x00, 0x00, 0x80, 0x12,
    0x01, 0x90, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x02, 0xe4,
    0x37, 0x90, 0x2c, 0x00, 0x00, 0x80, 0x00, 0x00, 0x45, 0x82, 0x80, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x20, 0xa1, 0x1a, 0xa0, 0x12,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x01, 0x08, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x09, 0xb0, 0x1e, 0xa0, 0x0a, 0x00, 0x00, 0x20,
    0x00, 0x00, 0x8a, 0x02, 0x00, 0x02, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x80, 0x00, 0xe9, 0x0b, 0x40, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44,
    0x14, 0x00, 0x10, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x40, 0x22, 0xa8,
    0x06, 0x80, 0x07, 0x00, 0x00, 0x08, 0x00, 0x00, 0x50, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x48, 0xde, 0x03, 0x80, 0x00,
    0x00, 0x00, 0x08, 0x00, 0x00, 0x88, 0x0a, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x90, 0x02, 0x35, 0x01, 0x00, 0x01, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x90, 0x52, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x90, 0xea, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x20,
    0x11, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0xa8, 0x84, 0xd6,
    0x00, 0x80, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x20, 0xa4, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x04, 0xc4, 0x3a, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x00, 0x00, 0x40, 0x09, 0x00, 0x00, 0x01, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x84, 0xa0, 0x57, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0a,
    0x00, 0x00, 0x80, 0x52, 0x01, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x22, 0x71, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x40, 0x19, 0x00, 0x00, 0x80,
    0x44, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x09, 0xd4, 0x0b,
    0x00, 0x00, 0x00, 0x00, 0x60, 0x02, 0x00, 0x00, 0x00, 0x12, 0x01, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x80, 0x24, 0x38, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x90, 0x28, 0x00, 0x00, 0x00, 0x20, 0x04, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x40, 0x00, 0xed, 0x07, 0x00, 0x00, 0x00, 0x00, 0x28, 0x45,
    0x00, 0x00, 0x00, 0x8a, 0x02, 0x00, 0x08, 0x00, 0xf0, 0x00, 0x00, 0x20,
    0x15, 0x9a, 0x01, 0x00, 0x00, 0x00, 0x00, 0x04, 0xa2, 0x00, 0x00, 0x00,
    0xa4, 0x08, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x20, 0x48, 0xf7, 0x01,
    0x00, 0x00, 0x00, 0x00, 0xa2, 0x08, 0x00, 0x00, 0x00, 0x10, 0x02, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x10, 0x81, 0xad, 0x00, 0x20, 0x00, 0x00,
    0x00, 0x0a, 0x45, 0x00, 0x00, 0x00, 0x48, 0x08, 0x00, 0x20, 0x00, 0xf0,
    0x00, 0x00, 0x48, 0x4a, 0x7b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x10,
    0x01, 0x00, 0x00, 0x90, 0x12, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x04,
    0xd1, 0x37, 0x00, 0x00, 0x00, 0x00, 0x80, 0x10, 0x55, 0x02, 0x00, 0x00,
    0x20, 0x40, 0x00, 0x40, 0x00, 0xf0, 0x00, 0x00, 0x8a, 0xe4, 0x2f, 0x10,
    0x00, 0x00, 0x00, 0x40, 0x15, 0x04, 0x04, 0x00, 0x00, 0x00, 0x0a, 0x00,
    0x80, 0x00, 0xf0, 0x00, 0x00, 0x26, 0xb1, 0x2f, 0x00, 0x00, 0x00, 0x00,
    0x20, 0x25, 0x51, 0x09, 0x00, 0x00, 0x80, 0xa4, 0x00, 0x08, 0x00, 0xf0,
    0x00, 0x00, 0x91, 0x7c, 0x01, 0x85, 0x00, 0x00, 0x00, 0x50, 0xa1, 0x04,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x01, 0xf0, 0x00, 0x80, 0x24,
    0x01, 0x54, 0x00, 0x00, 0x00, 0x00, 0x10, 0x4a, 0xa8, 0x12, 0x00, 0x00,
    0x00, 0x48, 0x4a, 0x40, 0x02, 0xf0, 0x00, 0x40, 0x49, 0x54, 0x81, 0x08,
    0x00, 0x00, 0x00, 0x50, 0x12, 0x02, 0x20, 0x00, 0x00, 0x00, 0x10, 0x00,
    0x28, 0x00, 0xf0, 0x00, 0x20, 0xca, 0x12, 0x4a, 0x42, 0x00, 0x00, 0x00,
    0x40, 0x44, 0xa8, 0x02, 0x00, 0x00, 0x00, 0xa2, 0x02, 0x02, 0x05, 0xf0,
    0x00, 0x40, 0x92, 0xa4, 0x10, 0x00, 0x00, 0x00, 0x00, 0x80, 0x92, 0x02,
    0x04, 0x00, 0x00, 0x00, 0x08, 0x42, 0x20, 0x00, 0xf0, 0x00, 0x90, 0x11,
    0x49, 0x85, 0x10, 0x04, 0x00, 0x00, 0x00, 0x24, 0xa4, 0x48, 0x00, 0x00,
    0x00, 0x04, 0x8d, 0x08, 0x04, 0xf0, 0x00, 0xa8, 0x24, 0x22, 0x08, 0x00,
    0x00, 0x01, 0x00, 0x80, 0x42, 0x01, 0x01, 0x01, 0x00, 0x00, 0x08, 0x18,
    0x10, 0x09, 0xf0, 0x00, 0x24, 0x95, 0x08, 0xa1, 0x00, 0x00, 0x00, 0x40,
    0x00, 0x28, 0x24, 0x09, 0x01, 0x00, 0x00, 0x50, 0x0b, 0xa1, 0x10, 0xf0,
    0x00, 0x4a, 0x08, 0xa1, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8a, 0x42,
    0x20, 0x02, 0x00, 0x00, 0x10, 0x40, 0x0a, 0x22, 0xf0, 0x00, 0x12, 0x29,
    0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x09, 0x0a, 0x00, 0x00,
    0x80, 0x00, 0x12, 0x50, 0x04, 0xf0, 0x00, 0x51, 0x92, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x00, 0x01, 0x48, 0x24, 0x80, 0x04, 0x00, 0x08, 0x00, 0x81,
    0x24, 0x51, 0xf0, 0x80, 0x0c, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x00, 0x90, 0x08, 0x25, 0x01, 0x10, 0x01, 0x00, 0x90, 0x20, 0x82, 0xf0,
    0x40, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0xa0, 0x22,
    0x00, 0x10, 0x01, 0x00, 0x08, 0x40, 0x8a, 0x24, 0xf0, 0x20, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x49, 0x48, 0x00, 0x00,
    0x00, 0x00, 0x8a, 0x20, 0x08, 0xf1, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x22, 0x00, 0x20, 0x4a, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x01, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00,
    0x04, 0x40, 0x11, 0x28, 0x02, 0x01, 0x00, 0x00, 0x10, 0x42, 0x22, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x20, 0x80, 0xa4,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x30, 0x00, 0x20, 0x01, 0x00, 0x4a, 0x13, 0x48, 0x00,
    0x00, 0x00, 0x80, 0x04, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x48, 0x00, 0xa5, 0x40, 0x01, 0x00, 0x00, 0x00, 0x04,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x02,
    0x00, 0x00, 0xa8, 0x0d, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x40, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x41, 0x00, 0x10, 0x01, 0x56,
    0x4b, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x45, 0x00, 0xa8, 0x1a, 0x04, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00,
    0x00, 0x00, 0x02, 0x20, 0x00, 0x58, 0x15, 0x01, 0x02, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x80, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x04, 0x05, 0xa0, 0x16, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0xc0, 0xdf, 0x00, 0x00, 0x00, 0x04, 0x04, 0x28, 0x08, 0xf0,
    0x35, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0xfa, 0x01, 0x00, 0x00, 0x00, 0x40, 0x80, 0x12, 0xa0, 0xda, 0x48, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0xdf, 0x02, 0x00,
    0x00, 0x10, 0x12, 0x11, 0x01, 0x40, 0xab, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x08, 0x00, 0xf6, 0x02, 0x00, 0x00, 0x00, 0x80,
    0xa0, 0x4c, 0xa0, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x7a, 0x07, 0x00, 0x00, 0x00, 0x00, 0x02, 0x22, 0x50,
    0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0xdc, 0x0e, 0x00, 0x00, 0x00, 0xa0, 0xa4, 0x48, 0x88, 0x16, 0x00, 0x00,
    0x00, 0x80, 0x01, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x58, 0x15, 0x00,
    0x00, 0x80, 0x04, 0x25, 0xa5, 0xa0, 0x01, 0x00, 0x00, 0x00, 0xb4, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x20,
    0x0d, 0x21, 0x55, 0x0d, 0x00, 0x00, 0xc0, 0x29, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x60, 0x2e, 0x00, 0x00, 0x00, 0x80, 0x42, 0xa4, 0x29,
    0x02, 0x00, 0x40, 0x41, 0x1a, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x40, 0x53, 0x00, 0x00, 0x00, 0x92, 0x14, 0x4a, 0x4a, 0x01, 0x00, 0x18,
    0xa0, 0x16, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0xa0, 0x94, 0x00,
    0x00, 0x00, 0x04, 0x6d, 0xa4, 0x5a, 0x00, 0x40, 0x01, 0x90, 0x0a, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x80, 0x52, 0x00, 0x00, 0x00, 0x40,
    0x52, 0x51, 0x49, 0x00, 0x10, 0x00, 0x38, 0x0d, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x80, 0x54, 0x01, 0x00, 0x00, 0x88, 0xbc, 0x34, 0x95,
    0x00, 0x00, 0x00, 0xd4, 0x02, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x25, 0x02, 0x00, 0x00, 0x10, 0xab, 0x90, 0x34, 0x00, 0x04, 0x00,
    0xaa, 0x01, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x4a, 0x05,
    0x00, 0x00, 0x40, 0x6b, 0x6d, 0x05, 0x00, 0x02, 0x00, 0x55, 0x01, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x18, 0x08, 0x00, 0x00, 0xc0,
    0xda, 0x2a, 0x19, 0x00, 0x01, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0xa4, 0x0a, 0x00, 0x00, 0x00, 0xb6, 0x4b, 0x05,
    0x80, 0x00, 0xc0, 0x5a, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x90, 0x00, 0x00, 0x00, 0x80, 0xed, 0xd5, 0x02, 0x40, 0x00, 0x80,
    0x2d, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x20, 0x2a,
    0x00, 0x00, 0x00, 0xf5, 0x54, 0x00, 0x00, 0x00, 0x70, 0x1b, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x20, 0x24, 0x00, 0x00, 0x00,
    0x3d, 0xab, 0x01, 0x20, 0x00, 0x40, 0x05, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x41, 0x00, 0x00, 0x00, 0x56, 0xa5, 0x00,
    0x10, 0x00, 0xd8, 0x0b, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x94, 0x00, 0x00, 0x00, 0x5c, 0x52, 0x00, 0x08, 0x00, 0x54,
    0x01, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0a,
    0x00, 0x00, 0x00, 0x90, 0x2a, 0x00, 0x15, 0x00, 0xaa, 0x08, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x02, 0x80, 0xa0, 0x02, 0x00, 0x00,
    0x28, 0x16, 0x00, 0x1a, 0x00, 0xfb, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x04, 0x00, 0x00, 0xc8, 0x01, 0x00,
    0x2e, 0x80, 0x26, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0xa0, 0x0c, 0x00, 0x3f, 0x40, 0x59,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
    0x08, 0x00, 0x00, 0x2a, 0x01, 0x80, 0x5b, 0x40, 0x17, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x10, 0x00, 0x28, 0x11, 0x00, 0x00,
    0x48, 0x01, 0xc0, 0xee, 0xa0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x08, 0x00, 0x80, 0x22, 0x00, 0xe0,
    0xff, 0xd9, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x22, 0x00, 0x00, 0x94, 0x00, 0xd0, 0xff, 0x55, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x40, 0x00, 0x80, 0x22, 0x00, 0xb8, 0xff, 0xab, 0x01, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x96, 0x00, 0x20,
    0x08, 0x00, 0xb4, 0xf6, 0x75, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x08, 0x15, 0x00, 0xec,
    0xff, 0x2d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x28, 0x00, 0xa4, 0x40, 0x20, 0xbe, 0xfe, 0x4b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
    0x81, 0x02, 0x00, 0x0a, 0x0a, 0xab, 0x7a, 0x35, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x05, 0xa1,
    0x00, 0x80, 0xef, 0xf5, 0x16, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x08, 0x10, 0x12, 0xc1, 0x7a,
    0xbb, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x04, 0x82, 0x44, 0x21, 0xa0, 0xee, 0xdf, 0x05, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0x19, 0x00, 0x00, 0x90, 0xfd, 0x7f, 0x05, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x28, 0x49,
    0x48, 0x08, 0x7f, 0xaf, 0x02, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x15, 0x00, 0x02, 0xec, 0xdf,
    0xff, 0x01, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x00, 0x40, 0x4b, 0x14, 0x28, 0xf6, 0xfb, 0x55, 0x00, 0x10,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0x04, 0x80, 0x00, 0xff, 0xff, 0x0b, 0x00, 0x08, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x02, 0x24,
    0x84, 0xff, 0x3f, 0x00, 0x01, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x82, 0xd0, 0x7f, 0x01,
    0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x02, 0x00, 0x00, 0x50, 0xe2, 0x5f, 0x20, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x40, 0x80, 0xf0, 0x00, 0x08, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x40, 0x00, 0x6a,
    0x04, 0x22, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x11, 0x08, 0x12,
    0x08, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x82, 0xa4, 0x40, 0x40, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x00, 0x84, 0x24, 0x00, 0x14, 0x0a, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91,
    0x14, 0x41, 0x00, 0x80, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x04, 0x41, 0x8a, 0x00,
    0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x40, 0x51, 0x94, 0x20, 0xea, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x01, 0x08, 0x84, 0x20, 0x8a, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x90, 0x10,
    0x8a, 0x74, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x04, 0x85, 0x78, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x60, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x0a, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0
  };
 
/*------------------------------------------------------------\
|                                                             |
|                          Functions                          |
|                                                             |
\------------------------------------------------------------*/
/*------------------------------------------------------------\
|                                                             |
|                    XgraBuildPresentPanel                   |
|                                                             |
\------------------------------------------------------------*/

void XgraBuildPresentPanel()

{
  Widget       PanelLabel;
  Widget       PanelButton;
  Pixmap       PanelPixmap;
  XmString     PanelString;
  XmString     PanelString1;
  XmString     PanelString2;
  XmFontList   PanelFontList;
  XFontStruct *PanelFont;
  Display     *PanelDisplay;
  char         Buffer[ 64 ];
  Arg          Args[3];

  autbegin();
  
  PanelDisplay  = XtDisplay( XgraMainWindow );
  PanelFont     = XLoadQueryFont( PanelDisplay, "-*-helvetica-bold-o-*--24-*" );
  PanelFontList = XmFontListCreate( PanelFont, "Panel_charset1" );
  PanelFont     = XLoadQueryFont( PanelDisplay, "-*-helvetica-bold-r-*--18-*" );
  PanelFontList = XmFontListAdd( PanelFontList, PanelFont, "Panel_charset2" );
  PanelFont     = XLoadQueryFont( PanelDisplay, "-*-helvetica-bold-r-*--12-*" );
  PanelFontList = XmFontListAdd( PanelFontList, PanelFont, "Panel_charset4" );

  XtSetArg( Args[0], XmNshadowType    , XmSHADOW_ETCHED_IN );
  XtSetArg( Args[1], XmNdeleteResponse, XmDESTROY          );
  XtSetArg( Args[2], XmNtitle         , "Xgra present"    );

  XgraHelpPresentPanel.PANEL = 

    XmCreateFormDialog( XgraMainWindow, XgraHelpPresentPanel.TITLE, Args, 3);

  XtAddCallback( XgraHelpPresentPanel.PANEL, XmNdestroyCallback,
                 XgraDestroyDialogCallback, NULL );

  XgraHelpPresentPanel.PANEL_FORM = 

     XtVaCreateManagedWidget( "",
                              xmFormWidgetClass,
                              XgraHelpPresentPanel.PANEL,
                              XmNtopAttachment    , XmATTACH_FORM,
                              XmNbottomAttachment , XmATTACH_FORM,
                              XmNleftAttachment   , XmATTACH_FORM,
                              XmNrightAttachment  , XmATTACH_FORM,
                              NULL
                            );

  XgraHelpPresentPanel.FRAME = 

     XtVaCreateManagedWidget( "",
                              xmFrameWidgetClass,
                              XgraHelpPresentPanel.PANEL_FORM,
                              XmNtopAttachment   , XmATTACH_POSITION,
                              XmNtopPosition     , 05,
                              XmNbottomAttachment, XmATTACH_POSITION,
                              XmNbottomPosition  , 95,
                              XmNleftAttachment  , XmATTACH_POSITION,
                              XmNleftPosition    , 05,
                              XmNrightAttachment , XmATTACH_POSITION,
                              XmNrightPosition   , 95,
                              NULL
                            );

  XgraHelpPresentPanel.FORM = 

    XtVaCreateManagedWidget( "",
                             xmFormWidgetClass,
                             XgraHelpPresentPanel.FRAME,
                             XmNtopAttachment   , XmATTACH_POSITION,
                             XmNtopPosition     , 05,
                             XmNbottomAttachment, XmATTACH_POSITION,
                             XmNbottomPosition  , 95,
                             XmNleftAttachment  , XmATTACH_POSITION,
                             XmNleftPosition    , 05,
                             XmNrightAttachment , XmATTACH_POSITION,
                             XmNrightPosition   , 95,
                             NULL
                           );

  PanelPixmap = XgraCreatePixmap( XgraMainWindow,
                                    XgraHelpPresentPixmap,
                                    XGRA_PRESENT_PIXMAP_WIDTH,
                                    XGRA_PRESENT_PIXMAP_HEIGHT );


  PanelLabel = XtVaCreateManagedWidget( "",
                                         xmLabelGadgetClass, 
                                         XgraHelpPresentPanel.FORM,
			                   XmNlabelType   , XmPIXMAP,
			                   XmNlabelPixmap , PanelPixmap,
			                   NULL
                                       );

  sprintf( Buffer, "ALLIANCE CAD SYSTEM  %s\n", ALLIANCE_VERSION );

  PanelString = XmStringCreateLtoR( Buffer, "Panel_charset2" );

  PanelLabel = XtVaCreateManagedWidget( "",
                                        xmLabelWidgetClass,
                                        XgraHelpPresentPanel.FORM,
                                        XmNfontList        , PanelFontList,
                                        XmNlabelString     , PanelString,
                                        XmNtopAttachment   , XmATTACH_POSITION,
                                        XmNtopPosition     , 15,
                                        XmNrightAttachment , XmATTACH_POSITION,
                                        XmNrightPosition   , 75,
                                        XmNleftAttachment  , XmATTACH_POSITION,
                                        XmNleftPosition    , 25,
                                        NULL
                                      );
  XmStringFree( PanelString );

  PanelString1 = XmStringCreateLtoR( "Xgra"         , "Panel_charset1" );
  PanelString2 = XmStringCreateLtoR( "\n( Touch Me )", "Panel_charset4" );
  PanelString  = XmStringConcat( PanelString1, PanelString2 );

  PanelButton = XtVaCreateManagedWidget( "",
                                          xmPushButtonWidgetClass, 
                                          XgraHelpPresentPanel.FORM,
                                          XmNfontList        , PanelFontList,
                                          XmNlabelString     , PanelString,
                                          XmNshadowThickness , 3,
                                          XmNtopAttachment   , XmATTACH_WIDGET,
                                          XmNtopWidget       , PanelLabel,
                                          XmNtopOffset       , 5,
                                          XmNrightAttachment , XmATTACH_POSITION,
                                          XmNrightPosition   , 60,
                                          XmNleftAttachment  , XmATTACH_POSITION,
                                          XmNleftPosition    , 40,
                                          NULL
                                        );
  XmStringFree( PanelString  );
  XmStringFree( PanelString1 );
  XmStringFree( PanelString2 );

  XtAddCallback( PanelButton, 
                 XmNactivateCallback,
                 XgraExitDialogCallback, NULL );

  sprintf( Buffer, "\nGraphic GRA Viewer\nVersion %s", ALLIANCE_VERSION );

  PanelString = XmStringCreateLtoR( Buffer, "Panel_charset2" );

  PanelLabel = XtVaCreateManagedWidget( "",
                                         xmLabelWidgetClass,
                                         XgraHelpPresentPanel.FORM,
                                         XmNfontList        , PanelFontList,
                                         XmNlabelString     , PanelString,
                                         XmNtopAttachment   , XmATTACH_WIDGET,
                                         XmNtopWidget       , PanelButton,
                                         XmNtopOffset       , 5,
                                         XmNrightAttachment , XmATTACH_POSITION,
                                         XmNrightPosition   , 75,
                                         XmNleftAttachment  , XmATTACH_POSITION,
                                         XmNleftPosition    , 25,
                                         NULL
                                       );
  XmStringFree( PanelString );

  PanelString = XmStringCreateLtoR( "copyright \251 1995 MASI, \
CAO-VLSI Team\nE-mail support: cao-vlsi@masi.ibp.fr", "Panel_charset4" );

  PanelLabel = XtVaCreateManagedWidget( "",
                                         xmLabelWidgetClass,
                                         XgraHelpPresentPanel.FORM,
                                         XmNfontList        , PanelFontList,
                                         XmNlabelString     , PanelString,
                                         XmNtopAttachment   , XmATTACH_WIDGET,
                                         XmNtopWidget       , PanelLabel,
                                         XmNtopOffset       , 5,
                                         XmNrightAttachment , XmATTACH_FORM,
                                         XmNleftAttachment  , XmATTACH_FORM,
                                         NULL
                                       );
  XmStringFree( PanelString );

  autend();
}

/*------------------------------------------------------------\
|                                                             |
|                    XgraEnterPresentPanel                   |
|                                                             |
\------------------------------------------------------------*/

void XgraEnterPresentPanel()

{
  autbegin();

  XgraEnterPanel( &XgraHelpPresentPanel );

  XgraLimitedLoop( XgraHelpPresentPanel.PANEL );

  XgraExitPanel( &XgraHelpPresentPanel );

  autend();
}
