/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with BVL_Y__ or bvl_y__.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with bvl_y_ or BVL_Y_, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define BVL_Y_BISON 30802

/* Bison version string.  */
#define BVL_Y_BISON_VERSION "3.8.2"

/* Skeleton name.  */
#define BVL_Y_SKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define BVL_Y_PURE 0

/* Push parsers.  */
#define BVL_Y_PUSH 0

/* Pull parsers.  */
#define BVL_Y_PULL 1




/* First part of user prologue.  */
#line 10 "./bvl_bcomp_y.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mut.h"
#include "log.h"
#include "beh.h"
#include "bvl.h"
#include "bvl_byacc.h"
#include "bvl_bedef.h"
#include "bvl_bcomp_y.h"

/* ###--------------------------------------------------------------### */
/* function	: bvl_y_error						*/
/* description	: print an error message				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

extern int  bvl_y_lex   (void);
static void bvl_y_error (str)

char *str;
  {
  BVL_ERRFLG++;
  fprintf (stderr, "`%s` Error line %d : %s\n", BVL_CURFIL, BEH_LINNUM, str);
  }

/* ###--------------------------------------------------------------### */
/* function	: tobin							*/
/* description	: translate a StringLit, BitStringLit or CharacterLit	*/
/*		  in a string of '0' and '1's				*/
/* ###--------------------------------------------------------------### */

static long tobin (

char *trg  ,
char *src  ,
long   left ,
long   right )

{
  char base         ;
  long  indx         ;
  long  j            = 0;
  long  errflg       = 0;
  char lcl_trg [256];

  lcl_trg [0] = '\0';

  if (src == NULL)
    {
    strcpy (trg,"0");
    }
  else
    {
    if (!strcmp (src,"others"))
      {
      strcpy (trg, src);
      }
    else
      {
      if ((src [0] != '\'') && (src [0] != '"') && (src [0] != '%'))
        {
        base = src [0];
        indx = 2;
        }
      else
        {
        base = 'B';
        indx = 1;
        }

      switch (base)
        {
        case 'B' :
        case 'b' :
          while ((lcl_trg[j] = src[indx]) != '\0')
            {
            switch (src[indx])
              {
              case '0':
              case '1':
              case 'd':				/* Beware Not VHDL	*/
                j++; break;

              case '%' :
              case '"' :
              case '\'':
              case '_' :
                break;

	    default :
	      errflg = 1; bvl_error (73,src);
              }
            indx++;
            }
          break;

        case 'O' :
        case 'o' :
          while (src[indx] != '\0')
            {
            j += 3;
            switch (src[indx])
              {
              case '0' :
                strcat (lcl_trg,"000"); break;
              case '1' :
                strcat (lcl_trg,"001"); break;
              case '2' :
                strcat (lcl_trg,"010"); break;
              case '3' :
                strcat (lcl_trg,"011"); break;
              case '4' :
                strcat (lcl_trg,"100"); break;
              case '5' :
                strcat (lcl_trg,"101"); break;
              case '6' :
                strcat (lcl_trg,"110"); break;
              case '7' :
                strcat (lcl_trg,"111"); break;
              case '"' :
              case '%' :
              case '_' :
                j -= 3; break;
	      default :
	        j -= 3; errflg = 1; bvl_error (73, src);
              }
            indx++;
            }
          break;

        case 'X' :
        case 'x' :
          while (src[indx] != '\0')
            {
            j += 4;
            switch (src[indx])
              {
              case '0' :
                strcat (lcl_trg,"0000"); break;
              case '1' :
                strcat (lcl_trg,"0001"); break;
              case '2' :
                strcat (lcl_trg,"0010"); break;
              case '3' :
                strcat (lcl_trg,"0011"); break;
              case '4' :
                strcat (lcl_trg,"0100"); break;
              case '5' :
                strcat (lcl_trg,"0101"); break;
              case '6' :
                strcat (lcl_trg,"0110"); break;
              case '7' :
                strcat (lcl_trg,"0111"); break;
              case '8' :
                strcat (lcl_trg,"1000"); break;
              case '9' :
                strcat (lcl_trg,"1001"); break;
              case 'a' :
              case 'A' :
                strcat (lcl_trg,"1010"); break;
              case 'b' :
              case 'B' :
                strcat (lcl_trg,"1011"); break;
              case 'c' :
              case 'C' :
                strcat (lcl_trg,"1100"); break;
              case 'd' :
              case 'D' :
                strcat (lcl_trg,"1101"); break;
              case 'e' :
              case 'E' :
                strcat (lcl_trg,"1110"); break;
              case 'f' :
              case 'F' :
                strcat (lcl_trg,"1111"); break;
              case '%' :
              case '"' :
              case '_' :
                j -= 4; break;
	      default :
	        j -= 4; errflg = 1; bvl_error(73,src);
              }
            indx++;
            }
          break;

        default :
          beh_toolbug (17, "tobin", NULL, base);
        }

      if ((j == 0) || (j <= right))
        {
        trg[0] = '0';
        trg[1] = '\0';
        }
      else
        {
        if (left != -1)
          {
          strcpy (trg, &lcl_trg[left]);
          trg[right - left + 1] = '\0';
          }
        else
          strcpy (trg, lcl_trg);
        }
      }
    }

  return (errflg);
}

/* ###--------------------------------------------------------------### */
/* function	: chkdcl						*/
/* ###--------------------------------------------------------------### */

static long chkdcl (object, mode, type, flag, kind, constraint, conf)

char object    ;
long  mode      ;
long  type      ;
char flag      ;
long  kind      ;
char constraint;
long  *conf     ;

  {
  long errflg = 0;
  long lclcnf = 0;

  if (flag != constraint)
    {
    errflg = 1;
    bvl_error (33, NULL);
    }
  else
    {
    switch (object)
      {
      case 'P':
	/* ###------------------------------------------------------### */
	/*    If object is a port :					*/
	/*       - if type is bit, no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:

            lclcnf += BVL_BITDFN + BVL_NORDFN;
            switch (mode)
              {
              case _IN :
                lclcnf += BVL_ICNDFN; break;
              case _OUT:
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != 0)
              errflg = 1;
            break;

          case MUX_BIT:

            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case WOR_BIT:

            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case REG_BIT:
          case NATURAL:

            errflg = 1;
            break;
          }
        if (errflg == 1)
          bvl_error (5, NULL);
        break;

      case 'G':
	/* ###------------------------------------------------------### */
	/*    If object is a generic :					*/
	/*       - only natural type is allowed				*/
	/* ###------------------------------------------------------### */

        if ((type != NATURAL) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (77, NULL);
          }
        break;

      case 'S':
	/* ###------------------------------------------------------### */
	/*    If object is a signal :					*/
	/*       - no mode can be specified				*/
	/*       - if type is bit no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - if type is reg_bit, register kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:
            lclcnf += BVL_BITDFN + BVL_NORDFN;
            if ((mode != 0) || (kind != 0))
              errflg = 1;
            break;
          case MUX_BIT:
            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case WOR_BIT:
            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case REG_BIT:
            lclcnf += BVL_RBIDFN + BVL_REGDFN;
            if ((mode != 0) || (kind != REGISTER))
              errflg = 1;
            break;
          case NATURAL:
            errflg = 1; break;
          }

        if (mode != 0)
          errflg = 1;

        if (errflg == 1)
          bvl_error (11, NULL);
        break;

      case 'C':
	/* ###------------------------------------------------------### */
	/*    If object is a constant :					*/
	/*       - only bit type without any other indication is legal	*/
	/* ###------------------------------------------------------### */

        lclcnf += BVL_CSTDFN;
        if ((type != BIT) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (78, NULL);
          }
        break;
      }
    }

  *conf = lclcnf ;
  return (errflg);
  }

/* ###--------------------------------------------------------------### */
/* function	: addstr						*/
/* ###--------------------------------------------------------------### */

static void *addstr (ptfig, object, mode, type, flag, name, left, right)

struct befig *ptfig ;
char          object;
long           mode  ;
long           type  ;
char          flag  ;
char         *name  ;
short         left  ;
short         right ;

  {
  void  *pnt          = NULL;
  char   porflg       = 0;
  char   rinflg       = 0;
  char   outflg       = 0;
  char   busflg       = 0;
  char   auxflg       = 0;
  char   buxflg       = 0;
  char   regflg       = 0;
  char   lclmod       = 'I';
  char   lcltyp       = 'B';
  char   extname [100];
  short  i            ;
  short  inc          = 1;

  switch (object)
    {
    case 'P':

	/* ###------------------------------------------------------### */
	/*   if object is a port ...					*/
	/* ###------------------------------------------------------### */

      porflg = 1;
      switch (mode)
        {
        case _IN:
          lclmod = 'I'; lcltyp = 'B'; rinflg = 1; break;
        case _OUT:
          switch (type)
            {
            case BIT:
              lclmod = 'O'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'Z'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'Z'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        case _INOUT:
          rinflg = 1;
          switch (type)
            {
            case BIT:
              lclmod = 'B'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'T'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'T'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        }
      break;

    case 'S':

	/* ###------------------------------------------------------### */
	/*   if object is a signal ...					*/
	/* ###------------------------------------------------------### */

      switch (type)
        {
        case BIT:
          lcltyp = 'B'; rinflg = BVL_AUXMOD; auxflg = 1; break;
        case REG_BIT:
          rinflg = 1; regflg = 1; break;
        case MUX_BIT:
          lcltyp = 'M'; rinflg = 1; buxflg = 1; break;
        case WOR_BIT:
          lcltyp = 'W'; rinflg = 1; buxflg = 1; break;
        }
      break;
    }

  if (flag == 'S')
    {
	/* ###------------------------------------------------------### */
	/*   if object is a scalar ...					*/
	/* ###------------------------------------------------------### */

    if (porflg == 1)
      ptfig->BEPOR = beh_addbepor (ptfig->BEPOR, name, lclmod, lcltyp);
    if (rinflg == 1)
      ptfig->BERIN = beh_addberin (ptfig->BERIN, name);
    if (outflg == 1)
      ptfig->BEOUT = beh_addbeout (ptfig->BEOUT, name, NULL, NULL);
    if (busflg == 1)
      ptfig->BEBUS = beh_addbebus (ptfig->BEBUS, name, NULL, NULL, lcltyp);
    if (auxflg == 1)
      ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX, name, NULL, NULL);
    if (buxflg == 1)
      ptfig->BEBUX = beh_addbebux (ptfig->BEBUX, name, NULL, NULL, lcltyp);
    if (regflg == 1)
      ptfig->BEREG = beh_addbereg (ptfig->BEREG, name, NULL, NULL);

    }
  else
    {
	/* ###------------------------------------------------------### */
	/*   if object is an array ...					*/
	/* ###------------------------------------------------------### */

    if (left >= right)
      inc = -1;

    for (i=left ; i!=(right+inc) ; i+=inc)
      {
      sprintf (extname, "%s %d", name, i);

      if (porflg == 1)
        ptfig->BEPOR = beh_addbepor (ptfig->BEPOR, extname, lclmod, lcltyp);
      if (rinflg == 1)
        ptfig->BERIN = beh_addberin (ptfig->BERIN, extname);
      if (outflg == 1)
        ptfig->BEOUT = beh_addbeout (ptfig->BEOUT, extname, NULL, NULL);
      if (busflg == 1)
        ptfig->BEBUS = beh_addbebus (ptfig->BEBUS, extname, NULL, NULL, lcltyp);
      if (auxflg == 1)
        ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX, extname, NULL, NULL);
      if (buxflg == 1)
        ptfig->BEBUX = beh_addbebux (ptfig->BEBUX, extname, NULL, NULL, lcltyp);
      if (regflg == 1)
        ptfig->BEREG = beh_addbereg (ptfig->BEREG, extname, NULL, NULL);
      }
    }

  if (outflg == 1)
    pnt = (void *) ptfig->BEOUT;
  if (busflg == 1)
    pnt = (void *) ptfig->BEBUS;
  if (auxflg == 1)
    pnt = (void *) ptfig->BEAUX;
  if (buxflg == 1)
    pnt = (void *) ptfig->BEBUX;
  if (regflg == 1)
    pnt = (void *) ptfig->BEREG;

  return (pnt);
  }

/* ###--------------------------------------------------------------### */
/* function	: addgen						*/
/* description	: create one or more BEGEN structures			*/
/*		  For a scalar a BEGEN is created at the head of	*/
/*		  existing BEGEN list.					*/
/*		  For an array (including arraies of one element) a set	*/
/*		  of BEGENs are created in a sorted list. BEGEN related	*/
/*		  to the index i of the array is named `name(i)`. The	*/
/*		  head of the list represents the right bound of the	*/
/*		  array. This list is then chained to the head of	*/
/*		  existing BEGEN list.					*/
/* called func.	: beh_addbegen, namealloc				*/
/* ###--------------------------------------------------------------### */

static struct begen *addgen (last_gen, nat_lst, nam_lst, type, left, right)

struct begen *last_gen; 	/* pointer on the last begen structure	*/
struct chain *nam_lst ;		/* generic's name list			*/
struct chain *nat_lst ;		/* generic's value list			*/
char         *type    ;		/* generic's type			*/
short         left    ;		/* array's left bound (= -1 if scalar)	*/
short         right   ;		/* array's right bound (= -1 if scalar)	*/

  {
  char          extname [128];
  char         *name         ;
  struct begen *ptgen        ;
  struct chain *ptauxnam     ;
  struct chain *ptauxnat     ;
  long           i            ;
  long           inc          = 1;

  ptgen    = last_gen;
  ptauxnam = nam_lst ;
  ptauxnat = nat_lst ;

  if ((left == -1) && (right == -1))
    {
    if ((ptauxnat != NULL) && (ptauxnat->NEXT == NULL))
      {
      while (ptauxnam != NULL)
        {
        name     = namealloc    ((char *) ptauxnam->DATA);
        ptgen    = beh_addbegen (ptgen, name, type, (void *) ptauxnat->DATA);
        ptauxnam = ptauxnam->NEXT;
        }
      }
    else
      bvl_error (75, NULL);
    }
  else
    {
    if (left >= right)
      inc = -1;

    while (ptauxnam != NULL)
      {
      for (i=left ; i!=(right+inc) ; i+=inc)
        {
        sprintf (extname, "%s %ld", (char *)ptauxnam->DATA, i);
        name = namealloc (extname);

        if (ptauxnat != NULL)
          {
          ptgen    = beh_addbegen (ptgen, name, type, (void *)ptauxnat->DATA);
	  ptauxnat = ptauxnat->NEXT;
          }
        else
          bvl_error (75, NULL);
        }

      if (ptauxnat != NULL)
        bvl_error (75, NULL);

      ptauxnat = nat_lst;
      ptauxnam = ptauxnam->NEXT;
      }
    }
  return (ptgen);
  }

/* ###--------------------------------------------------------------### */
/* function	: cpyabllst						*/
/* description	: duplicate bvl_abllst structure 			*/
/* called func.	: addchain, reverse, copyExpr				*/
/* ###--------------------------------------------------------------### */

static struct chain *cpyabllst (abllst)

struct chain *abllst;
  {
  struct chain *pt_abllst = NULL;

  while (abllst != NULL)
    {
    pt_abllst = addchain (pt_abllst, copyExpr ((struct chain *)abllst->DATA));
    abllst    = abllst->NEXT;
    }

  pt_abllst = reverse (pt_abllst);
  return (pt_abllst);
  }

/* ###--------------------------------------------------------------### */
/* function	: cpyablstr						*/
/* description	: duplicate bvl_ablstr structure 			*/
/* called func.	: mbkalloc, cpyabllst					*/
/* ###--------------------------------------------------------------### */

static bvl_ablstr cpyablstr (ablstr)

bvl_ablstr ablstr;
  {
  bvl_ablstr pt_ablstr;

  pt_ablstr.IDENT    = NULL;
  pt_ablstr.WIDTH    = ablstr.WIDTH;
  pt_ablstr.LIST_ABL = cpyabllst (ablstr.LIST_ABL);

  return (pt_ablstr);
  }

/* ###--------------------------------------------------------------### */
/* function     : crtabl						*/
/* description  : combine at most two ABLs and build a new one          */
/*    		  The following operations can be performed :		*/
/*		    CONC    perform concatenation			*/
/*		    NOPI    initialize a structure for a signal (scalar	*/
/*		            or array)					*/
/*		    NOPS    initialize a structure for a literal	*/
/*		    NE      create a structure with an ABL representing	*/
/*		            the 'non equality' of two expressions	*/
/*		    EQ      create a structure with an ABL representing	*/
/*		            the 'equality' of two expressions		*/
/*		    NOT     perform logical not of an expression	*/
/*		    AND     perform logical and  between two expressions*/
/*		    OR      perform logical or   between two expressions*/
/*		    NAND    perform logical nand between two expressions*/
/*		    NOR     perform logical nor  between two expressions*/
/*		    XOR     perform logical xor  between two expressions*/
/*		    ANDM    perform logical and  between two expressions*/
/*		            (the second expression is a scalar)		*/
/* called func. : createAtom , createExpr, addQExpr , beh_toolbug,	*/
/*		  bvl_error , addchain   , freechain			*/
/* ###--------------------------------------------------------------### */

static bvl_ablstr crtabl (

short      oper ,
bvl_ablstr expr1,
bvl_ablstr expr2,
long        left ,
long        right )

  {
  char            name [256]      ;
  char           *name2           ;
  struct chain   *pt_abl1         = NULL;
  struct chain   *pt_abl2         = NULL;
  struct chain   *pt_aux1         = NULL;
  struct chain   *pt_aux2         = NULL;
  bvl_ablstr      result          ;
  char            lcl_buffer [256];
  short           inc             ;
  short           i               ;
  char            true_flag_un    = 0;
  char            true_flag_zero  = 0;
  struct chain   *abl_un          = createAtom ("'1'");
  struct chain   *abl_zero        = createAtom ("'0'");

  result.IDENT    = NULL;
  result.TIME     = 0   ;
  result.LIST_ABL = NULL;
  result.WIDTH    = 0   ;

  switch (oper)
    {
    case CONC :
      if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
        beh_toolbug (4, "crtabl", NULL, 0);
      else
        {
        if (expr1.LIST_ABL == expr2.LIST_ABL)
          beh_toolbug (16, "crtabl", NULL, 0);
        else
          {
          pt_aux2 = expr2.LIST_ABL;
          while (pt_aux2->NEXT != NULL)
            pt_aux2 = pt_aux2->NEXT;

          pt_aux2->NEXT = expr1.LIST_ABL;

          result.LIST_ABL = expr2.LIST_ABL;
          result.WIDTH    = expr1.WIDTH + expr2.WIDTH;

          expr1.LIST_ABL  = NULL;
          expr2.LIST_ABL  = NULL;
          }
        }
      break;

      case NOPI :
        if (expr1.IDENT == NULL)
          beh_toolbug (2, "crtabl", NULL, 0);
        else
          {
          if ((left == -1) && (right == -1))
            {
            result.LIST_ABL = addchain(result.LIST_ABL,createAtom(expr1.IDENT));
            result.WIDTH    = 1;
            }
          else
            {
            if (left <= right)
              {
              inc = 1;
              result.WIDTH = right - left + 1;
              }
            else
              {
              inc = -1;
              result.WIDTH = left - right + 1;
              }

            for (i=left ; i!=(right+inc) ; i+=inc)
              {
              sprintf (name,"%s %i",expr1.IDENT,i);
              name2           = namealloc (name);
              result.LIST_ABL = addchain (result.LIST_ABL,createAtom(name2));
              }
            }
          expr1.IDENT = NULL;
          }
        break;

      case NOPS :
        if (expr1.IDENT == NULL)
          beh_toolbug (2, "crtabl", NULL, 0);
        else
          {
          tobin (lcl_buffer, expr1.IDENT, -1, -1);
          if ((left == -1) && (right == -1))
            {
            left  = 0;
            right = strlen (lcl_buffer) - 1;
            }

          for (i=left ; i<=right ; i++)
            {
            switch ( lcl_buffer[i] )
              {
              case '0' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'0'"));
                break;
              case '1' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'1'"));
                break;
/*-----------        Beware Not VHDL        -------------*/
              case 'd' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'D'"));
                break;
              default  :
                beh_toolbug (15, "crtabl", NULL, expr1.IDENT[i]);
              }
            }
          result.WIDTH = right - left + 1;
          }
        break;

      case STABLE :
        if (expr1.LIST_ABL == NULL)
	  beh_toolbug (3, "crtabl", NULL, 0);
        else
          {
	  pt_aux1 = expr1.LIST_ABL;
          while (pt_aux1 != NULL)
            {
            pt_abl1  = createExpr (STABLE);
            addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
            pt_aux1->DATA = pt_abl1;
            pt_aux1  = pt_aux1->NEXT;
            }

          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;

          expr1.LIST_ABL  = NULL;
          }
        break;

      case NOT :
        if (expr1.LIST_ABL == NULL)
	  beh_toolbug (3, "crtabl", NULL, 0);
        else
          {
	  pt_aux1  = expr1.LIST_ABL;
          while (pt_aux1 != NULL)
            {
            pt_abl1  = createExpr (NOT);
            addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
            pt_aux1->DATA = pt_abl1;
            pt_aux1  = pt_aux1->NEXT;
            }

          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;

          expr1.LIST_ABL  = NULL;
          }
        break;

      case EQ :
        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	  beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr1.WIDTH != expr2.WIDTH)
            {
            bvl_error (38,NULL);
            pt_abl2 = createAtom ("'1'");

	    pt_aux1 = expr1.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              freeExpr (pt_aux1->DATA);
              pt_aux1 = pt_aux1->NEXT;
              }
	    pt_aux2 = expr2.LIST_ABL;
            while (pt_aux2 != NULL)
              {
              freeExpr (pt_aux2->DATA);
              pt_aux2 = pt_aux2->NEXT;
              }
            }
          else
            {
	    pt_aux1 = expr1.LIST_ABL;
	    pt_aux2 = expr2.LIST_ABL;
            /* If expr2 = '1' then return expr1 */
            while(pt_aux2 != NULL)
              {
              true_flag_un = 1;
              if(!equalExpr(pt_aux2->DATA,abl_un))
                {
                /* One abl not abl_un */
                true_flag_un = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_un == 1)
              {
              pt_abl1 = (struct chain *)pt_aux1->DATA;
              pt_aux1 = pt_aux1->NEXT;
              if(pt_aux1 != NULL)
                {
                pt_abl2 = createExpr(AND);
                addQExpr(pt_abl2,pt_abl1);
                pt_abl1 = pt_abl2;
                }
              while(pt_aux1 != NULL)
                {
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1 = pt_aux1->NEXT;
                }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            /* If expr2 = '0' then return NOT(expr1) */
	    pt_aux2 = expr2.LIST_ABL;
            true_flag_zero = 0;
            while(pt_aux2 != NULL)
              {
              true_flag_zero = 1;
              if(!equalExpr(pt_aux2->DATA,abl_zero))
                {
                /* One abl not abl_zero */
                true_flag_zero = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_zero == 1)
              {
              while(pt_aux1 != NULL)
                {
                pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1 = pt_aux1->NEXT;
                if(pt_aux1 != NULL)
                  {
                  pt_abl2 = createExpr(AND);
                  addQExpr(pt_abl2,pt_abl1);
                  pt_abl1 = pt_abl2;
                  }
                while(pt_aux1 != NULL)
                  {
                  pt_abl2 = createExpr(NOT);
                  addQExpr(pt_abl2,(struct chain *)pt_aux1->DATA);
                  addQExpr(pt_abl1,pt_abl2);
                  pt_aux1 = pt_aux1->NEXT;
                  }
                /* --pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1->DATA = pt_abl1;
                pt_aux1       = pt_aux1->NEXT;
                --- */
                }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
               
              
	    pt_aux2 = expr2.LIST_ABL;
            if((true_flag_zero == 0) && (true_flag_un == 0))
              {
              pt_abl1 = createExpr (XOR);
              addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

              pt_aux1 = pt_aux1->NEXT;
              pt_aux2 = pt_aux2->NEXT;

	      while (pt_aux1 != NULL)
	        {
                pt_abl2 = createExpr (OR);
                addQExpr (pt_abl2,pt_abl1);

                pt_abl1 = createExpr (XOR);
                addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                addQExpr (pt_abl2, pt_abl1);
                pt_abl1 = pt_abl2;

	        pt_aux1 = pt_aux1->NEXT;
	        pt_aux2 = pt_aux2->NEXT;
	        }
              pt_abl2 = createExpr (NOT);
              addQExpr (pt_abl2, pt_abl1);

              result.LIST_ABL = addchain (result.LIST_ABL,pt_abl2);
              result.WIDTH    = 1;
              freechain (expr1.LIST_ABL);
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL = NULL;
              expr2.LIST_ABL = NULL;
              }
            }
          }
        break;

      case NE :

        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	  beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr1.WIDTH != expr2.WIDTH)
            {
            bvl_error(38,NULL);
            pt_abl1 = createAtom ("'1'");

	    pt_aux1 = expr1.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              freeExpr (pt_aux1->DATA);
              pt_aux1 = pt_aux1->NEXT;
              }
	    pt_aux2 = expr2.LIST_ABL;
            while (pt_aux2 != NULL)
              {
              freeExpr (pt_aux2->DATA);
              pt_aux2 = pt_aux2->NEXT;
              }
            }
          else
            {
	    pt_aux1 = expr1.LIST_ABL;
	    pt_aux2 = expr2.LIST_ABL;

            /* If expr2 = '0' then return expr1 */
            while(pt_aux2 != NULL)
              {
              true_flag_zero = 1;
              if(!equalExpr(pt_aux2->DATA,abl_zero))
                {
                /* One abl not abl_zero */
                true_flag_zero = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_zero == 1)
              {
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            /* If expr2 = '1' then return NOT(expr1) */
	    pt_aux2 = expr2.LIST_ABL;
            true_flag_un = 0;
            while(pt_aux2 != NULL)
              {
              true_flag_un = 1;
              if(!equalExpr(pt_aux2->DATA,abl_un))
                {
                /* One abl not abl_un */
                true_flag_un = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_un == 1)
              {
              while(pt_aux1 != NULL)
                {
                pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1->DATA = pt_abl1;
                pt_aux1       = pt_aux1->NEXT;
                }
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
               
              
	    pt_aux2 = expr2.LIST_ABL;
            if((true_flag_zero == 0) && (true_flag_un == 0))
              {
              pt_abl1 = createExpr (XOR);
              addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);
  
              pt_aux1 = pt_aux1->NEXT;
              pt_aux2 = pt_aux2->NEXT;

  	      for (i=2 ; i<=expr1.WIDTH ; i++)
	        {
                pt_abl2 = createExpr (OR);
                addQExpr (pt_abl2, pt_abl1);

                pt_abl1 = createExpr (XOR);
                addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                addQExpr (pt_abl2, pt_abl1);
                pt_abl1 = pt_abl2;

	        pt_aux1 = pt_aux1->NEXT;
	        pt_aux2 = pt_aux2->NEXT;
	        }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              freechain (expr1.LIST_ABL);
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL = NULL;
              expr2.LIST_ABL = NULL;
              }
            }
          }
        break;

      case AND  :
      case NAND :
      case OR   :
      case NOR  :
      case XOR  :

        if (expr1.LIST_ABL == NULL)
          {
          if (expr2.LIST_ABL == NULL)
	    beh_toolbug (4, "crtabl", NULL, 0);
          else
            {
            result.LIST_ABL = expr2.LIST_ABL;
            result.WIDTH    = expr2.WIDTH;
            expr2.LIST_ABL  = NULL;
            }
          }
        else
          {
          if (expr2.LIST_ABL == NULL)
            {
            result.LIST_ABL = expr1.LIST_ABL;
            result.WIDTH    = expr1.WIDTH;
            expr1.LIST_ABL  = NULL;
            }
          else
            {
            if (expr1.LIST_ABL == expr2.LIST_ABL)
              beh_toolbug (16, "crtabl", NULL, 0);
            else
              {
              if (expr1.WIDTH != expr2.WIDTH)
                {
                bvl_error(38,NULL);
                }
              else
                {
	        pt_aux1 = expr1.LIST_ABL;
	        pt_aux2 = expr2.LIST_ABL;

	        for (i=1 ; i<=expr1.WIDTH ; i++)
	          {
                  pt_abl1 = createExpr (oper);
                  addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                  addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                  pt_aux1->DATA = (void *)pt_abl1;

	          pt_aux1       = pt_aux1->NEXT;
	          pt_aux2       = pt_aux2->NEXT;
		  }
                }
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = expr1.WIDTH;
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            }
          }
        break;

      case ANDM :
        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	    beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr2.WIDTH != 1)
            {
            bvl_error( 38,NULL);
            }
          else
            {
            pt_aux1 = expr1.LIST_ABL;
            pt_aux2 = expr2.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              pt_abl1 = createExpr (AND);
              addQExpr (pt_abl1,          (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, copyExpr((struct chain *)pt_aux2->DATA));
              pt_aux1->DATA = (void *)pt_abl1;

              pt_aux1       = pt_aux1->NEXT;
              }
            }
          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;
	  pt_aux2 = expr2.LIST_ABL;
          while (pt_aux2 != NULL)
            {
            freeExpr (pt_aux2->DATA);
            pt_aux2 = pt_aux2->NEXT;
            }
          freechain (expr2.LIST_ABL);
          expr2.LIST_ABL  = NULL;
          expr1.LIST_ABL  = NULL;
          }
        break;

      default :
	beh_toolbug (1, "crtabl", NULL, 0);
      }

    return (result);
    }

/* ###--------------------------------------------------------------### */
/* function	: bvl_select						*/
/* description	: create an abl representing the choice in a selected	*/
/*		  signal assignment and perform unicity verification	*/
/*		  using BDDs.						*/
/* called func.	: tobin       , bddToAbl     , addInputCct      ,	*/
/*		  substPhyExpr, initializeCct, createNodeTermBdd,	*/
/*		  bvl_error   , notBdd       , applyBinBdd      ,	*/
/*		  addchain    , namealloc				*/
/* ###--------------------------------------------------------------### */

static void bvl_select (result, pt_str, pt_bdd, pt_ablstr)

bvl_ablstr   *result;
struct chain *pt_str;		/* pointer on a list of choices		*/
pNode        *pt_bdd;		/* used to check if a choice is legal	*/
bvl_ablstr    pt_ablstr;	/* tested expression			*/

  {
  char             binstr[256];
  long              i;
  struct chain    *pt_auxabl;
  pNode            pt_bddres;
  pNode            pt_bddnew;
  pNode            pt_bddtmp;
  pNode            pt_bddaux;
  char             nomvar[10];
  struct chain    *pt_newabl;
  struct chain    *pt_newabl2;
  static long       oth_flg=0;
  static long       last_width=0;
  static pCircuit  pC = NULL;

  result->LIST_ABL = NULL;
  result->IDENT    = NULL;

  pt_bddtmp = zero;

  if (pC == NULL)
    pC = initializeCct ("-select-",200,0);

  if (*pt_bdd == NULL)
    {
    if (last_width < pt_ablstr.WIDTH)
      {
      for (; last_width<pt_ablstr.WIDTH ; last_width++)
        {
        sprintf (nomvar,"(%ld)",last_width);
        createNodeTermBdd (addInputCct(pC,nomvar));
        }
      }
    *pt_bdd = zero;
    oth_flg = 0;
    }

  while (pt_str != NULL)
    {
    tobin (binstr, (char *)pt_str->DATA, -1, -1);
    if (oth_flg != 0)
      {
      bvl_error(30,NULL);
      }

    if (strcmp("others", (char *)pt_str->DATA))
      {
      pt_bddres = one;

      if (strlen (binstr) != pt_ablstr.WIDTH)
        {
        bvl_error(38,NULL);
        }
      for (i=0 ; binstr[i]!='\0' ; i++)
        {
        pt_bddaux = createNodeTermBdd (i+2);
        if (binstr[i] == '0')
          pt_bddaux = notBdd (pt_bddaux);
        pt_bddres = applyBinBdd (AND, pt_bddaux, pt_bddres);
        }
      pt_bddnew = applyBinBdd (OR,*pt_bdd,pt_bddres);

      if (*pt_bdd == pt_bddnew)
         {
         bvl_error(28,NULL);
         }

      *pt_bdd = pt_bddnew;
      }
    else
      {
      oth_flg   = 1;
      pt_bddres = notBdd (*pt_bdd);
      *pt_bdd   = one;
      }
    pt_bddtmp = applyBinBdd (OR,pt_bddtmp,pt_bddres);
    pt_str = pt_str->NEXT;
    }

  pt_newabl = bddToAbl (pt_bddtmp, pC->pNameI);

  pt_auxabl = pt_ablstr.LIST_ABL;
  i         = pt_ablstr.WIDTH - 1;
  while (pt_auxabl != NULL)
    {
    sprintf (nomvar,"(%li)",i);
/*--------
    substPhyExpr (pt_newabl,namealloc(nomvar),(struct chain *)pt_auxabl->DATA);
---------*/
    pt_newabl2 = substExpr (pt_newabl,namealloc(nomvar),
                            (struct chain *)pt_auxabl->DATA);
    freeExpr (pt_newabl);
    pt_newabl = pt_newabl2;

    i--;
    pt_auxabl = pt_auxabl->NEXT;
    }
  result->LIST_ABL = addchain (NULL, pt_newabl);
  result->WIDTH    = 1;

  }


#line 1415 "y.tab.c"

# ifndef BVL_Y__CAST
#  ifdef __cplusplus
#   define BVL_Y__CAST(Type, Val) static_cast<Type> (Val)
#   define BVL_Y__REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define BVL_Y__CAST(Type, Val) ((Type) (Val))
#   define BVL_Y__REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef BVL_Y__NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define BVL_Y__NULLPTR nullptr
#   else
#    define BVL_Y__NULLPTR 0
#   endif
#  else
#   define BVL_Y__NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef BVL_Y__BVL_Y__Y_TAB_H_INCLUDED
# define BVL_Y__BVL_Y__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef BVL_Y_DEBUG
# define BVL_Y_DEBUG 0
#endif
#if BVL_Y_DEBUG
extern int bvl_y_debug;
#endif

/* Token kinds.  */
#ifndef BVL_Y_TOKENTYPE
# define BVL_Y_TOKENTYPE
  enum bvl_y_tokentype
  {
    BVL_Y_EMPTY = -2,
    BVL_Y_EOF = 0,                     /* "end of file"  */
    BVL_Y_error = 256,                 /* error  */
    BVL_Y_UNDEF = 257,                 /* "invalid token"  */
    tok_AND = 258,                 /* tok_AND  */
    _BEGIN = 259,                  /* _BEGIN  */
    _END = 260,                    /* _END  */
    _EQSym = 261,                  /* _EQSym  */
    _EXIT = 262,                   /* _EXIT  */
    _FILE = 263,                   /* _FILE  */
    _GESym = 264,                  /* _GESym  */
    _GTSym = 265,                  /* _GTSym  */
    _IN = 266,                     /* _IN  */
    _INOUT = 267,                  /* _INOUT  */
    _LABEL = 268,                  /* _LABEL  */
    _LESym = 269,                  /* _LESym  */
    _LINKAGE = 270,                /* _LINKAGE  */
    _LTSym = 271,                  /* _LTSym  */
    _NAND = 272,                   /* _NAND  */
    _NESym = 273,                  /* _NESym  */
    _NEXT = 274,                   /* _NEXT  */
    _NOR = 275,                    /* _NOR  */
    _NOT = 276,                    /* _NOT  */
    tok_NULL = 277,                /* tok_NULL  */
    _OR = 278,                     /* _OR  */
    _OUT = 279,                    /* _OUT  */
    _XOR = 280,                    /* _XOR  */
    ABS = 281,                     /* ABS  */
    ACCESS = 282,                  /* ACCESS  */
    AFTER = 283,                   /* AFTER  */
    ALIAS = 284,                   /* ALIAS  */
    ALL = 285,                     /* ALL  */
    ARCHITECTURE = 286,            /* ARCHITECTURE  */
    ARRAY = 287,                   /* ARRAY  */
    ASSERT = 288,                  /* ASSERT  */
    ATTRIBUTE = 289,               /* ATTRIBUTE  */
    AbstractLit = 290,             /* AbstractLit  */
    Ampersand = 291,               /* Ampersand  */
    Apostrophe = 292,              /* Apostrophe  */
    Arrow = 293,                   /* Arrow  */
    BIT = 294,                     /* BIT  */
    BIT_VECTOR = 295,              /* BIT_VECTOR  */
    BLOCK = 296,                   /* BLOCK  */
    BODY = 297,                    /* BODY  */
    BUFFER = 298,                  /* BUFFER  */
    BUS = 299,                     /* BUS  */
    Bar = 300,                     /* Bar  */
    BasedInt = 301,                /* BasedInt  */
    BasedReal = 302,               /* BasedReal  */
    BitStringLit = 303,            /* BitStringLit  */
    Box = 304,                     /* Box  */
    CASE = 305,                    /* CASE  */
    COMPONENT = 306,               /* COMPONENT  */
    CONFIGURATION = 307,           /* CONFIGURATION  */
    CONSTANT = 308,                /* CONSTANT  */
    CharacterLit = 309,            /* CharacterLit  */
    Colon = 310,                   /* Colon  */
    Comma = 311,                   /* Comma  */
    DISCONNECT = 312,              /* DISCONNECT  */
    DOWNTO = 313,                  /* DOWNTO  */
    DecimalInt = 314,              /* DecimalInt  */
    DecimalReal = 315,             /* DecimalReal  */
    Dot = 316,                     /* Dot  */
    DoubleStar = 317,              /* DoubleStar  */
    ELSE = 318,                    /* ELSE  */
    ELSIF = 319,                   /* ELSIF  */
    ENTITY = 320,                  /* ENTITY  */
    ERROR = 321,                   /* ERROR  */
    FOR = 322,                     /* FOR  */
    FS = 323,                      /* FS  */
    FUNCTION = 324,                /* FUNCTION  */
    GENERATE = 325,                /* GENERATE  */
    GENERIC = 326,                 /* GENERIC  */
    GUARDED = 327,                 /* GUARDED  */
    IF = 328,                      /* IF  */
    IS = 329,                      /* IS  */
    Identifier = 330,              /* Identifier  */
    LIBRARY = 331,                 /* LIBRARY  */
    LOOP = 332,                    /* LOOP  */
    LeftParen = 333,               /* LeftParen  */
    MAP = 334,                     /* MAP  */
    MOD = 335,                     /* MOD  */
    MS = 336,                      /* MS  */
    MUX_BIT = 337,                 /* MUX_BIT  */
    MUX_VECTOR = 338,              /* MUX_VECTOR  */
    Minus = 339,                   /* Minus  */
    NATURAL = 340,                 /* NATURAL  */
    NATURAL_VECTOR = 341,          /* NATURAL_VECTOR  */
    NEW = 342,                     /* NEW  */
    NS = 343,                      /* NS  */
    OF = 344,                      /* OF  */
    ON = 345,                      /* ON  */
    OPEN = 346,                    /* OPEN  */
    OTHERS = 347,                  /* OTHERS  */
    _PACKAGE = 348,                /* _PACKAGE  */
    PORT = 349,                    /* PORT  */
    PROCEDURE = 350,               /* PROCEDURE  */
    PROCESS = 351,                 /* PROCESS  */
    PS = 352,                      /* PS  */
    Plus = 353,                    /* Plus  */
    RANGE = 354,                   /* RANGE  */
    RECORD = 355,                  /* RECORD  */
    REG_BIT = 356,                 /* REG_BIT  */
    REG_VECTOR = 357,              /* REG_VECTOR  */
    REGISTER = 358,                /* REGISTER  */
    REM = 359,                     /* REM  */
    REPORT = 360,                  /* REPORT  */
    RETURN = 361,                  /* RETURN  */
    RightParen = 362,              /* RightParen  */
    SELECT = 363,                  /* SELECT  */
    SEVERITY = 364,                /* SEVERITY  */
    SIGNAL = 365,                  /* SIGNAL  */
    _STABLE = 366,                 /* _STABLE  */
    SUBTYPE = 367,                 /* SUBTYPE  */
    Semicolon = 368,               /* Semicolon  */
    Slash = 369,                   /* Slash  */
    Star = 370,                    /* Star  */
    StringLit = 371,               /* StringLit  */
    THEN = 372,                    /* THEN  */
    TO = 373,                      /* TO  */
    TRANSPORT = 374,               /* TRANSPORT  */
    _TYPE = 375,                   /* _TYPE  */
    UNITS = 376,                   /* UNITS  */
    UNTIL = 377,                   /* UNTIL  */
    US = 378,                      /* US  */
    USE = 379,                     /* USE  */
    VARIABLE = 380,                /* VARIABLE  */
    VarAsgn = 381,                 /* VarAsgn  */
    WAIT = 382,                    /* WAIT  */
    WARNING = 383,                 /* WARNING  */
    WHEN = 384,                    /* WHEN  */
    WHILE = 385,                   /* WHILE  */
    WITH = 386,                    /* WITH  */
    WOR_BIT = 387,                 /* WOR_BIT  */
    WOR_VECTOR = 388               /* WOR_VECTOR  */
  };
  typedef enum bvl_y_tokentype bvl_y_token_kind_t;
#endif
/* Token kinds.  */
#define BVL_Y_EMPTY -2
#define BVL_Y_EOF 0
#define BVL_Y_error 256
#define BVL_Y_UNDEF 257
#define tok_AND 258
#define _BEGIN 259
#define _END 260
#define _EQSym 261
#define _EXIT 262
#define _FILE 263
#define _GESym 264
#define _GTSym 265
#define _IN 266
#define _INOUT 267
#define _LABEL 268
#define _LESym 269
#define _LINKAGE 270
#define _LTSym 271
#define _NAND 272
#define _NESym 273
#define _NEXT 274
#define _NOR 275
#define _NOT 276
#define tok_NULL 277
#define _OR 278
#define _OUT 279
#define _XOR 280
#define ABS 281
#define ACCESS 282
#define AFTER 283
#define ALIAS 284
#define ALL 285
#define ARCHITECTURE 286
#define ARRAY 287
#define ASSERT 288
#define ATTRIBUTE 289
#define AbstractLit 290
#define Ampersand 291
#define Apostrophe 292
#define Arrow 293
#define BIT 294
#define BIT_VECTOR 295
#define BLOCK 296
#define BODY 297
#define BUFFER 298
#define BUS 299
#define Bar 300
#define BasedInt 301
#define BasedReal 302
#define BitStringLit 303
#define Box 304
#define CASE 305
#define COMPONENT 306
#define CONFIGURATION 307
#define CONSTANT 308
#define CharacterLit 309
#define Colon 310
#define Comma 311
#define DISCONNECT 312
#define DOWNTO 313
#define DecimalInt 314
#define DecimalReal 315
#define Dot 316
#define DoubleStar 317
#define ELSE 318
#define ELSIF 319
#define ENTITY 320
#define ERROR 321
#define FOR 322
#define FS 323
#define FUNCTION 324
#define GENERATE 325
#define GENERIC 326
#define GUARDED 327
#define IF 328
#define IS 329
#define Identifier 330
#define LIBRARY 331
#define LOOP 332
#define LeftParen 333
#define MAP 334
#define MOD 335
#define MS 336
#define MUX_BIT 337
#define MUX_VECTOR 338
#define Minus 339
#define NATURAL 340
#define NATURAL_VECTOR 341
#define NEW 342
#define NS 343
#define OF 344
#define ON 345
#define OPEN 346
#define OTHERS 347
#define _PACKAGE 348
#define PORT 349
#define PROCEDURE 350
#define PROCESS 351
#define PS 352
#define Plus 353
#define RANGE 354
#define RECORD 355
#define REG_BIT 356
#define REG_VECTOR 357
#define REGISTER 358
#define REM 359
#define REPORT 360
#define RETURN 361
#define RightParen 362
#define SELECT 363
#define SEVERITY 364
#define SIGNAL 365
#define _STABLE 366
#define SUBTYPE 367
#define Semicolon 368
#define Slash 369
#define Star 370
#define StringLit 371
#define THEN 372
#define TO 373
#define TRANSPORT 374
#define _TYPE 375
#define UNITS 376
#define UNTIL 377
#define US 378
#define USE 379
#define VARIABLE 380
#define VarAsgn 381
#define WAIT 382
#define WARNING 383
#define WHEN 384
#define WHILE 385
#define WITH 386
#define WOR_BIT 387
#define WOR_VECTOR 388

/* Value type.  */
#if ! defined BVL_Y_STYPE && ! defined BVL_Y_STYPE_IS_DECLARED
union BVL_Y_STYPE
{
#line 1354 "./bvl_bcomp_y.y"

	long		 valu;
        float            flov;
	char		*text;
        bvl_ablstr       list;
	bvl_name	 name;
        struct g_type    dble;
	

#line 1744 "y.tab.c"

};
typedef union BVL_Y_STYPE BVL_Y_STYPE;
# define BVL_Y_STYPE_IS_TRIVIAL 1
# define BVL_Y_STYPE_IS_DECLARED 1
#endif


extern BVL_Y_STYPE bvl_y_lval;


int bvl_y_parse (void);


#endif /* !BVL_Y__BVL_Y__Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum bvl_y_symbol_kind_t
{
  BVL_Y_SYMBOL_BVL_Y_EMPTY = -2,
  BVL_Y_SYMBOL_BVL_Y_EOF = 0,                      /* "end of file"  */
  BVL_Y_SYMBOL_BVL_Y_error = 1,                    /* error  */
  BVL_Y_SYMBOL_BVL_Y_UNDEF = 2,                    /* "invalid token"  */
  BVL_Y_SYMBOL_tok_AND = 3,                    /* tok_AND  */
  BVL_Y_SYMBOL__BEGIN = 4,                     /* _BEGIN  */
  BVL_Y_SYMBOL__END = 5,                       /* _END  */
  BVL_Y_SYMBOL__EQSym = 6,                     /* _EQSym  */
  BVL_Y_SYMBOL__EXIT = 7,                      /* _EXIT  */
  BVL_Y_SYMBOL__FILE = 8,                      /* _FILE  */
  BVL_Y_SYMBOL__GESym = 9,                     /* _GESym  */
  BVL_Y_SYMBOL__GTSym = 10,                    /* _GTSym  */
  BVL_Y_SYMBOL__IN = 11,                       /* _IN  */
  BVL_Y_SYMBOL__INOUT = 12,                    /* _INOUT  */
  BVL_Y_SYMBOL__LABEL = 13,                    /* _LABEL  */
  BVL_Y_SYMBOL__LESym = 14,                    /* _LESym  */
  BVL_Y_SYMBOL__LINKAGE = 15,                  /* _LINKAGE  */
  BVL_Y_SYMBOL__LTSym = 16,                    /* _LTSym  */
  BVL_Y_SYMBOL__NAND = 17,                     /* _NAND  */
  BVL_Y_SYMBOL__NESym = 18,                    /* _NESym  */
  BVL_Y_SYMBOL__NEXT = 19,                     /* _NEXT  */
  BVL_Y_SYMBOL__NOR = 20,                      /* _NOR  */
  BVL_Y_SYMBOL__NOT = 21,                      /* _NOT  */
  BVL_Y_SYMBOL_tok_NULL = 22,                  /* tok_NULL  */
  BVL_Y_SYMBOL__OR = 23,                       /* _OR  */
  BVL_Y_SYMBOL__OUT = 24,                      /* _OUT  */
  BVL_Y_SYMBOL__XOR = 25,                      /* _XOR  */
  BVL_Y_SYMBOL_ABS = 26,                       /* ABS  */
  BVL_Y_SYMBOL_ACCESS = 27,                    /* ACCESS  */
  BVL_Y_SYMBOL_AFTER = 28,                     /* AFTER  */
  BVL_Y_SYMBOL_ALIAS = 29,                     /* ALIAS  */
  BVL_Y_SYMBOL_ALL = 30,                       /* ALL  */
  BVL_Y_SYMBOL_ARCHITECTURE = 31,              /* ARCHITECTURE  */
  BVL_Y_SYMBOL_ARRAY = 32,                     /* ARRAY  */
  BVL_Y_SYMBOL_ASSERT = 33,                    /* ASSERT  */
  BVL_Y_SYMBOL_ATTRIBUTE = 34,                 /* ATTRIBUTE  */
  BVL_Y_SYMBOL_AbstractLit = 35,               /* AbstractLit  */
  BVL_Y_SYMBOL_Ampersand = 36,                 /* Ampersand  */
  BVL_Y_SYMBOL_Apostrophe = 37,                /* Apostrophe  */
  BVL_Y_SYMBOL_Arrow = 38,                     /* Arrow  */
  BVL_Y_SYMBOL_BIT = 39,                       /* BIT  */
  BVL_Y_SYMBOL_BIT_VECTOR = 40,                /* BIT_VECTOR  */
  BVL_Y_SYMBOL_BLOCK = 41,                     /* BLOCK  */
  BVL_Y_SYMBOL_BODY = 42,                      /* BODY  */
  BVL_Y_SYMBOL_BUFFER = 43,                    /* BUFFER  */
  BVL_Y_SYMBOL_BUS = 44,                       /* BUS  */
  BVL_Y_SYMBOL_Bar = 45,                       /* Bar  */
  BVL_Y_SYMBOL_BasedInt = 46,                  /* BasedInt  */
  BVL_Y_SYMBOL_BasedReal = 47,                 /* BasedReal  */
  BVL_Y_SYMBOL_BitStringLit = 48,              /* BitStringLit  */
  BVL_Y_SYMBOL_Box = 49,                       /* Box  */
  BVL_Y_SYMBOL_CASE = 50,                      /* CASE  */
  BVL_Y_SYMBOL_COMPONENT = 51,                 /* COMPONENT  */
  BVL_Y_SYMBOL_CONFIGURATION = 52,             /* CONFIGURATION  */
  BVL_Y_SYMBOL_CONSTANT = 53,                  /* CONSTANT  */
  BVL_Y_SYMBOL_CharacterLit = 54,              /* CharacterLit  */
  BVL_Y_SYMBOL_Colon = 55,                     /* Colon  */
  BVL_Y_SYMBOL_Comma = 56,                     /* Comma  */
  BVL_Y_SYMBOL_DISCONNECT = 57,                /* DISCONNECT  */
  BVL_Y_SYMBOL_DOWNTO = 58,                    /* DOWNTO  */
  BVL_Y_SYMBOL_DecimalInt = 59,                /* DecimalInt  */
  BVL_Y_SYMBOL_DecimalReal = 60,               /* DecimalReal  */
  BVL_Y_SYMBOL_Dot = 61,                       /* Dot  */
  BVL_Y_SYMBOL_DoubleStar = 62,                /* DoubleStar  */
  BVL_Y_SYMBOL_ELSE = 63,                      /* ELSE  */
  BVL_Y_SYMBOL_ELSIF = 64,                     /* ELSIF  */
  BVL_Y_SYMBOL_ENTITY = 65,                    /* ENTITY  */
  BVL_Y_SYMBOL_ERROR = 66,                     /* ERROR  */
  BVL_Y_SYMBOL_FOR = 67,                       /* FOR  */
  BVL_Y_SYMBOL_FS = 68,                        /* FS  */
  BVL_Y_SYMBOL_FUNCTION = 69,                  /* FUNCTION  */
  BVL_Y_SYMBOL_GENERATE = 70,                  /* GENERATE  */
  BVL_Y_SYMBOL_GENERIC = 71,                   /* GENERIC  */
  BVL_Y_SYMBOL_GUARDED = 72,                   /* GUARDED  */
  BVL_Y_SYMBOL_IF = 73,                        /* IF  */
  BVL_Y_SYMBOL_IS = 74,                        /* IS  */
  BVL_Y_SYMBOL_Identifier = 75,                /* Identifier  */
  BVL_Y_SYMBOL_LIBRARY = 76,                   /* LIBRARY  */
  BVL_Y_SYMBOL_LOOP = 77,                      /* LOOP  */
  BVL_Y_SYMBOL_LeftParen = 78,                 /* LeftParen  */
  BVL_Y_SYMBOL_MAP = 79,                       /* MAP  */
  BVL_Y_SYMBOL_MOD = 80,                       /* MOD  */
  BVL_Y_SYMBOL_MS = 81,                        /* MS  */
  BVL_Y_SYMBOL_MUX_BIT = 82,                   /* MUX_BIT  */
  BVL_Y_SYMBOL_MUX_VECTOR = 83,                /* MUX_VECTOR  */
  BVL_Y_SYMBOL_Minus = 84,                     /* Minus  */
  BVL_Y_SYMBOL_NATURAL = 85,                   /* NATURAL  */
  BVL_Y_SYMBOL_NATURAL_VECTOR = 86,            /* NATURAL_VECTOR  */
  BVL_Y_SYMBOL_NEW = 87,                       /* NEW  */
  BVL_Y_SYMBOL_NS = 88,                        /* NS  */
  BVL_Y_SYMBOL_OF = 89,                        /* OF  */
  BVL_Y_SYMBOL_ON = 90,                        /* ON  */
  BVL_Y_SYMBOL_OPEN = 91,                      /* OPEN  */
  BVL_Y_SYMBOL_OTHERS = 92,                    /* OTHERS  */
  BVL_Y_SYMBOL__PACKAGE = 93,                  /* _PACKAGE  */
  BVL_Y_SYMBOL_PORT = 94,                      /* PORT  */
  BVL_Y_SYMBOL_PROCEDURE = 95,                 /* PROCEDURE  */
  BVL_Y_SYMBOL_PROCESS = 96,                   /* PROCESS  */
  BVL_Y_SYMBOL_PS = 97,                        /* PS  */
  BVL_Y_SYMBOL_Plus = 98,                      /* Plus  */
  BVL_Y_SYMBOL_RANGE = 99,                     /* RANGE  */
  BVL_Y_SYMBOL_RECORD = 100,                   /* RECORD  */
  BVL_Y_SYMBOL_REG_BIT = 101,                  /* REG_BIT  */
  BVL_Y_SYMBOL_REG_VECTOR = 102,               /* REG_VECTOR  */
  BVL_Y_SYMBOL_REGISTER = 103,                 /* REGISTER  */
  BVL_Y_SYMBOL_REM = 104,                      /* REM  */
  BVL_Y_SYMBOL_REPORT = 105,                   /* REPORT  */
  BVL_Y_SYMBOL_RETURN = 106,                   /* RETURN  */
  BVL_Y_SYMBOL_RightParen = 107,               /* RightParen  */
  BVL_Y_SYMBOL_SELECT = 108,                   /* SELECT  */
  BVL_Y_SYMBOL_SEVERITY = 109,                 /* SEVERITY  */
  BVL_Y_SYMBOL_SIGNAL = 110,                   /* SIGNAL  */
  BVL_Y_SYMBOL__STABLE = 111,                  /* _STABLE  */
  BVL_Y_SYMBOL_SUBTYPE = 112,                  /* SUBTYPE  */
  BVL_Y_SYMBOL_Semicolon = 113,                /* Semicolon  */
  BVL_Y_SYMBOL_Slash = 114,                    /* Slash  */
  BVL_Y_SYMBOL_Star = 115,                     /* Star  */
  BVL_Y_SYMBOL_StringLit = 116,                /* StringLit  */
  BVL_Y_SYMBOL_THEN = 117,                     /* THEN  */
  BVL_Y_SYMBOL_TO = 118,                       /* TO  */
  BVL_Y_SYMBOL_TRANSPORT = 119,                /* TRANSPORT  */
  BVL_Y_SYMBOL__TYPE = 120,                    /* _TYPE  */
  BVL_Y_SYMBOL_UNITS = 121,                    /* UNITS  */
  BVL_Y_SYMBOL_UNTIL = 122,                    /* UNTIL  */
  BVL_Y_SYMBOL_US = 123,                       /* US  */
  BVL_Y_SYMBOL_USE = 124,                      /* USE  */
  BVL_Y_SYMBOL_VARIABLE = 125,                 /* VARIABLE  */
  BVL_Y_SYMBOL_VarAsgn = 126,                  /* VarAsgn  */
  BVL_Y_SYMBOL_WAIT = 127,                     /* WAIT  */
  BVL_Y_SYMBOL_WARNING = 128,                  /* WARNING  */
  BVL_Y_SYMBOL_WHEN = 129,                     /* WHEN  */
  BVL_Y_SYMBOL_WHILE = 130,                    /* WHILE  */
  BVL_Y_SYMBOL_WITH = 131,                     /* WITH  */
  BVL_Y_SYMBOL_WOR_BIT = 132,                  /* WOR_BIT  */
  BVL_Y_SYMBOL_WOR_VECTOR = 133,               /* WOR_VECTOR  */
  BVL_Y_SYMBOL_BVL_Y_ACCEPT = 134,                 /* $accept  */
  BVL_Y_SYMBOL_design_file = 135,              /* design_file  */
  BVL_Y_SYMBOL_136_1 = 136,                    /* $@1  */
  BVL_Y_SYMBOL_entity_declaration = 137,       /* entity_declaration  */
  BVL_Y_SYMBOL_138_2 = 138,                    /* $@2  */
  BVL_Y_SYMBOL_139_generic_clause_ = 139,      /* .generic_clause.  */
  BVL_Y_SYMBOL_generic_clause = 140,           /* generic_clause  */
  BVL_Y_SYMBOL_formal_generic_list = 141,      /* formal_generic_list  */
  BVL_Y_SYMBOL_142_formal_generic_element_ = 142, /* ...formal_generic_element..  */
  BVL_Y_SYMBOL_formal_generic_element = 143,   /* formal_generic_element  */
  BVL_Y_SYMBOL_generic_VarAsgn__expression = 144, /* generic_VarAsgn__expression  */
  BVL_Y_SYMBOL_generic_expression = 145,       /* generic_expression  */
  BVL_Y_SYMBOL_generic_aggregate = 146,        /* generic_aggregate  */
  BVL_Y_SYMBOL_147_3 = 147,                    /* $@3  */
  BVL_Y_SYMBOL_148_generic_element_association_ = 148, /* ...generic_element_association..  */
  BVL_Y_SYMBOL_generic_element_association = 149, /* generic_element_association  */
  BVL_Y_SYMBOL_150_constraint_ = 150,          /* .constraint.  */
  BVL_Y_SYMBOL_constraint = 151,               /* constraint  */
  BVL_Y_SYMBOL_range = 152,                    /* range  */
  BVL_Y_SYMBOL_direction = 153,                /* direction  */
  BVL_Y_SYMBOL_154_port_clause_ = 154,         /* .port_clause.  */
  BVL_Y_SYMBOL_port_clause = 155,              /* port_clause  */
  BVL_Y_SYMBOL_formal_port_list = 156,         /* formal_port_list  */
  BVL_Y_SYMBOL_157_formal_port_element_ = 157, /* ...formal_port_element..  */
  BVL_Y_SYMBOL_formal_port_element = 158,      /* formal_port_element  */
  BVL_Y_SYMBOL_159_SIGNAL_ = 159,              /* .SIGNAL.  */
  BVL_Y_SYMBOL_160_mode_ = 160,                /* .mode.  */
  BVL_Y_SYMBOL_architecture_body = 161,        /* architecture_body  */
  BVL_Y_SYMBOL_162_4 = 162,                    /* $@4  */
  BVL_Y_SYMBOL_architecture_declarative_part = 163, /* architecture_declarative_part  */
  BVL_Y_SYMBOL_164_block_declarative_item_ = 164, /* ..block_declarative_item..  */
  BVL_Y_SYMBOL_block_declarative_item = 165,   /* block_declarative_item  */
  BVL_Y_SYMBOL_constant_declaration = 166,     /* constant_declaration  */
  BVL_Y_SYMBOL_constant_VarAsgn__expression = 167, /* constant_VarAsgn__expression  */
  BVL_Y_SYMBOL_signal_declaration = 168,       /* signal_declaration  */
  BVL_Y_SYMBOL_169_signal_kind_ = 169,         /* .signal_kind.  */
  BVL_Y_SYMBOL_architecture_statement_part = 170, /* architecture_statement_part  */
  BVL_Y_SYMBOL_171_concurrent_statement_ = 171, /* ..concurrent_statement..  */
  BVL_Y_SYMBOL_concurrent_statement = 172,     /* concurrent_statement  */
  BVL_Y_SYMBOL_block_statement = 173,          /* block_statement  */
  BVL_Y_SYMBOL_174_5 = 174,                    /* $@5  */
  BVL_Y_SYMBOL_set_of_statements = 175,        /* set_of_statements  */
  BVL_Y_SYMBOL_concurrent_assertion_statement = 176, /* concurrent_assertion_statement  */
  BVL_Y_SYMBOL_concurrent_signal_assignment_statement = 177, /* concurrent_signal_assignment_statement  */
  BVL_Y_SYMBOL_unlabeled_concurrent_assertion_statement = 178, /* unlabeled_concurrent_assertion_statement  */
  BVL_Y_SYMBOL_assertion_statement = 179,      /* assertion_statement  */
  BVL_Y_SYMBOL_unlabeled_conditional_signal_assignment = 180, /* unlabeled_conditional_signal_assignment  */
  BVL_Y_SYMBOL_181_waveform__WHEN__condition__ELSE_ = 181, /* ..waveform__WHEN__condition__ELSE..  */
  BVL_Y_SYMBOL_unlabeled_selected_signal_assignment = 182, /* unlabeled_selected_signal_assignment  */
  BVL_Y_SYMBOL_183_6 = 183,                    /* $@6  */
  BVL_Y_SYMBOL_184_waveform__WHEN__choices_ = 184, /* ...waveform__WHEN__choices..  */
  BVL_Y_SYMBOL_waveform__WHEN__choices = 185,  /* waveform__WHEN__choices  */
  BVL_Y_SYMBOL_waveform = 186,                 /* waveform  */
  BVL_Y_SYMBOL_waveform_element = 187,         /* waveform_element  */
  BVL_Y_SYMBOL_188_AFTER__delay_expression_ = 188, /* .AFTER__delay_expression.  */
  BVL_Y_SYMBOL_delay_expression = 189,         /* delay_expression  */
  BVL_Y_SYMBOL_time_unit = 190,                /* time_unit  */
  BVL_Y_SYMBOL_choices = 191,                  /* choices  */
  BVL_Y_SYMBOL_192_7 = 192,                    /* $@7  */
  BVL_Y_SYMBOL_193_Bar__choice_ = 193,         /* ..Bar__choice..  */
  BVL_Y_SYMBOL_choice = 194,                   /* choice  */
  BVL_Y_SYMBOL_195_REPORT__expression_ = 195,  /* .REPORT__expression.  */
  BVL_Y_SYMBOL_196_SEVERITY__expression_ = 196, /* .SEVERITY__expression.  */
  BVL_Y_SYMBOL_report__message = 197,          /* report__message  */
  BVL_Y_SYMBOL_severity__message = 198,        /* severity__message  */
  BVL_Y_SYMBOL_expression = 199,               /* expression  */
  BVL_Y_SYMBOL_200_relation_AND__relation_ = 200, /* relation..AND__relation..  */
  BVL_Y_SYMBOL_201_relation_OR__relation_ = 201, /* relation..OR__relation..  */
  BVL_Y_SYMBOL_202_relation_NAND_NOR__relation_ = 202, /* relation.NAND_NOR__relation.  */
  BVL_Y_SYMBOL_203_relation_XOR__relation_ = 203, /* relation..XOR__relation..  */
  BVL_Y_SYMBOL_relation = 204,                 /* relation  */
  BVL_Y_SYMBOL_simple_expression = 205,        /* simple_expression  */
  BVL_Y_SYMBOL_206_sign_term_add_op__term_ = 206, /* .sign.term..add_op__term..  */
  BVL_Y_SYMBOL_term = 207,                     /* term  */
  BVL_Y_SYMBOL_factor = 208,                   /* factor  */
  BVL_Y_SYMBOL_primary = 209,                  /* primary  */
  BVL_Y_SYMBOL_relational_operator = 210,      /* relational_operator  */
  BVL_Y_SYMBOL_literal = 211,                  /* literal  */
  BVL_Y_SYMBOL_aggregate = 212,                /* aggregate  */
  BVL_Y_SYMBOL_name = 213,                     /* name  */
  BVL_Y_SYMBOL_indexed_name = 214,             /* indexed_name  */
  BVL_Y_SYMBOL_slice_name = 215,               /* slice_name  */
  BVL_Y_SYMBOL_attribute_name = 216,           /* attribute_name  */
  BVL_Y_SYMBOL_attribute_designator = 217,     /* attribute_designator  */
  BVL_Y_SYMBOL_type_mark = 218,                /* type_mark  */
  BVL_Y_SYMBOL_identifier_list = 219,          /* identifier_list  */
  BVL_Y_SYMBOL_220_8 = 220,                    /* $@8  */
  BVL_Y_SYMBOL_221_identifier_ = 221,          /* ...identifier..  */
  BVL_Y_SYMBOL_222_label_ = 222,               /* .label.  */
  BVL_Y_SYMBOL_223_guard_expression_ = 223,    /* .guard_expression.  */
  BVL_Y_SYMBOL_guard_expression = 224,         /* guard_expression  */
  BVL_Y_SYMBOL_225_TRANSPORT_ = 225,           /* .TRANSPORT.  */
  BVL_Y_SYMBOL_226_GUARDED_ = 226,             /* .GUARDED.  */
  BVL_Y_SYMBOL_227_simple_name_ = 227,         /* .simple_name.  */
  BVL_Y_SYMBOL_simple_name = 228,              /* simple_name  */
  BVL_Y_SYMBOL_target = 229,                   /* target  */
  BVL_Y_SYMBOL_a_label = 230,                  /* a_label  */
  BVL_Y_SYMBOL_label = 231,                    /* label  */
  BVL_Y_SYMBOL_abstractlit = 232,              /* abstractlit  */
  BVL_Y_SYMBOL_RightParen_ERR = 233,           /* RightParen_ERR  */
  BVL_Y_SYMBOL_Semicolon_ERR = 234,            /* Semicolon_ERR  */
  BVL_Y_SYMBOL_END_ERR = 235                   /* END_ERR  */
};
typedef enum bvl_y_symbol_kind_t bvl_y_symbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define BVL_Y__STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ bvl_y_type_int8;
#elif defined BVL_Y__STDINT_H
typedef int_least8_t bvl_y_type_int8;
#else
typedef signed char bvl_y_type_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ bvl_y_type_int16;
#elif defined BVL_Y__STDINT_H
typedef int_least16_t bvl_y_type_int16;
#else
typedef short bvl_y_type_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ bvl_y_type_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined BVL_Y__STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t bvl_y_type_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char bvl_y_type_uint8;
#else
typedef short bvl_y_type_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ bvl_y_type_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined BVL_Y__STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t bvl_y_type_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short bvl_y_type_uint16;
#else
typedef int bvl_y_type_uint16;
#endif

#ifndef BVL_Y_PTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define BVL_Y_PTRDIFF_T __PTRDIFF_TYPE__
#  define BVL_Y_PTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define BVL_Y_PTRDIFF_T ptrdiff_t
#  define BVL_Y_PTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define BVL_Y_PTRDIFF_T long
#  define BVL_Y_PTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef BVL_Y_SIZE_T
# ifdef __SIZE_TYPE__
#  define BVL_Y_SIZE_T __SIZE_TYPE__
# elif defined size_t
#  define BVL_Y_SIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define BVL_Y_SIZE_T size_t
# else
#  define BVL_Y_SIZE_T unsigned
# endif
#endif

#define BVL_Y_SIZE_MAXIMUM                                  \
  BVL_Y__CAST (BVL_Y_PTRDIFF_T,                                 \
           (BVL_Y_PTRDIFF_MAXIMUM < BVL_Y__CAST (BVL_Y_SIZE_T, -1)  \
            ? BVL_Y_PTRDIFF_MAXIMUM                         \
            : BVL_Y__CAST (BVL_Y_SIZE_T, -1)))

#define BVL_Y_SIZEOF(X) BVL_Y__CAST (BVL_Y_PTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef bvl_y_type_int16 bvl_y__state_t;

/* State numbers in computations.  */
typedef int bvl_y__state_fast_t;

#ifndef BVL_Y__
# if defined BVL_Y_ENABLE_NLS && BVL_Y_ENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define BVL_Y__(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef BVL_Y__
#  define BVL_Y__(Msgid) Msgid
# endif
#endif


#ifndef BVL_Y__ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define BVL_Y__ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define BVL_Y__ATTRIBUTE_PURE
# endif
#endif

#ifndef BVL_Y__ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define BVL_Y__ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define BVL_Y__ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define BVL_Y__USE(E) ((void) (E))
#else
# define BVL_Y__USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about bvl_y_lval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define BVL_Y__INITIAL_VALUE(Value) Value
#endif
#ifndef BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef BVL_Y__INITIAL_VALUE
# define BVL_Y__INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define BVL_Y__IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define BVL_Y__IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef BVL_Y__IGNORE_USELESS_CAST_BEGIN
# define BVL_Y__IGNORE_USELESS_CAST_BEGIN
# define BVL_Y__IGNORE_USELESS_CAST_END
#endif


#define BVL_Y__ASSERT(E) ((void) (0 && (E)))

#if !defined bvl_y_overflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef BVL_Y_STACK_USE_ALLOCA
#  if BVL_Y_STACK_USE_ALLOCA
#   ifdef __GNUC__
#    define BVL_Y_STACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define BVL_Y_STACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define BVL_Y_STACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef BVL_Y_STACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define BVL_Y_STACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef BVL_Y_STACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define BVL_Y_STACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define BVL_Y_STACK_ALLOC BVL_Y_MALLOC
#  define BVL_Y_STACK_FREE BVL_Y_FREE
#  ifndef BVL_Y_STACK_ALLOC_MAXIMUM
#   define BVL_Y_STACK_ALLOC_MAXIMUM BVL_Y_SIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined BVL_Y_MALLOC || defined malloc) \
             && (defined BVL_Y_FREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef BVL_Y_MALLOC
#   define BVL_Y_MALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (BVL_Y_SIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef BVL_Y_FREE
#   define BVL_Y_FREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined bvl_y_overflow */

#if (! defined bvl_y_overflow \
     && (! defined __cplusplus \
         || (defined BVL_Y_STYPE_IS_TRIVIAL && BVL_Y_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union bvl_y_alloc
{
  bvl_y__state_t bvl_y_ss_alloc;
  BVL_Y_STYPE bvl_y_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define BVL_Y_STACK_GAP_MAXIMUM (BVL_Y_SIZEOF (union bvl_y_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define BVL_Y_STACK_BYTES(N) \
     ((N) * (BVL_Y_SIZEOF (bvl_y__state_t) + BVL_Y_SIZEOF (BVL_Y_STYPE)) \
      + BVL_Y_STACK_GAP_MAXIMUM)

# define BVL_Y_COPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables BVL_Y_SIZE and BVL_Y_STACKSIZE give the old and new number of
   elements in the stack, and BVL_Y_PTR gives the new location of the
   stack.  Advance BVL_Y_PTR to a properly aligned location for the next
   stack.  */
# define BVL_Y_STACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        BVL_Y_PTRDIFF_T bvl_y_newbytes;                                         \
        BVL_Y_COPY (&bvl_y_ptr->Stack_alloc, Stack, bvl_y_size);                    \
        Stack = &bvl_y_ptr->Stack_alloc;                                    \
        bvl_y_newbytes = bvl_y_stacksize * BVL_Y_SIZEOF (*Stack) + BVL_Y_STACK_GAP_MAXIMUM; \
        bvl_y_ptr += bvl_y_newbytes / BVL_Y_SIZEOF (*bvl_y_ptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined BVL_Y_COPY_NEEDED && BVL_Y_COPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef BVL_Y_COPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define BVL_Y_COPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, BVL_Y__CAST (BVL_Y_SIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define BVL_Y_COPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          BVL_Y_PTRDIFF_T bvl_y_i;                      \
          for (bvl_y_i = 0; bvl_y_i < (Count); bvl_y_i++)   \
            (Dst)[bvl_y_i] = (Src)[bvl_y_i];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !BVL_Y_COPY_NEEDED */

/* BVL_Y_FINAL -- State number of the termination state.  */
#define BVL_Y_FINAL  3
/* BVL_Y_LAST -- Last index in BVL_Y_TABLE.  */
#define BVL_Y_LAST   242

/* BVL_Y_NTOKENS -- Number of terminals.  */
#define BVL_Y_NTOKENS  134
/* BVL_Y_NNTS -- Number of nonterminals.  */
#define BVL_Y_NNTS  102
/* BVL_Y_NRULES -- Number of rules.  */
#define BVL_Y_NRULES  180
/* BVL_Y_NSTATES -- Number of states.  */
#define BVL_Y_NSTATES  289

/* BVL_Y_MAXUTOK -- Last valid token kind.  */
#define BVL_Y_MAXUTOK   388


/* BVL_Y_TRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by bvl_y_lex, with out-of-bounds checking.  */
#define BVL_Y_TRANSLATE(BVL_Y_X)                                \
  (0 <= (BVL_Y_X) && (BVL_Y_X) <= BVL_Y_MAXUTOK                     \
   ? BVL_Y__CAST (bvl_y_symbol_kind_t, bvl_y_translate[BVL_Y_X])        \
   : BVL_Y_SYMBOL_BVL_Y_UNDEF)

/* BVL_Y_TRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by bvl_y_lex.  */
static const bvl_y_type_uint8 bvl_y_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133
};

#if BVL_Y_DEBUG
/* BVL_Y_RLINE[BVL_Y_N] -- Source line where rule number BVL_Y_N was defined.  */
static const bvl_y_type_int16 bvl_y_rline[] =
{
       0,  1559,  1559,  1559,  1652,  1649,  1665,  1673,  1674,  1682,
    1687,  1694,  1699,  1700,  1706,  1729,  1745,  1750,  1758,  1764,
    1762,  1776,  1777,  1790,  1796,  1801,  1806,  1813,  1831,  1833,
    1838,  1839,  1843,  1848,  1855,  1860,  1861,  1867,  1905,  1922,
    1923,  1928,  1929,  1931,  1933,  1943,  1938,  1957,  1963,  1967,
    1968,  1973,  1974,  1975,  1981,  2002,  2008,  2050,  2051,  2053,
    2058,  2062,  2063,  2068,  2069,  2070,  2071,  2081,  2077,  2103,
    2107,  2117,  2121,  2128,  2129,  2136,  2140,  2144,  2159,  2435,
    2436,  2459,  2457,  2732,  2733,  2754,  2770,  2775,  2785,  2786,
    2792,  2811,  2813,  2815,  2817,  2819,  2825,  2824,  2831,  2832,
    2843,  2845,  2847,  2919,  2920,  2927,  2928,  2934,  2939,  2941,
    2946,  2948,  2950,  2952,  2957,  2961,  2968,  2972,  2979,  2981,
    2985,  2993,  2997,  3004,  3006,  3013,  3018,  3020,  3028,  3033,
    3035,  3041,  3047,  3049,  3144,  3146,  3151,  3153,  3155,  3160,
    3167,  3173,  3175,  3177,  3182,  3194,  3212,  3276,  3280,  3282,
    3284,  3286,  3288,  3290,  3292,  3294,  3296,  3298,  3304,  3303,
    3309,  3310,  3318,  3319,  3325,  3326,  3331,  3339,  3340,  3346,
    3347,  3353,  3354,  3359,  3364,  3369,  3378,  3383,  3388,  3393,
    3398
};
#endif

/** Accessing symbol of state STATE.  */
#define BVL_Y__ACCESSING_SYMBOL(State) BVL_Y__CAST (bvl_y_symbol_kind_t, bvl_y_stos[State])

#if BVL_Y_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   BVL_Y_SYMBOL.  No bounds checking.  */
static const char *bvl_y_symbol_name (bvl_y_symbol_kind_t bvl_y_symbol) BVL_Y__ATTRIBUTE_UNUSED;

/* BVL_Y_TNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at BVL_Y_NTOKENS, nonterminals.  */
static const char *const bvl_y_tname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "tok_AND", "_BEGIN",
  "_END", "_EQSym", "_EXIT", "_FILE", "_GESym", "_GTSym", "_IN", "_INOUT",
  "_LABEL", "_LESym", "_LINKAGE", "_LTSym", "_NAND", "_NESym", "_NEXT",
  "_NOR", "_NOT", "tok_NULL", "_OR", "_OUT", "_XOR", "ABS", "ACCESS",
  "AFTER", "ALIAS", "ALL", "ARCHITECTURE", "ARRAY", "ASSERT", "ATTRIBUTE",
  "AbstractLit", "Ampersand", "Apostrophe", "Arrow", "BIT", "BIT_VECTOR",
  "BLOCK", "BODY", "BUFFER", "BUS", "Bar", "BasedInt", "BasedReal",
  "BitStringLit", "Box", "CASE", "COMPONENT", "CONFIGURATION", "CONSTANT",
  "CharacterLit", "Colon", "Comma", "DISCONNECT", "DOWNTO", "DecimalInt",
  "DecimalReal", "Dot", "DoubleStar", "ELSE", "ELSIF", "ENTITY", "ERROR",
  "FOR", "FS", "FUNCTION", "GENERATE", "GENERIC", "GUARDED", "IF", "IS",
  "Identifier", "LIBRARY", "LOOP", "LeftParen", "MAP", "MOD", "MS",
  "MUX_BIT", "MUX_VECTOR", "Minus", "NATURAL", "NATURAL_VECTOR", "NEW",
  "NS", "OF", "ON", "OPEN", "OTHERS", "_PACKAGE", "PORT", "PROCEDURE",
  "PROCESS", "PS", "Plus", "RANGE", "RECORD", "REG_BIT", "REG_VECTOR",
  "REGISTER", "REM", "REPORT", "RETURN", "RightParen", "SELECT",
  "SEVERITY", "SIGNAL", "_STABLE", "SUBTYPE", "Semicolon", "Slash", "Star",
  "StringLit", "THEN", "TO", "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "US",
  "USE", "VARIABLE", "VarAsgn", "WAIT", "WARNING", "WHEN", "WHILE", "WITH",
  "WOR_BIT", "WOR_VECTOR", "$accept", "design_file", "$@1",
  "entity_declaration", "$@2", ".generic_clause.", "generic_clause",
  "formal_generic_list", "...formal_generic_element..",
  "formal_generic_element", "generic_VarAsgn__expression",
  "generic_expression", "generic_aggregate", "$@3",
  "...generic_element_association..", "generic_element_association",
  ".constraint.", "constraint", "range", "direction", ".port_clause.",
  "port_clause", "formal_port_list", "...formal_port_element..",
  "formal_port_element", ".SIGNAL.", ".mode.", "architecture_body", "$@4",
  "architecture_declarative_part", "..block_declarative_item..",
  "block_declarative_item", "constant_declaration",
  "constant_VarAsgn__expression", "signal_declaration", ".signal_kind.",
  "architecture_statement_part", "..concurrent_statement..",
  "concurrent_statement", "block_statement", "$@5", "set_of_statements",
  "concurrent_assertion_statement",
  "concurrent_signal_assignment_statement",
  "unlabeled_concurrent_assertion_statement", "assertion_statement",
  "unlabeled_conditional_signal_assignment",
  "..waveform__WHEN__condition__ELSE..",
  "unlabeled_selected_signal_assignment", "$@6",
  "...waveform__WHEN__choices..", "waveform__WHEN__choices", "waveform",
  "waveform_element", ".AFTER__delay_expression.", "delay_expression",
  "time_unit", "choices", "$@7", "..Bar__choice..", "choice",
  ".REPORT__expression.", ".SEVERITY__expression.", "report__message",
  "severity__message", "expression", "relation..AND__relation..",
  "relation..OR__relation..", "relation.NAND_NOR__relation.",
  "relation..XOR__relation..", "relation", "simple_expression",
  ".sign.term..add_op__term..", "term", "factor", "primary",
  "relational_operator", "literal", "aggregate", "name", "indexed_name",
  "slice_name", "attribute_name", "attribute_designator", "type_mark",
  "identifier_list", "$@8", "...identifier..", ".label.",
  ".guard_expression.", "guard_expression", ".TRANSPORT.", ".GUARDED.",
  ".simple_name.", "simple_name", "target", "a_label", "label",
  "abstractlit", "RightParen_ERR", "Semicolon_ERR", "END_ERR", BVL_Y__NULLPTR
};

static const char *
bvl_y_symbol_name (bvl_y_symbol_kind_t bvl_y_symbol)
{
  return bvl_y_tname[bvl_y_symbol];
}
#endif

#define BVL_Y_PACT_NINF (-190)

#define bvl_y_pact_value_is_default(Yyn) \
  ((Yyn) == BVL_Y_PACT_NINF)

#define BVL_Y_TABLE_NINF (-177)

#define bvl_y_table_value_is_error(Yyn) \
  0

/* BVL_Y_PACT[STATE-NUM] -- Index in BVL_Y_TABLE of the portion describing
   STATE-NUM.  */
static const bvl_y_type_int16 bvl_y_pact[] =
{
    -190,    44,    -4,  -190,    22,    31,  -190,  -190,     3,    29,
    -190,  -190,  -190,    10,    32,    25,     4,    24,  -190,    33,
      23,    52,    18,   117,  -190,  -190,  -190,  -190,  -190,    46,
      28,  -190,    23,     5,  -190,    25,  -190,  -190,    74,  -190,
      23,    23,  -190,  -190,  -190,    28,  -190,    46,    23,  -190,
     127,    14,  -190,   -13,  -190,    52,    23,    23,    83,  -190,
    -190,    23,    66,    46,  -190,  -190,  -190,    86,  -190,  -190,
    -190,  -190,  -190,  -190,  -190,  -190,  -190,  -190,    68,  -190,
    -190,     5,   116,   117,     6,  -190,    89,    96,    77,   119,
      30,  -190,  -190,  -190,  -190,  -190,   -13,    25,    23,     0,
     102,     0,  -190,  -190,  -190,  -190,  -190,  -190,  -190,  -190,
    -190,  -190,  -190,  -190,    13,   144,   -19,   104,   -13,   -13,
    -190,  -190,    28,   -26,     7,  -190,    68,    23,  -190,    -7,
    -190,  -190,     0,  -190,    55,   158,   141,  -190,   145,   130,
     108,   133,  -190,  -190,  -190,  -190,  -190,  -190,  -190,    60,
     119,    94,    95,  -190,  -190,  -190,  -190,    68,    68,  -190,
    -190,  -190,   119,   119,  -190,  -190,  -190,     8,  -190,  -190,
      65,    59,    67,     0,     0,     0,     0,     0,     0,     0,
       0,  -190,  -190,     0,     0,    69,  -190,  -190,   -24,  -190,
      61,     0,   174,  -190,    56,     8,  -190,  -190,  -190,  -190,
    -190,  -190,  -190,  -190,  -190,   -38,    23,  -190,  -190,  -190,
    -190,  -190,  -190,  -190,  -190,  -190,  -190,    25,   119,  -190,
    -190,  -190,    28,  -190,    -8,    23,    23,  -190,  -190,  -190,
    -190,  -190,   167,    28,     0,  -190,  -190,  -190,  -190,  -190,
      -1,    94,  -190,   -64,  -190,   155,    12,   117,   119,  -190,
      61,     0,  -190,   119,  -190,   143,  -190,     0,   122,  -190,
      42,   111,  -190,    58,  -190,  -190,  -190,  -190,  -190,  -190,
    -190,  -190,    23,  -190,   -20,     9,  -190,     0,  -190,  -190,
    -190,  -190,  -190,  -190,  -190,  -190,   146,     9,  -190
};

/* BVL_Y_DEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when BVL_Y_TABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const bvl_y_type_uint8 bvl_y_defact[] =
{
       2,     0,     0,     1,     0,     0,     6,   173,     0,     0,
       3,     4,    47,     0,     7,     0,     0,    30,     8,     0,
       0,     0,     0,     0,    31,    45,   179,    10,    15,     0,
       0,    12,     0,     0,   180,   171,    49,   158,     0,   178,
       0,    11,    33,    38,    40,     0,    35,     0,     0,   172,
       0,     0,   160,     0,     9,     0,     0,    34,     0,     5,
      61,     0,     0,     0,    50,    52,    51,   159,   148,   151,
     150,   153,   156,   157,   154,   155,   149,   152,    24,    13,
      32,     0,    41,     0,     0,    53,     0,     0,     0,     0,
       0,    25,    36,    42,    44,    43,     0,   171,     0,     0,
     173,     0,    62,    63,    64,    65,    71,    76,    73,    75,
     174,   141,   142,   143,   140,     0,     0,     0,     0,     0,
     161,   177,     0,     0,     0,    14,    24,     0,    66,     0,
     138,   136,     0,   137,   103,   110,   111,   112,   113,   118,
     123,   125,   126,   128,   129,   131,   132,   133,    81,     0,
       0,   169,   164,    70,    72,    74,   175,    24,    24,    26,
      29,    28,     0,     0,    16,    18,    17,    57,    46,   130,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,   134,   135,     0,     0,     0,   147,   146,     0,   170,
     167,     0,     0,   165,     0,    57,    27,    19,    23,    59,
      58,    37,   139,   107,   104,     0,     0,   115,   117,   122,
     114,   119,   120,   116,   121,   124,   127,     0,     0,   144,
     168,    79,     0,    67,     0,     0,     0,    21,   108,   109,
     106,    77,     0,     0,     0,   166,    61,    55,    54,    56,
       0,   169,   145,     0,    86,    88,     0,     0,     0,    20,
     167,     0,    78,     0,    87,     0,    22,     0,     0,    89,
       0,   162,    83,     0,    80,    91,    95,    93,    92,    94,
      90,   176,     0,   163,     0,     0,    68,     0,    82,   101,
      85,    96,   100,   102,    84,    98,    97,     0,    99
};

/* BVL_Y_PGOTO[NTERM-NUM].  */
static const bvl_y_type_int16 bvl_y_pgoto[] =
{
    -190,  -190,  -190,  -190,  -190,  -190,  -190,  -190,  -190,   134,
    -190,  -190,  -190,  -190,  -190,   -60,    -9,  -190,  -190,    15,
    -190,  -190,  -190,  -190,   114,  -190,  -190,  -190,  -190,  -190,
    -190,  -190,  -190,  -190,  -190,     1,  -190,   -37,  -190,  -190,
    -190,  -190,  -190,  -190,    82,  -190,    84,  -190,    85,  -190,
    -190,   -75,   -29,  -190,  -190,  -190,  -190,  -190,  -190,  -190,
     -81,  -190,  -190,  -190,  -190,   -89,  -190,  -190,  -190,  -190,
      39,    26,  -190,    36,  -190,    78,  -190,  -189,  -190,   -83,
    -190,  -190,  -190,  -190,   -59,    11,  -190,  -190,  -190,  -190,
    -190,   -42,   -31,   124,    16,    17,  -190,   -39,   -86,   -43,
     -32,   -79
};

/* BVL_Y_DEFGOTO[NTERM-NUM].  */
static const bvl_y_type_int16 bvl_y_defgoto[] =
{
       0,     1,     2,     5,    14,    17,    18,    30,    41,    31,
     125,   164,   165,   227,   240,   197,    90,    91,   122,   162,
      23,    24,    45,    57,    46,    47,    96,    10,    36,    50,
      51,    64,    65,   225,    66,   201,    83,    84,   102,   103,
     236,   247,   104,   105,   106,   107,   108,   234,   109,   185,
     274,   262,   263,   244,   254,   259,   270,   280,   285,   286,
     281,   172,   206,   204,   230,   245,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   183,   145,   146,   147,
     111,   112,   113,   187,    78,    38,    52,    67,   272,   192,
     193,   221,   190,    48,   114,   115,   116,   117,   198,    40,
      27,    35
};

/* BVL_Y_TABLE[BVL_Y_PACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If BVL_Y_TABLE_NINF, syntax error.  */
static const bvl_y_type_int16 bvl_y_table[] =
{
      42,   110,    56,   123,    97,    20,    43,    98,    54,    55,
     134,   -60,   148,    98,    99,    61,    59,   -69,   -48,    32,
       8,   129,   152,     6,    80,    81,    68,    69,   228,    85,
      12,    19,   160,   110,   160,   237,   277,   126,   166,    99,
     130,   130,   121,   170,     3,    99,   131,   131,   130,    26,
     149,    49,   199,    28,   131,   248,     7,   130,    58,   157,
     158,     4,     9,   131,   188,   251,   128,    62,     7,    70,
      71,   132,    72,    73,    87,     7,   196,    11,   132,   159,
     -39,   100,    21,    39,     7,   163,   282,   100,    74,    75,
     229,   150,   161,    26,   161,   168,    33,     7,   282,    15,
       7,   279,   222,    16,    13,    29,    39,    25,   133,   133,
     265,   200,   101,    49,   181,    44,   133,   167,    22,    76,
      77,    37,    34,   266,    63,   133,   182,    93,    94,    53,
     267,    60,   233,   176,   110,    39,    26,   101,    82,   268,
      95,    86,    88,   101,   118,   219,    89,   177,   194,   195,
     178,   119,   120,   179,   121,   180,   124,  -176,   151,   156,
     171,   173,   258,   110,   174,   269,   189,   260,   255,   184,
     175,   186,   202,   191,   231,   203,   205,   217,   223,   235,
     220,   241,   224,   253,   261,   264,   271,   275,   256,    79,
     242,   287,   283,   238,   239,    92,   226,   249,   153,   246,
     154,   155,   284,   218,   283,   243,   288,   169,   257,   215,
     250,   252,   207,   208,   209,   210,   211,   212,   213,   214,
     216,   127,   273,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   232,     0,     0,     0,     0,     0,
     276,     0,   278
};

static const bvl_y_type_int16 bvl_y_check[] =
{
      32,    84,    45,    89,    83,     1,     1,     1,    40,    41,
      99,     5,   101,     1,    33,     1,    48,     5,     4,     1,
       4,    21,    41,     1,    56,    57,    39,    40,    66,    61,
       1,    15,    58,   116,    58,   224,    56,    96,   124,    33,
      48,    48,    35,   132,     0,    33,    54,    54,    48,   113,
      37,    35,    44,     1,    54,    56,    75,    48,    47,   118,
     119,    65,    31,    54,   150,   129,    98,    53,    75,    82,
      83,    78,    85,    86,    63,    75,   162,    74,    78,   122,
      75,    75,    78,   107,    75,    78,   275,    75,   101,   102,
     128,    78,   118,   113,   118,   127,    78,    75,   287,    89,
      75,    92,   191,    71,    75,    53,   107,    74,   116,   116,
      68,   103,   131,    97,     6,   110,   116,   126,    94,   132,
     133,    75,     5,    81,   110,   116,    18,    11,    12,    55,
      88,     4,   218,     3,   217,   107,   113,   131,    55,    97,
      24,    75,    56,   131,    55,   188,    78,    17,   157,   158,
      20,    55,    75,    23,    35,    25,   126,    55,    14,    55,
     105,     3,   251,   246,    23,   123,    72,   253,   247,    36,
      25,   111,   107,    78,   206,   116,   109,   108,     4,   222,
     119,    14,   126,    28,    41,    63,    75,   129,   248,    55,
     233,    45,   275,   225,   226,    81,   195,   240,   116,   236,
     116,   116,   277,   188,   287,   234,   287,   129,   250,   183,
     241,   243,   173,   174,   175,   176,   177,   178,   179,   180,
     184,    97,   261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,
     272,    -1,   274
};

/* BVL_Y_STOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const bvl_y_type_uint8 bvl_y_stos[] =
{
       0,   135,   136,     0,    65,   137,     1,    75,   228,    31,
     161,    74,     1,    75,   138,    89,    71,   139,   140,   228,
       1,    78,    94,   154,   155,    74,   113,   234,     1,    53,
     141,   143,     1,    78,     5,   235,   162,    75,   219,   107,
     233,   142,   234,     1,   110,   156,   158,   159,   227,   228,
     163,   164,   220,    55,   234,   234,   233,   157,   219,   234,
       4,     1,    53,   110,   165,   166,   168,   221,    39,    40,
      82,    83,    85,    86,   101,   102,   132,   133,   218,   143,
     234,   234,    55,   170,   171,   234,    75,   219,    56,    78,
     150,   151,   158,    11,    12,    24,   160,   235,     1,    33,
      75,   131,   172,   173,   176,   177,   178,   179,   180,   182,
     213,   214,   215,   216,   228,   229,   230,   231,    55,    55,
      75,    35,   152,   232,   126,   144,   218,   227,   234,    21,
      48,    54,    78,   116,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   211,   212,   213,   199,    37,
      78,    14,    41,   178,   180,   182,    55,   218,   218,   233,
      58,   118,   153,    78,   145,   146,   232,   150,   234,   209,
     199,   105,   195,     3,    23,    25,     3,    17,    20,    23,
      25,     6,    18,   210,    36,   183,   111,   217,   232,    72,
     226,    78,   223,   224,   150,   150,   232,   149,   232,    44,
     103,   169,   107,   116,   197,   109,   196,   204,   204,   204,
     204,   204,   204,   204,   204,   205,   207,   108,   153,   233,
     119,   225,   199,     4,   126,   167,   169,   147,    66,   128,
     198,   234,   229,   232,   181,   233,   174,   211,   234,   234,
     148,    14,   233,   186,   187,   199,   171,   175,    56,   233,
     226,   129,   234,    28,   188,   235,   149,   225,   199,   189,
     232,    41,   185,   186,    63,    68,    81,    88,    97,   123,
     190,    75,   222,   231,   184,   129,   234,    56,   234,    92,
     191,   194,   211,   213,   185,   192,   193,    45,   194
};

/* BVL_Y_R1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const bvl_y_type_uint8 bvl_y_r1[] =
{
       0,   134,   136,   135,   138,   137,   137,   139,   139,   140,
     140,   141,   142,   142,   143,   143,   144,   145,   145,   147,
     146,   148,   148,   149,   150,   150,   151,   152,   153,   153,
     154,   154,   155,   155,   156,   157,   157,   158,   158,   159,
     159,   160,   160,   160,   160,   162,   161,   161,   163,   164,
     164,   165,   165,   165,   166,   167,   168,   169,   169,   169,
     170,   171,   171,   172,   172,   172,   172,   174,   173,   175,
     176,   176,   177,   177,   177,   177,   178,   179,   180,   181,
     181,   183,   182,   184,   184,   185,   186,   187,   188,   188,
     189,   190,   190,   190,   190,   190,   192,   191,   193,   193,
     194,   194,   194,   195,   195,   196,   196,   197,   198,   198,
     199,   199,   199,   199,   200,   200,   201,   201,   202,   202,
     202,   203,   203,   204,   204,   205,   206,   206,   207,   208,
     208,   209,   209,   209,   210,   210,   211,   211,   211,   212,
     213,   213,   213,   213,   214,   215,   216,   217,   218,   218,
     218,   218,   218,   218,   218,   218,   218,   218,   220,   219,
     221,   221,   222,   222,   223,   223,   224,   225,   225,   226,
     226,   227,   227,   228,   229,   230,   231,   232,   233,   234,
     235
};

/* BVL_Y_R2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const bvl_y_type_int8 bvl_y_r2[] =
{
       0,     2,     0,     3,     0,     9,     2,     0,     1,     5,
       3,     2,     0,     3,     6,     1,     2,     1,     1,     0,
       5,     0,     3,     1,     0,     1,     3,     3,     1,     1,
       0,     1,     5,     3,     2,     0,     3,     7,     1,     0,
       1,     0,     1,     1,     1,     0,    12,     2,     1,     0,
       2,     1,     1,     2,     7,     2,     7,     0,     1,     1,
       1,     0,     2,     1,     1,     1,     2,     0,    10,     1,
       2,     1,     2,     1,     2,     1,     1,     5,     7,     0,
       5,     0,    11,     0,     3,     3,     1,     2,     0,     2,
       2,     1,     1,     1,     1,     1,     0,     3,     0,     3,
       1,     1,     1,     0,     2,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     1,     3,     1,     1,     3,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     4,     6,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     0,     1,     0,     1,     3,     0,     1,     0,
       1,     0,     1,     1,     1,     2,     1,     1,     1,     1,
       1
};


enum { BVL_Y_ENOMEM = -2 };

#define bvl_y_errok         (bvl_y_errstatus = 0)
#define bvl_y_clearin       (bvl_y_char = BVL_Y_EMPTY)

#define BVL_Y_ACCEPT        goto bvl_y_acceptlab
#define BVL_Y_ABORT         goto bvl_y_abortlab
#define BVL_Y_ERROR         goto bvl_y_errorlab
#define BVL_Y_NOMEM         goto bvl_y_exhaustedlab


#define BVL_Y_RECOVERING()  (!!bvl_y_errstatus)

#define BVL_Y_BACKUP(Token, Value)                                    \
  do                                                              \
    if (bvl_y_char == BVL_Y_EMPTY)                                        \
      {                                                           \
        bvl_y_char = (Token);                                         \
        bvl_y_lval = (Value);                                         \
        BVL_Y_POPSTACK (bvl_y_len);                                       \
        bvl_y_state = *bvl_y_ssp;                                         \
        goto bvl_y_backup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        bvl_y_error (BVL_Y__("syntax error: cannot back up")); \
        BVL_Y_ERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use BVL_Y_error or BVL_Y_UNDEF. */
#define BVL_Y_ERRCODE BVL_Y_UNDEF


/* Enable debugging if requested.  */
#if BVL_Y_DEBUG

# ifndef BVL_Y_FPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define BVL_Y_FPRINTF fprintf
# endif

# define BVL_Y_DPRINTF(Args)                        \
do {                                            \
  if (bvl_y_debug)                                  \
    BVL_Y_FPRINTF Args;                             \
} while (0)




# define BVL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (bvl_y_debug)                                                            \
    {                                                                     \
      BVL_Y_FPRINTF (stderr, "%s ", Title);                                   \
      bvl_y__symbol_print (stderr,                                            \
                  Kind, Value); \
      BVL_Y_FPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on BVL_Y_O.  |
`-----------------------------------*/

static void
bvl_y__symbol_value_print (FILE *bvl_y_o,
                       bvl_y_symbol_kind_t bvl_y_kind, BVL_Y_STYPE const * const bvl_y_valuep)
{
  FILE *bvl_y_output = bvl_y_o;
  BVL_Y__USE (bvl_y_output);
  if (!bvl_y_valuep)
    return;
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  BVL_Y__USE (bvl_y_kind);
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on BVL_Y_O.  |
`---------------------------*/

static void
bvl_y__symbol_print (FILE *bvl_y_o,
                 bvl_y_symbol_kind_t bvl_y_kind, BVL_Y_STYPE const * const bvl_y_valuep)
{
  BVL_Y_FPRINTF (bvl_y_o, "%s %s (",
             bvl_y_kind < BVL_Y_NTOKENS ? "token" : "nterm", bvl_y_symbol_name (bvl_y_kind));

  bvl_y__symbol_value_print (bvl_y_o, bvl_y_kind, bvl_y_valuep);
  BVL_Y_FPRINTF (bvl_y_o, ")");
}

/*------------------------------------------------------------------.
| bvl_y__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
bvl_y__stack_print (bvl_y__state_t *bvl_y_bottom, bvl_y__state_t *bvl_y_top)
{
  BVL_Y_FPRINTF (stderr, "Stack now");
  for (; bvl_y_bottom <= bvl_y_top; bvl_y_bottom++)
    {
      int bvl_y_bot = *bvl_y_bottom;
      BVL_Y_FPRINTF (stderr, " %d", bvl_y_bot);
    }
  BVL_Y_FPRINTF (stderr, "\n");
}

# define BVL_Y__STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (bvl_y_debug)                                                  \
    bvl_y__stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the BVL_Y_RULE is going to be reduced.  |
`------------------------------------------------*/

static void
bvl_y__reduce_print (bvl_y__state_t *bvl_y_ssp, BVL_Y_STYPE *bvl_y_vsp,
                 int bvl_y_rule)
{
  int bvl_y_lno = bvl_y_rline[bvl_y_rule];
  int bvl_y_nrhs = bvl_y_r2[bvl_y_rule];
  int bvl_y_i;
  BVL_Y_FPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             bvl_y_rule - 1, bvl_y_lno);
  /* The symbols being reduced.  */
  for (bvl_y_i = 0; bvl_y_i < bvl_y_nrhs; bvl_y_i++)
    {
      BVL_Y_FPRINTF (stderr, "   $%d = ", bvl_y_i + 1);
      bvl_y__symbol_print (stderr,
                       BVL_Y__ACCESSING_SYMBOL (+bvl_y_ssp[bvl_y_i + 1 - bvl_y_nrhs]),
                       &bvl_y_vsp[(bvl_y_i + 1) - (bvl_y_nrhs)]);
      BVL_Y_FPRINTF (stderr, "\n");
    }
}

# define BVL_Y__REDUCE_PRINT(Rule)          \
do {                                    \
  if (bvl_y_debug)                          \
    bvl_y__reduce_print (bvl_y_ssp, bvl_y_vsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int bvl_y_debug;
#else /* !BVL_Y_DEBUG */
# define BVL_Y_DPRINTF(Args) ((void) 0)
# define BVL_Y__SYMBOL_PRINT(Title, Kind, Value, Location)
# define BVL_Y__STACK_PRINT(Bottom, Top)
# define BVL_Y__REDUCE_PRINT(Rule)
#endif /* !BVL_Y_DEBUG */


/* BVL_Y_INITDEPTH -- initial size of the parser's stacks.  */
#ifndef BVL_Y_INITDEPTH
# define BVL_Y_INITDEPTH 200
#endif

/* BVL_Y_MAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   BVL_Y_STACK_ALLOC_MAXIMUM < BVL_Y_STACK_BYTES (BVL_Y_MAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef BVL_Y_MAXDEPTH
# define BVL_Y_MAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
bvl_y_destruct (const char *bvl_y_msg,
            bvl_y_symbol_kind_t bvl_y_kind, BVL_Y_STYPE *bvl_y_valuep)
{
  BVL_Y__USE (bvl_y_valuep);
  if (!bvl_y_msg)
    bvl_y_msg = "Deleting";
  BVL_Y__SYMBOL_PRINT (bvl_y_msg, bvl_y_kind, bvl_y_valuep, bvl_y_locationp);

  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  BVL_Y__USE (bvl_y_kind);
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int bvl_y_char;

/* The semantic value of the lookahead symbol.  */
BVL_Y_STYPE bvl_y_lval;
/* Number of syntax errors so far.  */
int bvl_y_nerrs;




/*----------.
| bvl_y_parse.  |
`----------*/

int
bvl_y_parse (void)
{
    bvl_y__state_fast_t bvl_y_state = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int bvl_y_errstatus = 0;

    /* Refer to the stacks through separate pointers, to allow bvl_y_overflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    BVL_Y_PTRDIFF_T bvl_y_stacksize = BVL_Y_INITDEPTH;

    /* The state stack: array, bottom, top.  */
    bvl_y__state_t bvl_y_ssa[BVL_Y_INITDEPTH];
    bvl_y__state_t *bvl_y_ss = bvl_y_ssa;
    bvl_y__state_t *bvl_y_ssp = bvl_y_ss;

    /* The semantic value stack: array, bottom, top.  */
    BVL_Y_STYPE bvl_y_vsa[BVL_Y_INITDEPTH];
    BVL_Y_STYPE *bvl_y_vs = bvl_y_vsa;
    BVL_Y_STYPE *bvl_y_vsp = bvl_y_vs;

  int bvl_y_n;
  /* The return value of bvl_y_parse.  */
  int bvl_y_result;
  /* Lookahead symbol kind.  */
  bvl_y_symbol_kind_t bvl_y_token = BVL_Y_SYMBOL_BVL_Y_EMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  BVL_Y_STYPE bvl_y_val;



#define BVL_Y_POPSTACK(N)   (bvl_y_vsp -= (N), bvl_y_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int bvl_y_len = 0;

  BVL_Y_DPRINTF ((stderr, "Starting parse\n"));

  bvl_y_char = BVL_Y_EMPTY; /* Cause a token to be read.  */

  goto bvl_y_setstate;


/*------------------------------------------------------------.
| bvl_y_newstate -- push a new state, which is found in bvl_y_state.  |
`------------------------------------------------------------*/
bvl_y_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  bvl_y_ssp++;


/*--------------------------------------------------------------------.
| bvl_y_setstate -- set current state (the top of the stack) to bvl_y_state.  |
`--------------------------------------------------------------------*/
bvl_y_setstate:
  BVL_Y_DPRINTF ((stderr, "Entering state %d\n", bvl_y_state));
  BVL_Y__ASSERT (0 <= bvl_y_state && bvl_y_state < BVL_Y_NSTATES);
  BVL_Y__IGNORE_USELESS_CAST_BEGIN
  *bvl_y_ssp = BVL_Y__CAST (bvl_y__state_t, bvl_y_state);
  BVL_Y__IGNORE_USELESS_CAST_END
  BVL_Y__STACK_PRINT (bvl_y_ss, bvl_y_ssp);

  if (bvl_y_ss + bvl_y_stacksize - 1 <= bvl_y_ssp)
#if !defined bvl_y_overflow && !defined BVL_Y_STACK_RELOCATE
    BVL_Y_NOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      BVL_Y_PTRDIFF_T bvl_y_size = bvl_y_ssp - bvl_y_ss + 1;

# if defined bvl_y_overflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        bvl_y__state_t *bvl_y_ss1 = bvl_y_ss;
        BVL_Y_STYPE *bvl_y_vs1 = bvl_y_vs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if bvl_y_overflow is a macro.  */
        bvl_y_overflow (BVL_Y__("memory exhausted"),
                    &bvl_y_ss1, bvl_y_size * BVL_Y_SIZEOF (*bvl_y_ssp),
                    &bvl_y_vs1, bvl_y_size * BVL_Y_SIZEOF (*bvl_y_vsp),
                    &bvl_y_stacksize);
        bvl_y_ss = bvl_y_ss1;
        bvl_y_vs = bvl_y_vs1;
      }
# else /* defined BVL_Y_STACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (BVL_Y_MAXDEPTH <= bvl_y_stacksize)
        BVL_Y_NOMEM;
      bvl_y_stacksize *= 2;
      if (BVL_Y_MAXDEPTH < bvl_y_stacksize)
        bvl_y_stacksize = BVL_Y_MAXDEPTH;

      {
        bvl_y__state_t *bvl_y_ss1 = bvl_y_ss;
        union bvl_y_alloc *bvl_y_ptr =
          BVL_Y__CAST (union bvl_y_alloc *,
                   BVL_Y_STACK_ALLOC (BVL_Y__CAST (BVL_Y_SIZE_T, BVL_Y_STACK_BYTES (bvl_y_stacksize))));
        if (! bvl_y_ptr)
          BVL_Y_NOMEM;
        BVL_Y_STACK_RELOCATE (bvl_y_ss_alloc, bvl_y_ss);
        BVL_Y_STACK_RELOCATE (bvl_y_vs_alloc, bvl_y_vs);
#  undef BVL_Y_STACK_RELOCATE
        if (bvl_y_ss1 != bvl_y_ssa)
          BVL_Y_STACK_FREE (bvl_y_ss1);
      }
# endif

      bvl_y_ssp = bvl_y_ss + bvl_y_size - 1;
      bvl_y_vsp = bvl_y_vs + bvl_y_size - 1;

      BVL_Y__IGNORE_USELESS_CAST_BEGIN
      BVL_Y_DPRINTF ((stderr, "Stack size increased to %ld\n",
                  BVL_Y__CAST (long, bvl_y_stacksize)));
      BVL_Y__IGNORE_USELESS_CAST_END

      if (bvl_y_ss + bvl_y_stacksize - 1 <= bvl_y_ssp)
        BVL_Y_ABORT;
    }
#endif /* !defined bvl_y_overflow && !defined BVL_Y_STACK_RELOCATE */


  if (bvl_y_state == BVL_Y_FINAL)
    BVL_Y_ACCEPT;

  goto bvl_y_backup;


/*-----------.
| bvl_y_backup.  |
`-----------*/
bvl_y_backup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  bvl_y_n = bvl_y_pact[bvl_y_state];
  if (bvl_y_pact_value_is_default (bvl_y_n))
    goto bvl_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* BVL_Y_CHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (bvl_y_char == BVL_Y_EMPTY)
    {
      BVL_Y_DPRINTF ((stderr, "Reading a token\n"));
      bvl_y_char = bvl_y_lex ();
    }

  if (bvl_y_char <= BVL_Y_EOF)
    {
      bvl_y_char = BVL_Y_EOF;
      bvl_y_token = BVL_Y_SYMBOL_BVL_Y_EOF;
      BVL_Y_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (bvl_y_char == BVL_Y_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      bvl_y_char = BVL_Y_UNDEF;
      bvl_y_token = BVL_Y_SYMBOL_BVL_Y_error;
      goto bvl_y_errlab1;
    }
  else
    {
      bvl_y_token = BVL_Y_TRANSLATE (bvl_y_char);
      BVL_Y__SYMBOL_PRINT ("Next token is", bvl_y_token, &bvl_y_lval, &bvl_y_lloc);
    }

  /* If the proper action on seeing token BVL_Y_TOKEN is to reduce or to
     detect an error, take that action.  */
  bvl_y_n += bvl_y_token;
  if (bvl_y_n < 0 || BVL_Y_LAST < bvl_y_n || bvl_y_check[bvl_y_n] != bvl_y_token)
    goto bvl_y_default;
  bvl_y_n = bvl_y_table[bvl_y_n];
  if (bvl_y_n <= 0)
    {
      if (bvl_y_table_value_is_error (bvl_y_n))
        goto bvl_y_errlab;
      bvl_y_n = -bvl_y_n;
      goto bvl_y_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (bvl_y_errstatus)
    bvl_y_errstatus--;

  /* Shift the lookahead token.  */
  BVL_Y__SYMBOL_PRINT ("Shifting", bvl_y_token, &bvl_y_lval, &bvl_y_lloc);
  bvl_y_state = bvl_y_n;
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++bvl_y_vsp = bvl_y_lval;
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  bvl_y_char = BVL_Y_EMPTY;
  goto bvl_y_newstate;


/*-----------------------------------------------------------.
| bvl_y_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
bvl_y_default:
  bvl_y_n = bvl_y_defact[bvl_y_state];
  if (bvl_y_n == 0)
    goto bvl_y_errlab;
  goto bvl_y_reduce;


/*-----------------------------.
| bvl_y_reduce -- do a reduction.  |
`-----------------------------*/
bvl_y_reduce:
  /* bvl_y_n is the number of a rule to reduce with.  */
  bvl_y_len = bvl_y_r2[bvl_y_n];

  /* If BVL_Y_LEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets BVL_Y_VAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to BVL_Y_VAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that BVL_Y_VAL may be used uninitialized.  */
  bvl_y_val = bvl_y_vsp[1-bvl_y_len];


  BVL_Y__REDUCE_PRINT (bvl_y_n);
  switch (bvl_y_n)
    {
  case 2: /* $@1: %empty  */
#line 1559 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*    Initializations					*/
		/*      - initialize the time unit conversion variables	*/
		/*      - erroneous  description presumed !		*/
		/*      - zero delay description presumed !		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = NULL;
		BVL_GRDLST = NULL;
		BVL_CNDLST = NULL;
		BVL_VALLST = NULL;
		BVL_ERRFLG = 0;
		switch (BEH_TIMEUNIT)
		  {
		  case BEH_TU__FS :
		    BVL_CNVFS = 1      ;
		    BVL_CNVPS = 1.0E+3 ;
		    BVL_CNVNS = 1.0E+6 ;
		    BVL_CNVUS = 1.0E+9 ;
		    BVL_CNVMS = 1.0E+12;
		    break;

		  case BEH_TU__PS :
		    BVL_CNVFS = 1.0E-3 ;
		    BVL_CNVPS = 1      ;
		    BVL_CNVNS = 1.0E+3 ;
		    BVL_CNVUS = 1.0E+6 ;
		    BVL_CNVMS = 1.0E+9 ;
		    break;

		  case BEH_TU__NS :
		    BVL_CNVFS = 1.0E-6 ;
		    BVL_CNVPS = 1.0E-3 ;
		    BVL_CNVNS = 1      ;
		    BVL_CNVUS = 1.0E+3 ;
		    BVL_CNVMS = 1.0E+6 ;
		    break;

		  case BEH_TU__US :
		    BVL_CNVFS = 1.0E-9 ;
		    BVL_CNVPS = 1.0E-6 ;
		    BVL_CNVNS = 1.0E-3 ;
		    BVL_CNVUS = 1      ;
		    BVL_CNVMS = 1.0E+3 ;
		    break;

		  case BEH_TU__MS :
		    BVL_CNVFS = 1.0E-12;
		    BVL_CNVPS = 1.0E-9 ;
		    BVL_CNVNS = 1.0E-6 ;
		    BVL_CNVUS = 1.0E-3 ;
		    BVL_CNVMS = 1      ;
		    break;

		  default :
		    BVL_CNVFS = 1      ;
		    BVL_CNVPS = 1      ;
		    BVL_CNVNS = 1      ;
		    BVL_CNVUS = 1      ;
		    BVL_CNVMS = 1      ;
		    bvl_error (83, NULL);
		  }

		if (BVL_ERRFLG == 0)
		  {
		  BVL_CNVFS = BVL_CNVFS / BEH_TIMESTEP;
		  BVL_CNVPS = BVL_CNVPS / BEH_TIMESTEP;
		  BVL_CNVNS = BVL_CNVNS / BEH_TIMESTEP;
		  BVL_CNVUS = BVL_CNVUS / BEH_TIMESTEP;
		  BVL_CNVMS = BVL_CNVMS / BEH_TIMESTEP;
		  }

		dic                 = beh_initab ();
		BVL_BEFPNT          = beh_addbefig (BVL_HEDFIG, NULL);
		BVL_BEFPNT->FLAG   |= BEH_FIG_ZERODELAY;
		BVL_BEFPNT->ERRFLG  = 1;
		BVL_HEDFIG          = BVL_BEFPNT;
		}
#line 3292 "y.tab.c"
    break;

  case 3: /* design_file: $@1 entity_declaration architecture_body  */
#line 1640 "./bvl_bcomp_y.y"
                {
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->ERRFLG = 0;

		beh_fretab (dic);
		}
#line 3303 "y.tab.c"
    break;

  case 4: /* $@2: %empty  */
#line 1652 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->NAME = (bvl_y_vsp[-1].text);
		BVL_MODNAM       = (bvl_y_vsp[-1].text);
		}
#line 3312 "y.tab.c"
    break;

  case 5: /* entity_declaration: ENTITY simple_name IS $@2 .generic_clause. .port_clause. END_ERR .simple_name. Semicolon_ERR  */
#line 1661 "./bvl_bcomp_y.y"
                {
		if (((bvl_y_vsp[-1].text) != NULL) && ((bvl_y_vsp[-1].text) != (bvl_y_vsp[-7].text)))
		  bvl_error (1, (bvl_y_vsp[-1].text));
		}
#line 3321 "y.tab.c"
    break;

  case 6: /* entity_declaration: ENTITY error  */
#line 1667 "./bvl_bcomp_y.y"
                {
		bvl_error (2, NULL);
		}
#line 3329 "y.tab.c"
    break;

  case 8: /* .generic_clause.: generic_clause  */
#line 1675 "./bvl_bcomp_y.y"
                {
		BVL_BEFPNT->BEGEN = BVL_GENPNT;
		BVL_GENPNT        = NULL      ;
		}
#line 3338 "y.tab.c"
    break;

  case 10: /* generic_clause: GENERIC error Semicolon_ERR  */
#line 1690 "./bvl_bcomp_y.y"
                { bvl_error (74, NULL); }
#line 3344 "y.tab.c"
    break;

  case 14: /* formal_generic_element: CONSTANT identifier_list Colon type_mark .constraint. generic_VarAsgn__expression  */
#line 1712 "./bvl_bcomp_y.y"
                {
		char *type;

		if ((bvl_y_vsp[-1].name).FLAG == (bvl_y_vsp[-2].dble).FLAG)
		  {
		  BVL_NM1LST = reverse   (BVL_NM1LST);
		  type       = namealloc ("natural");
		  BVL_GENPNT = addgen (BVL_GENPNT, BVL_INTLST, BVL_NM1LST,
		                       type, (bvl_y_vsp[-1].name).LEFT, (bvl_y_vsp[-1].name).RIGHT);
		  }
		else
		  bvl_error (33, NULL);
		freechain (BVL_NM1LST);
		freechain (BVL_INTLST);
		BVL_NM1LST = NULL;
		BVL_INTLST = NULL;
		}
#line 3366 "y.tab.c"
    break;

  case 15: /* formal_generic_element: error  */
#line 1730 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  bvl_y_char = bvl_y_lex ();
		while ((bvl_y_char != Semicolon) && (bvl_y_char != 0));
		bvl_y_errok;
		bvl_error (75, NULL);
		}
#line 3383 "y.tab.c"
    break;

  case 17: /* generic_expression: abstractlit  */
#line 1751 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (bvl_y_vsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		}
#line 3395 "y.tab.c"
    break;

  case 19: /* $@3: %empty  */
#line 1764 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (bvl_y_vsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		}
#line 3407 "y.tab.c"
    break;

  case 22: /* ...generic_element_association..: ...generic_element_association.. Comma generic_element_association  */
#line 1780 "./bvl_bcomp_y.y"
                {
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = (bvl_y_vsp[0].valu);
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		}
#line 3419 "y.tab.c"
    break;

  case 23: /* generic_element_association: abstractlit  */
#line 1791 "./bvl_bcomp_y.y"
                {(bvl_y_val.valu) = (bvl_y_vsp[0].valu);}
#line 3425 "y.tab.c"
    break;

  case 24: /* .constraint.: %empty  */
#line 1796 "./bvl_bcomp_y.y"
                {
		(bvl_y_val.name).FLAG  = 'S';
		(bvl_y_val.name).LEFT  = -1;
		(bvl_y_val.name).RIGHT = -1;
		}
#line 3435 "y.tab.c"
    break;

  case 25: /* .constraint.: constraint  */
#line 1802 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[0].name); }
#line 3441 "y.tab.c"
    break;

  case 26: /* constraint: LeftParen range RightParen_ERR  */
#line 1809 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[-1].name); }
#line 3447 "y.tab.c"
    break;

  case 27: /* range: abstractlit direction abstractlit  */
#line 1816 "./bvl_bcomp_y.y"
                {
		(bvl_y_val.name).FLAG  = 'A';
		(bvl_y_val.name).LEFT  = (bvl_y_vsp[-2].valu);
		(bvl_y_val.name).RIGHT = (bvl_y_vsp[0].valu);

		if ((((bvl_y_vsp[-2].valu) > (bvl_y_vsp[0].valu)) && ((bvl_y_vsp[-1].valu) == BVL_UPTDFN)) ||
		    (((bvl_y_vsp[-2].valu) < (bvl_y_vsp[0].valu)) && ((bvl_y_vsp[-1].valu) == BVL_DWTDFN)) ||
		    (((bvl_y_vsp[-2].valu) < 0 ) || ((bvl_y_vsp[-1].valu) < 0 )))
		  {
		  bvl_error (32, NULL);
		  }
		}
#line 3464 "y.tab.c"
    break;

  case 28: /* direction: TO  */
#line 1832 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BVL_UPTDFN; }
#line 3470 "y.tab.c"
    break;

  case 29: /* direction: DOWNTO  */
#line 1834 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BVL_DWTDFN; }
#line 3476 "y.tab.c"
    break;

  case 33: /* port_clause: PORT error Semicolon_ERR  */
#line 1851 "./bvl_bcomp_y.y"
                { bvl_error (3, NULL); }
#line 3482 "y.tab.c"
    break;

  case 37: /* formal_port_element: .SIGNAL. identifier_list Colon .mode. type_mark .constraint. .signal_kind.  */
#line 1874 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each port, create the apropriate set of	*/
		/* structures (berin, bepor, beout, bebus)		*/
		/* ###----------------------------------------------### */

		chkdcl ('P', (bvl_y_vsp[-3].valu), (bvl_y_vsp[-2].dble).VALU, (bvl_y_vsp[-2].dble).FLAG, (bvl_y_vsp[0].valu), (bvl_y_vsp[-1].name).FLAG, &sigconf);

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic, signame, BVL_MODNAM, BVL_SIGDFN) != 0)
		    bvl_error (4, signame);

		  pnt = addstr (BVL_BEFPNT, 'P', (bvl_y_vsp[-3].valu), (bvl_y_vsp[-2].dble).VALU, (bvl_y_vsp[-2].dble).FLAG, signame,
		                (bvl_y_vsp[-1].name).LEFT, (bvl_y_vsp[-1].name).RIGHT);

		  beh_addtab (dic, signame, BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMNDFN, (bvl_y_vsp[-1].name).LEFT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMXDFN, (bvl_y_vsp[-1].name).RIGHT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_PNTDFN, (long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		}
#line 3518 "y.tab.c"
    break;

  case 38: /* formal_port_element: error  */
#line 1906 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  bvl_y_char = bvl_y_lex ();
		while ((bvl_y_char != Semicolon) && (bvl_y_char != 0));
		bvl_y_errok;

		bvl_error (6, NULL);
		}
#line 3536 "y.tab.c"
    break;

  case 41: /* .mode.: %empty  */
#line 1928 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = _IN; }
#line 3542 "y.tab.c"
    break;

  case 42: /* .mode.: _IN  */
#line 1930 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = _IN; }
#line 3548 "y.tab.c"
    break;

  case 43: /* .mode.: _OUT  */
#line 1932 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = _OUT; }
#line 3554 "y.tab.c"
    break;

  case 44: /* .mode.: _INOUT  */
#line 1934 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = _INOUT; }
#line 3560 "y.tab.c"
    break;

  case 45: /* $@4: %empty  */
#line 1943 "./bvl_bcomp_y.y"
                {
		if ((bvl_y_vsp[-1].text) != BVL_MODNAM)
		  bvl_error (1, (bvl_y_vsp[-1].text));
		}
#line 3569 "y.tab.c"
    break;

  case 46: /* architecture_body: ARCHITECTURE Identifier OF simple_name IS $@4 architecture_declarative_part _BEGIN architecture_statement_part END_ERR .simple_name. Semicolon_ERR  */
#line 1953 "./bvl_bcomp_y.y"
                {
		if (((bvl_y_vsp[-1].text) != NULL) && ((bvl_y_vsp[-1].text) != (bvl_y_vsp[-10].text)))
		  bvl_error (7, (bvl_y_vsp[-1].text));
		}
#line 3578 "y.tab.c"
    break;

  case 47: /* architecture_body: ARCHITECTURE error  */
#line 1959 "./bvl_bcomp_y.y"
                { bvl_error (8, NULL); }
#line 3584 "y.tab.c"
    break;

  case 53: /* block_declarative_item: error Semicolon_ERR  */
#line 1977 "./bvl_bcomp_y.y"
                { bvl_error (9, NULL); }
#line 3590 "y.tab.c"
    break;

  case 54: /* constant_declaration: CONSTANT Identifier Colon type_mark .constraint. constant_VarAsgn__expression Semicolon_ERR  */
#line 1988 "./bvl_bcomp_y.y"
                {
		long sigconf;
		
		if (chkdcl ('C', 0, (bvl_y_vsp[-3].dble).VALU, (bvl_y_vsp[-3].dble).FLAG, 0, (bvl_y_vsp[-2].name).FLAG, &sigconf)==0)
		  {
		  beh_addtab (dic, (bvl_y_vsp[-5].text), BVL_MODNAM, BVL_WMNDFN, (bvl_y_vsp[-2].name).LEFT);
		  beh_addtab (dic, (bvl_y_vsp[-5].text), BVL_MODNAM, BVL_WMXDFN, (bvl_y_vsp[-2].name).RIGHT);
		  beh_addtab (dic, (bvl_y_vsp[-5].text), BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, (bvl_y_vsp[-5].text), NULL, BVL_PNTDFN, (bvl_y_vsp[-1].text));
		  }
		}
#line 3606 "y.tab.c"
    break;

  case 55: /* constant_VarAsgn__expression: VarAsgn literal  */
#line 2004 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 3612 "y.tab.c"
    break;

  case 56: /* signal_declaration: SIGNAL identifier_list Colon type_mark .constraint. .signal_kind. Semicolon_ERR  */
#line 2015 "./bvl_bcomp_y.y"
                {
		char *signame;
		long   sigconf;
		void *pnt;

		chkdcl ('S',0,(bvl_y_vsp[-3].dble).VALU,(bvl_y_vsp[-3].dble).FLAG,(bvl_y_vsp[-1].valu),(bvl_y_vsp[-2].name).FLAG,&sigconf);

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each signal, create the apropriate set of	*/
		/* structures (berin, bereg, beaux, bebux)		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic, signame, BVL_MODNAM, BVL_SIGDFN) != 0)
		    bvl_error (10, signame);

		  pnt = addstr (BVL_BEFPNT, 'S', 0, (bvl_y_vsp[-3].dble).VALU, (bvl_y_vsp[-3].dble).FLAG, signame,
		                (bvl_y_vsp[-2].name).LEFT, (bvl_y_vsp[-2].name).RIGHT);

		  beh_addtab (dic, signame, BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMNDFN, (bvl_y_vsp[-2].name).LEFT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMXDFN, (bvl_y_vsp[-2].name).RIGHT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_PNTDFN, (long)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		}
#line 3648 "y.tab.c"
    break;

  case 57: /* .signal_kind.: %empty  */
#line 2050 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = 0; }
#line 3654 "y.tab.c"
    break;

  case 58: /* .signal_kind.: REGISTER  */
#line 2052 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = REGISTER; }
#line 3660 "y.tab.c"
    break;

  case 59: /* .signal_kind.: BUS  */
#line 2054 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BUS; }
#line 3666 "y.tab.c"
    break;

  case 66: /* concurrent_statement: error Semicolon_ERR  */
#line 2073 "./bvl_bcomp_y.y"
                { bvl_error (18, NULL); }
#line 3672 "y.tab.c"
    break;

  case 67: /* $@5: %empty  */
#line 2081 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic, (bvl_y_vsp[-3].text), BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, (bvl_y_vsp[-3].text));

		beh_addtab (dic, (bvl_y_vsp[-3].text), BVL_MODNAM, BVL_LBLDFN, 1);
		if ((bvl_y_vsp[-1].text) != NULL)
		  BVL_GRDLST = addchain (BVL_GRDLST, (char *)(bvl_y_vsp[-1].text));
		}
#line 3685 "y.tab.c"
    break;

  case 68: /* block_statement: a_label BLOCK .guard_expression. _BEGIN $@5 set_of_statements END_ERR BLOCK .label. Semicolon_ERR  */
#line 2094 "./bvl_bcomp_y.y"
                {
		if ((bvl_y_vsp[-7].text) != NULL)
		  BVL_GRDLST = delchain (BVL_GRDLST, BVL_GRDLST);
		if (((bvl_y_vsp[-1].text) != NULL) && ((bvl_y_vsp[-1].text) != (bvl_y_vsp[-9].text)))
		  bvl_error (20, (bvl_y_vsp[-1].text));
		}
#line 3696 "y.tab.c"
    break;

  case 70: /* concurrent_assertion_statement: a_label unlabeled_concurrent_assertion_statement  */
#line 2109 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, (bvl_y_vsp[-1].text));

		beh_addtab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN, 1);
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->BEMSG->LABEL = (bvl_y_vsp[-1].text);
		}
#line 3709 "y.tab.c"
    break;

  case 72: /* concurrent_signal_assignment_statement: a_label unlabeled_conditional_signal_assignment  */
#line 2123 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, (bvl_y_vsp[-1].text));
		beh_addtab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN, 1);
		}
#line 3719 "y.tab.c"
    break;

  case 74: /* concurrent_signal_assignment_statement: a_label unlabeled_selected_signal_assignment  */
#line 2131 "./bvl_bcomp_y.y"
                {
		if (beh_chktab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, (bvl_y_vsp[-1].text));
		beh_addtab (dic, (bvl_y_vsp[-1].text), BVL_MODNAM, BVL_LBLDFN, 1);
		}
#line 3729 "y.tab.c"
    break;

  case 77: /* assertion_statement: ASSERT expression .REPORT__expression. .SEVERITY__expression. Semicolon_ERR  */
#line 2149 "./bvl_bcomp_y.y"
                {
		if (BVL_ERRFLG == 0)
		  {
		  BVL_BEFPNT->BEMSG = beh_addbemsg(BVL_BEFPNT->BEMSG, NULL, (bvl_y_vsp[-1].valu),
		                                   (bvl_y_vsp[-2].text), (bvl_y_vsp[-3].list).LIST_ABL->DATA, NULL);
		  }
		}
#line 3741 "y.tab.c"
    break;

  case 78: /* unlabeled_conditional_signal_assignment: target _LESym .GUARDED. .TRANSPORT. ..waveform__WHEN__condition__ELSE.. waveform Semicolon_ERR  */
#line 2166 "./bvl_bcomp_y.y"
                {
		long             i        ;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt  ;
		unsigned long   delay    ;
		struct bvl_expr expr0    ;
		struct bvl_expr expr1    ;
		struct bvl_expr expr2    ;
		struct bvl_expr expr3    ;
		struct bvl_expr expr4    ;
		struct bvl_expr expr5    ;
		struct bvl_expr expr6    ;
		long             rev_flg  = 0;
		long             left_bnd ;
		long             right_bnd;
		long             left     ;
		long             right    ;
		long             in_bound ;
		long             out_bound;
		long             sig_width;
		long             sig_conf ;

		delay = (bvl_y_vsp[-1].list).TIME;
		expr4 = (bvl_y_vsp[-1].list)     ;

		while (BVL_CNDLST != NULL)
		  {
		  expr5 = *((bvl_ablstr *) BVL_CNDLST->DATA);
		  expr6 = *((bvl_ablstr *) BVL_VALLST->DATA);

		  expr0 = cpyablstr (expr5);
		  expr1 = crtabl (NOT , expr5, BVL_EMPSTR, -1, -1);
		  expr5 = expr0;
		  expr2 = crtabl (ANDM, expr4, expr1     , -1, -1);
		  expr3 = crtabl (ANDM, expr6, expr5     , -1, -1);
		  expr4 = crtabl (OR  , expr2, expr3     , -1, -1);

		  BVL_CNDLST = delchain (BVL_CNDLST, BVL_CNDLST);
		  BVL_VALLST = delchain (BVL_VALLST, BVL_VALLST);
		  }

		left_bnd  = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_WMXDFN);
		sig_conf  = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_SIGDFN);

		left  = (bvl_y_vsp[-6].name).LEFT ;
		right = (bvl_y_vsp[-6].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left ;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left ;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr4.WIDTH)
		  bvl_error (35, (bvl_y_vsp[-6].name).NAME);

		if (rev_flg == 1)
		  expr4.LIST_ABL = reverse (expr4.LIST_ABL);

		abl_pnt = expr4.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21, (bvl_y_vsp[-6].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((bvl_y_vsp[-4].valu) == BVL_GRDDFN)
		      bvl_error (22, (bvl_y_vsp[-6].name).NAME);
		    beout_pnt = (struct beout *)
		                 beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39, beout_pnt->NAME);
		          else
		            {
		            beout_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beout_pnt->TIME = delay;
		            beout_pnt->FLAG = (bvl_y_vsp[-3].valu)   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bebus_pnt = (struct bebus *)
		                 beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL, NULL);
		          bebus_pnt->BINODE->TIME = delay;
		          bebus_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebus_pnt->BIABL->TIME = delay;
		          bebus_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((bvl_y_vsp[-4].valu) == BVL_GRDDFN)
		      bvl_error (22, (bvl_y_vsp[-6].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39, beaux_pnt->NAME);
		          else
		            {
		            beaux_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beaux_pnt->TIME = delay;
		            beaux_pnt->FLAG = (bvl_y_vsp[-3].valu)   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL, NULL);
		          bereg_pnt->BINODE->TIME = delay;
		          bereg_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bereg_pnt->BIABL->TIME = delay;
		          bereg_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL, NULL);
		          bebux_pnt->BINODE->TIME = delay;
		          bebux_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebux_pnt->BIABL->TIME = delay;
		          bebux_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17, (bvl_y_vsp[-6].name).NAME);
		    break;
		  }
		}
#line 4012 "y.tab.c"
    break;

  case 80: /* ..waveform__WHEN__condition__ELSE..: ..waveform__WHEN__condition__ELSE.. waveform WHEN expression ELSE  */
#line 2441 "./bvl_bcomp_y.y"
                {
		struct bvl_expr *expr_pnt;

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (bvl_y_vsp[-1].list).WIDTH;
		expr_pnt->LIST_ABL = (bvl_y_vsp[-1].list).LIST_ABL;
		BVL_CNDLST         = addchain (BVL_CNDLST, (char *) expr_pnt);

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = (bvl_y_vsp[-3].list).WIDTH;
		expr_pnt->LIST_ABL = (bvl_y_vsp[-3].list).LIST_ABL;
		BVL_VALLST         = addchain (BVL_VALLST, (char *) expr_pnt);
		}
#line 4030 "y.tab.c"
    break;

  case 81: /* $@6: %empty  */
#line 2459 "./bvl_bcomp_y.y"
                {
		BVL_SLCEXP = (bvl_y_vsp[0].list);
		BVL_BDDPNT = NULL;
		}
#line 4039 "y.tab.c"
    break;

  case 82: /* unlabeled_selected_signal_assignment: WITH expression $@6 SELECT target _LESym .GUARDED. .TRANSPORT. waveform__WHEN__choices ...waveform__WHEN__choices.. Semicolon_ERR  */
#line 2471 "./bvl_bcomp_y.y"
                {
		long             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt  ;
		unsigned long   delay    ;
		struct bvl_expr expr1    ;
		long             rev_flg  = 0;
		long             left_bnd;
		long             right_bnd;
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             sig_width;
		long             sig_conf;

		/* ###----------------------------------------------### */
		/*    $10 est une structure, pas un pointeur...		*/
		/*    et c'est bien la le probleme............		*/
		/*    Pour BVL_EMPSTR le champs LIST_ABL doit etre NULL	*/
		/* ###----------------------------------------------### */

                if (((bvl_y_vsp[-1].list).LIST_ABL != NULL) && ((bvl_y_vsp[-2].list).TIME != (bvl_y_vsp[-1].list).TIME))
                  {
		  bvl_error (80, NULL);
                  }
		expr1      = crtabl (OR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[-1].list), -1, -1);
		expr1.TIME = (bvl_y_vsp[-2].list).TIME;

		if (BVL_BDDPNT != one)
		  bvl_error (25, NULL);

		left_bnd  = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_WMXDFN);
		sig_conf  = beh_chktab (dic, (bvl_y_vsp[-6].name).NAME, BVL_MODNAM, BVL_SIGDFN);

		left  = (bvl_y_vsp[-6].name).LEFT ;
		right = (bvl_y_vsp[-6].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left ;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left ;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, (bvl_y_vsp[-6].name).NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr1.WIDTH)
		  bvl_error (35, (bvl_y_vsp[-6].name).NAME);

		if (rev_flg == 1)
		  expr1.LIST_ABL = reverse (expr1.LIST_ABL);

		abl_pnt = expr1.LIST_ABL;
		delay   = expr1.TIME    ;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21, (bvl_y_vsp[-6].name).NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if ((bvl_y_vsp[-4].valu) == BVL_GRDDFN)
		      bvl_error (22, (bvl_y_vsp[-6].name).NAME);
		    beout_pnt = (struct beout *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39, beout_pnt->NAME);
		          else
		            {
		            beout_pnt->ABL  = (struct chain *)abl_pnt->DATA;
		            beout_pnt->TIME = delay;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bebus_pnt = (struct bebus *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL, NULL);
		          bebus_pnt->BINODE->TIME = delay;
		          bebus_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebus_pnt->BIABL->TIME = delay;
		          bebus_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if ((bvl_y_vsp[-4].valu) == BVL_GRDDFN)
		      bvl_error (22, (bvl_y_vsp[-6].name).NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39, beaux_pnt->NAME);
		          else
		           {
		            beaux_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beaux_pnt->TIME = delay;
		            beaux_pnt->FLAG = (bvl_y_vsp[-3].valu)   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL, NULL);
		          bereg_pnt->BINODE->TIME = delay;
		          bereg_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bereg_pnt->BIABL->TIME = delay;
		          bereg_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if (((bvl_y_vsp[-4].valu) != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, (bvl_y_vsp[-6].name).NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,(bvl_y_vsp[-6].name).NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL, NULL);
		          bebux_pnt->BINODE->TIME = delay;
		          bebux_pnt->BINODE->FLAG = (bvl_y_vsp[-3].valu)   ;

		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebux_pnt->BIABL->TIME = delay;
		          bebux_pnt->BIABL->FLAG = (bvl_y_vsp[-3].valu)   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17, (bvl_y_vsp[-6].name).NAME);
		    break;
		  }
		}
#line 4301 "y.tab.c"
    break;

  case 83: /* ...waveform__WHEN__choices..: %empty  */
#line 2732 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = BVL_EMPSTR; }
#line 4307 "y.tab.c"
    break;

  case 84: /* ...waveform__WHEN__choices..: ...waveform__WHEN__choices.. Comma waveform__WHEN__choices  */
#line 2736 "./bvl_bcomp_y.y"
                {
		/* ###----------------------------------------------### */
		/*    $9 est une structure, pas un pointeur...		*/
		/*    et c'est bien la le probleme............		*/
		/*    Pour BVL_EMPSTR le champs LIST_ABL doit etre NULL	*/
		/* ###----------------------------------------------### */

		if (((bvl_y_vsp[-2].list).LIST_ABL != NULL) && ((bvl_y_vsp[-2].list).TIME != (bvl_y_vsp[0].list).TIME))
                  {
		  bvl_error (80, NULL);
                  }

		(bvl_y_val.list)      = crtabl (OR, (bvl_y_vsp[-2].list), (bvl_y_vsp[0].list), -1, -1);
		(bvl_y_val.list).TIME = (bvl_y_vsp[0].list).TIME;
		}
#line 4327 "y.tab.c"
    break;

  case 85: /* waveform__WHEN__choices: waveform WHEN choices  */
#line 2757 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;

		bvl_select (&expr1, BVL_NM1LST, &BVL_BDDPNT, BVL_SLCEXP);
		freechain  (BVL_NM1LST);
		BVL_NM1LST = NULL;

		(bvl_y_val.list)      = crtabl (ANDM, (bvl_y_vsp[-2].list), expr1, -1, -1);
		(bvl_y_val.list).TIME = (bvl_y_vsp[-2].list).TIME;
		}
#line 4342 "y.tab.c"
    break;

  case 86: /* waveform: waveform_element  */
#line 2771 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4348 "y.tab.c"
    break;

  case 87: /* waveform_element: expression .AFTER__delay_expression.  */
#line 2777 "./bvl_bcomp_y.y"
                {
		(bvl_y_val.list)      = (bvl_y_vsp[-1].list);
		(bvl_y_val.list).TIME = (bvl_y_vsp[0].valu);
		}
#line 4357 "y.tab.c"
    break;

  case 88: /* .AFTER__delay_expression.: %empty  */
#line 2785 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = 0; }
#line 4363 "y.tab.c"
    break;

  case 89: /* .AFTER__delay_expression.: AFTER delay_expression  */
#line 2788 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = (bvl_y_vsp[0].valu); }
#line 4369 "y.tab.c"
    break;

  case 90: /* delay_expression: abstractlit time_unit  */
#line 2794 "./bvl_bcomp_y.y"
                {
		unsigned long dly;

		/* ###----------------------------------------------### */
		/*    if the delay is not null unset the 'zero delay'	*/
		/* flag of the description				*/
		/* ###----------------------------------------------### */

		dly = (bvl_y_vsp[-1].valu) * (bvl_y_vsp[0].flov);
		if (dly != 0)
		  BVL_BEFPNT->FLAG &= ~BEH_FIG_ZERODELAY;

		(bvl_y_val.valu) = dly;
		}
#line 4388 "y.tab.c"
    break;

  case 91: /* time_unit: FS  */
#line 2812 "./bvl_bcomp_y.y"
                { (bvl_y_val.flov) = BVL_CNVFS ; }
#line 4394 "y.tab.c"
    break;

  case 92: /* time_unit: PS  */
#line 2814 "./bvl_bcomp_y.y"
                { (bvl_y_val.flov) = BVL_CNVPS ; }
#line 4400 "y.tab.c"
    break;

  case 93: /* time_unit: NS  */
#line 2816 "./bvl_bcomp_y.y"
                { (bvl_y_val.flov) = BVL_CNVNS ; }
#line 4406 "y.tab.c"
    break;

  case 94: /* time_unit: US  */
#line 2818 "./bvl_bcomp_y.y"
                { (bvl_y_val.flov) = BVL_CNVUS ; }
#line 4412 "y.tab.c"
    break;

  case 95: /* time_unit: MS  */
#line 2820 "./bvl_bcomp_y.y"
                { (bvl_y_val.flov) = BVL_CNVMS ; }
#line 4418 "y.tab.c"
    break;

  case 96: /* $@7: %empty  */
#line 2825 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (NULL, (bvl_y_vsp[0].text)); }
#line 4424 "y.tab.c"
    break;

  case 97: /* choices: choice $@7 ..Bar__choice..  */
#line 2827 "./bvl_bcomp_y.y"
                { bvl_y_errok; }
#line 4430 "y.tab.c"
    break;

  case 99: /* ..Bar__choice..: ..Bar__choice.. Bar choice  */
#line 2835 "./bvl_bcomp_y.y"
                {
        if (!strncmp((bvl_y_vsp[0].text),"others",7))
		  bvl_error (30, NULL);
		BVL_NM1LST = addchain (BVL_NM1LST, (bvl_y_vsp[0].text));
		}
#line 4440 "y.tab.c"
    break;

  case 100: /* choice: literal  */
#line 2844 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4446 "y.tab.c"
    break;

  case 101: /* choice: OTHERS  */
#line 2846 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = "others"; }
#line 4452 "y.tab.c"
    break;

  case 102: /* choice: name  */
#line 2848 "./bvl_bcomp_y.y"
                {
		char           *val;
		char            val2[256];
		long             left;
		long             right;
		long             in_bound;
		long             out_bound;
		long             left_bnd;
		long             right_bnd;
		long             sig_conf;

		strcpy (val2, "B\"");
		sig_conf = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_SIGDFN);
		val      = (char *) beh_chktab (dic, (bvl_y_vsp[0].name).NAME, NULL, BVL_PNTDFN);
		if (sig_conf == 0)
		  bvl_error (17, (bvl_y_vsp[0].name).NAME);
		else
		  {
		  if (sig_conf != BVL_CSTDFN)
		    bvl_error (76, (bvl_y_vsp[0].name).NAME);
		  }

		left_bnd  = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_WMXDFN);

		left  = (bvl_y_vsp[0].name).LEFT;
		right = (bvl_y_vsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound = left - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = left - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound = right - left_bnd;
		    out_bound = left - left_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound = right - right_bnd;
		    out_bound = left - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  }

		tobin (&val2[2], val, in_bound, out_bound);
		strcat (val2, "\"");
		(bvl_y_val.text) = namealloc (val2);
		}
#line 4524 "y.tab.c"
    break;

  case 103: /* .REPORT__expression.: %empty  */
#line 2919 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = NULL; }
#line 4530 "y.tab.c"
    break;

  case 104: /* .REPORT__expression.: REPORT report__message  */
#line 2922 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4536 "y.tab.c"
    break;

  case 105: /* .SEVERITY__expression.: %empty  */
#line 2927 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = 'E'; }
#line 4542 "y.tab.c"
    break;

  case 106: /* .SEVERITY__expression.: SEVERITY severity__message  */
#line 2930 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = (bvl_y_vsp[0].valu); }
#line 4548 "y.tab.c"
    break;

  case 107: /* report__message: StringLit  */
#line 2935 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4554 "y.tab.c"
    break;

  case 108: /* severity__message: ERROR  */
#line 2940 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = 'E'; }
#line 4560 "y.tab.c"
    break;

  case 109: /* severity__message: WARNING  */
#line 2942 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = 'W'; }
#line 4566 "y.tab.c"
    break;

  case 110: /* expression: relation..AND__relation..  */
#line 2947 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4572 "y.tab.c"
    break;

  case 111: /* expression: relation..OR__relation..  */
#line 2949 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4578 "y.tab.c"
    break;

  case 112: /* expression: relation.NAND_NOR__relation.  */
#line 2951 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4584 "y.tab.c"
    break;

  case 113: /* expression: relation..XOR__relation..  */
#line 2953 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4590 "y.tab.c"
    break;

  case 114: /* relation..AND__relation..: relation tok_AND relation  */
#line 2960 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (AND , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4596 "y.tab.c"
    break;

  case 115: /* relation..AND__relation..: relation..AND__relation.. tok_AND relation  */
#line 2964 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (AND , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4602 "y.tab.c"
    break;

  case 116: /* relation..OR__relation..: relation _OR relation  */
#line 2971 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (OR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4608 "y.tab.c"
    break;

  case 117: /* relation..OR__relation..: relation..OR__relation.. _OR relation  */
#line 2975 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (OR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4614 "y.tab.c"
    break;

  case 118: /* relation.NAND_NOR__relation.: relation  */
#line 2980 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4620 "y.tab.c"
    break;

  case 119: /* relation.NAND_NOR__relation.: relation _NAND relation  */
#line 2984 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (NAND , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4626 "y.tab.c"
    break;

  case 120: /* relation.NAND_NOR__relation.: relation _NOR relation  */
#line 2988 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (NOR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4632 "y.tab.c"
    break;

  case 121: /* relation..XOR__relation..: relation _XOR relation  */
#line 2996 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (XOR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4638 "y.tab.c"
    break;

  case 122: /* relation..XOR__relation..: relation..XOR__relation.. _XOR relation  */
#line 3000 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (XOR , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4644 "y.tab.c"
    break;

  case 123: /* relation: simple_expression  */
#line 3005 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4650 "y.tab.c"
    break;

  case 124: /* relation: simple_expression relational_operator simple_expression  */
#line 3009 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl ((bvl_y_vsp[-1].valu) , (bvl_y_vsp[-2].list) , (bvl_y_vsp[0].list) , -1, -1); }
#line 4656 "y.tab.c"
    break;

  case 125: /* simple_expression: .sign.term..add_op__term..  */
#line 3014 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4662 "y.tab.c"
    break;

  case 126: /* .sign.term..add_op__term..: term  */
#line 3019 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4668 "y.tab.c"
    break;

  case 127: /* .sign.term..add_op__term..: .sign.term..add_op__term.. Ampersand term  */
#line 3023 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (CONC, (bvl_y_vsp[-2].list), (bvl_y_vsp[0].list), -1, -1); }
#line 4674 "y.tab.c"
    break;

  case 128: /* term: factor  */
#line 3029 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4680 "y.tab.c"
    break;

  case 129: /* factor: primary  */
#line 3034 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4686 "y.tab.c"
    break;

  case 130: /* factor: _NOT primary  */
#line 3037 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = crtabl (NOT, (bvl_y_vsp[0].list), BVL_EMPSTR, -1, -1); }
#line 4692 "y.tab.c"
    break;

  case 131: /* primary: literal  */
#line 3042 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		expr1.IDENT = (bvl_y_vsp[0].text);
		(bvl_y_val.list) = crtabl (NOPS, expr1, BVL_EMPSTR, -1, -1);
		}
#line 4702 "y.tab.c"
    break;

  case 132: /* primary: aggregate  */
#line 3048 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[0].list); }
#line 4708 "y.tab.c"
    break;

  case 133: /* primary: name  */
#line 3050 "./bvl_bcomp_y.y"
                {
		struct bvl_expr expr1;
		long             left;
		long             right;
		long             left_bnd;
		long             right_bnd;
		long             in_bound;
		long             out_bound;
		long             sig_conf;

		sig_conf = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		  case (BVL_CSTDFN):
		    break;
		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    bvl_error (26, (bvl_y_vsp[0].name).NAME);
		    break;
		  default :
		    bvl_error (17, (bvl_y_vsp[0].name).NAME);
		    break;
		  }

		left_bnd  = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, (bvl_y_vsp[0].name).NAME, BVL_MODNAM, BVL_WMXDFN);

		left  = (bvl_y_vsp[0].name).LEFT;
		right = (bvl_y_vsp[0].name).RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - left_bnd;
		    out_bound = left  - left_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  else
		    {
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, (bvl_y_vsp[0].name).NAME);
		    }
		  }

		if (sig_conf != BVL_CSTDFN)
		  {
		  expr1.IDENT = (bvl_y_vsp[0].name).NAME;
		  if((bvl_y_vsp[0].name).FLAG == 'X')
		    {
		    expr1 = crtabl (NOPI  , expr1, BVL_EMPSTR, left, right);
		    (bvl_y_val.list)    = crtabl (STABLE, expr1, BVL_EMPSTR, left, right);
		    }
		  else 
		    (bvl_y_val.list)    = crtabl (NOPI  , expr1, BVL_EMPSTR, left, right);
		  }
		else
		  {
		  expr1.IDENT = (char *)beh_chktab(dic,(bvl_y_vsp[0].name).NAME,NULL,BVL_PNTDFN);
		  (bvl_y_val.list) = crtabl (NOPS,expr1,BVL_EMPSTR,in_bound,out_bound);
		  }
		}
#line 4804 "y.tab.c"
    break;

  case 134: /* relational_operator: _EQSym  */
#line 3145 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = EQ; }
#line 4810 "y.tab.c"
    break;

  case 135: /* relational_operator: _NESym  */
#line 3147 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = NE; }
#line 4816 "y.tab.c"
    break;

  case 136: /* literal: CharacterLit  */
#line 3152 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4822 "y.tab.c"
    break;

  case 137: /* literal: StringLit  */
#line 3154 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4828 "y.tab.c"
    break;

  case 138: /* literal: BitStringLit  */
#line 3156 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 4834 "y.tab.c"
    break;

  case 139: /* aggregate: LeftParen expression RightParen  */
#line 3163 "./bvl_bcomp_y.y"
                { (bvl_y_val.list) = (bvl_y_vsp[-1].list); }
#line 4840 "y.tab.c"
    break;

  case 140: /* name: simple_name  */
#line 3168 "./bvl_bcomp_y.y"
                {
		(bvl_y_val.name).NAME  = (bvl_y_vsp[0].text);
		(bvl_y_val.name).LEFT  = beh_chktab (dic, (bvl_y_vsp[0].text), BVL_MODNAM, BVL_WMNDFN);
		(bvl_y_val.name).RIGHT = beh_chktab (dic, (bvl_y_vsp[0].text), BVL_MODNAM, BVL_WMXDFN);
		}
#line 4850 "y.tab.c"
    break;

  case 141: /* name: indexed_name  */
#line 3174 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[0].name); }
#line 4856 "y.tab.c"
    break;

  case 142: /* name: slice_name  */
#line 3176 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[0].name); }
#line 4862 "y.tab.c"
    break;

  case 143: /* name: attribute_name  */
#line 3178 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[0].name); }
#line 4868 "y.tab.c"
    break;

  case 144: /* indexed_name: simple_name LeftParen abstractlit RightParen_ERR  */
#line 3186 "./bvl_bcomp_y.y"
                {
		(bvl_y_val.name).NAME  = (bvl_y_vsp[-3].text);
		(bvl_y_val.name).LEFT  = (bvl_y_vsp[-1].valu);
		(bvl_y_val.name).RIGHT = (bvl_y_vsp[-1].valu);
		}
#line 4878 "y.tab.c"
    break;

  case 145: /* slice_name: simple_name LeftParen abstractlit direction abstractlit RightParen_ERR  */
#line 3200 "./bvl_bcomp_y.y"
                {
		if ((((bvl_y_vsp[-1].valu) > (bvl_y_vsp[-3].valu)) && ((bvl_y_vsp[-2].valu) != BVL_UPTDFN)) ||
		    (((bvl_y_vsp[-1].valu) < (bvl_y_vsp[-3].valu)) && ((bvl_y_vsp[-2].valu) != BVL_DWTDFN)))
		  bvl_error (32, (bvl_y_vsp[-5].text));

		(bvl_y_val.name).NAME  = (bvl_y_vsp[-5].text);
		(bvl_y_val.name).LEFT  = (bvl_y_vsp[-3].valu);
		(bvl_y_val.name).RIGHT = (bvl_y_vsp[-1].valu);
		}
#line 4892 "y.tab.c"
    break;

  case 146: /* attribute_name: simple_name Apostrophe attribute_designator  */
#line 3215 "./bvl_bcomp_y.y"
                {
		char             extname [100];
		char            *lclname      ;
		long              sig_conf     ;
		struct bvl_expr  expr1        ;
		struct bvl_expr  expr2        ;
		struct chain    *ptabl        ;

		sig_conf = beh_chktab (dic, (bvl_y_vsp[-2].text), BVL_MODNAM, BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		    break;
		  default :
		    bvl_error (79, (bvl_y_vsp[-2].text));
		  }

		if (beh_chktab (dic, (bvl_y_vsp[-2].text), BVL_MODNAM, BVL_WMNDFN) != -1)
		  bvl_error (79, (bvl_y_vsp[-2].text));

		sprintf (extname, "%s'delayed", (bvl_y_vsp[-2].text));
		lclname = namealloc (extname);

		if (BVL_ERRFLG == 0)
		  {
		  if (beh_chktab (dic, (bvl_y_vsp[-2].text), BVL_MODNAM, BVL_STBDFN) == 0)
		    {
		    expr1.IDENT = (bvl_y_vsp[-2].text);
		    expr1.WIDTH  = 1;
		    expr2 = crtabl (NOPI, expr1, BVL_EMPSTR, -1, -1);
		    ptabl = expr2.LIST_ABL->DATA;

		    if (BVL_AUXMOD == 1)
		      BVL_BEFPNT->BERIN=beh_addberin(BVL_BEFPNT->BERIN,lclname);

		    BVL_BEFPNT->BEDLY = beh_addbeaux(BVL_BEFPNT->BEDLY,lclname,
		                                     ptabl, NULL);
		    beh_addtab (dic, (bvl_y_vsp[-2].text)     , BVL_MODNAM, BVL_STBDFN, 1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_WMNDFN, -1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_WMXDFN, -1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_SIGDFN,
		                (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN));
		    }
		  }
		BVL_BEFPNT->TYPE |= BEH_STABLE;
		(bvl_y_val.name).NAME  = (bvl_y_vsp[-2].text) ;
		(bvl_y_val.name).LEFT  = -1 ;
		(bvl_y_val.name).RIGHT = -1 ;
		(bvl_y_val.name).FLAG  = 'X';

		}
#line 4955 "y.tab.c"
    break;

  case 148: /* type_mark: BIT  */
#line 3281 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = BIT; (bvl_y_val.dble).FLAG = 'S'; }
#line 4961 "y.tab.c"
    break;

  case 149: /* type_mark: WOR_BIT  */
#line 3283 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = WOR_BIT; (bvl_y_val.dble).FLAG = 'S'; }
#line 4967 "y.tab.c"
    break;

  case 150: /* type_mark: MUX_BIT  */
#line 3285 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = MUX_BIT; (bvl_y_val.dble).FLAG = 'S'; }
#line 4973 "y.tab.c"
    break;

  case 151: /* type_mark: BIT_VECTOR  */
#line 3287 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = BIT; (bvl_y_val.dble).FLAG = 'A'; }
#line 4979 "y.tab.c"
    break;

  case 152: /* type_mark: WOR_VECTOR  */
#line 3289 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = WOR_BIT; (bvl_y_val.dble).FLAG = 'A'; }
#line 4985 "y.tab.c"
    break;

  case 153: /* type_mark: MUX_VECTOR  */
#line 3291 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = MUX_BIT; (bvl_y_val.dble).FLAG = 'A'; }
#line 4991 "y.tab.c"
    break;

  case 154: /* type_mark: REG_BIT  */
#line 3293 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = REG_BIT; (bvl_y_val.dble).FLAG = 'S'; }
#line 4997 "y.tab.c"
    break;

  case 155: /* type_mark: REG_VECTOR  */
#line 3295 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = REG_BIT; (bvl_y_val.dble).FLAG = 'A'; }
#line 5003 "y.tab.c"
    break;

  case 156: /* type_mark: NATURAL  */
#line 3297 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = NATURAL; (bvl_y_val.dble).FLAG = 'S'; }
#line 5009 "y.tab.c"
    break;

  case 157: /* type_mark: NATURAL_VECTOR  */
#line 3299 "./bvl_bcomp_y.y"
                { (bvl_y_val.dble).VALU = NATURAL; (bvl_y_val.dble).FLAG = 'A'; }
#line 5015 "y.tab.c"
    break;

  case 158: /* $@8: %empty  */
#line 3304 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST, (bvl_y_vsp[0].text)); }
#line 5021 "y.tab.c"
    break;

  case 161: /* ...identifier..: ...identifier.. Comma Identifier  */
#line 3313 "./bvl_bcomp_y.y"
                { BVL_NM1LST = addchain (BVL_NM1LST, (bvl_y_vsp[0].text)); }
#line 5027 "y.tab.c"
    break;

  case 162: /* .label.: %empty  */
#line 3318 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = NULL; }
#line 5033 "y.tab.c"
    break;

  case 163: /* .label.: label  */
#line 3320 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 5039 "y.tab.c"
    break;

  case 164: /* .guard_expression.: %empty  */
#line 3325 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = NULL; }
#line 5045 "y.tab.c"
    break;

  case 165: /* .guard_expression.: guard_expression  */
#line 3327 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 5051 "y.tab.c"
    break;

  case 166: /* guard_expression: LeftParen expression RightParen_ERR  */
#line 3334 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (char *)(bvl_y_vsp[-1].list).LIST_ABL->DATA; }
#line 5057 "y.tab.c"
    break;

  case 167: /* .TRANSPORT.: %empty  */
#line 3339 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BEH_ASG_INERTIAL ; }
#line 5063 "y.tab.c"
    break;

  case 168: /* .TRANSPORT.: TRANSPORT  */
#line 3341 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BEH_ASG_TRANSPORT; }
#line 5069 "y.tab.c"
    break;

  case 169: /* .GUARDED.: %empty  */
#line 3346 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BVL_UNGDFN ; }
#line 5075 "y.tab.c"
    break;

  case 170: /* .GUARDED.: GUARDED  */
#line 3348 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = BVL_GRDDFN; }
#line 5081 "y.tab.c"
    break;

  case 171: /* .simple_name.: %empty  */
#line 3353 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = NULL; }
#line 5087 "y.tab.c"
    break;

  case 172: /* .simple_name.: simple_name  */
#line 3355 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 5093 "y.tab.c"
    break;

  case 173: /* simple_name: Identifier  */
#line 3360 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 5099 "y.tab.c"
    break;

  case 174: /* target: name  */
#line 3365 "./bvl_bcomp_y.y"
                { (bvl_y_val.name) = (bvl_y_vsp[0].name); }
#line 5105 "y.tab.c"
    break;

  case 175: /* a_label: label Colon  */
#line 3371 "./bvl_bcomp_y.y"
                {
		BVL_LBLNAM = (bvl_y_vsp[-1].text);
		(bvl_y_val.text) = (bvl_y_vsp[-1].text);
		}
#line 5114 "y.tab.c"
    break;

  case 176: /* label: Identifier  */
#line 3379 "./bvl_bcomp_y.y"
                { (bvl_y_val.text) = (bvl_y_vsp[0].text); }
#line 5120 "y.tab.c"
    break;

  case 177: /* abstractlit: AbstractLit  */
#line 3384 "./bvl_bcomp_y.y"
                { (bvl_y_val.valu) = atoi ((bvl_y_vsp[0].text)); }
#line 5126 "y.tab.c"
    break;

  case 178: /* RightParen_ERR: RightParen  */
#line 3389 "./bvl_bcomp_y.y"
                { bvl_y_errok; }
#line 5132 "y.tab.c"
    break;

  case 179: /* Semicolon_ERR: Semicolon  */
#line 3394 "./bvl_bcomp_y.y"
                { bvl_y_errok; }
#line 5138 "y.tab.c"
    break;

  case 180: /* END_ERR: _END  */
#line 3399 "./bvl_bcomp_y.y"
                { bvl_y_errok; }
#line 5144 "y.tab.c"
    break;


#line 5148 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter bvl_y_char, and that requires
     that bvl_y_token be updated with the new translation.  We take the
     approach of translating immediately before every use of bvl_y_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     BVL_Y_ABORT, BVL_Y_ACCEPT, or BVL_Y_ERROR immediately after altering bvl_y_char or
     if it invokes BVL_Y_BACKUP.  In the case of BVL_Y_ABORT or BVL_Y_ACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of BVL_Y_ERROR or BVL_Y_BACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  BVL_Y__SYMBOL_PRINT ("-> $$ =", BVL_Y__CAST (bvl_y_symbol_kind_t, bvl_y_r1[bvl_y_n]), &bvl_y_val, &bvl_y_loc);

  BVL_Y_POPSTACK (bvl_y_len);
  bvl_y_len = 0;

  *++bvl_y_vsp = bvl_y_val;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int bvl_y_lhs = bvl_y_r1[bvl_y_n] - BVL_Y_NTOKENS;
    const int bvl_y_i = bvl_y_pgoto[bvl_y_lhs] + *bvl_y_ssp;
    bvl_y_state = (0 <= bvl_y_i && bvl_y_i <= BVL_Y_LAST && bvl_y_check[bvl_y_i] == *bvl_y_ssp
               ? bvl_y_table[bvl_y_i]
               : bvl_y_defgoto[bvl_y_lhs]);
  }

  goto bvl_y_newstate;


/*--------------------------------------.
| bvl_y_errlab -- here on detecting error.  |
`--------------------------------------*/
bvl_y_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  bvl_y_token = bvl_y_char == BVL_Y_EMPTY ? BVL_Y_SYMBOL_BVL_Y_EMPTY : BVL_Y_TRANSLATE (bvl_y_char);
  /* If not already recovering from an error, report this error.  */
  if (!bvl_y_errstatus)
    {
      ++bvl_y_nerrs;
      bvl_y_error (BVL_Y__("syntax error"));
    }

  if (bvl_y_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (bvl_y_char <= BVL_Y_EOF)
        {
          /* Return failure if at end of input.  */
          if (bvl_y_char == BVL_Y_EOF)
            BVL_Y_ABORT;
        }
      else
        {
          bvl_y_destruct ("Error: discarding",
                      bvl_y_token, &bvl_y_lval);
          bvl_y_char = BVL_Y_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto bvl_y_errlab1;


/*---------------------------------------------------.
| bvl_y_errorlab -- error raised explicitly by BVL_Y_ERROR.  |
`---------------------------------------------------*/
bvl_y_errorlab:
  /* Pacify compilers when the user code never invokes BVL_Y_ERROR and the
     label bvl_y_errorlab therefore never appears in user code.  */
  if (0)
    BVL_Y_ERROR;
  ++bvl_y_nerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this BVL_Y_ERROR.  */
  BVL_Y_POPSTACK (bvl_y_len);
  bvl_y_len = 0;
  BVL_Y__STACK_PRINT (bvl_y_ss, bvl_y_ssp);
  bvl_y_state = *bvl_y_ssp;
  goto bvl_y_errlab1;


/*-------------------------------------------------------------.
| bvl_y_errlab1 -- common code for both syntax error and BVL_Y_ERROR.  |
`-------------------------------------------------------------*/
bvl_y_errlab1:
  bvl_y_errstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      bvl_y_n = bvl_y_pact[bvl_y_state];
      if (!bvl_y_pact_value_is_default (bvl_y_n))
        {
          bvl_y_n += BVL_Y_SYMBOL_BVL_Y_error;
          if (0 <= bvl_y_n && bvl_y_n <= BVL_Y_LAST && bvl_y_check[bvl_y_n] == BVL_Y_SYMBOL_BVL_Y_error)
            {
              bvl_y_n = bvl_y_table[bvl_y_n];
              if (0 < bvl_y_n)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (bvl_y_ssp == bvl_y_ss)
        BVL_Y_ABORT;


      bvl_y_destruct ("Error: popping",
                  BVL_Y__ACCESSING_SYMBOL (bvl_y_state), bvl_y_vsp);
      BVL_Y_POPSTACK (1);
      bvl_y_state = *bvl_y_ssp;
      BVL_Y__STACK_PRINT (bvl_y_ss, bvl_y_ssp);
    }

  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++bvl_y_vsp = bvl_y_lval;
  BVL_Y__IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  BVL_Y__SYMBOL_PRINT ("Shifting", BVL_Y__ACCESSING_SYMBOL (bvl_y_n), bvl_y_vsp, bvl_y_lsp);

  bvl_y_state = bvl_y_n;
  goto bvl_y_newstate;


/*-------------------------------------.
| bvl_y_acceptlab -- BVL_Y_ACCEPT comes here.  |
`-------------------------------------*/
bvl_y_acceptlab:
  bvl_y_result = 0;
  goto bvl_y_returnlab;


/*-----------------------------------.
| bvl_y_abortlab -- BVL_Y_ABORT comes here.  |
`-----------------------------------*/
bvl_y_abortlab:
  bvl_y_result = 1;
  goto bvl_y_returnlab;


/*-----------------------------------------------------------.
| bvl_y_exhaustedlab -- BVL_Y_NOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
bvl_y_exhaustedlab:
  bvl_y_error (BVL_Y__("memory exhausted"));
  bvl_y_result = 2;
  goto bvl_y_returnlab;


/*----------------------------------------------------------.
| bvl_y_returnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
bvl_y_returnlab:
  if (bvl_y_char != BVL_Y_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      bvl_y_token = BVL_Y_TRANSLATE (bvl_y_char);
      bvl_y_destruct ("Cleanup: discarding lookahead",
                  bvl_y_token, &bvl_y_lval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this BVL_Y_ABORT or BVL_Y_ACCEPT.  */
  BVL_Y_POPSTACK (bvl_y_len);
  BVL_Y__STACK_PRINT (bvl_y_ss, bvl_y_ssp);
  while (bvl_y_ssp != bvl_y_ss)
    {
      bvl_y_destruct ("Cleanup: popping",
                  BVL_Y__ACCESSING_SYMBOL (+*bvl_y_ssp), bvl_y_vsp);
      BVL_Y_POPSTACK (1);
    }
#ifndef bvl_y_overflow
  if (bvl_y_ss != bvl_y_ssa)
    BVL_Y_STACK_FREE (bvl_y_ss);
#endif

  return bvl_y_result;
}

#line 3401 "./bvl_bcomp_y.y"

